package jbox.agent.instrumentation;

import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.security.ProtectionDomain;

import jbox.agent.Agent;

import org.apache.log4j.Logger;
import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;

public class JBoxClassFileTransformer implements ClassFileTransformer {
	private static final Logger LOG = Logger.getLogger(JBoxClassFileTransformer.class);

	public byte[] transform(ClassLoader loader, String className,
			Class<?> classBeingRedefined, ProtectionDomain protectionDomain,
			byte[] classfileBuffer) throws IllegalClassFormatException {

		Agent.isAgentActive = true;
		byte[] result = null;
		try {
		/*
		if (className.startsWith("java") || className.startsWith("jbox/agent") || className.startsWith("org/objectweb")) {
			return classfileBuffer;
		}
		*/
		//TODO: 
		if (className.startsWith("jbox/agent/") || 
				className.startsWith("jbox/runtime/") ||
				className.startsWith("jbox/analysis/") ||
				className.startsWith("jbox.agent.") || 
				className.startsWith("jbox.runtime.") ||
				className.startsWith("jbox.analysis.") ||
				className.startsWith("java/util") ||
				className.startsWith("java/lang") ||
				className.startsWith("java/security") ||
				className.startsWith("java/rmi") ||
				className.startsWith("jcs") ||
				className.startsWith("org/sat4j") ||
				className.startsWith("katja") ||
				className.startsWith("sun/") ||
				className.startsWith("$Proxy") ||
				className.startsWith("javax") ||
				className.startsWith("com")
						) {
			Agent.isAgentActive = false;
			return null;
		}
		//System.out.println(className);
		
		LOG.debug("Transformiere Klasse: " + className);
		
		ClassReader reader = new ClassReader(classfileBuffer);
        ClassWriter classWriter = new ClassWriter(ClassWriter.COMPUTE_MAXS  /*| ClassWriter.COMPUTE_FRAMES*/);
        ClassVisitor target = classWriter;

        ClassVisitor injectClassVisitor = null;
        
        injectClassVisitor = new BoxTransformer(target);
        
        injectClassVisitor = new MethodTransformer(injectClassVisitor, className);
        
        
       
        
        
        ClassVisitor visitor = new IfInterfaceClassVisitor(target, injectClassVisitor);

        reader.accept(visitor, 0);

        result = classWriter.toByteArray();
        Agent.isAgentActive = false;
        
        //LOG.debug("Transformation ok der Klasse: " + className);
        
		} catch (Throwable e) {
			//t.printStackTrace();
			if(e.getCause() != null) {
				
				e.getCause().printStackTrace();
			}
			e.printStackTrace();
			LOG.fatal("Transformation failed for class " + className);
			Agent.isAgentActive = false;
			return classfileBuffer;
		}
        
        
        return result;
		
	}
	

}
