package jbox.agent.instrumentation;

import java.io.File;
import java.io.FileOutputStream;
import java.lang.instrument.ClassFileTransformer;
import java.lang.instrument.IllegalClassFormatException;
import java.security.ProtectionDomain;

import jbox.agent.Agent;

import org.apache.log4j.Logger;
import org.objectweb.asm.ClassReader;
import org.objectweb.asm.ClassVisitor;
import org.objectweb.asm.ClassWriter;

public class JBoxObjectTransformer implements ClassFileTransformer {
	private static final Logger LOG = Logger.getLogger(JBoxObjectTransformer.class);

	public byte[] transform(ClassLoader loader, String className,
			Class<?> classBeingRedefined, ProtectionDomain protectionDomain,
			byte[] classfileBuffer) throws IllegalClassFormatException {
		Agent.isAgentActive = true;
		byte[] result = null;
		
		try{
		if(!className.equals("java.lang.Object")) {
			Agent.isAgentActive = false;
			return classfileBuffer;
		}
		
		LOG.debug("Redefine Object: " + className);
		
		ClassReader reader = new ClassReader(classfileBuffer);
        ClassWriter classWriter = new ClassWriter(ClassWriter.COMPUTE_MAXS | ClassWriter.COMPUTE_FRAMES);
        ClassVisitor target = classWriter;

        
        ObjectTransformer visitor = new ObjectTransformer(target);

        reader.accept(visitor, ClassReader.EXPAND_FRAMES);

        result = classWriter.toByteArray();
        
        /*
        FileOutputStream fs = new FileOutputStream("Object.class");
        fs.write(result);
        fs.close();
        */
        
        Agent.isAgentActive = false;
        
        

			} catch (Throwable t) {
				Agent.isAgentActive = false;
				LOG.fatal(t.getMessage());
				t.printStackTrace();
				LOG.fatal("Redefinition of Object failed");
			}
			return result;
	}

}
