package jbox.agent.instrumentation;

import org.objectweb.asm.*;
import org.objectweb.asm.commons.AdviceAdapter;
import org.objectweb.asm.commons.GeneratorAdapter;
import org.objectweb.asm.commons.Method;

public class ObjectTransformer extends ClassAdapter implements Opcodes {
	public ObjectTransformer(ClassVisitor visitor) {
		super(visitor);
	}
	
	@Override
	public FieldVisitor visitField(int access, String name, String desc, String signature, Object value) {
		//System.out.println(name);
		return super.visitField(access, name, desc, signature, value);
	}
	
	
	@Override
	public void visitEnd() {
		//this.visitField(ACC_PUBLIC, "testasdasd", Type.INT_TYPE.getDescriptor(), null, null);
		super.visitEnd();
	}

	public MethodVisitor visitMethod(int access, String name, String descriptor, String signature,
            String[] exceptions) {
		MethodVisitor visitor = super.visitMethod(access, name, descriptor, signature, exceptions);

		

		if (name.equals("<init>")) {


    		return new AdviceAdapter(visitor, access, name, descriptor) {
    			
    			@Override
				protected void onMethodEnter() {
					super.onMethodEnter();
					
				}

				@Override
				protected void onMethodExit(int arg0) {
						super.onMethodExit(arg0);
							this.loadThis();
							this.invokeStatic(Type.getObjectType("jbox/agent/Handler"), Method.getMethod("void onNewObject(Object)"));
							//super.visitMethodInsn(INVOKESTATIC, "jbox/runtime/Handler", "newObject", "(Ljava/lang/Object;)V");
							/*this.invokeStatic(Type.getType(Handler.class), 
										new Method("newObject",
												Type.getMethodDescriptor(
														Handler.class.getMethod("newObject", 
																Object.class))));
							*/
		
				}
    		    
    		};
    	}
    	return visitor;

    }

}