package jbox.test.test2;

import java.util.ArrayList;
import java.util.List;

import jbox.runtime.annotation.newBox;

public class SubjectImpl implements Subject {
	final private List<Observer> obs = new ArrayList<Observer>();
	
	@newBox(specHandler = jcs.JCSHandler.class, spec = "Subject.spec")
	public static Subject create() {
		return new SubjectImpl();
	}
	
	public void register(Observer o) {
		obs.add(o);
	}

	public void update() {
		for (Observer o : obs) {
			o.notify(this);
		}
	}
}
