package jcs;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import xtc.parser.Result;

import jbox.runtime.BoxI;
import jbox.runtime.JBoxException;
import jbox.runtime.MsgSet;
import jbox.runtime.spec.NoTransitionException;
import jbox.runtime.spec.SpecificationHandler;
import jbox.runtime.spec.SpecificationState;
import jcs.ast.Transformer;
import jcs.ast.gen.BoxSpecification;
import jcs.ast.gen.JCS;
import jcs.ast.gen.JCSRecognizer;
import jcs.checker.GPDA;
import jcs.checker.UnionState;

public class JCSHandler implements SpecificationHandler {

	private GPDA gpda;
	
	public static JCSHandler create(BoxI box, String specfile) {
		try {
			JCSHandler result = new JCSHandler();
			JCSRecognizer parser;
			Package pckge = box.getInterfaceClass().getPackage();
			/*if (pckge != null) {
				specfile = pckge.getName().replace('.', '/') + "/" + specfile;
			}*/

			URL url = box.getInterfaceClass().getResource(specfile);
			parser = new JCSRecognizer(new FileReader(url.getFile()), specfile);
			Result r = parser.pBoxSpecification(0);
			if (r.hasValue()) {
				BoxSpecification b = r.semanticValue();
				System.out.println(b);


				Transformer t = new Transformer(JCS.BoxSpecificationNd(b));
				result.gpda = t.buildAutomaton();
				System.out.println(result.gpda.toDot());
				return result;
			} else {
				throw new JBoxException("Parse Error occured for specification " + specfile);
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	private JCSHandler() {

	}

	public SpecificationState initState() {
		return UnionState.initialState();
	}

	public SpecificationState transition(MsgSet messages,
			SpecificationState previousState) throws NoTransitionException {
		return gpda.transition(messages.getMessages(), (UnionState)previousState);
	}

}
