package jcs.checker;

import positronic.satisfiability.elements.Conjunction;
import positronic.satisfiability.elements.IBooleanLiteral;
import positronic.satisfiability.elements.IClause;
import positronic.satisfiability.elements.IProblem;

public class Guard {
	public IProblem problem;
	
	public Guard and(Guard g) {
		Guard result = new Guard();
		
		if (problem != null && g.problem != null ){
			IProblem p = new Conjunction(problem, g.problem);
			result.problem = p;
		} else {
			if (problem == null) {
				result.problem = g.problem;
			}
			else {
				result.problem = problem;
			}
		}
		return result;
	}
	
	public String toString() {
		if (problem == null) {
			return "true";
		} else {
			IClause[] clauses = problem.getClauses();
			StringBuffer sb = new StringBuffer();
			for (int j = 0; j < clauses.length; j++) {
				IClause clause = clauses[j];
				//sb.append(clause);
				//sb.append("(");
				for (int i = 0; i < clause.size(); i++) {
					try {
						IBooleanLiteral bl = clause.getLiteralAt(i);
						sb.append(bl.toString());
						if (i < clause.size() - 1) {
							sb.append("||");
						}
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				//sb.append(")");
				if (j < clauses.length - 1) {
					sb.append("&&");
				}
			}
			return sb.toString();
		}
	}

}
