package jcs.test;

import java.io.FileReader;
import java.io.IOException;

import xtc.parser.Result;

import jcs.ast.Transformer;
import jcs.ast.gen.*;
import jcs.checker.GPDA;

public class Test {
	public static final String spec = "src/jcs/test/test.spec";
	
	public static void main(String[] args) throws IOException {
		JCSRecognizer parser = new JCSRecognizer(new FileReader(spec), spec);
		Result r = parser.pBoxSpecification(0);
		if (r.hasValue()) {
			BoxSpecification b = r.semanticValue();
			//System.out.println(b);
			
			
			Transformer t = new Transformer(JCS.BoxSpecificationNd(b));
			GPDA gpda = t.buildAutomaton();
			
			System.out.println(gpda.toDot());
		} else {
			System.out.println("Parse Error occured");
		}
		
	}

}
