package jcs.types;

public class ConcreteType extends Type {

	private Class<?> c;
	
	public ConcreteType(Class<?> c) {
		this.c = c;
	}
	
	@Override
	public boolean matches(Class<?> clazz) {
		return c.isAssignableFrom(clazz);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((c == null) ? 0 : c.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final ConcreteType other = (ConcreteType) obj;
		if (c == null) {
			if (other.c != null)
				return false;
		} else if (!c.equals(other.c))
			return false;
		return true;
	}
	
	@Override
	public String toString() {
		return c.toString();
	}

}
