package jcs.types;

import java.util.HashSet;
import java.util.Set;

public class StateType extends Type {
	private String id;
	private Set<String> values = new HashSet<String>();

	public StateType(String id, Set<String> values) {
		super();
		this.id = id;
		this.values = values;
	}

	@Override
	public boolean matches(Class<?> clazz) {
		return false;
	}
	
	public boolean hasValue(String s) {
		return values.contains(s);
	}
	
	public boolean hasName(String s) {
		return id.equals(s);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((values == null) ? 0 : values.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final StateType other = (StateType) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (values == null) {
			if (other.values != null)
				return false;
		} else if (!values.equals(other.values))
			return false;
		return true;
	}

	public String getId() {
		return id;
	}

	public Set<String> getValues() {
		return values;
	}
	
	
	
	

}
