#! /usr/bin/env bash

# This function ensures a dynamic libpath is available in the
# LD_LIBRARY_PATH variable.
function ensure_libpath() {
    local NEWPATH=$1
    local P
    for P in `echo $LD_LIBRARY_PATH|tr ':' ' '`;do 
	if [[ $P = "$NEWPATH" ]];then return;fi
    done
    export LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${NEWPATH}
}

# This function ensures a class path is available in the CLASSPATH
# variable.
function ensure_classpath() {
    local NEWPATH=$1
    local P
    for P in `echo $CLASSPATH|tr ':' ' '`;do 
	if [[ $P = "$NEWPATH" ]];then return;fi
    done
    export CLASSPATH="${CLASSPATH}:${NEWPATH}"
}

# Ensure that the debuggee can access debug helper executable codes
# including the Java byte code and native library. For futher
# information, see DebugHelper.jni source file.
ensure_libpath "$JAVA_DEV_ROOT/classes"
ensure_classpath "$JAVA_DEV_ROOT/classes"

if [[ ! -f "$JAVA_DEV_ROOT/classes/DebugHelper.class" ]];then
    echo "can not find the debug helper class under the $JAVA_DEV_ROOT/classes"
    echo "try \"make -C $JAVA_DEV_ROOT/src/xtc/lang/jeannie\""
    exit -1;
elif [[ ! -f "$JAVA_DEV_ROOT/classes/libDebugHelper.so" ]];then
    echo "can not find the debug helper class under the $JAVA_DEV_ROOT/classes"
    echo "try \"make -C $JAVA_DEV_ROOT/src/xtc/lang/jeannie\""
    exit -1;    
fi

# Now, run jeannie debugger.
java -ea xtc.lang.jeannie.Debugger  $*

