package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface AssertNd extends jcs.ast.gen.StatementNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.Assert> {

    //----- methods of AssertNd -----

    public jcs.ast.gen.Assert termStatement();
    public jcs.ast.gen.Assert term();
    public jcs.ast.gen.ExpressionNd expr();
    public jcs.ast.gen.AssertNd replaceExpr(jcs.ast.gen.Expression expr);
    public jcs.ast.gen.ExpressionNd get(int i);
    public int size();
    public jcs.ast.gen.AssertNd replace(jcs.ast.gen.Assert term);
    public jcs.ast.gen.StatementNd parent();
    public jcs.ast.gen.StatementNd lsib();
    public jcs.ast.gen.StatementNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of AssertNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
        public void visitAssertNd(jcs.ast.gen.AssertNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.AssertNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.Assert> implements jcs.ast.gen.AssertNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.ExpressionNd _expr = null;

        //----- methods of Impl -----

        public jcs.ast.gen.Assert termStatement() {
            return term();
        }

        public jcs.ast.gen.ExpressionNd expr() {
            if(_expr == null)
                _expr = jcs.ast.gen.JCS.ExpressionNd(this, _term.expr(), 0);

            return _expr;
        }

        public jcs.ast.gen.AssertNd replaceExpr(jcs.ast.gen.Expression expr) {
            return replace(_term.replaceExpr(expr));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.Assert term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.ExpressionNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_expr == null)
                        _expr = JCS.ExpressionNd(this, _term.expr(), 0);
                    
                    return _expr;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort AssertNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort AssertNd invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.AssertNd replace(jcs.ast.gen.Assert term) {
            return (jcs.ast.gen.AssertNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.StatementNd parent() {
            return (jcs.ast.gen.StatementNd) super.parent();
        }

        public jcs.ast.gen.StatementNd lsib() {
            return (jcs.ast.gen.StatementNd) super.lsib();
        }

        public jcs.ast.gen.StatementNd rsib() {
            return (jcs.ast.gen.StatementNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseAssertNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "AssertNd";
        }
    }
}

