package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface BoolValue extends jcs.ast.gen.Expression, KatjaTuple {

    //----- methods of BoolValue -----

    public java.lang.Boolean child0();
    public jcs.ast.gen.BoolValue replaceChild0(java.lang.Boolean child0);
    public java.lang.Boolean get(int i);
    public int size();
    public jcs.ast.gen.BoolValue replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E;

    //----- nested classes of BoolValue -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitBoolValue(jcs.ast.gen.BoolValue term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.BoolValue.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.BoolValue {

        //----- attributes of Impl -----

        private java.lang.Boolean _child0 = null;

        //----- methods of Impl -----

        public java.lang.Boolean child0() {
            return _child0;
        }

        public jcs.ast.gen.BoolValue replaceChild0(java.lang.Boolean child0) {
            return replace(0, child0);
        }

        Impl(java.lang.Boolean child0) {
            if(child0 == null)
                throw new IllegalArgumentException("constructor of sort BoolValue invoked with null parameter child0");

            this._child0 = child0;
        }

        public java.lang.Boolean get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort BoolValue invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort BoolValue invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.BoolValue replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort BoolValue invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort BoolValue invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.Boolean))
                throw new IllegalArgumentException("replace on sort BoolValue invoked with term of incorrect sort, Boolean expected");

            return (jcs.ast.gen.BoolValue) JCS.unique(new jcs.ast.gen.BoolValue.Impl(
                pos == 0 ? (java.lang.Boolean) term : _child0
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseBoolValue(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoolValue");
            builder.append("( ");
            builder.append(_child0.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("BoolValue");
            builder.append("( ");
            builder.append(_child0.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "BoolValue";
        }
    }
}

