package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface BoxDeclarationNd extends jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.BoxDeclaration> {

    //----- methods of BoxDeclarationNd -----

    public jcs.ast.gen.BoxDeclaration term();
    public jcs.ast.gen.IdentifierNd ident();
    public jcs.ast.gen.BoxDeclarationNd replaceIdent(jcs.ast.gen.Identifier ident);
    public jcs.ast.gen.TypeOptNd type();
    public jcs.ast.gen.BoxDeclarationNd replaceType(jcs.ast.gen.TypeOpt type);
    public jcs.ast.gen.StateDeclarationListNd states();
    public jcs.ast.gen.BoxDeclarationNd replaceStates(jcs.ast.gen.StateDeclarationList states);
    public jcs.ast.gen.MatchDeclarationListNd matches();
    public jcs.ast.gen.BoxDeclarationNd replaceMatches(jcs.ast.gen.MatchDeclarationList matches);
    public jcs.ast.gen.JCS.SortNd get(int i);
    public int size();
    public jcs.ast.gen.BoxDeclarationNd replace(jcs.ast.gen.BoxDeclaration term);
    public jcs.ast.gen.BoxSpecificationNd parent();
    public jcs.ast.gen.ImportDeclarationListNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of BoxDeclarationNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitTypeOptNd(jcs.ast.gen.TypeOptNd term) throws E;
        public void visitStateDeclarationListNd(jcs.ast.gen.StateDeclarationListNd term) throws E;
        public void visitMatchDeclarationListNd(jcs.ast.gen.MatchDeclarationListNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitStateDeclarationNd(jcs.ast.gen.StateDeclarationNd term) throws E;
        public void visitMatchDeclarationNd(jcs.ast.gen.MatchDeclarationNd term) throws E;
        public void visitTypeListNd(jcs.ast.gen.TypeListNd term) throws E;
        public void visitMethodDeclarationListNd(jcs.ast.gen.MethodDeclarationListNd term) throws E;
        public void visitMethodDeclarationNd(jcs.ast.gen.MethodDeclarationNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
        public void visitBlockNd(jcs.ast.gen.BlockNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitStatementNd(jcs.ast.gen.StatementNd term) throws E;
        public void visitOrNd(jcs.ast.gen.OrNd term) throws E;
        public void visitLoopNd(jcs.ast.gen.LoopNd term) throws E;
        public void visitAssumeNd(jcs.ast.gen.AssumeNd term) throws E;
        public void visitAssertNd(jcs.ast.gen.AssertNd term) throws E;
        public void visitCallNd(jcs.ast.gen.CallNd term) throws E;
        public void visitEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E;
        public void visitBreakNd(jcs.ast.gen.BreakNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
        public void visitBoxDeclarationNd(jcs.ast.gen.BoxDeclarationNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.BoxDeclarationNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };
        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.StatementNd.Switch<Object, E> variantVisit$StatementNd = new jcs.ast.gen.StatementNd.Switch<Object, E>() { public final Object CaseOrNd(jcs.ast.gen.OrNd term) throws E { visitOrNd(term); return null; } public final Object CaseLoopNd(jcs.ast.gen.LoopNd term) throws E { visitLoopNd(term); return null; } public final Object CaseBlockNd(jcs.ast.gen.BlockNd term) throws E { visitBlockNd(term); return null; } public final Object CaseAssumeNd(jcs.ast.gen.AssumeNd term) throws E { visitAssumeNd(term); return null; } public final Object CaseAssertNd(jcs.ast.gen.AssertNd term) throws E { visitAssertNd(term); return null; } public final Object CaseCallNd(jcs.ast.gen.CallNd term) throws E { visitCallNd(term); return null; } public final Object CaseEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E { visitEmptyStatementNd(term); return null; } public final Object CaseBreakNd(jcs.ast.gen.BreakNd term) throws E { visitBreakNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };
        private final jcs.ast.gen.TypeOptNd.Switch<Object, E> variantVisit$TypeOptNd = new jcs.ast.gen.TypeOptNd.Switch<Object, E>() { public final Object CaseTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E { visitTypeNoneNd(term); return null; } public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitStatementNd(jcs.ast.gen.StatementNd term) throws E {
            term.Switch(variantVisit$StatementNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }

        public final void visitTypeOptNd(jcs.ast.gen.TypeOptNd term) throws E {
            term.Switch(variantVisit$TypeOptNd);
        }
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.BoxDeclaration> implements jcs.ast.gen.BoxDeclarationNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.IdentifierNd _ident = null;
        private jcs.ast.gen.TypeOptNd _type = null;
        private jcs.ast.gen.StateDeclarationListNd _states = null;
        private jcs.ast.gen.MatchDeclarationListNd _matches = null;

        //----- methods of Impl -----

        public jcs.ast.gen.IdentifierNd ident() {
            if(_ident == null)
                _ident = jcs.ast.gen.JCS.IdentifierNd(this, _term.ident(), 0);

            return _ident;
        }

        public jcs.ast.gen.BoxDeclarationNd replaceIdent(jcs.ast.gen.Identifier ident) {
            return replace(_term.replaceIdent(ident));
        }

        public jcs.ast.gen.TypeOptNd type() {
            if(_type == null)
                _type = jcs.ast.gen.JCS.TypeOptNd(this, _term.type(), 1);

            return _type;
        }

        public jcs.ast.gen.BoxDeclarationNd replaceType(jcs.ast.gen.TypeOpt type) {
            return replace(_term.replaceType(type));
        }

        public jcs.ast.gen.StateDeclarationListNd states() {
            if(_states == null)
                _states = jcs.ast.gen.JCS.StateDeclarationListNd(this, _term.states(), 2);

            return _states;
        }

        public jcs.ast.gen.BoxDeclarationNd replaceStates(jcs.ast.gen.StateDeclarationList states) {
            return replace(_term.replaceStates(states));
        }

        public jcs.ast.gen.MatchDeclarationListNd matches() {
            if(_matches == null)
                _matches = jcs.ast.gen.JCS.MatchDeclarationListNd(this, _term.matches(), 3);

            return _matches;
        }

        public jcs.ast.gen.BoxDeclarationNd replaceMatches(jcs.ast.gen.MatchDeclarationList matches) {
            return replace(_term.replaceMatches(matches));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.BoxDeclaration term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.JCS.SortNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0:
                    if(_ident == null)
                        _ident = JCS.IdentifierNd(this, _term.ident(), 0);
                    
                    return _ident;
                case 1:
                    if(_type == null)
                        _type = JCS.TypeOptNd(this, _term.type(), 1);
                    
                    return _type;
                case 2:
                    if(_states == null)
                        _states = JCS.StateDeclarationListNd(this, _term.states(), 2);
                    
                    return _states;
                case 3:
                    if(_matches == null)
                        _matches = JCS.MatchDeclarationListNd(this, _term.matches(), 3);
                    
                    return _matches;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort BoxDeclarationNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort BoxDeclarationNd invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public jcs.ast.gen.BoxDeclarationNd replace(jcs.ast.gen.BoxDeclaration term) {
            return (jcs.ast.gen.BoxDeclarationNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.BoxSpecificationNd parent() {
            return (jcs.ast.gen.BoxSpecificationNd) super.parent();
        }

        public jcs.ast.gen.ImportDeclarationListNd lsib() {
            return (jcs.ast.gen.ImportDeclarationListNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "BoxDeclarationNd";
        }
    }
}

