package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface BreakNd extends jcs.ast.gen.StatementNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.Break> {

    //----- methods of BreakNd -----

    public jcs.ast.gen.Break termStatement();
    public jcs.ast.gen.Break term();
    public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i);
    public int size();
    public jcs.ast.gen.BreakNd replace(jcs.ast.gen.Break term);
    public jcs.ast.gen.StatementNd parent();
    public jcs.ast.gen.StatementNd lsib();
    public jcs.ast.gen.StatementNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of BreakNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitBreakNd(jcs.ast.gen.BreakNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.BreakNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.Break> implements jcs.ast.gen.BreakNd {

        //----- methods of Impl -----

        public jcs.ast.gen.Break termStatement() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.Break term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort BreakNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort BreakNd invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.BreakNd replace(jcs.ast.gen.Break term) {
            return (jcs.ast.gen.BreakNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.StatementNd parent() {
            return (jcs.ast.gen.StatementNd) super.parent();
        }

        public jcs.ast.gen.StatementNd lsib() {
            return (jcs.ast.gen.StatementNd) super.lsib();
        }

        public jcs.ast.gen.StatementNd rsib() {
            return (jcs.ast.gen.StatementNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseBreakNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "BreakNd";
        }
    }
}

