package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface CallNd extends jcs.ast.gen.StatementNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.Call> {

    //----- methods of CallNd -----

    public jcs.ast.gen.Call termStatement();
    public jcs.ast.gen.Call term();
    public jcs.ast.gen.TypeNd type();
    public jcs.ast.gen.CallNd replaceType(jcs.ast.gen.Type type);
    public jcs.ast.gen.IdentifierOptNd identCallee();
    public jcs.ast.gen.CallNd replaceIdentCallee(jcs.ast.gen.IdentifierOpt identCallee);
    public jcs.ast.gen.IdentifierNd methodName();
    public jcs.ast.gen.CallNd replaceMethodName(jcs.ast.gen.Identifier methodName);
    public jcs.ast.gen.ParameterListNd params();
    public jcs.ast.gen.CallNd replaceParams(jcs.ast.gen.ParameterList params);
    public jcs.ast.gen.IdentifierOptNd identReturn();
    public jcs.ast.gen.CallNd replaceIdentReturn(jcs.ast.gen.IdentifierOpt identReturn);
    public jcs.ast.gen.JCS.SortNd get(int i);
    public int size();
    public jcs.ast.gen.CallNd replace(jcs.ast.gen.Call term);
    public jcs.ast.gen.StatementNd parent();
    public jcs.ast.gen.StatementNd lsib();
    public jcs.ast.gen.StatementNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of CallNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitCallNd(jcs.ast.gen.CallNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.CallNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.Call> implements jcs.ast.gen.CallNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.TypeNd _type = null;
        private jcs.ast.gen.IdentifierOptNd _identCallee = null;
        private jcs.ast.gen.IdentifierNd _methodName = null;
        private jcs.ast.gen.ParameterListNd _params = null;
        private jcs.ast.gen.IdentifierOptNd _identReturn = null;

        //----- methods of Impl -----

        public jcs.ast.gen.Call termStatement() {
            return term();
        }

        public jcs.ast.gen.TypeNd type() {
            if(_type == null)
                _type = jcs.ast.gen.JCS.TypeNd(this, _term.type(), 0);

            return _type;
        }

        public jcs.ast.gen.CallNd replaceType(jcs.ast.gen.Type type) {
            return replace(_term.replaceType(type));
        }

        public jcs.ast.gen.IdentifierOptNd identCallee() {
            if(_identCallee == null)
                _identCallee = jcs.ast.gen.JCS.IdentifierOptNd(this, _term.identCallee(), 1);

            return _identCallee;
        }

        public jcs.ast.gen.CallNd replaceIdentCallee(jcs.ast.gen.IdentifierOpt identCallee) {
            return replace(_term.replaceIdentCallee(identCallee));
        }

        public jcs.ast.gen.IdentifierNd methodName() {
            if(_methodName == null)
                _methodName = jcs.ast.gen.JCS.IdentifierNd(this, _term.methodName(), 2);

            return _methodName;
        }

        public jcs.ast.gen.CallNd replaceMethodName(jcs.ast.gen.Identifier methodName) {
            return replace(_term.replaceMethodName(methodName));
        }

        public jcs.ast.gen.ParameterListNd params() {
            if(_params == null)
                _params = jcs.ast.gen.JCS.ParameterListNd(this, _term.params(), 3);

            return _params;
        }

        public jcs.ast.gen.CallNd replaceParams(jcs.ast.gen.ParameterList params) {
            return replace(_term.replaceParams(params));
        }

        public jcs.ast.gen.IdentifierOptNd identReturn() {
            if(_identReturn == null)
                _identReturn = jcs.ast.gen.JCS.IdentifierOptNd(this, _term.identReturn(), 4);

            return _identReturn;
        }

        public jcs.ast.gen.CallNd replaceIdentReturn(jcs.ast.gen.IdentifierOpt identReturn) {
            return replace(_term.replaceIdentReturn(identReturn));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.Call term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.JCS.SortNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 5;

            switch(ith) {
                case 0:
                    if(_type == null)
                        _type = JCS.TypeNd(this, _term.type(), 0);
                    
                    return _type;
                case 1:
                    if(_identCallee == null)
                        _identCallee = JCS.IdentifierOptNd(this, _term.identCallee(), 1);
                    
                    return _identCallee;
                case 2:
                    if(_methodName == null)
                        _methodName = JCS.IdentifierNd(this, _term.methodName(), 2);
                    
                    return _methodName;
                case 3:
                    if(_params == null)
                        _params = JCS.ParameterListNd(this, _term.params(), 3);
                    
                    return _params;
                case 4:
                    if(_identReturn == null)
                        _identReturn = JCS.IdentifierOptNd(this, _term.identReturn(), 4);
                    
                    return _identReturn;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort CallNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort CallNd invoked with too large parameter "+i+", sort has only 5 components");
                    }
            }
        }

        public int size() {
            return 5;
        }

        public jcs.ast.gen.CallNd replace(jcs.ast.gen.Call term) {
            return (jcs.ast.gen.CallNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.StatementNd parent() {
            return (jcs.ast.gen.StatementNd) super.parent();
        }

        public jcs.ast.gen.StatementNd lsib() {
            return (jcs.ast.gen.StatementNd) super.lsib();
        }

        public jcs.ast.gen.StatementNd rsib() {
            return (jcs.ast.gen.StatementNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseCallNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "CallNd";
        }
    }
}

