package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface EmptyStatement extends jcs.ast.gen.Statement, KatjaTuple {

    //----- methods of EmptyStatement -----

    public Object get(int i);
    public int size();
    public jcs.ast.gen.EmptyStatement replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Statement.Switch<CT, E> switchClass) throws E;

    //----- nested classes of EmptyStatement -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitEmptyStatement(jcs.ast.gen.EmptyStatement term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.EmptyStatement.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.EmptyStatement {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort EmptyStatement invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort EmptyStatement invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.EmptyStatement replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort EmptyStatement invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort EmptyStatement invoked with too large parameter "+pos+", sort has only 0 components");


            return (jcs.ast.gen.EmptyStatement) JCS.unique(new jcs.ast.gen.EmptyStatement.Impl(
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Statement.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseEmptyStatement(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.EmptyStatement");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("EmptyStatement");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "EmptyStatement";
        }
    }
}

