package jcs.ast.gen;

import katja.common.*;

public interface Expression extends KatjaSort {

    //----- methods of Expression -----

    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E;

    //----- nested classes of Expression -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseOrExpression(jcs.ast.gen.OrExpression term) throws E;
        public CT CaseAndExpression(jcs.ast.gen.AndExpression term) throws E;
        public CT CaseEqExpression(jcs.ast.gen.EqExpression term) throws E;
        public CT CaseNotExpression(jcs.ast.gen.NotExpression term) throws E;
        public CT CaseLiteral(jcs.ast.gen.Literal term) throws E;
        public CT CaseIdentifier(jcs.ast.gen.Identifier term) throws E;
        public CT CaseBoolValue(jcs.ast.gen.BoolValue term) throws E;
        public CT CaseIntValue(jcs.ast.gen.IntValue term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExpression(jcs.ast.gen.Expression term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitOrExpression(jcs.ast.gen.OrExpression term) throws E;
        public void visitAndExpression(jcs.ast.gen.AndExpression term) throws E;
        public void visitEqExpression(jcs.ast.gen.EqExpression term) throws E;
        public void visitNotExpression(jcs.ast.gen.NotExpression term) throws E;
        public void visitLiteral(jcs.ast.gen.Literal term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitBoolValue(jcs.ast.gen.BoolValue term) throws E;
        public void visitIntValue(jcs.ast.gen.IntValue term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.Expression.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.Expression.Switch<Object, E> variantVisit$Expression = new jcs.ast.gen.Expression.Switch<Object, E>() { public final Object CaseOrExpression(jcs.ast.gen.OrExpression term) throws E { visitOrExpression(term); return null; } public final Object CaseAndExpression(jcs.ast.gen.AndExpression term) throws E { visitAndExpression(term); return null; } public final Object CaseEqExpression(jcs.ast.gen.EqExpression term) throws E { visitEqExpression(term); return null; } public final Object CaseNotExpression(jcs.ast.gen.NotExpression term) throws E { visitNotExpression(term); return null; } public final Object CaseLiteral(jcs.ast.gen.Literal term) throws E { visitLiteral(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseBoolValue(jcs.ast.gen.BoolValue term) throws E { visitBoolValue(term); return null; } public final Object CaseIntValue(jcs.ast.gen.IntValue term) throws E { visitIntValue(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpression(jcs.ast.gen.Expression term) throws E {
            term.Switch(variantVisit$Expression);
        }
    }
}

