package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface Identifier extends jcs.ast.gen.Expression, jcs.ast.gen.IdentifierOpt, jcs.ast.gen.Type, KatjaTuple {

    //----- methods of Identifier -----

    public java.lang.String child0();
    public jcs.ast.gen.Identifier replaceChild0(java.lang.String child0);
    public java.lang.String get(int i);
    public int size();
    public jcs.ast.gen.Identifier replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOpt.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of Identifier -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.Identifier.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.Identifier {

        //----- attributes of Impl -----

        private java.lang.String _child0 = null;

        //----- methods of Impl -----

        public java.lang.String child0() {
            return _child0;
        }

        public jcs.ast.gen.Identifier replaceChild0(java.lang.String child0) {
            return replace(0, child0);
        }

        Impl(java.lang.String child0) {
            if(child0 == null)
                throw new IllegalArgumentException("constructor of sort Identifier invoked with null parameter child0");

            this._child0 = child0;
        }

        public java.lang.String get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Identifier invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Identifier invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.Identifier replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Identifier invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort Identifier invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Identifier invoked with term of incorrect sort, String expected");

            return (jcs.ast.gen.Identifier) JCS.unique(new jcs.ast.gen.Identifier.Impl(
                pos == 0 ? (java.lang.String) term : _child0
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifier(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifier(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifier(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifier(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.Identifier");
            builder.append("( ");
            builder.append("\"").append(_child0.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Identifier");
            builder.append("( ");
            builder.append("\"").append(_child0.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Identifier";
        }
    }
}

