package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface IdentifierList extends jcs.ast.gen.Type, KatjaList<jcs.ast.gen.Identifier> {

    //----- methods of IdentifierList -----

    public jcs.ast.gen.IdentifierList add(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList addAll(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierList remove(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList removeAll(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierList appBack(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList appFront(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList conc(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierList front();
    public jcs.ast.gen.IdentifierList back();
    public jcs.ast.gen.IdentifierList reverse();
    public jcs.ast.gen.IdentifierList sublist(int from, int to);
    public jcs.ast.gen.IdentifierList replace(int ith, Object element);
    public jcs.ast.gen.IdentifierList toSet();
    public jcs.ast.gen.IdentifierList setAdd(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList setRemove(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierList setUnion(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierList setIntersection(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierList setWithout(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.Identifier> implements jcs.ast.gen.IdentifierList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.Identifier... elements) {
            super(elements);

            for(jcs.ast.gen.Identifier element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IdentifierList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.IdentifierList createInstance(jcs.ast.gen.Identifier[] elements, boolean isSet) {
            for(jcs.ast.gen.Identifier element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IdentifierList invoked with null element");

            IdentifierList.Impl temp = new jcs.ast.gen.IdentifierList.Impl();
            temp.values = elements;
            temp = (IdentifierList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.Identifier[] createArray(int size) {
            return new jcs.ast.gen.Identifier[size];
        }

        public jcs.ast.gen.IdentifierList add(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.add(element);
        }

        public jcs.ast.gen.IdentifierList addAll(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.addAll(list);
        }

        public jcs.ast.gen.IdentifierList remove(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.remove(element);
        }

        public jcs.ast.gen.IdentifierList removeAll(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.removeAll(list);
        }

        public jcs.ast.gen.IdentifierList appBack(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.appBack(element);
        }

        public jcs.ast.gen.IdentifierList appFront(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.appFront(element);
        }

        public jcs.ast.gen.IdentifierList conc(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.conc(list);
        }

        public jcs.ast.gen.IdentifierList front() {
            return (jcs.ast.gen.IdentifierList) super.front();
        }

        public jcs.ast.gen.IdentifierList back() {
            return (jcs.ast.gen.IdentifierList) super.back();
        }

        public jcs.ast.gen.IdentifierList reverse() {
            return (jcs.ast.gen.IdentifierList) super.reverse();
        }

        public jcs.ast.gen.IdentifierList sublist(int from, int to) {
            return (jcs.ast.gen.IdentifierList) super.sublist(from, to);
        }

        public jcs.ast.gen.IdentifierList replace(int ith, Object element) {
            return (jcs.ast.gen.IdentifierList) super.replace(ith, element);
        }

        public jcs.ast.gen.IdentifierList toSet() {
            return (jcs.ast.gen.IdentifierList) super.toSet();
        }

        public jcs.ast.gen.IdentifierList setAdd(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.setAdd(element);
        }

        public jcs.ast.gen.IdentifierList setRemove(jcs.ast.gen.Identifier element) {
            return (jcs.ast.gen.IdentifierList) super.setRemove(element);
        }

        public jcs.ast.gen.IdentifierList setUnion(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.setUnion(list);
        }

        public jcs.ast.gen.IdentifierList setIntersection(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.setIntersection(list);
        }

        public jcs.ast.gen.IdentifierList setWithout(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return (jcs.ast.gen.IdentifierList) super.setWithout(list);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierList(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierList(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.IdentifierList");
            builder.append("( ");
            for(jcs.ast.gen.Identifier element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("IdentifierList");
            builder.append("( ");
            for(jcs.ast.gen.Identifier element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IdentifierList";
        }
    }
}

