package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface IdentifierListNd extends jcs.ast.gen.TypeNd, jcs.ast.gen.JCS.ListNd<jcs.ast.gen.IdentifierList, jcs.ast.gen.IdentifierNd, jcs.ast.gen.Identifier> {

    //----- methods of IdentifierListNd -----

    public jcs.ast.gen.IdentifierList termType();
    public jcs.ast.gen.IdentifierList termTypeOpt();
    public jcs.ast.gen.IdentifierList term();
    public jcs.ast.gen.IdentifierListNd add(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd addAll(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierListNd remove(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd removeAll(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierListNd appBack(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd appFront(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd conc(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierListNd reverse();
    public jcs.ast.gen.IdentifierListNd toSet();
    public jcs.ast.gen.IdentifierListNd setAdd(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd setRemove(jcs.ast.gen.Identifier element);
    public jcs.ast.gen.IdentifierListNd setUnion(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierListNd setWithout(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public jcs.ast.gen.IdentifierListNd setIntersection(KatjaList<? extends jcs.ast.gen.Identifier> list);
    public KatjaList<jcs.ast.gen.IdentifierNd> toList();
    public jcs.ast.gen.IdentifierListNd replace(jcs.ast.gen.IdentifierList term);
    public jcs.ast.gen.JCS.NodeNd<?> parent();
    public jcs.ast.gen.TypeNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierListNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.IdentifierNd> implements KatjaList<jcs.ast.gen.IdentifierNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.IdentifierNd... elements) {
            super(elements);

            for(jcs.ast.gen.IdentifierNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort IdentifierNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.IdentifierNd> createInstance(jcs.ast.gen.IdentifierNd[] elements, boolean isSet) {
            for(jcs.ast.gen.IdentifierNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort IdentifierNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.IdentifierNd[] createArray(int size) {
            return new jcs.ast.gen.IdentifierNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.IdentifierNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierListNd.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.IdentifierList, jcs.ast.gen.IdentifierNd, jcs.ast.gen.Identifier> implements jcs.ast.gen.IdentifierListNd {

        //----- methods of Impl -----

        public jcs.ast.gen.IdentifierList termType() {
            return term();
        }

        public jcs.ast.gen.IdentifierList termTypeOpt() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.IdentifierList term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.IdentifierNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.IdentifierNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.IdentifierNd[] createArray(int size) {
            return new jcs.ast.gen.IdentifierNd[size];
        }

        public jcs.ast.gen.IdentifierListNd add(jcs.ast.gen.Identifier element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.IdentifierListNd addAll(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.IdentifierListNd remove(jcs.ast.gen.Identifier element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.IdentifierListNd removeAll(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.IdentifierListNd appBack(jcs.ast.gen.Identifier element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.IdentifierListNd appFront(jcs.ast.gen.Identifier element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.IdentifierListNd conc(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.IdentifierListNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.IdentifierListNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.IdentifierListNd setAdd(jcs.ast.gen.Identifier element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.IdentifierListNd setRemove(jcs.ast.gen.Identifier element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.IdentifierListNd setUnion(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.IdentifierListNd setWithout(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.IdentifierListNd setIntersection(KatjaList<? extends jcs.ast.gen.Identifier> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.IdentifierNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new IdentifierListNd.ListImpl(values);
        }

        public jcs.ast.gen.IdentifierListNd replace(jcs.ast.gen.IdentifierList term) {
            return (jcs.ast.gen.IdentifierListNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.NodeNd<?> parent() {
            return (jcs.ast.gen.JCS.NodeNd<?>) super.parent();
        }

        public jcs.ast.gen.TypeNd lsib() {
            return (jcs.ast.gen.TypeNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierListNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierListNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IdentifierListNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.IdentifierNd> implements KatjaList<jcs.ast.gen.IdentifierNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.IdentifierNd... elements) {
                super(elements);

                for(jcs.ast.gen.IdentifierNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort IdentifierNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.IdentifierNd> createInstance(jcs.ast.gen.IdentifierNd[] elements, boolean isSet) {
                for(jcs.ast.gen.IdentifierNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort IdentifierNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.IdentifierNd[] createArray(int size) {
                return new jcs.ast.gen.IdentifierNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.IdentifierNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

