package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface IdentifierNd extends jcs.ast.gen.ExpressionNd, jcs.ast.gen.IdentifierOptNd, jcs.ast.gen.TypeNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.Identifier> {

    //----- methods of IdentifierNd -----

    public jcs.ast.gen.Identifier termExpression();
    public jcs.ast.gen.Identifier termIdentifierOpt();
    public jcs.ast.gen.Identifier termType();
    public jcs.ast.gen.Identifier termTypeOpt();
    public jcs.ast.gen.Identifier term();
    public jcs.ast.gen.StringNd child0();
    public jcs.ast.gen.IdentifierNd replaceChild0(java.lang.String child0);
    public jcs.ast.gen.StringNd get(int i);
    public int size();
    public jcs.ast.gen.IdentifierNd replace(jcs.ast.gen.Identifier term);
    public jcs.ast.gen.JCS.NodeNd<?> parent();
    public jcs.ast.gen.JCS.SortNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.ExpressionNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOptNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IdentifierNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IdentifierNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.Identifier> implements jcs.ast.gen.IdentifierNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.StringNd _child0 = null;

        //----- methods of Impl -----

        public jcs.ast.gen.Identifier termExpression() {
            return term();
        }

        public jcs.ast.gen.Identifier termIdentifierOpt() {
            return term();
        }

        public jcs.ast.gen.Identifier termType() {
            return term();
        }

        public jcs.ast.gen.Identifier termTypeOpt() {
            return term();
        }

        public jcs.ast.gen.StringNd child0() {
            if(_child0 == null)
                _child0 = jcs.ast.gen.JCS.StringNd(this, _term.child0(), 0);

            return _child0;
        }

        public jcs.ast.gen.IdentifierNd replaceChild0(java.lang.String child0) {
            return replace(_term.replaceChild0(child0));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.Identifier term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.StringNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_child0 == null)
                        _child0 = JCS.StringNd(this, _term.child0(), 0);
                    
                    return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort IdentifierNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort IdentifierNd invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.IdentifierNd replace(jcs.ast.gen.Identifier term) {
            return (jcs.ast.gen.IdentifierNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.NodeNd<?> parent() {
            return (jcs.ast.gen.JCS.NodeNd<?>) super.parent();
        }

        public jcs.ast.gen.JCS.SortNd lsib() {
            return (jcs.ast.gen.JCS.SortNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.ExpressionNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.IdentifierOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIdentifierNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IdentifierNd";
        }
    }
}

