package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface ImportDeclaration extends KatjaTuple {

    //----- methods of ImportDeclaration -----

    public Object get(int i);
    public int size();
    public jcs.ast.gen.ImportDeclaration replace(int pos, Object term);

    //----- nested classes of ImportDeclaration -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImportDeclaration(jcs.ast.gen.ImportDeclaration term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ImportDeclaration.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.ImportDeclaration {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ImportDeclaration invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ImportDeclaration invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.ImportDeclaration replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort ImportDeclaration invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort ImportDeclaration invoked with too large parameter "+pos+", sort has only 0 components");


            return (jcs.ast.gen.ImportDeclaration) JCS.unique(new jcs.ast.gen.ImportDeclaration.Impl(
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.ImportDeclaration");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("ImportDeclaration");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ImportDeclaration";
        }
    }
}

