package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface ImportDeclarationList extends KatjaList<jcs.ast.gen.ImportDeclaration> {

    //----- methods of ImportDeclarationList -----

    public jcs.ast.gen.ImportDeclarationList add(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList addAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationList remove(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationList appBack(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList appFront(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList conc(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationList front();
    public jcs.ast.gen.ImportDeclarationList back();
    public jcs.ast.gen.ImportDeclarationList reverse();
    public jcs.ast.gen.ImportDeclarationList sublist(int from, int to);
    public jcs.ast.gen.ImportDeclarationList replace(int ith, Object element);
    public jcs.ast.gen.ImportDeclarationList toSet();
    public jcs.ast.gen.ImportDeclarationList setAdd(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList setRemove(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);

    //----- nested classes of ImportDeclarationList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImportDeclaration(jcs.ast.gen.ImportDeclaration term) throws E;
        public void visitImportDeclarationList(jcs.ast.gen.ImportDeclarationList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ImportDeclarationList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.ImportDeclaration> implements jcs.ast.gen.ImportDeclarationList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.ImportDeclaration... elements) {
            super(elements);

            for(jcs.ast.gen.ImportDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ImportDeclarationList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.ImportDeclarationList createInstance(jcs.ast.gen.ImportDeclaration[] elements, boolean isSet) {
            for(jcs.ast.gen.ImportDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ImportDeclarationList invoked with null element");

            ImportDeclarationList.Impl temp = new jcs.ast.gen.ImportDeclarationList.Impl();
            temp.values = elements;
            temp = (ImportDeclarationList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.ImportDeclaration[] createArray(int size) {
            return new jcs.ast.gen.ImportDeclaration[size];
        }

        public jcs.ast.gen.ImportDeclarationList add(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.add(element);
        }

        public jcs.ast.gen.ImportDeclarationList addAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.addAll(list);
        }

        public jcs.ast.gen.ImportDeclarationList remove(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.remove(element);
        }

        public jcs.ast.gen.ImportDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.removeAll(list);
        }

        public jcs.ast.gen.ImportDeclarationList appBack(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.appBack(element);
        }

        public jcs.ast.gen.ImportDeclarationList appFront(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.appFront(element);
        }

        public jcs.ast.gen.ImportDeclarationList conc(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.conc(list);
        }

        public jcs.ast.gen.ImportDeclarationList front() {
            return (jcs.ast.gen.ImportDeclarationList) super.front();
        }

        public jcs.ast.gen.ImportDeclarationList back() {
            return (jcs.ast.gen.ImportDeclarationList) super.back();
        }

        public jcs.ast.gen.ImportDeclarationList reverse() {
            return (jcs.ast.gen.ImportDeclarationList) super.reverse();
        }

        public jcs.ast.gen.ImportDeclarationList sublist(int from, int to) {
            return (jcs.ast.gen.ImportDeclarationList) super.sublist(from, to);
        }

        public jcs.ast.gen.ImportDeclarationList replace(int ith, Object element) {
            return (jcs.ast.gen.ImportDeclarationList) super.replace(ith, element);
        }

        public jcs.ast.gen.ImportDeclarationList toSet() {
            return (jcs.ast.gen.ImportDeclarationList) super.toSet();
        }

        public jcs.ast.gen.ImportDeclarationList setAdd(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.setAdd(element);
        }

        public jcs.ast.gen.ImportDeclarationList setRemove(jcs.ast.gen.ImportDeclaration element) {
            return (jcs.ast.gen.ImportDeclarationList) super.setRemove(element);
        }

        public jcs.ast.gen.ImportDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.setUnion(list);
        }

        public jcs.ast.gen.ImportDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.setIntersection(list);
        }

        public jcs.ast.gen.ImportDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return (jcs.ast.gen.ImportDeclarationList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.ImportDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.ImportDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ImportDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.ImportDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ImportDeclarationList";
        }
    }
}

