package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ImportDeclarationListNd extends jcs.ast.gen.JCS.ListNd<jcs.ast.gen.ImportDeclarationList, jcs.ast.gen.ImportDeclarationNd, jcs.ast.gen.ImportDeclaration> {

    //----- methods of ImportDeclarationListNd -----

    public jcs.ast.gen.ImportDeclarationList term();
    public jcs.ast.gen.ImportDeclarationListNd add(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationListNd remove(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationListNd appBack(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd appFront(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationListNd reverse();
    public jcs.ast.gen.ImportDeclarationListNd toSet();
    public jcs.ast.gen.ImportDeclarationListNd setAdd(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd setRemove(jcs.ast.gen.ImportDeclaration element);
    public jcs.ast.gen.ImportDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public jcs.ast.gen.ImportDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list);
    public KatjaList<jcs.ast.gen.ImportDeclarationNd> toList();
    public jcs.ast.gen.ImportDeclarationListNd replace(jcs.ast.gen.ImportDeclarationList term);
    public jcs.ast.gen.BoxSpecificationNd parent();
    public jcs.ast.gen.IdentifierListNd lsib();
    public jcs.ast.gen.BoxDeclarationNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of ImportDeclarationListNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.ImportDeclarationNd> implements KatjaList<jcs.ast.gen.ImportDeclarationNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.ImportDeclarationNd... elements) {
            super(elements);

            for(jcs.ast.gen.ImportDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ImportDeclarationNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.ImportDeclarationNd> createInstance(jcs.ast.gen.ImportDeclarationNd[] elements, boolean isSet) {
            for(jcs.ast.gen.ImportDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ImportDeclarationNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.ImportDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.ImportDeclarationNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.ImportDeclarationNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImportDeclarationNd(jcs.ast.gen.ImportDeclarationNd term) throws E;
        public void visitImportDeclarationListNd(jcs.ast.gen.ImportDeclarationListNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ImportDeclarationListNd.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.ImportDeclarationList, jcs.ast.gen.ImportDeclarationNd, jcs.ast.gen.ImportDeclaration> implements jcs.ast.gen.ImportDeclarationListNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.ImportDeclarationList term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.ImportDeclarationNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.ImportDeclarationNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.ImportDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.ImportDeclarationNd[size];
        }

        public jcs.ast.gen.ImportDeclarationListNd add(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.ImportDeclarationListNd remove(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.ImportDeclarationListNd appBack(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd appFront(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.ImportDeclarationListNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.ImportDeclarationListNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.ImportDeclarationListNd setAdd(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd setRemove(jcs.ast.gen.ImportDeclaration element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.ImportDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.ImportDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.ImportDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.ImportDeclaration> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.ImportDeclarationNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new ImportDeclarationListNd.ListImpl(values);
        }

        public jcs.ast.gen.ImportDeclarationListNd replace(jcs.ast.gen.ImportDeclarationList term) {
            return (jcs.ast.gen.ImportDeclarationListNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.BoxSpecificationNd parent() {
            return (jcs.ast.gen.BoxSpecificationNd) super.parent();
        }

        public jcs.ast.gen.IdentifierListNd lsib() {
            return (jcs.ast.gen.IdentifierListNd) super.lsib();
        }

        public jcs.ast.gen.BoxDeclarationNd rsib() {
            return (jcs.ast.gen.BoxDeclarationNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ImportDeclarationListNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.ImportDeclarationNd> implements KatjaList<jcs.ast.gen.ImportDeclarationNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.ImportDeclarationNd... elements) {
                super(elements);

                for(jcs.ast.gen.ImportDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ImportDeclarationNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.ImportDeclarationNd> createInstance(jcs.ast.gen.ImportDeclarationNd[] elements, boolean isSet) {
                for(jcs.ast.gen.ImportDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ImportDeclarationNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.ImportDeclarationNd[] createArray(int size) {
                return new jcs.ast.gen.ImportDeclarationNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.ImportDeclarationNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

