package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ImportDeclarationNd extends jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.ImportDeclaration> {

    //----- methods of ImportDeclarationNd -----

    public jcs.ast.gen.ImportDeclaration term();
    public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i);
    public int size();
    public jcs.ast.gen.ImportDeclarationNd replace(jcs.ast.gen.ImportDeclaration term);
    public jcs.ast.gen.ImportDeclarationListNd parent();
    public jcs.ast.gen.ImportDeclarationNd lsib();
    public jcs.ast.gen.ImportDeclarationNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of ImportDeclarationNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImportDeclarationNd(jcs.ast.gen.ImportDeclarationNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ImportDeclarationNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.ImportDeclaration> implements jcs.ast.gen.ImportDeclarationNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.ImportDeclaration term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ImportDeclarationNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ImportDeclarationNd invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.ImportDeclarationNd replace(jcs.ast.gen.ImportDeclaration term) {
            return (jcs.ast.gen.ImportDeclarationNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.ImportDeclarationListNd parent() {
            return (jcs.ast.gen.ImportDeclarationListNd) super.parent();
        }

        public jcs.ast.gen.ImportDeclarationNd lsib() {
            return (jcs.ast.gen.ImportDeclarationNd) super.lsib();
        }

        public jcs.ast.gen.ImportDeclarationNd rsib() {
            return (jcs.ast.gen.ImportDeclarationNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ImportDeclarationNd";
        }
    }
}

