package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface IntValue extends jcs.ast.gen.Expression, KatjaTuple {

    //----- methods of IntValue -----

    public java.lang.Integer child0();
    public jcs.ast.gen.IntValue replaceChild0(java.lang.Integer child0);
    public java.lang.Integer get(int i);
    public int size();
    public jcs.ast.gen.IntValue replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IntValue -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitInteger(java.lang.Integer term) throws E;
        public void visitIntValue(jcs.ast.gen.IntValue term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IntValue.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.IntValue {

        //----- attributes of Impl -----

        private java.lang.Integer _child0 = null;

        //----- methods of Impl -----

        public java.lang.Integer child0() {
            return _child0;
        }

        public jcs.ast.gen.IntValue replaceChild0(java.lang.Integer child0) {
            return replace(0, child0);
        }

        Impl(java.lang.Integer child0) {
            if(child0 == null)
                throw new IllegalArgumentException("constructor of sort IntValue invoked with null parameter child0");

            this._child0 = child0;
        }

        public java.lang.Integer get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort IntValue invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort IntValue invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.IntValue replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort IntValue invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort IntValue invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort IntValue invoked with term of incorrect sort, Integer expected");

            return (jcs.ast.gen.IntValue) JCS.unique(new jcs.ast.gen.IntValue.Impl(
                pos == 0 ? (java.lang.Integer) term : _child0
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntValue(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.IntValue");
            builder.append("( ");
            builder.append(_child0.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("IntValue");
            builder.append("( ");
            builder.append(_child0.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IntValue";
        }
    }
}

