package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface IntValueNd extends jcs.ast.gen.ExpressionNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.IntValue> {

    //----- methods of IntValueNd -----

    public jcs.ast.gen.IntValue termExpression();
    public jcs.ast.gen.IntValue term();
    public jcs.ast.gen.IntegerNd child0();
    public jcs.ast.gen.IntValueNd replaceChild0(java.lang.Integer child0);
    public jcs.ast.gen.IntegerNd get(int i);
    public int size();
    public jcs.ast.gen.IntValueNd replace(jcs.ast.gen.IntValue term);
    public jcs.ast.gen.JCS.TupleNd<?> parent();
    public jcs.ast.gen.ExpressionNd lsib();
    public jcs.ast.gen.ExpressionNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.ExpressionNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IntValueNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IntValueNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.IntValue> implements jcs.ast.gen.IntValueNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.IntegerNd _child0 = null;

        //----- methods of Impl -----

        public jcs.ast.gen.IntValue termExpression() {
            return term();
        }

        public jcs.ast.gen.IntegerNd child0() {
            if(_child0 == null)
                _child0 = jcs.ast.gen.JCS.IntegerNd(this, _term.child0(), 0);

            return _child0;
        }

        public jcs.ast.gen.IntValueNd replaceChild0(java.lang.Integer child0) {
            return replace(_term.replaceChild0(child0));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.IntValue term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.IntegerNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_child0 == null)
                        _child0 = JCS.IntegerNd(this, _term.child0(), 0);
                    
                    return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort IntValueNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort IntValueNd invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.IntValueNd replace(jcs.ast.gen.IntValue term) {
            return (jcs.ast.gen.IntValueNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.TupleNd<?> parent() {
            return (jcs.ast.gen.JCS.TupleNd<?>) super.parent();
        }

        public jcs.ast.gen.ExpressionNd lsib() {
            return (jcs.ast.gen.ExpressionNd) super.lsib();
        }

        public jcs.ast.gen.ExpressionNd rsib() {
            return (jcs.ast.gen.ExpressionNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.ExpressionNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntValueNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IntValueNd";
        }
    }
}

