package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface IntersectionType extends jcs.ast.gen.Type, KatjaList<jcs.ast.gen.Type> {

    //----- methods of IntersectionType -----

    public jcs.ast.gen.IntersectionType add(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType addAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionType remove(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType removeAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionType appBack(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType appFront(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType conc(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionType front();
    public jcs.ast.gen.IntersectionType back();
    public jcs.ast.gen.IntersectionType reverse();
    public jcs.ast.gen.IntersectionType sublist(int from, int to);
    public jcs.ast.gen.IntersectionType replace(int ith, Object element);
    public jcs.ast.gen.IntersectionType toSet();
    public jcs.ast.gen.IntersectionType setAdd(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType setRemove(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionType setUnion(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionType setIntersection(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionType setWithout(KatjaList<? extends jcs.ast.gen.Type> list);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IntersectionType -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
        public void visitString(java.lang.String term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IntersectionType.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.Type.Switch<Object, E> variantVisit$Type = new jcs.ast.gen.Type.Switch<Object, E>() { public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$Type);
        }
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.Type> implements jcs.ast.gen.IntersectionType {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.Type... elements) {
            super(elements);

            for(jcs.ast.gen.Type element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IntersectionType invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.IntersectionType createInstance(jcs.ast.gen.Type[] elements, boolean isSet) {
            for(jcs.ast.gen.Type element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IntersectionType invoked with null element");

            IntersectionType.Impl temp = new jcs.ast.gen.IntersectionType.Impl();
            temp.values = elements;
            temp = (IntersectionType.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.Type[] createArray(int size) {
            return new jcs.ast.gen.Type[size];
        }

        public jcs.ast.gen.IntersectionType add(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.add(element);
        }

        public jcs.ast.gen.IntersectionType addAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.addAll(list);
        }

        public jcs.ast.gen.IntersectionType remove(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.remove(element);
        }

        public jcs.ast.gen.IntersectionType removeAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.removeAll(list);
        }

        public jcs.ast.gen.IntersectionType appBack(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.appBack(element);
        }

        public jcs.ast.gen.IntersectionType appFront(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.appFront(element);
        }

        public jcs.ast.gen.IntersectionType conc(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.conc(list);
        }

        public jcs.ast.gen.IntersectionType front() {
            return (jcs.ast.gen.IntersectionType) super.front();
        }

        public jcs.ast.gen.IntersectionType back() {
            return (jcs.ast.gen.IntersectionType) super.back();
        }

        public jcs.ast.gen.IntersectionType reverse() {
            return (jcs.ast.gen.IntersectionType) super.reverse();
        }

        public jcs.ast.gen.IntersectionType sublist(int from, int to) {
            return (jcs.ast.gen.IntersectionType) super.sublist(from, to);
        }

        public jcs.ast.gen.IntersectionType replace(int ith, Object element) {
            return (jcs.ast.gen.IntersectionType) super.replace(ith, element);
        }

        public jcs.ast.gen.IntersectionType toSet() {
            return (jcs.ast.gen.IntersectionType) super.toSet();
        }

        public jcs.ast.gen.IntersectionType setAdd(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.setAdd(element);
        }

        public jcs.ast.gen.IntersectionType setRemove(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.IntersectionType) super.setRemove(element);
        }

        public jcs.ast.gen.IntersectionType setUnion(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.setUnion(list);
        }

        public jcs.ast.gen.IntersectionType setIntersection(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.setIntersection(list);
        }

        public jcs.ast.gen.IntersectionType setWithout(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.IntersectionType) super.setWithout(list);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntersectionType(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntersectionType(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.IntersectionType");
            builder.append("( ");
            for(jcs.ast.gen.Type element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("IntersectionType");
            builder.append("( ");
            for(jcs.ast.gen.Type element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IntersectionType";
        }
    }
}

