package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface IntersectionTypeNd extends jcs.ast.gen.TypeNd, jcs.ast.gen.JCS.ListNd<jcs.ast.gen.IntersectionType, jcs.ast.gen.TypeNd, jcs.ast.gen.Type> {

    //----- methods of IntersectionTypeNd -----

    public jcs.ast.gen.IntersectionType termType();
    public jcs.ast.gen.IntersectionType termTypeOpt();
    public jcs.ast.gen.IntersectionType term();
    public jcs.ast.gen.IntersectionTypeNd add(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd addAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionTypeNd remove(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd removeAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionTypeNd appBack(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd appFront(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd conc(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionTypeNd reverse();
    public jcs.ast.gen.IntersectionTypeNd toSet();
    public jcs.ast.gen.IntersectionTypeNd setAdd(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd setRemove(jcs.ast.gen.Type element);
    public jcs.ast.gen.IntersectionTypeNd setUnion(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionTypeNd setWithout(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.IntersectionTypeNd setIntersection(KatjaList<? extends jcs.ast.gen.Type> list);
    public KatjaList<jcs.ast.gen.TypeNd> toList();
    public jcs.ast.gen.IntersectionTypeNd replace(jcs.ast.gen.IntersectionType term);
    public jcs.ast.gen.JCS.NodeNd<?> parent();
    public jcs.ast.gen.TypeNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of IntersectionTypeNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.TypeNd> implements KatjaList<jcs.ast.gen.TypeNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.TypeNd... elements) {
            super(elements);

            for(jcs.ast.gen.TypeNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort TypeNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.TypeNd> createInstance(jcs.ast.gen.TypeNd[] elements, boolean isSet) {
            for(jcs.ast.gen.TypeNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort TypeNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.TypeNd[] createArray(int size) {
            return new jcs.ast.gen.TypeNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.TypeNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.IntersectionTypeNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.IntersectionType, jcs.ast.gen.TypeNd, jcs.ast.gen.Type> implements jcs.ast.gen.IntersectionTypeNd {

        //----- methods of Impl -----

        public jcs.ast.gen.IntersectionType termType() {
            return term();
        }

        public jcs.ast.gen.IntersectionType termTypeOpt() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.IntersectionType term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.TypeNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.TypeNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.TypeNd[] createArray(int size) {
            return new jcs.ast.gen.TypeNd[size];
        }

        public jcs.ast.gen.IntersectionTypeNd add(jcs.ast.gen.Type element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.IntersectionTypeNd addAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.IntersectionTypeNd remove(jcs.ast.gen.Type element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.IntersectionTypeNd removeAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.IntersectionTypeNd appBack(jcs.ast.gen.Type element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.IntersectionTypeNd appFront(jcs.ast.gen.Type element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.IntersectionTypeNd conc(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.IntersectionTypeNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.IntersectionTypeNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.IntersectionTypeNd setAdd(jcs.ast.gen.Type element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.IntersectionTypeNd setRemove(jcs.ast.gen.Type element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.IntersectionTypeNd setUnion(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.IntersectionTypeNd setWithout(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.IntersectionTypeNd setIntersection(KatjaList<? extends jcs.ast.gen.Type> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.TypeNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new IntersectionTypeNd.ListImpl(values);
        }

        public jcs.ast.gen.IntersectionTypeNd replace(jcs.ast.gen.IntersectionType term) {
            return (jcs.ast.gen.IntersectionTypeNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.NodeNd<?> parent() {
            return (jcs.ast.gen.JCS.NodeNd<?>) super.parent();
        }

        public jcs.ast.gen.TypeNd lsib() {
            return (jcs.ast.gen.TypeNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntersectionTypeNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseIntersectionTypeNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IntersectionTypeNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.TypeNd> implements KatjaList<jcs.ast.gen.TypeNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.TypeNd... elements) {
                super(elements);

                for(jcs.ast.gen.TypeNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort TypeNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.TypeNd> createInstance(jcs.ast.gen.TypeNd[] elements, boolean isSet) {
                for(jcs.ast.gen.TypeNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort TypeNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.TypeNd[] createArray(int size) {
                return new jcs.ast.gen.TypeNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.TypeNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

