package jcs.ast.gen;

import katja.common.*;
import java.util.*;
import java.io.Reader;
import java.io.IOException;
import java.util.List;
import java.util.TreeMap;

public class JCS extends KatjaSpecification {

    //----- attributes of JCS -----

    private static final Map<jcs.ast.gen.BoxSpecification, jcs.ast.gen.BoxSpecificationNd> _Ndcache = new TreeMap<jcs.ast.gen.BoxSpecification, jcs.ast.gen.BoxSpecificationNd>();
    private static final JCS$Creator _JCS$Creator = new JCS$Creator();

    //----- methods of JCS -----

    static final KatjaTerm unique(KatjaTerm term) {
        if(_termcache.containsKey(term)) return _termcache.get(term);
        _termcache.put(term, term);

        return term;
    }

    public static final jcs.ast.gen.AndExpression AndExpression(jcs.ast.gen.Expression e1, jcs.ast.gen.Expression e2) {
        jcs.ast.gen.AndExpression _temp = new jcs.ast.gen.AndExpression.Impl(e1, e2);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.AndExpression) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.AndExpressionNd AndExpressionNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.AndExpression term, final int pos) {
        return new jcs.ast.gen.AndExpressionNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Assert Assert(jcs.ast.gen.Expression expr) {
        jcs.ast.gen.Assert _temp = new jcs.ast.gen.Assert.Impl(expr);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Assert) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.AssertNd AssertNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Assert term, final int pos) {
        return new jcs.ast.gen.AssertNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Assume Assume(jcs.ast.gen.Expression expr) {
        jcs.ast.gen.Assume _temp = new jcs.ast.gen.Assume.Impl(expr);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Assume) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.AssumeNd AssumeNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Assume term, final int pos) {
        return new jcs.ast.gen.AssumeNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.BasicType BasicType(java.lang.String child0) {
        jcs.ast.gen.BasicType _temp = new jcs.ast.gen.BasicType.Impl(child0);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.BasicType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BasicTypeNd BasicTypeNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.BasicType term, final int pos) {
        return new jcs.ast.gen.BasicTypeNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Block Block(jcs.ast.gen.Statement... elements) {
        jcs.ast.gen.Block _temp = new jcs.ast.gen.Block.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Block) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BlockNd BlockNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Block term, final int pos) {
        return new jcs.ast.gen.BlockNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.BoolValue BoolValue(java.lang.Boolean child0) {
        jcs.ast.gen.BoolValue _temp = new jcs.ast.gen.BoolValue.Impl(child0);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.BoolValue) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BoolValueNd BoolValueNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.BoolValue term, final int pos) {
        return new jcs.ast.gen.BoolValueNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.BooleanNd BooleanNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final java.lang.Boolean term, final int pos) {
        return new jcs.ast.gen.BooleanNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.BoxDeclaration BoxDeclaration(jcs.ast.gen.Identifier ident, jcs.ast.gen.TypeOpt type, jcs.ast.gen.StateDeclarationList states, jcs.ast.gen.MatchDeclarationList matches) {
        jcs.ast.gen.BoxDeclaration _temp = new jcs.ast.gen.BoxDeclaration.Impl(ident, type, states, matches);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.BoxDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.BoxDeclaration BoxDeclaration(jcs.ast.gen.Identifier ident, jcs.ast.gen.TypeOpt type, jcs.ast.gen.StateDeclarationList states, jcs.ast.gen.MatchDeclaration... matches) {
        jcs.ast.gen.MatchDeclarationList _list = jcs.ast.gen.JCS.MatchDeclarationList(matches);
        jcs.ast.gen.BoxDeclaration _temp = new jcs.ast.gen.BoxDeclaration.Impl(ident, type, states, _list);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.BoxDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BoxDeclarationNd BoxDeclarationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.BoxDeclaration term, final int pos) {
        return new jcs.ast.gen.BoxDeclarationNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.BoxSpecification BoxSpecification(jcs.ast.gen.IdentifierList identPackage, jcs.ast.gen.ImportDeclarationList imports, jcs.ast.gen.BoxDeclaration box) {
        jcs.ast.gen.BoxSpecification _temp = new jcs.ast.gen.BoxSpecification.Impl(identPackage, imports, box);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.BoxSpecification) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BoxSpecificationNd BoxSpecificationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.BoxSpecification term, final int pos) {
        return new jcs.ast.gen.BoxSpecificationNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.BoxSpecificationNd BoxSpecificationNd(jcs.ast.gen.BoxSpecification term) {
        if(!_Ndcache.containsKey(term))
            _Ndcache.put(term, new jcs.ast.gen.BoxSpecificationNd.Impl(term));

        return _Ndcache.get(term);
    }

    public static final jcs.ast.gen.Break Break() {
        jcs.ast.gen.Break _temp = new jcs.ast.gen.Break.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Break) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.BreakNd BreakNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Break term, final int pos) {
        return new jcs.ast.gen.BreakNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Call Call(jcs.ast.gen.Type type, jcs.ast.gen.IdentifierOpt identCallee, jcs.ast.gen.Identifier methodName, jcs.ast.gen.ParameterList params, jcs.ast.gen.IdentifierOpt identReturn) {
        jcs.ast.gen.Call _temp = new jcs.ast.gen.Call.Impl(type, identCallee, methodName, params, identReturn);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Call) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.CallNd CallNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Call term, final int pos) {
        return new jcs.ast.gen.CallNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.EmptyStatement EmptyStatement() {
        jcs.ast.gen.EmptyStatement _temp = new jcs.ast.gen.EmptyStatement.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.EmptyStatement) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.EmptyStatementNd EmptyStatementNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.EmptyStatement term, final int pos) {
        return new jcs.ast.gen.EmptyStatementNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.EqExpression EqExpression(jcs.ast.gen.Expression e1, jcs.ast.gen.Expression e2) {
        jcs.ast.gen.EqExpression _temp = new jcs.ast.gen.EqExpression.Impl(e1, e2);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.EqExpression) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.EqExpressionNd EqExpressionNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.EqExpression term, final int pos) {
        return new jcs.ast.gen.EqExpressionNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.ExpressionNd ExpressionNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Expression term, final int pos) {
        return term.Switch(new jcs.ast.gen.Expression.Switch<jcs.ast.gen.ExpressionNd, RuntimeException>() { public final jcs.ast.gen.ExpressionNd CaseOrExpression(jcs.ast.gen.OrExpression term) { return new jcs.ast.gen.OrExpressionNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseAndExpression(jcs.ast.gen.AndExpression term) { return new jcs.ast.gen.AndExpressionNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseEqExpression(jcs.ast.gen.EqExpression term) { return new jcs.ast.gen.EqExpressionNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseNotExpression(jcs.ast.gen.NotExpression term) { return new jcs.ast.gen.NotExpressionNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseLiteral(jcs.ast.gen.Literal term) { return new jcs.ast.gen.LiteralNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseIdentifier(jcs.ast.gen.Identifier term) { return new jcs.ast.gen.IdentifierNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseBoolValue(jcs.ast.gen.BoolValue term) { return new jcs.ast.gen.BoolValueNd.Impl(parent, term, pos); } public final jcs.ast.gen.ExpressionNd CaseIntValue(jcs.ast.gen.IntValue term) { return new jcs.ast.gen.IntValueNd.Impl(parent, term, pos); } });
    }

    public static final jcs.ast.gen.Identifier Identifier(java.lang.String child0) {
        jcs.ast.gen.Identifier _temp = new jcs.ast.gen.Identifier.Impl(child0);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Identifier) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.IdentifierList IdentifierList(jcs.ast.gen.Identifier... elements) {
        jcs.ast.gen.IdentifierList _temp = new jcs.ast.gen.IdentifierList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.IdentifierList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.IdentifierListNd IdentifierListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.IdentifierList term, final int pos) {
        return new jcs.ast.gen.IdentifierListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.IdentifierNd IdentifierNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Identifier term, final int pos) {
        return new jcs.ast.gen.IdentifierNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.IdentifierNone IdentifierNone() {
        jcs.ast.gen.IdentifierNone _temp = new jcs.ast.gen.IdentifierNone.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.IdentifierNone) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.IdentifierNoneNd IdentifierNoneNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.IdentifierNone term, final int pos) {
        return new jcs.ast.gen.IdentifierNoneNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.IdentifierOptNd IdentifierOptNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.IdentifierOpt term, final int pos) {
        return term.Switch(new jcs.ast.gen.IdentifierOpt.Switch<jcs.ast.gen.IdentifierOptNd, RuntimeException>() { public final jcs.ast.gen.IdentifierOptNd CaseIdentifier(jcs.ast.gen.Identifier term) { return new jcs.ast.gen.IdentifierNd.Impl(parent, term, pos); } public final jcs.ast.gen.IdentifierOptNd CaseIdentifierNone(jcs.ast.gen.IdentifierNone term) { return new jcs.ast.gen.IdentifierNoneNd.Impl(parent, term, pos); } });
    }

    public static final jcs.ast.gen.ImportDeclaration ImportDeclaration() {
        jcs.ast.gen.ImportDeclaration _temp = new jcs.ast.gen.ImportDeclaration.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.ImportDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.ImportDeclarationList ImportDeclarationList(jcs.ast.gen.ImportDeclaration... elements) {
        jcs.ast.gen.ImportDeclarationList _temp = new jcs.ast.gen.ImportDeclarationList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.ImportDeclarationList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.ImportDeclarationListNd ImportDeclarationListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.ImportDeclarationList term, final int pos) {
        return new jcs.ast.gen.ImportDeclarationListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.ImportDeclarationNd ImportDeclarationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.ImportDeclaration term, final int pos) {
        return new jcs.ast.gen.ImportDeclarationNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.IntValue IntValue(java.lang.Integer child0) {
        jcs.ast.gen.IntValue _temp = new jcs.ast.gen.IntValue.Impl(child0);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.IntValue) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.IntValueNd IntValueNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.IntValue term, final int pos) {
        return new jcs.ast.gen.IntValueNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.IntegerNd IntegerNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final java.lang.Integer term, final int pos) {
        return new jcs.ast.gen.IntegerNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.IntersectionType IntersectionType(jcs.ast.gen.Type... elements) {
        jcs.ast.gen.IntersectionType _temp = new jcs.ast.gen.IntersectionType.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.IntersectionType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.IntersectionTypeNd IntersectionTypeNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.IntersectionType term, final int pos) {
        return new jcs.ast.gen.IntersectionTypeNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Literal Literal(java.lang.String child0) {
        jcs.ast.gen.Literal _temp = new jcs.ast.gen.Literal.Impl(child0);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Literal) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.LiteralNd LiteralNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Literal term, final int pos) {
        return new jcs.ast.gen.LiteralNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Loop Loop(jcs.ast.gen.Statement statement) {
        jcs.ast.gen.Loop _temp = new jcs.ast.gen.Loop.Impl(statement);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Loop) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.LoopNd LoopNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Loop term, final int pos) {
        return new jcs.ast.gen.LoopNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.MatchDeclaration MatchDeclaration(jcs.ast.gen.TypeList types, jcs.ast.gen.MethodDeclarationList methods) {
        jcs.ast.gen.MatchDeclaration _temp = new jcs.ast.gen.MatchDeclaration.Impl(types, methods);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MatchDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.MatchDeclaration MatchDeclaration(jcs.ast.gen.TypeList types, jcs.ast.gen.MethodDeclaration... methods) {
        jcs.ast.gen.MethodDeclarationList _list = jcs.ast.gen.JCS.MethodDeclarationList(methods);
        jcs.ast.gen.MatchDeclaration _temp = new jcs.ast.gen.MatchDeclaration.Impl(types, _list);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MatchDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.MatchDeclarationList MatchDeclarationList(jcs.ast.gen.MatchDeclaration... elements) {
        jcs.ast.gen.MatchDeclarationList _temp = new jcs.ast.gen.MatchDeclarationList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MatchDeclarationList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.MatchDeclarationListNd MatchDeclarationListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.MatchDeclarationList term, final int pos) {
        return new jcs.ast.gen.MatchDeclarationListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.MatchDeclarationNd MatchDeclarationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.MatchDeclaration term, final int pos) {
        return new jcs.ast.gen.MatchDeclarationNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.MethodDeclaration MethodDeclaration(jcs.ast.gen.Type type, jcs.ast.gen.Identifier id, jcs.ast.gen.ParameterList params, jcs.ast.gen.Block block) {
        jcs.ast.gen.MethodDeclaration _temp = new jcs.ast.gen.MethodDeclaration.Impl(type, id, params, block);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MethodDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.MethodDeclaration MethodDeclaration(jcs.ast.gen.Type type, jcs.ast.gen.Identifier id, jcs.ast.gen.ParameterList params, jcs.ast.gen.Statement... block) {
        jcs.ast.gen.Block _list = jcs.ast.gen.JCS.Block(block);
        jcs.ast.gen.MethodDeclaration _temp = new jcs.ast.gen.MethodDeclaration.Impl(type, id, params, _list);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MethodDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.MethodDeclarationList MethodDeclarationList(jcs.ast.gen.MethodDeclaration... elements) {
        jcs.ast.gen.MethodDeclarationList _temp = new jcs.ast.gen.MethodDeclarationList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.MethodDeclarationList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.MethodDeclarationListNd MethodDeclarationListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.MethodDeclarationList term, final int pos) {
        return new jcs.ast.gen.MethodDeclarationListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.MethodDeclarationNd MethodDeclarationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.MethodDeclaration term, final int pos) {
        return new jcs.ast.gen.MethodDeclarationNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.NeqExpression NeqExpression(jcs.ast.gen.Expression e1, jcs.ast.gen.Expression e2) {
        jcs.ast.gen.NeqExpression _temp = new jcs.ast.gen.NeqExpression.Impl(e1, e2);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.NeqExpression) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.NotExpression NotExpression(jcs.ast.gen.Expression e) {
        jcs.ast.gen.NotExpression _temp = new jcs.ast.gen.NotExpression.Impl(e);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.NotExpression) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.NotExpressionNd NotExpressionNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.NotExpression term, final int pos) {
        return new jcs.ast.gen.NotExpressionNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Or Or(jcs.ast.gen.Statement... elements) {
        jcs.ast.gen.Or _temp = new jcs.ast.gen.Or.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Or) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.OrExpression OrExpression(jcs.ast.gen.Expression e1, jcs.ast.gen.Expression e2) {
        jcs.ast.gen.OrExpression _temp = new jcs.ast.gen.OrExpression.Impl(e1, e2);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.OrExpression) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.OrExpressionNd OrExpressionNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.OrExpression term, final int pos) {
        return new jcs.ast.gen.OrExpressionNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.OrNd OrNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Or term, final int pos) {
        return new jcs.ast.gen.OrNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.Parameter Parameter(jcs.ast.gen.Type type, jcs.ast.gen.IdentifierOpt ident) {
        jcs.ast.gen.Parameter _temp = new jcs.ast.gen.Parameter.Impl(type, ident);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.Parameter) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.ParameterList ParameterList(jcs.ast.gen.Parameter... elements) {
        jcs.ast.gen.ParameterList _temp = new jcs.ast.gen.ParameterList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.ParameterList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.ParameterListNd ParameterListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.ParameterList term, final int pos) {
        return new jcs.ast.gen.ParameterListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.ParameterNd ParameterNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Parameter term, final int pos) {
        return new jcs.ast.gen.ParameterNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.StateDeclaration StateDeclaration(jcs.ast.gen.Identifier ident, jcs.ast.gen.IdentifierList idents) {
        jcs.ast.gen.StateDeclaration _temp = new jcs.ast.gen.StateDeclaration.Impl(ident, idents);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.StateDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.StateDeclaration StateDeclaration(jcs.ast.gen.Identifier ident, jcs.ast.gen.Identifier... idents) {
        jcs.ast.gen.IdentifierList _list = jcs.ast.gen.JCS.IdentifierList(idents);
        jcs.ast.gen.StateDeclaration _temp = new jcs.ast.gen.StateDeclaration.Impl(ident, _list);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.StateDeclaration) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final jcs.ast.gen.StateDeclarationList StateDeclarationList(jcs.ast.gen.StateDeclaration... elements) {
        jcs.ast.gen.StateDeclarationList _temp = new jcs.ast.gen.StateDeclarationList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.StateDeclarationList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.StateDeclarationListNd StateDeclarationListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.StateDeclarationList term, final int pos) {
        return new jcs.ast.gen.StateDeclarationListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.StateDeclarationNd StateDeclarationNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.StateDeclaration term, final int pos) {
        return new jcs.ast.gen.StateDeclarationNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.StatementNd StatementNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Statement term, final int pos) {
        return term.Switch(new jcs.ast.gen.Statement.Switch<jcs.ast.gen.StatementNd, RuntimeException>() { public final jcs.ast.gen.StatementNd CaseOr(jcs.ast.gen.Or term) { return new jcs.ast.gen.OrNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseLoop(jcs.ast.gen.Loop term) { return new jcs.ast.gen.LoopNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseBlock(jcs.ast.gen.Block term) { return new jcs.ast.gen.BlockNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseAssume(jcs.ast.gen.Assume term) { return new jcs.ast.gen.AssumeNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseAssert(jcs.ast.gen.Assert term) { return new jcs.ast.gen.AssertNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseCall(jcs.ast.gen.Call term) { return new jcs.ast.gen.CallNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseEmptyStatement(jcs.ast.gen.EmptyStatement term) { return new jcs.ast.gen.EmptyStatementNd.Impl(parent, term, pos); } public final jcs.ast.gen.StatementNd CaseBreak(jcs.ast.gen.Break term) { return new jcs.ast.gen.BreakNd.Impl(parent, term, pos); } });
    }

    static final jcs.ast.gen.StringNd StringNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final java.lang.String term, final int pos) {
        return new jcs.ast.gen.StringNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.TypeList TypeList(jcs.ast.gen.Type... elements) {
        jcs.ast.gen.TypeList _temp = new jcs.ast.gen.TypeList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.TypeList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.TypeListNd TypeListNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.TypeList term, final int pos) {
        return new jcs.ast.gen.TypeListNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.TypeNd TypeNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.Type term, final int pos) {
        return term.Switch(new jcs.ast.gen.Type.Switch<jcs.ast.gen.TypeNd, RuntimeException>() { public final jcs.ast.gen.TypeNd CaseWildcardOne(jcs.ast.gen.WildcardOne term) { return new jcs.ast.gen.WildcardOneNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeNd CaseWildcardAny(jcs.ast.gen.WildcardAny term) { return new jcs.ast.gen.WildcardAnyNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeNd CaseIdentifier(jcs.ast.gen.Identifier term) { return new jcs.ast.gen.IdentifierNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeNd CaseIdentifierList(jcs.ast.gen.IdentifierList term) { return new jcs.ast.gen.IdentifierListNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeNd CaseIntersectionType(jcs.ast.gen.IntersectionType term) { return new jcs.ast.gen.IntersectionTypeNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeNd CaseBasicType(jcs.ast.gen.BasicType term) { return new jcs.ast.gen.BasicTypeNd.Impl(parent, term, pos); } });
    }

    public static final jcs.ast.gen.TypeNone TypeNone() {
        jcs.ast.gen.TypeNone _temp = new jcs.ast.gen.TypeNone.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.TypeNone) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.TypeNoneNd TypeNoneNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.TypeNone term, final int pos) {
        return new jcs.ast.gen.TypeNoneNd.Impl(parent, term, pos);
    }

    static final jcs.ast.gen.TypeOptNd TypeOptNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.TypeOpt term, final int pos) {
        return term.Switch(new jcs.ast.gen.TypeOpt.Switch<jcs.ast.gen.TypeOptNd, RuntimeException>() { public final jcs.ast.gen.TypeOptNd CaseTypeNone(jcs.ast.gen.TypeNone term) { return new jcs.ast.gen.TypeNoneNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseWildcardOne(jcs.ast.gen.WildcardOne term) { return new jcs.ast.gen.WildcardOneNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseWildcardAny(jcs.ast.gen.WildcardAny term) { return new jcs.ast.gen.WildcardAnyNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseIdentifier(jcs.ast.gen.Identifier term) { return new jcs.ast.gen.IdentifierNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseIdentifierList(jcs.ast.gen.IdentifierList term) { return new jcs.ast.gen.IdentifierListNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseIntersectionType(jcs.ast.gen.IntersectionType term) { return new jcs.ast.gen.IntersectionTypeNd.Impl(parent, term, pos); } public final jcs.ast.gen.TypeOptNd CaseBasicType(jcs.ast.gen.BasicType term) { return new jcs.ast.gen.BasicTypeNd.Impl(parent, term, pos); } });
    }

    public static final jcs.ast.gen.WildcardAny WildcardAny() {
        jcs.ast.gen.WildcardAny _temp = new jcs.ast.gen.WildcardAny.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.WildcardAny) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.WildcardAnyNd WildcardAnyNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.WildcardAny term, final int pos) {
        return new jcs.ast.gen.WildcardAnyNd.Impl(parent, term, pos);
    }

    public static final jcs.ast.gen.WildcardOne WildcardOne() {
        jcs.ast.gen.WildcardOne _temp = new jcs.ast.gen.WildcardOne.Impl();
        if(_termcache.containsKey(_temp)) return (jcs.ast.gen.WildcardOne) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final jcs.ast.gen.WildcardOneNd WildcardOneNd(final KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, final jcs.ast.gen.WildcardOne term, final int pos) {
        return new jcs.ast.gen.WildcardOneNd.Impl(parent, term, pos);
    }

    public static final KatjaElement fromAssembler(Reader reader) throws IOException {
        return parseInternal(reader, _JCS$Creator);
    }

    //----- nested classes of JCS -----

    public static interface SortNd extends KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> {

        //----- methods of SortNd -----

        public JCS.SortNd parent();
        public JCS.SortNd lsib();
        public JCS.SortNd rsib();
        public JCS.SortNd preOrder();
        public JCS.SortNd preOrderSkip();
        public JCS.SortNd postOrder();
        public JCS.SortNd postOrderStart();
        public JCS.SortNd follow(List<Integer> path);
    }

    public static interface TermNd<T> extends JCS.SortNd, KatjaTermPos<jcs.ast.gen.BoxSpecificationNd, T> {
    }

    public static interface NodeNd<T extends KatjaTerm> extends JCS.TermNd<T>, KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, T> {
    }

    public static interface LeafNd<T> extends JCS.TermNd<T>, KatjaLeafPos<jcs.ast.gen.BoxSpecificationNd, T> {
    }

    public static interface TupleNd<T extends KatjaTuple> extends JCS.NodeNd<T>, KatjaTuplePos<jcs.ast.gen.BoxSpecificationNd, T> {
    }

    public static interface ListNd<T extends KatjaList<E>, L extends KatjaSortPos<jcs.ast.gen.BoxSpecificationNd>, E> extends JCS.NodeNd<T>, KatjaListPos<jcs.ast.gen.BoxSpecificationNd, T, L, E> {
    }

    private static final class JCS$Creator implements KatjaSpecification.ElementCreator {

        //----- attributes of JCS$Creator -----

        private TreeMap<String, Integer> _sortnumber = new TreeMap<String, Integer>();

        //----- methods of JCS$Creator -----

        JCS$Creator() {
            _sortnumber.put("AndExpression", 0);
            _sortnumber.put("Assert", 1);
            _sortnumber.put("Assume", 2);
            _sortnumber.put("BasicType", 3);
            _sortnumber.put("BoolValue", 4);
            _sortnumber.put("BoxDeclaration", 5);
            _sortnumber.put("BoxSpecification", 6);
            _sortnumber.put("Break", 7);
            _sortnumber.put("Call", 8);
            _sortnumber.put("EmptyStatement", 9);
            _sortnumber.put("EqExpression", 10);
            _sortnumber.put("Identifier", 11);
            _sortnumber.put("IdentifierNone", 12);
            _sortnumber.put("ImportDeclaration", 13);
            _sortnumber.put("IntValue", 14);
            _sortnumber.put("Literal", 15);
            _sortnumber.put("Loop", 16);
            _sortnumber.put("MatchDeclaration", 17);
            _sortnumber.put("MethodDeclaration", 18);
            _sortnumber.put("NeqExpression", 19);
            _sortnumber.put("NotExpression", 20);
            _sortnumber.put("OrExpression", 21);
            _sortnumber.put("Parameter", 22);
            _sortnumber.put("StateDeclaration", 23);
            _sortnumber.put("TypeNone", 24);
            _sortnumber.put("WildcardAny", 25);
            _sortnumber.put("WildcardOne", 26);
            _sortnumber.put("Block", 27);
            _sortnumber.put("IdentifierList", 28);
            _sortnumber.put("ImportDeclarationList", 29);
            _sortnumber.put("IntersectionType", 30);
            _sortnumber.put("MatchDeclarationList", 31);
            _sortnumber.put("MethodDeclarationList", 32);
            _sortnumber.put("Or", 33);
            _sortnumber.put("ParameterList", 34);
            _sortnumber.put("StateDeclarationList", 35);
            _sortnumber.put("TypeList", 36);
            _sortnumber.put("BoxSpecificationNd", 37);
        }

        public final KatjaElement create(String name, Object[] parameters, int line) {
            if(!_sortnumber.containsKey(name))
                throw new IllegalArgumentException("unknown sort name "+name+", in line "+line);

            switch(_sortnumber.get(name)) {
                case 0:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort AndExpression, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of AndExpression constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of AndExpression constructor, in line "+line);
                    return jcs.ast.gen.JCS.AndExpression((jcs.ast.gen.Expression) parameters[0], (jcs.ast.gen.Expression) parameters[1]);
                case 1:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Assert, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Assert constructor, in line "+line);
                    return jcs.ast.gen.JCS.Assert((jcs.ast.gen.Expression) parameters[0]);
                case 2:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Assume, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Assume constructor, in line "+line);
                    return jcs.ast.gen.JCS.Assume((jcs.ast.gen.Expression) parameters[0]);
                case 3:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BasicType, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BasicType constructor, in line "+line);
                    return jcs.ast.gen.JCS.BasicType((java.lang.String) parameters[0]);
                case 4:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BoolValue, in line "+line);

                    if(!(parameters[0] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BoolValue constructor, in line "+line);
                    return jcs.ast.gen.JCS.BoolValue((java.lang.Boolean) parameters[0]);
                case 5:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BoxDeclaration, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Identifier))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BoxDeclaration constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.TypeOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of BoxDeclaration constructor, in line "+line);
                    if(!(parameters[2] instanceof jcs.ast.gen.StateDeclarationList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of BoxDeclaration constructor, in line "+line);
                    if(!(parameters[3] instanceof jcs.ast.gen.MatchDeclarationList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of BoxDeclaration constructor, in line "+line);
                    return jcs.ast.gen.JCS.BoxDeclaration((jcs.ast.gen.Identifier) parameters[0], (jcs.ast.gen.TypeOpt) parameters[1], (jcs.ast.gen.StateDeclarationList) parameters[2], (jcs.ast.gen.MatchDeclarationList) parameters[3]);
                case 6:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BoxSpecification, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.IdentifierList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BoxSpecification constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.ImportDeclarationList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of BoxSpecification constructor, in line "+line);
                    if(!(parameters[2] instanceof jcs.ast.gen.BoxDeclaration))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of BoxSpecification constructor, in line "+line);
                    return jcs.ast.gen.JCS.BoxSpecification((jcs.ast.gen.IdentifierList) parameters[0], (jcs.ast.gen.ImportDeclarationList) parameters[1], (jcs.ast.gen.BoxDeclaration) parameters[2]);
                case 7:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Break, in line "+line);

                    return jcs.ast.gen.JCS.Break();
                case 8:
                    if(parameters.length != 5)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Call, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Type))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Call constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.IdentifierOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Call constructor, in line "+line);
                    if(!(parameters[2] instanceof jcs.ast.gen.Identifier))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Call constructor, in line "+line);
                    if(!(parameters[3] instanceof jcs.ast.gen.ParameterList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of Call constructor, in line "+line);
                    if(!(parameters[4] instanceof jcs.ast.gen.IdentifierOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of Call constructor, in line "+line);
                    return jcs.ast.gen.JCS.Call((jcs.ast.gen.Type) parameters[0], (jcs.ast.gen.IdentifierOpt) parameters[1], (jcs.ast.gen.Identifier) parameters[2], (jcs.ast.gen.ParameterList) parameters[3], (jcs.ast.gen.IdentifierOpt) parameters[4]);
                case 9:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort EmptyStatement, in line "+line);

                    return jcs.ast.gen.JCS.EmptyStatement();
                case 10:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort EqExpression, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of EqExpression constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of EqExpression constructor, in line "+line);
                    return jcs.ast.gen.JCS.EqExpression((jcs.ast.gen.Expression) parameters[0], (jcs.ast.gen.Expression) parameters[1]);
                case 11:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Identifier, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Identifier constructor, in line "+line);
                    return jcs.ast.gen.JCS.Identifier((java.lang.String) parameters[0]);
                case 12:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort IdentifierNone, in line "+line);

                    return jcs.ast.gen.JCS.IdentifierNone();
                case 13:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ImportDeclaration, in line "+line);

                    return jcs.ast.gen.JCS.ImportDeclaration();
                case 14:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort IntValue, in line "+line);

                    if(!(parameters[0] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of IntValue constructor, in line "+line);
                    return jcs.ast.gen.JCS.IntValue((java.lang.Integer) parameters[0]);
                case 15:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Literal, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Literal constructor, in line "+line);
                    return jcs.ast.gen.JCS.Literal((java.lang.String) parameters[0]);
                case 16:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Loop, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Statement))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Loop constructor, in line "+line);
                    return jcs.ast.gen.JCS.Loop((jcs.ast.gen.Statement) parameters[0]);
                case 17:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MatchDeclaration, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.TypeList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MatchDeclaration constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.MethodDeclarationList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MatchDeclaration constructor, in line "+line);
                    return jcs.ast.gen.JCS.MatchDeclaration((jcs.ast.gen.TypeList) parameters[0], (jcs.ast.gen.MethodDeclarationList) parameters[1]);
                case 18:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MethodDeclaration, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Type))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MethodDeclaration constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.Identifier))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MethodDeclaration constructor, in line "+line);
                    if(!(parameters[2] instanceof jcs.ast.gen.ParameterList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of MethodDeclaration constructor, in line "+line);
                    if(!(parameters[3] instanceof jcs.ast.gen.Block))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of MethodDeclaration constructor, in line "+line);
                    return jcs.ast.gen.JCS.MethodDeclaration((jcs.ast.gen.Type) parameters[0], (jcs.ast.gen.Identifier) parameters[1], (jcs.ast.gen.ParameterList) parameters[2], (jcs.ast.gen.Block) parameters[3]);
                case 19:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort NeqExpression, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of NeqExpression constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of NeqExpression constructor, in line "+line);
                    return jcs.ast.gen.JCS.NeqExpression((jcs.ast.gen.Expression) parameters[0], (jcs.ast.gen.Expression) parameters[1]);
                case 20:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort NotExpression, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of NotExpression constructor, in line "+line);
                    return jcs.ast.gen.JCS.NotExpression((jcs.ast.gen.Expression) parameters[0]);
                case 21:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort OrExpression, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of OrExpression constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.Expression))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of OrExpression constructor, in line "+line);
                    return jcs.ast.gen.JCS.OrExpression((jcs.ast.gen.Expression) parameters[0], (jcs.ast.gen.Expression) parameters[1]);
                case 22:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Parameter, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Type))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Parameter constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.IdentifierOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Parameter constructor, in line "+line);
                    return jcs.ast.gen.JCS.Parameter((jcs.ast.gen.Type) parameters[0], (jcs.ast.gen.IdentifierOpt) parameters[1]);
                case 23:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort StateDeclaration, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.Identifier))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of StateDeclaration constructor, in line "+line);
                    if(!(parameters[1] instanceof jcs.ast.gen.IdentifierList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of StateDeclaration constructor, in line "+line);
                    return jcs.ast.gen.JCS.StateDeclaration((jcs.ast.gen.Identifier) parameters[0], (jcs.ast.gen.IdentifierList) parameters[1]);
                case 24:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TypeNone, in line "+line);

                    return jcs.ast.gen.JCS.TypeNone();
                case 25:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort WildcardAny, in line "+line);

                    return jcs.ast.gen.JCS.WildcardAny();
                case 26:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort WildcardOne, in line "+line);

                    return jcs.ast.gen.JCS.WildcardOne();
                case 27:
                    jcs.ast.gen.Statement[] _Block$array = new jcs.ast.gen.Statement[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Statement))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for Block constructor, in line "+line);
                        _Block$array[i] = (jcs.ast.gen.Statement) parameters[i];
                    }

                    return jcs.ast.gen.JCS.Block(_Block$array);
                case 28:
                    jcs.ast.gen.Identifier[] _IdentifierList$array = new jcs.ast.gen.Identifier[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Identifier))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IdentifierList constructor, in line "+line);
                        _IdentifierList$array[i] = (jcs.ast.gen.Identifier) parameters[i];
                    }

                    return jcs.ast.gen.JCS.IdentifierList(_IdentifierList$array);
                case 29:
                    jcs.ast.gen.ImportDeclaration[] _ImportDeclarationList$array = new jcs.ast.gen.ImportDeclaration[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.ImportDeclaration))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ImportDeclarationList constructor, in line "+line);
                        _ImportDeclarationList$array[i] = (jcs.ast.gen.ImportDeclaration) parameters[i];
                    }

                    return jcs.ast.gen.JCS.ImportDeclarationList(_ImportDeclarationList$array);
                case 30:
                    jcs.ast.gen.Type[] _IntersectionType$array = new jcs.ast.gen.Type[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Type))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IntersectionType constructor, in line "+line);
                        _IntersectionType$array[i] = (jcs.ast.gen.Type) parameters[i];
                    }

                    return jcs.ast.gen.JCS.IntersectionType(_IntersectionType$array);
                case 31:
                    jcs.ast.gen.MatchDeclaration[] _MatchDeclarationList$array = new jcs.ast.gen.MatchDeclaration[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.MatchDeclaration))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MatchDeclarationList constructor, in line "+line);
                        _MatchDeclarationList$array[i] = (jcs.ast.gen.MatchDeclaration) parameters[i];
                    }

                    return jcs.ast.gen.JCS.MatchDeclarationList(_MatchDeclarationList$array);
                case 32:
                    jcs.ast.gen.MethodDeclaration[] _MethodDeclarationList$array = new jcs.ast.gen.MethodDeclaration[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.MethodDeclaration))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MethodDeclarationList constructor, in line "+line);
                        _MethodDeclarationList$array[i] = (jcs.ast.gen.MethodDeclaration) parameters[i];
                    }

                    return jcs.ast.gen.JCS.MethodDeclarationList(_MethodDeclarationList$array);
                case 33:
                    jcs.ast.gen.Statement[] _Or$array = new jcs.ast.gen.Statement[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Statement))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for Or constructor, in line "+line);
                        _Or$array[i] = (jcs.ast.gen.Statement) parameters[i];
                    }

                    return jcs.ast.gen.JCS.Or(_Or$array);
                case 34:
                    jcs.ast.gen.Parameter[] _ParameterList$array = new jcs.ast.gen.Parameter[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Parameter))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ParameterList constructor, in line "+line);
                        _ParameterList$array[i] = (jcs.ast.gen.Parameter) parameters[i];
                    }

                    return jcs.ast.gen.JCS.ParameterList(_ParameterList$array);
                case 35:
                    jcs.ast.gen.StateDeclaration[] _StateDeclarationList$array = new jcs.ast.gen.StateDeclaration[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.StateDeclaration))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for StateDeclarationList constructor, in line "+line);
                        _StateDeclarationList$array[i] = (jcs.ast.gen.StateDeclaration) parameters[i];
                    }

                    return jcs.ast.gen.JCS.StateDeclarationList(_StateDeclarationList$array);
                case 36:
                    jcs.ast.gen.Type[] _TypeList$array = new jcs.ast.gen.Type[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof jcs.ast.gen.Type))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TypeList constructor, in line "+line);
                        _TypeList$array[i] = (jcs.ast.gen.Type) parameters[i];
                    }

                    return jcs.ast.gen.JCS.TypeList(_TypeList$array);
                case 37:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given root position BoxSpecificationNd, in line "+line);

                    if(!(parameters[0] instanceof jcs.ast.gen.BoxSpecification))
                        throw new IllegalArgumentException("wrong sort on stack as parameter for BoxSpecificationNd constructor, in line "+line);

                    return jcs.ast.gen.JCS.BoxSpecificationNd((jcs.ast.gen.BoxSpecification) parameters[0]);
                default:
                    throw new IllegalStateException("impossible state");
            }
        }
    }
}

