package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface Literal extends jcs.ast.gen.Expression, KatjaTuple {

    //----- methods of Literal -----

    public java.lang.String child0();
    public jcs.ast.gen.Literal replaceChild0(java.lang.String child0);
    public java.lang.String get(int i);
    public int size();
    public jcs.ast.gen.Literal replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E;

    //----- nested classes of Literal -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitLiteral(jcs.ast.gen.Literal term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.Literal.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.Literal {

        //----- attributes of Impl -----

        private java.lang.String _child0 = null;

        //----- methods of Impl -----

        public java.lang.String child0() {
            return _child0;
        }

        public jcs.ast.gen.Literal replaceChild0(java.lang.String child0) {
            return replace(0, child0);
        }

        Impl(java.lang.String child0) {
            if(child0 == null)
                throw new IllegalArgumentException("constructor of sort Literal invoked with null parameter child0");

            this._child0 = child0;
        }

        public java.lang.String get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _child0;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Literal invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Literal invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public jcs.ast.gen.Literal replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Literal invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort Literal invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Literal invoked with term of incorrect sort, String expected");

            return (jcs.ast.gen.Literal) JCS.unique(new jcs.ast.gen.Literal.Impl(
                pos == 0 ? (java.lang.String) term : _child0
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Expression.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseLiteral(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.Literal");
            builder.append("( ");
            builder.append("\"").append(_child0.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Literal");
            builder.append("( ");
            builder.append("\"").append(_child0.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Literal";
        }
    }
}

