package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface MatchDeclarationList extends KatjaList<jcs.ast.gen.MatchDeclaration> {

    //----- methods of MatchDeclarationList -----

    public jcs.ast.gen.MatchDeclarationList add(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList addAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationList remove(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationList appBack(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList appFront(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList conc(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationList front();
    public jcs.ast.gen.MatchDeclarationList back();
    public jcs.ast.gen.MatchDeclarationList reverse();
    public jcs.ast.gen.MatchDeclarationList sublist(int from, int to);
    public jcs.ast.gen.MatchDeclarationList replace(int ith, Object element);
    public jcs.ast.gen.MatchDeclarationList toSet();
    public jcs.ast.gen.MatchDeclarationList setAdd(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList setRemove(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);

    //----- nested classes of MatchDeclarationList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMatchDeclaration(jcs.ast.gen.MatchDeclaration term) throws E;
        public void visitTypeList(jcs.ast.gen.TypeList term) throws E;
        public void visitMethodDeclarationList(jcs.ast.gen.MethodDeclarationList term) throws E;
        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitMethodDeclaration(jcs.ast.gen.MethodDeclaration term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
        public void visitParameterList(jcs.ast.gen.ParameterList term) throws E;
        public void visitBlock(jcs.ast.gen.Block term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitParameter(jcs.ast.gen.Parameter term) throws E;
        public void visitStatement(jcs.ast.gen.Statement term) throws E;
        public void visitOr(jcs.ast.gen.Or term) throws E;
        public void visitLoop(jcs.ast.gen.Loop term) throws E;
        public void visitAssume(jcs.ast.gen.Assume term) throws E;
        public void visitAssert(jcs.ast.gen.Assert term) throws E;
        public void visitCall(jcs.ast.gen.Call term) throws E;
        public void visitEmptyStatement(jcs.ast.gen.EmptyStatement term) throws E;
        public void visitBreak(jcs.ast.gen.Break term) throws E;
        public void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E;
        public void visitExpression(jcs.ast.gen.Expression term) throws E;
        public void visitIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E;
        public void visitOrExpression(jcs.ast.gen.OrExpression term) throws E;
        public void visitAndExpression(jcs.ast.gen.AndExpression term) throws E;
        public void visitEqExpression(jcs.ast.gen.EqExpression term) throws E;
        public void visitNotExpression(jcs.ast.gen.NotExpression term) throws E;
        public void visitLiteral(jcs.ast.gen.Literal term) throws E;
        public void visitBoolValue(jcs.ast.gen.BoolValue term) throws E;
        public void visitIntValue(jcs.ast.gen.IntValue term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitMatchDeclarationList(jcs.ast.gen.MatchDeclarationList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.MatchDeclarationList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.Expression.Switch<Object, E> variantVisit$Expression = new jcs.ast.gen.Expression.Switch<Object, E>() { public final Object CaseOrExpression(jcs.ast.gen.OrExpression term) throws E { visitOrExpression(term); return null; } public final Object CaseAndExpression(jcs.ast.gen.AndExpression term) throws E { visitAndExpression(term); return null; } public final Object CaseEqExpression(jcs.ast.gen.EqExpression term) throws E { visitEqExpression(term); return null; } public final Object CaseNotExpression(jcs.ast.gen.NotExpression term) throws E { visitNotExpression(term); return null; } public final Object CaseLiteral(jcs.ast.gen.Literal term) throws E { visitLiteral(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseBoolValue(jcs.ast.gen.BoolValue term) throws E { visitBoolValue(term); return null; } public final Object CaseIntValue(jcs.ast.gen.IntValue term) throws E { visitIntValue(term); return null; } };
        private final jcs.ast.gen.IdentifierOpt.Switch<Object, E> variantVisit$IdentifierOpt = new jcs.ast.gen.IdentifierOpt.Switch<Object, E>() { public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E { visitIdentifierNone(term); return null; } };
        private final jcs.ast.gen.Statement.Switch<Object, E> variantVisit$Statement = new jcs.ast.gen.Statement.Switch<Object, E>() { public final Object CaseOr(jcs.ast.gen.Or term) throws E { visitOr(term); return null; } public final Object CaseLoop(jcs.ast.gen.Loop term) throws E { visitLoop(term); return null; } public final Object CaseBlock(jcs.ast.gen.Block term) throws E { visitBlock(term); return null; } public final Object CaseAssume(jcs.ast.gen.Assume term) throws E { visitAssume(term); return null; } public final Object CaseAssert(jcs.ast.gen.Assert term) throws E { visitAssert(term); return null; } public final Object CaseCall(jcs.ast.gen.Call term) throws E { visitCall(term); return null; } public final Object CaseEmptyStatement(jcs.ast.gen.EmptyStatement term) throws E { visitEmptyStatement(term); return null; } public final Object CaseBreak(jcs.ast.gen.Break term) throws E { visitBreak(term); return null; } };
        private final jcs.ast.gen.Type.Switch<Object, E> variantVisit$Type = new jcs.ast.gen.Type.Switch<Object, E>() { public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpression(jcs.ast.gen.Expression term) throws E {
            term.Switch(variantVisit$Expression);
        }

        public final void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E {
            term.Switch(variantVisit$IdentifierOpt);
        }

        public final void visitStatement(jcs.ast.gen.Statement term) throws E {
            term.Switch(variantVisit$Statement);
        }

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$Type);
        }
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.MatchDeclaration> implements jcs.ast.gen.MatchDeclarationList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.MatchDeclaration... elements) {
            super(elements);

            for(jcs.ast.gen.MatchDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MatchDeclarationList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.MatchDeclarationList createInstance(jcs.ast.gen.MatchDeclaration[] elements, boolean isSet) {
            for(jcs.ast.gen.MatchDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MatchDeclarationList invoked with null element");

            MatchDeclarationList.Impl temp = new jcs.ast.gen.MatchDeclarationList.Impl();
            temp.values = elements;
            temp = (MatchDeclarationList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.MatchDeclaration[] createArray(int size) {
            return new jcs.ast.gen.MatchDeclaration[size];
        }

        public jcs.ast.gen.MatchDeclarationList add(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.add(element);
        }

        public jcs.ast.gen.MatchDeclarationList addAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.addAll(list);
        }

        public jcs.ast.gen.MatchDeclarationList remove(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.remove(element);
        }

        public jcs.ast.gen.MatchDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.removeAll(list);
        }

        public jcs.ast.gen.MatchDeclarationList appBack(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.appBack(element);
        }

        public jcs.ast.gen.MatchDeclarationList appFront(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.appFront(element);
        }

        public jcs.ast.gen.MatchDeclarationList conc(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.conc(list);
        }

        public jcs.ast.gen.MatchDeclarationList front() {
            return (jcs.ast.gen.MatchDeclarationList) super.front();
        }

        public jcs.ast.gen.MatchDeclarationList back() {
            return (jcs.ast.gen.MatchDeclarationList) super.back();
        }

        public jcs.ast.gen.MatchDeclarationList reverse() {
            return (jcs.ast.gen.MatchDeclarationList) super.reverse();
        }

        public jcs.ast.gen.MatchDeclarationList sublist(int from, int to) {
            return (jcs.ast.gen.MatchDeclarationList) super.sublist(from, to);
        }

        public jcs.ast.gen.MatchDeclarationList replace(int ith, Object element) {
            return (jcs.ast.gen.MatchDeclarationList) super.replace(ith, element);
        }

        public jcs.ast.gen.MatchDeclarationList toSet() {
            return (jcs.ast.gen.MatchDeclarationList) super.toSet();
        }

        public jcs.ast.gen.MatchDeclarationList setAdd(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.setAdd(element);
        }

        public jcs.ast.gen.MatchDeclarationList setRemove(jcs.ast.gen.MatchDeclaration element) {
            return (jcs.ast.gen.MatchDeclarationList) super.setRemove(element);
        }

        public jcs.ast.gen.MatchDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.setUnion(list);
        }

        public jcs.ast.gen.MatchDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.setIntersection(list);
        }

        public jcs.ast.gen.MatchDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return (jcs.ast.gen.MatchDeclarationList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.MatchDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.MatchDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MatchDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.MatchDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MatchDeclarationList";
        }
    }
}

