package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MatchDeclarationListNd extends jcs.ast.gen.JCS.ListNd<jcs.ast.gen.MatchDeclarationList, jcs.ast.gen.MatchDeclarationNd, jcs.ast.gen.MatchDeclaration> {

    //----- methods of MatchDeclarationListNd -----

    public jcs.ast.gen.MatchDeclarationList term();
    public jcs.ast.gen.MatchDeclarationListNd add(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationListNd remove(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationListNd appBack(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd appFront(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationListNd reverse();
    public jcs.ast.gen.MatchDeclarationListNd toSet();
    public jcs.ast.gen.MatchDeclarationListNd setAdd(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd setRemove(jcs.ast.gen.MatchDeclaration element);
    public jcs.ast.gen.MatchDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public jcs.ast.gen.MatchDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list);
    public KatjaList<jcs.ast.gen.MatchDeclarationNd> toList();
    public jcs.ast.gen.MatchDeclarationListNd replace(jcs.ast.gen.MatchDeclarationList term);
    public jcs.ast.gen.BoxDeclarationNd parent();
    public jcs.ast.gen.StateDeclarationListNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of MatchDeclarationListNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.MatchDeclarationNd> implements KatjaList<jcs.ast.gen.MatchDeclarationNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.MatchDeclarationNd... elements) {
            super(elements);

            for(jcs.ast.gen.MatchDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MatchDeclarationNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.MatchDeclarationNd> createInstance(jcs.ast.gen.MatchDeclarationNd[] elements, boolean isSet) {
            for(jcs.ast.gen.MatchDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MatchDeclarationNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.MatchDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.MatchDeclarationNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.MatchDeclarationNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMatchDeclarationNd(jcs.ast.gen.MatchDeclarationNd term) throws E;
        public void visitTypeListNd(jcs.ast.gen.TypeListNd term) throws E;
        public void visitMethodDeclarationListNd(jcs.ast.gen.MethodDeclarationListNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitMethodDeclarationNd(jcs.ast.gen.MethodDeclarationNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
        public void visitBlockNd(jcs.ast.gen.BlockNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitStatementNd(jcs.ast.gen.StatementNd term) throws E;
        public void visitOrNd(jcs.ast.gen.OrNd term) throws E;
        public void visitLoopNd(jcs.ast.gen.LoopNd term) throws E;
        public void visitAssumeNd(jcs.ast.gen.AssumeNd term) throws E;
        public void visitAssertNd(jcs.ast.gen.AssertNd term) throws E;
        public void visitCallNd(jcs.ast.gen.CallNd term) throws E;
        public void visitEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E;
        public void visitBreakNd(jcs.ast.gen.BreakNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
        public void visitMatchDeclarationListNd(jcs.ast.gen.MatchDeclarationListNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.MatchDeclarationListNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };
        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.StatementNd.Switch<Object, E> variantVisit$StatementNd = new jcs.ast.gen.StatementNd.Switch<Object, E>() { public final Object CaseOrNd(jcs.ast.gen.OrNd term) throws E { visitOrNd(term); return null; } public final Object CaseLoopNd(jcs.ast.gen.LoopNd term) throws E { visitLoopNd(term); return null; } public final Object CaseBlockNd(jcs.ast.gen.BlockNd term) throws E { visitBlockNd(term); return null; } public final Object CaseAssumeNd(jcs.ast.gen.AssumeNd term) throws E { visitAssumeNd(term); return null; } public final Object CaseAssertNd(jcs.ast.gen.AssertNd term) throws E { visitAssertNd(term); return null; } public final Object CaseCallNd(jcs.ast.gen.CallNd term) throws E { visitCallNd(term); return null; } public final Object CaseEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E { visitEmptyStatementNd(term); return null; } public final Object CaseBreakNd(jcs.ast.gen.BreakNd term) throws E { visitBreakNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitStatementNd(jcs.ast.gen.StatementNd term) throws E {
            term.Switch(variantVisit$StatementNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.MatchDeclarationList, jcs.ast.gen.MatchDeclarationNd, jcs.ast.gen.MatchDeclaration> implements jcs.ast.gen.MatchDeclarationListNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.MatchDeclarationList term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.MatchDeclarationNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.MatchDeclarationNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.MatchDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.MatchDeclarationNd[size];
        }

        public jcs.ast.gen.MatchDeclarationListNd add(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.MatchDeclarationListNd remove(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.MatchDeclarationListNd appBack(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd appFront(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.MatchDeclarationListNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.MatchDeclarationListNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.MatchDeclarationListNd setAdd(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd setRemove(jcs.ast.gen.MatchDeclaration element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.MatchDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.MatchDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.MatchDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.MatchDeclaration> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.MatchDeclarationNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new MatchDeclarationListNd.ListImpl(values);
        }

        public jcs.ast.gen.MatchDeclarationListNd replace(jcs.ast.gen.MatchDeclarationList term) {
            return (jcs.ast.gen.MatchDeclarationListNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.BoxDeclarationNd parent() {
            return (jcs.ast.gen.BoxDeclarationNd) super.parent();
        }

        public jcs.ast.gen.StateDeclarationListNd lsib() {
            return (jcs.ast.gen.StateDeclarationListNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MatchDeclarationListNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.MatchDeclarationNd> implements KatjaList<jcs.ast.gen.MatchDeclarationNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.MatchDeclarationNd... elements) {
                super(elements);

                for(jcs.ast.gen.MatchDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MatchDeclarationNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.MatchDeclarationNd> createInstance(jcs.ast.gen.MatchDeclarationNd[] elements, boolean isSet) {
                for(jcs.ast.gen.MatchDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MatchDeclarationNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.MatchDeclarationNd[] createArray(int size) {
                return new jcs.ast.gen.MatchDeclarationNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.MatchDeclarationNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

