package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MatchDeclarationNd extends jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.MatchDeclaration> {

    //----- methods of MatchDeclarationNd -----

    public jcs.ast.gen.MatchDeclaration term();
    public jcs.ast.gen.TypeListNd types();
    public jcs.ast.gen.MatchDeclarationNd replaceTypes(jcs.ast.gen.TypeList types);
    public jcs.ast.gen.MethodDeclarationListNd methods();
    public jcs.ast.gen.MatchDeclarationNd replaceMethods(jcs.ast.gen.MethodDeclarationList methods);
    public jcs.ast.gen.JCS.ListNd<?, ?, ?> get(int i);
    public int size();
    public jcs.ast.gen.MatchDeclarationNd replace(jcs.ast.gen.MatchDeclaration term);
    public jcs.ast.gen.MatchDeclarationListNd parent();
    public jcs.ast.gen.MatchDeclarationNd lsib();
    public jcs.ast.gen.MatchDeclarationNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of MatchDeclarationNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTypeListNd(jcs.ast.gen.TypeListNd term) throws E;
        public void visitMethodDeclarationListNd(jcs.ast.gen.MethodDeclarationListNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitMethodDeclarationNd(jcs.ast.gen.MethodDeclarationNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
        public void visitBlockNd(jcs.ast.gen.BlockNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitStatementNd(jcs.ast.gen.StatementNd term) throws E;
        public void visitOrNd(jcs.ast.gen.OrNd term) throws E;
        public void visitLoopNd(jcs.ast.gen.LoopNd term) throws E;
        public void visitAssumeNd(jcs.ast.gen.AssumeNd term) throws E;
        public void visitAssertNd(jcs.ast.gen.AssertNd term) throws E;
        public void visitCallNd(jcs.ast.gen.CallNd term) throws E;
        public void visitEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E;
        public void visitBreakNd(jcs.ast.gen.BreakNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
        public void visitMatchDeclarationNd(jcs.ast.gen.MatchDeclarationNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.MatchDeclarationNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };
        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.StatementNd.Switch<Object, E> variantVisit$StatementNd = new jcs.ast.gen.StatementNd.Switch<Object, E>() { public final Object CaseOrNd(jcs.ast.gen.OrNd term) throws E { visitOrNd(term); return null; } public final Object CaseLoopNd(jcs.ast.gen.LoopNd term) throws E { visitLoopNd(term); return null; } public final Object CaseBlockNd(jcs.ast.gen.BlockNd term) throws E { visitBlockNd(term); return null; } public final Object CaseAssumeNd(jcs.ast.gen.AssumeNd term) throws E { visitAssumeNd(term); return null; } public final Object CaseAssertNd(jcs.ast.gen.AssertNd term) throws E { visitAssertNd(term); return null; } public final Object CaseCallNd(jcs.ast.gen.CallNd term) throws E { visitCallNd(term); return null; } public final Object CaseEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E { visitEmptyStatementNd(term); return null; } public final Object CaseBreakNd(jcs.ast.gen.BreakNd term) throws E { visitBreakNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitStatementNd(jcs.ast.gen.StatementNd term) throws E {
            term.Switch(variantVisit$StatementNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.MatchDeclaration> implements jcs.ast.gen.MatchDeclarationNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.TypeListNd _types = null;
        private jcs.ast.gen.MethodDeclarationListNd _methods = null;

        //----- methods of Impl -----

        public jcs.ast.gen.TypeListNd types() {
            if(_types == null)
                _types = jcs.ast.gen.JCS.TypeListNd(this, _term.types(), 0);

            return _types;
        }

        public jcs.ast.gen.MatchDeclarationNd replaceTypes(jcs.ast.gen.TypeList types) {
            return replace(_term.replaceTypes(types));
        }

        public jcs.ast.gen.MethodDeclarationListNd methods() {
            if(_methods == null)
                _methods = jcs.ast.gen.JCS.MethodDeclarationListNd(this, _term.methods(), 1);

            return _methods;
        }

        public jcs.ast.gen.MatchDeclarationNd replaceMethods(jcs.ast.gen.MethodDeclarationList methods) {
            return replace(_term.replaceMethods(methods));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.MatchDeclaration term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.JCS.ListNd<?, ?, ?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_types == null)
                        _types = JCS.TypeListNd(this, _term.types(), 0);
                    
                    return _types;
                case 1:
                    if(_methods == null)
                        _methods = JCS.MethodDeclarationListNd(this, _term.methods(), 1);
                    
                    return _methods;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MatchDeclarationNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MatchDeclarationNd invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public jcs.ast.gen.MatchDeclarationNd replace(jcs.ast.gen.MatchDeclaration term) {
            return (jcs.ast.gen.MatchDeclarationNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.MatchDeclarationListNd parent() {
            return (jcs.ast.gen.MatchDeclarationListNd) super.parent();
        }

        public jcs.ast.gen.MatchDeclarationNd lsib() {
            return (jcs.ast.gen.MatchDeclarationNd) super.lsib();
        }

        public jcs.ast.gen.MatchDeclarationNd rsib() {
            return (jcs.ast.gen.MatchDeclarationNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MatchDeclarationNd";
        }
    }
}

