package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface ParameterList extends KatjaList<jcs.ast.gen.Parameter> {

    //----- methods of ParameterList -----

    public jcs.ast.gen.ParameterList add(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList addAll(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterList remove(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList removeAll(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterList appBack(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList appFront(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList conc(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterList front();
    public jcs.ast.gen.ParameterList back();
    public jcs.ast.gen.ParameterList reverse();
    public jcs.ast.gen.ParameterList sublist(int from, int to);
    public jcs.ast.gen.ParameterList replace(int ith, Object element);
    public jcs.ast.gen.ParameterList toSet();
    public jcs.ast.gen.ParameterList setAdd(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList setRemove(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterList setUnion(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterList setIntersection(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterList setWithout(KatjaList<? extends jcs.ast.gen.Parameter> list);

    //----- nested classes of ParameterList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitParameter(jcs.ast.gen.Parameter term) throws E;
        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
        public void visitIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitParameterList(jcs.ast.gen.ParameterList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ParameterList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOpt.Switch<Object, E> variantVisit$IdentifierOpt = new jcs.ast.gen.IdentifierOpt.Switch<Object, E>() { public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierNone(jcs.ast.gen.IdentifierNone term) throws E { visitIdentifierNone(term); return null; } };
        private final jcs.ast.gen.Type.Switch<Object, E> variantVisit$Type = new jcs.ast.gen.Type.Switch<Object, E>() { public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOpt(jcs.ast.gen.IdentifierOpt term) throws E {
            term.Switch(variantVisit$IdentifierOpt);
        }

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$Type);
        }
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.Parameter> implements jcs.ast.gen.ParameterList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.Parameter... elements) {
            super(elements);

            for(jcs.ast.gen.Parameter element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ParameterList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.ParameterList createInstance(jcs.ast.gen.Parameter[] elements, boolean isSet) {
            for(jcs.ast.gen.Parameter element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ParameterList invoked with null element");

            ParameterList.Impl temp = new jcs.ast.gen.ParameterList.Impl();
            temp.values = elements;
            temp = (ParameterList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.Parameter[] createArray(int size) {
            return new jcs.ast.gen.Parameter[size];
        }

        public jcs.ast.gen.ParameterList add(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.add(element);
        }

        public jcs.ast.gen.ParameterList addAll(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.addAll(list);
        }

        public jcs.ast.gen.ParameterList remove(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.remove(element);
        }

        public jcs.ast.gen.ParameterList removeAll(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.removeAll(list);
        }

        public jcs.ast.gen.ParameterList appBack(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.appBack(element);
        }

        public jcs.ast.gen.ParameterList appFront(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.appFront(element);
        }

        public jcs.ast.gen.ParameterList conc(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.conc(list);
        }

        public jcs.ast.gen.ParameterList front() {
            return (jcs.ast.gen.ParameterList) super.front();
        }

        public jcs.ast.gen.ParameterList back() {
            return (jcs.ast.gen.ParameterList) super.back();
        }

        public jcs.ast.gen.ParameterList reverse() {
            return (jcs.ast.gen.ParameterList) super.reverse();
        }

        public jcs.ast.gen.ParameterList sublist(int from, int to) {
            return (jcs.ast.gen.ParameterList) super.sublist(from, to);
        }

        public jcs.ast.gen.ParameterList replace(int ith, Object element) {
            return (jcs.ast.gen.ParameterList) super.replace(ith, element);
        }

        public jcs.ast.gen.ParameterList toSet() {
            return (jcs.ast.gen.ParameterList) super.toSet();
        }

        public jcs.ast.gen.ParameterList setAdd(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.setAdd(element);
        }

        public jcs.ast.gen.ParameterList setRemove(jcs.ast.gen.Parameter element) {
            return (jcs.ast.gen.ParameterList) super.setRemove(element);
        }

        public jcs.ast.gen.ParameterList setUnion(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.setUnion(list);
        }

        public jcs.ast.gen.ParameterList setIntersection(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.setIntersection(list);
        }

        public jcs.ast.gen.ParameterList setWithout(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return (jcs.ast.gen.ParameterList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.ParameterList");
            builder.append("( ");
            for(jcs.ast.gen.Parameter element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ParameterList");
            builder.append("( ");
            for(jcs.ast.gen.Parameter element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ParameterList";
        }
    }
}

