package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ParameterListNd extends jcs.ast.gen.JCS.ListNd<jcs.ast.gen.ParameterList, jcs.ast.gen.ParameterNd, jcs.ast.gen.Parameter> {

    //----- methods of ParameterListNd -----

    public jcs.ast.gen.ParameterList term();
    public jcs.ast.gen.ParameterListNd add(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd addAll(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterListNd remove(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd removeAll(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterListNd appBack(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd appFront(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd conc(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterListNd reverse();
    public jcs.ast.gen.ParameterListNd toSet();
    public jcs.ast.gen.ParameterListNd setAdd(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd setRemove(jcs.ast.gen.Parameter element);
    public jcs.ast.gen.ParameterListNd setUnion(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterListNd setWithout(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public jcs.ast.gen.ParameterListNd setIntersection(KatjaList<? extends jcs.ast.gen.Parameter> list);
    public KatjaList<jcs.ast.gen.ParameterNd> toList();
    public jcs.ast.gen.ParameterListNd replace(jcs.ast.gen.ParameterList term);
    public jcs.ast.gen.JCS.TupleNd<?> parent();
    public jcs.ast.gen.IdentifierNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of ParameterListNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.ParameterNd> implements KatjaList<jcs.ast.gen.ParameterNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.ParameterNd... elements) {
            super(elements);

            for(jcs.ast.gen.ParameterNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ParameterNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.ParameterNd> createInstance(jcs.ast.gen.ParameterNd[] elements, boolean isSet) {
            for(jcs.ast.gen.ParameterNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ParameterNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.ParameterNd[] createArray(int size) {
            return new jcs.ast.gen.ParameterNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.ParameterNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ParameterListNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.ParameterList, jcs.ast.gen.ParameterNd, jcs.ast.gen.Parameter> implements jcs.ast.gen.ParameterListNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.ParameterList term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.ParameterNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.ParameterNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.ParameterNd[] createArray(int size) {
            return new jcs.ast.gen.ParameterNd[size];
        }

        public jcs.ast.gen.ParameterListNd add(jcs.ast.gen.Parameter element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.ParameterListNd addAll(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.ParameterListNd remove(jcs.ast.gen.Parameter element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.ParameterListNd removeAll(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.ParameterListNd appBack(jcs.ast.gen.Parameter element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.ParameterListNd appFront(jcs.ast.gen.Parameter element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.ParameterListNd conc(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.ParameterListNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.ParameterListNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.ParameterListNd setAdd(jcs.ast.gen.Parameter element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.ParameterListNd setRemove(jcs.ast.gen.Parameter element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.ParameterListNd setUnion(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.ParameterListNd setWithout(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.ParameterListNd setIntersection(KatjaList<? extends jcs.ast.gen.Parameter> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.ParameterNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new ParameterListNd.ListImpl(values);
        }

        public jcs.ast.gen.ParameterListNd replace(jcs.ast.gen.ParameterList term) {
            return (jcs.ast.gen.ParameterListNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.TupleNd<?> parent() {
            return (jcs.ast.gen.JCS.TupleNd<?>) super.parent();
        }

        public jcs.ast.gen.IdentifierNd lsib() {
            return (jcs.ast.gen.IdentifierNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ParameterListNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.ParameterNd> implements KatjaList<jcs.ast.gen.ParameterNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.ParameterNd... elements) {
                super(elements);

                for(jcs.ast.gen.ParameterNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ParameterNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.ParameterNd> createInstance(jcs.ast.gen.ParameterNd[] elements, boolean isSet) {
                for(jcs.ast.gen.ParameterNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ParameterNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.ParameterNd[] createArray(int size) {
                return new jcs.ast.gen.ParameterNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.ParameterNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

