package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface ParameterNd extends jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.Parameter> {

    //----- methods of ParameterNd -----

    public jcs.ast.gen.Parameter term();
    public jcs.ast.gen.TypeNd type();
    public jcs.ast.gen.ParameterNd replaceType(jcs.ast.gen.Type type);
    public jcs.ast.gen.IdentifierOptNd ident();
    public jcs.ast.gen.ParameterNd replaceIdent(jcs.ast.gen.IdentifierOpt ident);
    public jcs.ast.gen.JCS.SortNd get(int i);
    public int size();
    public jcs.ast.gen.ParameterNd replace(jcs.ast.gen.Parameter term);
    public jcs.ast.gen.ParameterListNd parent();
    public jcs.ast.gen.ParameterNd lsib();
    public jcs.ast.gen.ParameterNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of ParameterNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.ParameterNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.Parameter> implements jcs.ast.gen.ParameterNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.TypeNd _type = null;
        private jcs.ast.gen.IdentifierOptNd _ident = null;

        //----- methods of Impl -----

        public jcs.ast.gen.TypeNd type() {
            if(_type == null)
                _type = jcs.ast.gen.JCS.TypeNd(this, _term.type(), 0);

            return _type;
        }

        public jcs.ast.gen.ParameterNd replaceType(jcs.ast.gen.Type type) {
            return replace(_term.replaceType(type));
        }

        public jcs.ast.gen.IdentifierOptNd ident() {
            if(_ident == null)
                _ident = jcs.ast.gen.JCS.IdentifierOptNd(this, _term.ident(), 1);

            return _ident;
        }

        public jcs.ast.gen.ParameterNd replaceIdent(jcs.ast.gen.IdentifierOpt ident) {
            return replace(_term.replaceIdent(ident));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.Parameter term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.JCS.SortNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_type == null)
                        _type = JCS.TypeNd(this, _term.type(), 0);
                    
                    return _type;
                case 1:
                    if(_ident == null)
                        _ident = JCS.IdentifierOptNd(this, _term.ident(), 1);
                    
                    return _ident;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ParameterNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ParameterNd invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public jcs.ast.gen.ParameterNd replace(jcs.ast.gen.Parameter term) {
            return (jcs.ast.gen.ParameterNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.ParameterListNd parent() {
            return (jcs.ast.gen.ParameterListNd) super.parent();
        }

        public jcs.ast.gen.ParameterNd lsib() {
            return (jcs.ast.gen.ParameterNd) super.lsib();
        }

        public jcs.ast.gen.ParameterNd rsib() {
            return (jcs.ast.gen.ParameterNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ParameterNd";
        }
    }
}

