package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface StateDeclarationList extends KatjaList<jcs.ast.gen.StateDeclaration> {

    //----- methods of StateDeclarationList -----

    public jcs.ast.gen.StateDeclarationList add(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList addAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationList remove(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationList appBack(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList appFront(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList conc(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationList front();
    public jcs.ast.gen.StateDeclarationList back();
    public jcs.ast.gen.StateDeclarationList reverse();
    public jcs.ast.gen.StateDeclarationList sublist(int from, int to);
    public jcs.ast.gen.StateDeclarationList replace(int ith, Object element);
    public jcs.ast.gen.StateDeclarationList toSet();
    public jcs.ast.gen.StateDeclarationList setAdd(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList setRemove(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);

    //----- nested classes of StateDeclarationList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStateDeclaration(jcs.ast.gen.StateDeclaration term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitStateDeclarationList(jcs.ast.gen.StateDeclarationList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.StateDeclarationList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.StateDeclaration> implements jcs.ast.gen.StateDeclarationList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.StateDeclaration... elements) {
            super(elements);

            for(jcs.ast.gen.StateDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort StateDeclarationList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.StateDeclarationList createInstance(jcs.ast.gen.StateDeclaration[] elements, boolean isSet) {
            for(jcs.ast.gen.StateDeclaration element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort StateDeclarationList invoked with null element");

            StateDeclarationList.Impl temp = new jcs.ast.gen.StateDeclarationList.Impl();
            temp.values = elements;
            temp = (StateDeclarationList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.StateDeclaration[] createArray(int size) {
            return new jcs.ast.gen.StateDeclaration[size];
        }

        public jcs.ast.gen.StateDeclarationList add(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.add(element);
        }

        public jcs.ast.gen.StateDeclarationList addAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.addAll(list);
        }

        public jcs.ast.gen.StateDeclarationList remove(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.remove(element);
        }

        public jcs.ast.gen.StateDeclarationList removeAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.removeAll(list);
        }

        public jcs.ast.gen.StateDeclarationList appBack(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.appBack(element);
        }

        public jcs.ast.gen.StateDeclarationList appFront(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.appFront(element);
        }

        public jcs.ast.gen.StateDeclarationList conc(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.conc(list);
        }

        public jcs.ast.gen.StateDeclarationList front() {
            return (jcs.ast.gen.StateDeclarationList) super.front();
        }

        public jcs.ast.gen.StateDeclarationList back() {
            return (jcs.ast.gen.StateDeclarationList) super.back();
        }

        public jcs.ast.gen.StateDeclarationList reverse() {
            return (jcs.ast.gen.StateDeclarationList) super.reverse();
        }

        public jcs.ast.gen.StateDeclarationList sublist(int from, int to) {
            return (jcs.ast.gen.StateDeclarationList) super.sublist(from, to);
        }

        public jcs.ast.gen.StateDeclarationList replace(int ith, Object element) {
            return (jcs.ast.gen.StateDeclarationList) super.replace(ith, element);
        }

        public jcs.ast.gen.StateDeclarationList toSet() {
            return (jcs.ast.gen.StateDeclarationList) super.toSet();
        }

        public jcs.ast.gen.StateDeclarationList setAdd(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.setAdd(element);
        }

        public jcs.ast.gen.StateDeclarationList setRemove(jcs.ast.gen.StateDeclaration element) {
            return (jcs.ast.gen.StateDeclarationList) super.setRemove(element);
        }

        public jcs.ast.gen.StateDeclarationList setUnion(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.setUnion(list);
        }

        public jcs.ast.gen.StateDeclarationList setIntersection(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.setIntersection(list);
        }

        public jcs.ast.gen.StateDeclarationList setWithout(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return (jcs.ast.gen.StateDeclarationList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.StateDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.StateDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("StateDeclarationList");
            builder.append("( ");
            for(jcs.ast.gen.StateDeclaration element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "StateDeclarationList";
        }
    }
}

