package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface StateDeclarationListNd extends jcs.ast.gen.JCS.ListNd<jcs.ast.gen.StateDeclarationList, jcs.ast.gen.StateDeclarationNd, jcs.ast.gen.StateDeclaration> {

    //----- methods of StateDeclarationListNd -----

    public jcs.ast.gen.StateDeclarationList term();
    public jcs.ast.gen.StateDeclarationListNd add(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationListNd remove(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationListNd appBack(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd appFront(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationListNd reverse();
    public jcs.ast.gen.StateDeclarationListNd toSet();
    public jcs.ast.gen.StateDeclarationListNd setAdd(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd setRemove(jcs.ast.gen.StateDeclaration element);
    public jcs.ast.gen.StateDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public jcs.ast.gen.StateDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.StateDeclaration> list);
    public KatjaList<jcs.ast.gen.StateDeclarationNd> toList();
    public jcs.ast.gen.StateDeclarationListNd replace(jcs.ast.gen.StateDeclarationList term);
    public jcs.ast.gen.BoxDeclarationNd parent();
    public jcs.ast.gen.TypeOptNd lsib();
    public jcs.ast.gen.MatchDeclarationListNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of StateDeclarationListNd -----

    static class ListImpl extends KatjaListImpl<jcs.ast.gen.StateDeclarationNd> implements KatjaList<jcs.ast.gen.StateDeclarationNd> {

        //----- methods of ListImpl -----

        ListImpl(jcs.ast.gen.StateDeclarationNd... elements) {
            super(elements);

            for(jcs.ast.gen.StateDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StateDeclarationNd invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<jcs.ast.gen.StateDeclarationNd> createInstance(jcs.ast.gen.StateDeclarationNd[] elements, boolean isSet) {
            for(jcs.ast.gen.StateDeclarationNd element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StateDeclarationNd invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.StateDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.StateDeclarationNd[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(jcs.ast.gen.StateDeclarationNd element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStateDeclarationNd(jcs.ast.gen.StateDeclarationNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitStateDeclarationListNd(jcs.ast.gen.StateDeclarationListNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.StateDeclarationListNd.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.StateDeclarationList, jcs.ast.gen.StateDeclarationNd, jcs.ast.gen.StateDeclaration> implements jcs.ast.gen.StateDeclarationListNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.StateDeclarationList term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.StateDeclarationNd getElementInstance(int pos) {
            return jcs.ast.gen.JCS.StateDeclarationNd(this, _term.get(pos), pos);
        }

        protected jcs.ast.gen.StateDeclarationNd[] createArray(int size) {
            return new jcs.ast.gen.StateDeclarationNd[size];
        }

        public jcs.ast.gen.StateDeclarationListNd add(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.add(element));
        }

        public jcs.ast.gen.StateDeclarationListNd addAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.addAll(list));
        }

        public jcs.ast.gen.StateDeclarationListNd remove(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.remove(element));
        }

        public jcs.ast.gen.StateDeclarationListNd removeAll(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.removeAll(list));
        }

        public jcs.ast.gen.StateDeclarationListNd appBack(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.appBack(element));
        }

        public jcs.ast.gen.StateDeclarationListNd appFront(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.appFront(element));
        }

        public jcs.ast.gen.StateDeclarationListNd conc(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.conc(list));
        }

        public jcs.ast.gen.StateDeclarationListNd reverse() {
            return replace(_term.reverse());
        }

        public jcs.ast.gen.StateDeclarationListNd toSet() {
            return replace(_term.toSet());
        }

        public jcs.ast.gen.StateDeclarationListNd setAdd(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.setAdd(element));
        }

        public jcs.ast.gen.StateDeclarationListNd setRemove(jcs.ast.gen.StateDeclaration element) {
            return replace(_term.setRemove(element));
        }

        public jcs.ast.gen.StateDeclarationListNd setUnion(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.setUnion(list));
        }

        public jcs.ast.gen.StateDeclarationListNd setWithout(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.setWithout(list));
        }

        public jcs.ast.gen.StateDeclarationListNd setIntersection(KatjaList<? extends jcs.ast.gen.StateDeclaration> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<jcs.ast.gen.StateDeclarationNd> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new StateDeclarationListNd.ListImpl(values);
        }

        public jcs.ast.gen.StateDeclarationListNd replace(jcs.ast.gen.StateDeclarationList term) {
            return (jcs.ast.gen.StateDeclarationListNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.BoxDeclarationNd parent() {
            return (jcs.ast.gen.BoxDeclarationNd) super.parent();
        }

        public jcs.ast.gen.TypeOptNd lsib() {
            return (jcs.ast.gen.TypeOptNd) super.lsib();
        }

        public jcs.ast.gen.MatchDeclarationListNd rsib() {
            return (jcs.ast.gen.MatchDeclarationListNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StateDeclarationListNd";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<jcs.ast.gen.StateDeclarationNd> implements KatjaList<jcs.ast.gen.StateDeclarationNd> {

            //----- methods of ListImpl -----

            ListImpl(jcs.ast.gen.StateDeclarationNd... elements) {
                super(elements);

                for(jcs.ast.gen.StateDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StateDeclarationNd invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<jcs.ast.gen.StateDeclarationNd> createInstance(jcs.ast.gen.StateDeclarationNd[] elements, boolean isSet) {
                for(jcs.ast.gen.StateDeclarationNd element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StateDeclarationNd invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) JCS.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected jcs.ast.gen.StateDeclarationNd[] createArray(int size) {
                return new jcs.ast.gen.StateDeclarationNd[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(jcs.ast.gen.StateDeclarationNd element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

