package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface StateDeclarationNd extends jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.StateDeclaration> {

    //----- methods of StateDeclarationNd -----

    public jcs.ast.gen.StateDeclaration term();
    public jcs.ast.gen.IdentifierNd ident();
    public jcs.ast.gen.StateDeclarationNd replaceIdent(jcs.ast.gen.Identifier ident);
    public jcs.ast.gen.IdentifierListNd idents();
    public jcs.ast.gen.StateDeclarationNd replaceIdents(jcs.ast.gen.IdentifierList idents);
    public jcs.ast.gen.TypeNd get(int i);
    public int size();
    public jcs.ast.gen.StateDeclarationNd replace(jcs.ast.gen.StateDeclaration term);
    public jcs.ast.gen.StateDeclarationListNd parent();
    public jcs.ast.gen.StateDeclarationNd lsib();
    public jcs.ast.gen.StateDeclarationNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of StateDeclarationNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitStateDeclarationNd(jcs.ast.gen.StateDeclarationNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.StateDeclarationNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.StateDeclaration> implements jcs.ast.gen.StateDeclarationNd {

        //----- attributes of Impl -----

        private jcs.ast.gen.IdentifierNd _ident = null;
        private jcs.ast.gen.IdentifierListNd _idents = null;

        //----- methods of Impl -----

        public jcs.ast.gen.IdentifierNd ident() {
            if(_ident == null)
                _ident = jcs.ast.gen.JCS.IdentifierNd(this, _term.ident(), 0);

            return _ident;
        }

        public jcs.ast.gen.StateDeclarationNd replaceIdent(jcs.ast.gen.Identifier ident) {
            return replace(_term.replaceIdent(ident));
        }

        public jcs.ast.gen.IdentifierListNd idents() {
            if(_idents == null)
                _idents = jcs.ast.gen.JCS.IdentifierListNd(this, _term.idents(), 1);

            return _idents;
        }

        public jcs.ast.gen.StateDeclarationNd replaceIdents(jcs.ast.gen.IdentifierList idents) {
            return replace(_term.replaceIdents(idents));
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.StateDeclaration term, int pos) {
            super(parent, term, pos);
        }

        public jcs.ast.gen.TypeNd get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_ident == null)
                        _ident = JCS.IdentifierNd(this, _term.ident(), 0);
                    
                    return _ident;
                case 1:
                    if(_idents == null)
                        _idents = JCS.IdentifierListNd(this, _term.idents(), 1);
                    
                    return _idents;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort StateDeclarationNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort StateDeclarationNd invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public jcs.ast.gen.StateDeclarationNd replace(jcs.ast.gen.StateDeclaration term) {
            return (jcs.ast.gen.StateDeclarationNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.StateDeclarationListNd parent() {
            return (jcs.ast.gen.StateDeclarationListNd) super.parent();
        }

        public jcs.ast.gen.StateDeclarationNd lsib() {
            return (jcs.ast.gen.StateDeclarationNd) super.lsib();
        }

        public jcs.ast.gen.StateDeclarationNd rsib() {
            return (jcs.ast.gen.StateDeclarationNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StateDeclarationNd";
        }
    }
}

