package jcs.ast.gen;

import katja.common.*;

public interface StatementNd extends jcs.ast.gen.JCS.SortNd {

    //----- methods of StatementNd -----

    public KatjaSort term();
    public jcs.ast.gen.Statement termStatement();
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.StatementNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of StatementNd -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseOrNd(jcs.ast.gen.OrNd term) throws E;
        public CT CaseLoopNd(jcs.ast.gen.LoopNd term) throws E;
        public CT CaseBlockNd(jcs.ast.gen.BlockNd term) throws E;
        public CT CaseAssumeNd(jcs.ast.gen.AssumeNd term) throws E;
        public CT CaseAssertNd(jcs.ast.gen.AssertNd term) throws E;
        public CT CaseCallNd(jcs.ast.gen.CallNd term) throws E;
        public CT CaseEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E;
        public CT CaseBreakNd(jcs.ast.gen.BreakNd term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStatementNd(jcs.ast.gen.StatementNd term) throws E;
        public void visitOrNd(jcs.ast.gen.OrNd term) throws E;
        public void visitLoopNd(jcs.ast.gen.LoopNd term) throws E;
        public void visitBlockNd(jcs.ast.gen.BlockNd term) throws E;
        public void visitAssumeNd(jcs.ast.gen.AssumeNd term) throws E;
        public void visitAssertNd(jcs.ast.gen.AssertNd term) throws E;
        public void visitCallNd(jcs.ast.gen.CallNd term) throws E;
        public void visitEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E;
        public void visitBreakNd(jcs.ast.gen.BreakNd term) throws E;
        public void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitParameterListNd(jcs.ast.gen.ParameterListNd term) throws E;
        public void visitOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E;
        public void visitAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E;
        public void visitEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E;
        public void visitNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E;
        public void visitLiteralNd(jcs.ast.gen.LiteralNd term) throws E;
        public void visitBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E;
        public void visitIntValueNd(jcs.ast.gen.IntValueNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
        public void visitIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E;
        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitParameterNd(jcs.ast.gen.ParameterNd term) throws E;
        public void visitBooleanNd(jcs.ast.gen.BooleanNd term) throws E;
        public void visitIntegerNd(jcs.ast.gen.IntegerNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.StatementNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.ExpressionNd.Switch<Object, E> variantVisit$ExpressionNd = new jcs.ast.gen.ExpressionNd.Switch<Object, E>() { public final Object CaseOrExpressionNd(jcs.ast.gen.OrExpressionNd term) throws E { visitOrExpressionNd(term); return null; } public final Object CaseAndExpressionNd(jcs.ast.gen.AndExpressionNd term) throws E { visitAndExpressionNd(term); return null; } public final Object CaseEqExpressionNd(jcs.ast.gen.EqExpressionNd term) throws E { visitEqExpressionNd(term); return null; } public final Object CaseNotExpressionNd(jcs.ast.gen.NotExpressionNd term) throws E { visitNotExpressionNd(term); return null; } public final Object CaseLiteralNd(jcs.ast.gen.LiteralNd term) throws E { visitLiteralNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseBoolValueNd(jcs.ast.gen.BoolValueNd term) throws E { visitBoolValueNd(term); return null; } public final Object CaseIntValueNd(jcs.ast.gen.IntValueNd term) throws E { visitIntValueNd(term); return null; } };
        private final jcs.ast.gen.IdentifierOptNd.Switch<Object, E> variantVisit$IdentifierOptNd = new jcs.ast.gen.IdentifierOptNd.Switch<Object, E>() { public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierNoneNd(jcs.ast.gen.IdentifierNoneNd term) throws E { visitIdentifierNoneNd(term); return null; } };
        private final jcs.ast.gen.StatementNd.Switch<Object, E> variantVisit$StatementNd = new jcs.ast.gen.StatementNd.Switch<Object, E>() { public final Object CaseOrNd(jcs.ast.gen.OrNd term) throws E { visitOrNd(term); return null; } public final Object CaseLoopNd(jcs.ast.gen.LoopNd term) throws E { visitLoopNd(term); return null; } public final Object CaseBlockNd(jcs.ast.gen.BlockNd term) throws E { visitBlockNd(term); return null; } public final Object CaseAssumeNd(jcs.ast.gen.AssumeNd term) throws E { visitAssumeNd(term); return null; } public final Object CaseAssertNd(jcs.ast.gen.AssertNd term) throws E { visitAssertNd(term); return null; } public final Object CaseCallNd(jcs.ast.gen.CallNd term) throws E { visitCallNd(term); return null; } public final Object CaseEmptyStatementNd(jcs.ast.gen.EmptyStatementNd term) throws E { visitEmptyStatementNd(term); return null; } public final Object CaseBreakNd(jcs.ast.gen.BreakNd term) throws E { visitBreakNd(term); return null; } };
        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitExpressionNd(jcs.ast.gen.ExpressionNd term) throws E {
            term.Switch(variantVisit$ExpressionNd);
        }

        public final void visitIdentifierOptNd(jcs.ast.gen.IdentifierOptNd term) throws E {
            term.Switch(variantVisit$IdentifierOptNd);
        }

        public final void visitStatementNd(jcs.ast.gen.StatementNd term) throws E {
            term.Switch(variantVisit$StatementNd);
        }

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }
}

