package jcs.ast.gen;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface StringNd extends jcs.ast.gen.JCS.LeafNd<java.lang.String> {

    //----- methods of StringNd -----

    public java.lang.String term();
    public jcs.ast.gen.JCS.TupleNd<?> parent();
    public jcs.ast.gen.JCS.SortNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);

    //----- nested classes of StringNd -----

    static class Impl extends KatjaLeafPosImpl<jcs.ast.gen.BoxSpecificationNd, java.lang.String> implements jcs.ast.gen.StringNd {

        //----- methods of Impl -----

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, java.lang.String term, int pos) {
            super(parent, term, pos);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.TupleNd<?> parent() {
            return (jcs.ast.gen.JCS.TupleNd<?>) super.parent();
        }

        public jcs.ast.gen.JCS.SortNd lsib() {
            return (jcs.ast.gen.JCS.SortNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("\"").append(term().toString()).append("\"");
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StringNd";
        }
    }
}

