package jcs.ast.gen;

import katja.common.*;

public interface Type extends jcs.ast.gen.TypeOpt, KatjaSort {

    //----- methods of Type -----

    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E;

    //----- nested classes of Type -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public CT CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public CT CaseIdentifier(jcs.ast.gen.Identifier term) throws E;
        public CT CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public CT CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public CT CaseBasicType(jcs.ast.gen.BasicType term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.Type.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.Type.Switch<Object, E> variantVisit$Type = new jcs.ast.gen.Type.Switch<Object, E>() { public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$Type);
        }
    }
}

