package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface TypeList extends KatjaList<jcs.ast.gen.Type> {

    //----- methods of TypeList -----

    public jcs.ast.gen.TypeList add(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList addAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.TypeList remove(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList removeAll(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.TypeList appBack(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList appFront(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList conc(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.TypeList front();
    public jcs.ast.gen.TypeList back();
    public jcs.ast.gen.TypeList reverse();
    public jcs.ast.gen.TypeList sublist(int from, int to);
    public jcs.ast.gen.TypeList replace(int ith, Object element);
    public jcs.ast.gen.TypeList toSet();
    public jcs.ast.gen.TypeList setAdd(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList setRemove(jcs.ast.gen.Type element);
    public jcs.ast.gen.TypeList setUnion(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.TypeList setIntersection(KatjaList<? extends jcs.ast.gen.Type> list);
    public jcs.ast.gen.TypeList setWithout(KatjaList<? extends jcs.ast.gen.Type> list);

    //----- nested classes of TypeList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitTypeList(jcs.ast.gen.TypeList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.TypeList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.Type.Switch<Object, E> variantVisit$Type = new jcs.ast.gen.Type.Switch<Object, E>() { public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$Type);
        }
    }

    static class Impl extends KatjaListImpl<jcs.ast.gen.Type> implements jcs.ast.gen.TypeList {

        //----- methods of Impl -----

        Impl(jcs.ast.gen.Type... elements) {
            super(elements);

            for(jcs.ast.gen.Type element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TypeList invoked with null element");
        }

        private Impl() {
        }

        protected jcs.ast.gen.TypeList createInstance(jcs.ast.gen.Type[] elements, boolean isSet) {
            for(jcs.ast.gen.Type element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TypeList invoked with null element");

            TypeList.Impl temp = new jcs.ast.gen.TypeList.Impl();
            temp.values = elements;
            temp = (TypeList.Impl) JCS.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected jcs.ast.gen.Type[] createArray(int size) {
            return new jcs.ast.gen.Type[size];
        }

        public jcs.ast.gen.TypeList add(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.add(element);
        }

        public jcs.ast.gen.TypeList addAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.addAll(list);
        }

        public jcs.ast.gen.TypeList remove(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.remove(element);
        }

        public jcs.ast.gen.TypeList removeAll(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.removeAll(list);
        }

        public jcs.ast.gen.TypeList appBack(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.appBack(element);
        }

        public jcs.ast.gen.TypeList appFront(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.appFront(element);
        }

        public jcs.ast.gen.TypeList conc(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.conc(list);
        }

        public jcs.ast.gen.TypeList front() {
            return (jcs.ast.gen.TypeList) super.front();
        }

        public jcs.ast.gen.TypeList back() {
            return (jcs.ast.gen.TypeList) super.back();
        }

        public jcs.ast.gen.TypeList reverse() {
            return (jcs.ast.gen.TypeList) super.reverse();
        }

        public jcs.ast.gen.TypeList sublist(int from, int to) {
            return (jcs.ast.gen.TypeList) super.sublist(from, to);
        }

        public jcs.ast.gen.TypeList replace(int ith, Object element) {
            return (jcs.ast.gen.TypeList) super.replace(ith, element);
        }

        public jcs.ast.gen.TypeList toSet() {
            return (jcs.ast.gen.TypeList) super.toSet();
        }

        public jcs.ast.gen.TypeList setAdd(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.setAdd(element);
        }

        public jcs.ast.gen.TypeList setRemove(jcs.ast.gen.Type element) {
            return (jcs.ast.gen.TypeList) super.setRemove(element);
        }

        public jcs.ast.gen.TypeList setUnion(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.setUnion(list);
        }

        public jcs.ast.gen.TypeList setIntersection(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.setIntersection(list);
        }

        public jcs.ast.gen.TypeList setWithout(KatjaList<? extends jcs.ast.gen.Type> list) {
            return (jcs.ast.gen.TypeList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("JCS.TypeList");
            builder.append("( ");
            for(jcs.ast.gen.Type element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TypeList");
            builder.append("( ");
            for(jcs.ast.gen.Type element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TypeList";
        }
    }
}

