package jcs.ast.gen;

import katja.common.*;

public interface TypeNd extends jcs.ast.gen.TypeOptNd, jcs.ast.gen.JCS.SortNd {

    //----- methods of TypeNd -----

    public jcs.ast.gen.Type termTypeOpt();
    public KatjaSort term();
    public jcs.ast.gen.Type termType();
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TypeNd -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public CT CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public CT CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public CT CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public CT CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public CT CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringNd(jcs.ast.gen.StringNd term) throws E;
        public void visitIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E;
        public void visitTypeNd(jcs.ast.gen.TypeNd term) throws E;
        public void visitWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E;
        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
        public void visitIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E;
        public void visitIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E;
        public void visitBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.TypeNd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.TypeNd.Switch<Object, E> variantVisit$TypeNd = new jcs.ast.gen.TypeNd.Switch<Object, E>() { public final Object CaseWildcardOneNd(jcs.ast.gen.WildcardOneNd term) throws E { visitWildcardOneNd(term); return null; } public final Object CaseWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E { visitWildcardAnyNd(term); return null; } public final Object CaseIdentifierNd(jcs.ast.gen.IdentifierNd term) throws E { visitIdentifierNd(term); return null; } public final Object CaseIdentifierListNd(jcs.ast.gen.IdentifierListNd term) throws E { visitIdentifierListNd(term); return null; } public final Object CaseIntersectionTypeNd(jcs.ast.gen.IntersectionTypeNd term) throws E { visitIntersectionTypeNd(term); return null; } public final Object CaseBasicTypeNd(jcs.ast.gen.BasicTypeNd term) throws E { visitBasicTypeNd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTypeNd(jcs.ast.gen.TypeNd term) throws E {
            term.Switch(variantVisit$TypeNd);
        }
    }
}

