package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface TypeNoneNd extends jcs.ast.gen.TypeOptNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.TypeNone> {

    //----- methods of TypeNoneNd -----

    public jcs.ast.gen.TypeNone termTypeOpt();
    public jcs.ast.gen.TypeNone term();
    public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i);
    public int size();
    public jcs.ast.gen.TypeNoneNd replace(jcs.ast.gen.TypeNone term);
    public jcs.ast.gen.BoxDeclarationNd parent();
    public jcs.ast.gen.IdentifierNd lsib();
    public jcs.ast.gen.StateDeclarationListNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TypeNoneNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTypeNoneNd(jcs.ast.gen.TypeNoneNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.TypeNoneNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.TypeNone> implements jcs.ast.gen.TypeNoneNd {

        //----- methods of Impl -----

        public jcs.ast.gen.TypeNone termTypeOpt() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.TypeNone term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort TypeNoneNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort TypeNoneNd invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.TypeNoneNd replace(jcs.ast.gen.TypeNone term) {
            return (jcs.ast.gen.TypeNoneNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.BoxDeclarationNd parent() {
            return (jcs.ast.gen.BoxDeclarationNd) super.parent();
        }

        public jcs.ast.gen.IdentifierNd lsib() {
            return (jcs.ast.gen.IdentifierNd) super.lsib();
        }

        public jcs.ast.gen.StateDeclarationListNd rsib() {
            return (jcs.ast.gen.StateDeclarationListNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTypeNoneNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "TypeNoneNd";
        }
    }
}

