package jcs.ast.gen;

import katja.common.*;

public interface TypeOpt extends KatjaSort {

    //----- methods of TypeOpt -----

    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TypeOpt -----

    public static interface Switch<CT, E extends Throwable> extends jcs.ast.gen.Type.Switch<CT, E> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseTypeNone(jcs.ast.gen.TypeNone term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitIdentifier(jcs.ast.gen.Identifier term) throws E;
        public void visitType(jcs.ast.gen.Type term) throws E;
        public void visitWildcardOne(jcs.ast.gen.WildcardOne term) throws E;
        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
        public void visitIdentifierList(jcs.ast.gen.IdentifierList term) throws E;
        public void visitIntersectionType(jcs.ast.gen.IntersectionType term) throws E;
        public void visitBasicType(jcs.ast.gen.BasicType term) throws E;
        public void visitTypeOpt(jcs.ast.gen.TypeOpt term) throws E;
        public void visitTypeNone(jcs.ast.gen.TypeNone term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.TypeOpt.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final jcs.ast.gen.TypeOpt.Switch<Object, E> variantVisit$TypeOpt = new jcs.ast.gen.TypeOpt.Switch<Object, E>() { public final Object CaseTypeNone(jcs.ast.gen.TypeNone term) throws E { visitTypeNone(term); return null; } public final Object CaseWildcardOne(jcs.ast.gen.WildcardOne term) throws E { visitWildcardOne(term); return null; } public final Object CaseWildcardAny(jcs.ast.gen.WildcardAny term) throws E { visitWildcardAny(term); return null; } public final Object CaseIdentifier(jcs.ast.gen.Identifier term) throws E { visitIdentifier(term); return null; } public final Object CaseIdentifierList(jcs.ast.gen.IdentifierList term) throws E { visitIdentifierList(term); return null; } public final Object CaseIntersectionType(jcs.ast.gen.IntersectionType term) throws E { visitIntersectionType(term); return null; } public final Object CaseBasicType(jcs.ast.gen.BasicType term) throws E { visitBasicType(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitType(jcs.ast.gen.Type term) throws E {
            term.Switch(variantVisit$TypeOpt);
        }

        public final void visitTypeOpt(jcs.ast.gen.TypeOpt term) throws E {
            term.Switch(variantVisit$TypeOpt);
        }
    }
}

