package jcs.ast.gen;

import katja.common.*;
import java.io.IOException;

public interface WildcardAny extends jcs.ast.gen.Type, KatjaTuple {

    //----- methods of WildcardAny -----

    public Object get(int i);
    public int size();
    public jcs.ast.gen.WildcardAny replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of WildcardAny -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitWildcardAny(jcs.ast.gen.WildcardAny term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.WildcardAny.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements jcs.ast.gen.WildcardAny {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort WildcardAny invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort WildcardAny invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.WildcardAny replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort WildcardAny invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort WildcardAny invoked with too large parameter "+pos+", sort has only 0 components");


            return (jcs.ast.gen.WildcardAny) JCS.unique(new jcs.ast.gen.WildcardAny.Impl(
            ));
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.Type.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseWildcardAny(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseWildcardAny(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.WildcardAny");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("WildcardAny");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "WildcardAny";
        }
    }
}

