package jcs.ast.gen;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface WildcardAnyNd extends jcs.ast.gen.TypeNd, jcs.ast.gen.JCS.TupleNd<jcs.ast.gen.WildcardAny> {

    //----- methods of WildcardAnyNd -----

    public jcs.ast.gen.WildcardAny termType();
    public jcs.ast.gen.WildcardAny termTypeOpt();
    public jcs.ast.gen.WildcardAny term();
    public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i);
    public int size();
    public jcs.ast.gen.WildcardAnyNd replace(jcs.ast.gen.WildcardAny term);
    public jcs.ast.gen.JCS.NodeNd<?> parent();
    public jcs.ast.gen.TypeNd lsib();
    public jcs.ast.gen.JCS.SortNd rsib();
    public jcs.ast.gen.JCS.SortNd preOrder();
    public jcs.ast.gen.JCS.SortNd preOrderSkip();
    public jcs.ast.gen.JCS.SortNd postOrder();
    public jcs.ast.gen.JCS.SortNd postOrderStart();
    public jcs.ast.gen.JCS.SortNd follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E;

    //----- nested classes of WildcardAnyNd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitWildcardAnyNd(jcs.ast.gen.WildcardAnyNd term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements jcs.ast.gen.WildcardAnyNd.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<jcs.ast.gen.BoxSpecificationNd, jcs.ast.gen.WildcardAny> implements jcs.ast.gen.WildcardAnyNd {

        //----- methods of Impl -----

        public jcs.ast.gen.WildcardAny termType() {
            return term();
        }

        public jcs.ast.gen.WildcardAny termTypeOpt() {
            return term();
        }

        Impl(KatjaNodePos<jcs.ast.gen.BoxSpecificationNd, ?> parent, jcs.ast.gen.WildcardAny term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<jcs.ast.gen.BoxSpecificationNd> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort WildcardAnyNd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort WildcardAnyNd invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public jcs.ast.gen.WildcardAnyNd replace(jcs.ast.gen.WildcardAny term) {
            return (jcs.ast.gen.WildcardAnyNd) super.replace(term);
        }

        protected jcs.ast.gen.BoxSpecificationNd freshRootPosition(KatjaSort term) {
            if(!(term instanceof jcs.ast.gen.BoxSpecification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort BoxSpecification");

            return JCS.BoxSpecificationNd((BoxSpecification) term);
        }

        public jcs.ast.gen.JCS.NodeNd<?> parent() {
            return (jcs.ast.gen.JCS.NodeNd<?>) super.parent();
        }

        public jcs.ast.gen.TypeNd lsib() {
            return (jcs.ast.gen.TypeNd) super.lsib();
        }

        public jcs.ast.gen.JCS.SortNd rsib() {
            return (jcs.ast.gen.JCS.SortNd) super.rsib();
        }

        public jcs.ast.gen.JCS.SortNd preOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrder();
        }

        public jcs.ast.gen.JCS.SortNd preOrderSkip() {
            return (jcs.ast.gen.JCS.SortNd) super.preOrderSkip();
        }

        public jcs.ast.gen.JCS.SortNd postOrder() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrder();
        }

        public jcs.ast.gen.JCS.SortNd postOrderStart() {
            return (jcs.ast.gen.JCS.SortNd) super.postOrderStart();
        }

        public jcs.ast.gen.JCS.SortNd follow(List<Integer> path) {
            return (jcs.ast.gen.JCS.SortNd) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseWildcardAnyNd(this);
        }

        public <CT, E extends Throwable> CT Switch(jcs.ast.gen.TypeOptNd.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseWildcardAnyNd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("JCS.BoxSpecificationNd");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@BoxSpecification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "WildcardAnyNd";
        }
    }
}

