/*
    Katja
    Copyright (C) 2003-2007 see README file for authors

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package katja.common;

public interface KatjaList<L> extends KatjaTerm, Iterable<L> {

    public L first();
    public L last();

    public L get(int i);

    public KatjaList<L> front();
    public KatjaList<L> back();

    public KatjaList<L> conc(KatjaList<? extends L> list);

    public KatjaList<L> appFront(L element);
    public KatjaList<L> appBack(L element)  ;

    public KatjaList<L> add(L element);
    public KatjaList<L> addAll(KatjaList<? extends L> list);

    public KatjaList<L> remove(L element);
    public KatjaList<L> removeAll(KatjaList<? extends L> list);

    public KatjaList<L> sublist(int from, int to);
    public KatjaList<L> reverse();

    public boolean isEmpty();
    public boolean contains(L element);
    public boolean containsAll(KatjaList<? extends L> list);

    public L[] toArray();

    public KatjaList<L> toSet();
    public KatjaList<L> setAdd(L element);
    public KatjaList<L> setRemove(L element);
    public KatjaList<L> setUnion(KatjaList<? extends L> list);
    public KatjaList<L> setIntersection(KatjaList<? extends L> list);
    public KatjaList<L> setWithout(KatjaList<? extends L> list);

    public boolean setEquals(KatjaList<? extends L> list);
}
