/*
    Katja
    Copyright (C) 2003-2007 see README file for authors

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package katja.common;

/**
 * User: paddy
 * Date: Jun 29, 2004
 * Time: 2:55:24 PM
 */
public interface KatjaListPos<R extends KatjaSortPos<R>, T extends KatjaList<E>, L extends KatjaSortPos<R>, E> extends KatjaNodePos<R, T>, Iterable<L> {

    public L first();
    public L last();

    public L get(int ith);

    public KatjaList<L> toList();
    public KatjaList<L> front();
    public KatjaList<L> back();

    public KatjaListPos<R, T, L, E> appFront(E element);
    public KatjaListPos<R, T, L, E> appBack(E element)  ;

    public KatjaListPos<R, T, L, E> add(E element);
    public KatjaListPos<R, T, L, E> addAll(KatjaList<? extends E> list);

    public KatjaListPos<R, T, L, E> conc(KatjaList<? extends E> list);

    public KatjaListPos<R, T, L, E> remove(E element);
    public KatjaListPos<R, T, L, E> removeAll(KatjaList<? extends E> list);

    public KatjaListPos<R, T, L, E> reverse();

    public boolean isEmpty();
    public boolean contains(L element);
    public boolean containsAll(KatjaList<L> list);
    public boolean termContains(KatjaTermPos<?, ? extends E> element);
    public boolean termContainsAll(KatjaListPos<?, KatjaList<? extends E>, ? extends KatjaSortPos<R>, ?> list);

    public KatjaListPos<R, T, L, E> toSet();
    public KatjaListPos<R, T, L, E> setAdd(E element);
    public KatjaListPos<R, T, L, E> setRemove(E element);
    public KatjaListPos<R, T, L, E> setUnion(KatjaList<? extends E> list);
    public KatjaListPos<R, T, L, E> setIntersection(KatjaList<? extends E> list);
    public KatjaListPos<R, T, L, E> setWithout(KatjaList<? extends E> list);

    public KatjaListPos<R, T, L, E> replace(T term);
}
