/*
    Katja
    Copyright (C) 2003-2007 see README file for authors

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package katja.common;

import java.util.Iterator;

/**
 * User: paddy
 * Date: Jan 19, 2006
 * Time: 3:56:16 PM
 */
public interface KatjaSort extends KatjaElement, Comparable<KatjaSort> {

    /**
     * Returns a new term, which is a copy of the current one, with one
     * child replaced by another term. The position of the child, as well
     * as the term to replace it with are given as parameter.
     * The type of the new term can be anything, as tuples and lists can have
     * any Java type as component.
     * @param pos the child position to replace
     * @param term the new child term
     * @return an updated copy of the current term
     */
    public KatjaSort replace(int pos, Object term);


    /**
     * Create an iterator over all subterms of a term. If leaf terms are
     * external Katja elements, this iterator will descend to those elements.
     * @return an iterator over all subterms, in unspecified order
     */
    public Iterator<Object> iterate();
}
