/*
    Katja
    Copyright (C) 2003-2007 see README file for authors

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as
    published by the Free Software Foundation, either version 3 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
package katja.common;

import katja.common.KatjaTuple;
import katja.common.KatjaNodePosImpl;
import katja.common.KatjaSortPos;
import katja.common.KatjaTuplePos;

/**
 * User: paddy
 * Date: Jun 29, 2004
 * Time: 2:36:27 PM
 */
public abstract class KatjaTuplePosImpl<R extends KatjaSortPos<R>, T extends KatjaTuple> extends KatjaNodePosImpl<R, T> implements KatjaTuplePos<R, T> {

    /**
     * Constructor of KatjaTuplePos; There is nothing to add to the super constructor.
     * @param parent reference to parent pos
     */
    public KatjaTuplePosImpl(KatjaSortPos<R> parent, T term, int pos) {
        super(parent, term, pos);
    }

    /**
     * Constructor of KatjaTuplePos as root.
     */
    public KatjaTuplePosImpl(T term) {
        super(term);
    }

    /**
     * Better types the replace method
     * @param term the term to put in place
     * @return types the replace method
     */
    public KatjaTuplePos<R, T> replace(T term) {
        return (KatjaTuplePos<R, T>) super.replace(term);
    }
}
