package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface BackendBlock extends KatjaTuple {

    //----- methods of BackendBlock -----

    public java.lang.Integer line();
    public katja.spec.BackendBlock replaceLine(java.lang.Integer line);
    public java.lang.String backendName();
    public katja.spec.BackendBlock replaceBackendName(java.lang.String backendName);
    public java.lang.String content();
    public katja.spec.BackendBlock replaceContent(java.lang.String content);
    public Object get(int i);
    public int size();
    public katja.spec.BackendBlock replace(int pos, Object term);

    //----- nested classes of BackendBlock -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitInteger(java.lang.Integer term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBackendBlock(katja.spec.BackendBlock term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.BackendBlock.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.BackendBlock {

        //----- attributes of Impl -----

        private java.lang.Integer _line = null;
        private java.lang.String _backendName = null;
        private java.lang.String _content = null;

        //----- methods of Impl -----

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.BackendBlock replaceLine(java.lang.Integer line) {
            return replace(0, line);
        }

        public java.lang.String backendName() {
            return _backendName;
        }

        public katja.spec.BackendBlock replaceBackendName(java.lang.String backendName) {
            return replace(1, backendName);
        }

        public java.lang.String content() {
            return _content;
        }

        public katja.spec.BackendBlock replaceContent(java.lang.String content) {
            return replace(2, content);
        }

        Impl(java.lang.Integer line, java.lang.String backendName, java.lang.String content) {
            if(line == null)
                throw new IllegalArgumentException("constructor of sort BackendBlock invoked with null parameter line");
            if(backendName == null)
                throw new IllegalArgumentException("constructor of sort BackendBlock invoked with null parameter backendName");
            if(content == null)
                throw new IllegalArgumentException("constructor of sort BackendBlock invoked with null parameter content");

            this._line = line;
            this._backendName = backendName;
            this._content = content;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0: return _line;
                case 1: return _backendName;
                case 2: return _content;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort BackendBlock invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort BackendBlock invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.BackendBlock replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort BackendBlock invoked with negative parameter "+pos);
            if(pos >= 3)
                throw new IllegalArgumentException("replace on sort BackendBlock invoked with too large parameter "+pos+", sort has only 3 components");

            if(pos == 0 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort BackendBlock invoked with term of incorrect sort, Integer expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort BackendBlock invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort BackendBlock invoked with term of incorrect sort, String expected");

            return (katja.spec.BackendBlock) Katja.unique(new katja.spec.BackendBlock.Impl(
                pos == 0 ? (java.lang.Integer) term : _line,
                pos == 1 ? (java.lang.String) term : _backendName,
                pos == 2 ? (java.lang.String) term : _content
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.BackendBlock");
            builder.append("( ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append("\"").append(_backendName.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_content.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("BackendBlock");
            builder.append("( ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append("\"").append(_backendName.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_content.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "BackendBlock";
        }
    }
}

