package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface BackendBlockList extends KatjaList<katja.spec.BackendBlock> {

    //----- methods of BackendBlockList -----

    public katja.spec.BackendBlockList add(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList addAll(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockList remove(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList removeAll(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockList appBack(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList appFront(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList conc(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockList front();
    public katja.spec.BackendBlockList back();
    public katja.spec.BackendBlockList reverse();
    public katja.spec.BackendBlockList sublist(int from, int to);
    public katja.spec.BackendBlockList replace(int ith, Object element);
    public katja.spec.BackendBlockList toSet();
    public katja.spec.BackendBlockList setAdd(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList setRemove(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockList setUnion(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockList setIntersection(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockList setWithout(KatjaList<? extends katja.spec.BackendBlock> list);

    //----- nested classes of BackendBlockList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitBackendBlock(katja.spec.BackendBlock term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBackendBlockList(katja.spec.BackendBlockList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.BackendBlockList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.BackendBlock> implements katja.spec.BackendBlockList {

        //----- methods of Impl -----

        Impl(katja.spec.BackendBlock... elements) {
            super(elements);

            for(katja.spec.BackendBlock element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort BackendBlockList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.BackendBlockList createInstance(katja.spec.BackendBlock[] elements, boolean isSet) {
            for(katja.spec.BackendBlock element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort BackendBlockList invoked with null element");

            BackendBlockList.Impl temp = new katja.spec.BackendBlockList.Impl();
            temp.values = elements;
            temp = (BackendBlockList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.BackendBlock[] createArray(int size) {
            return new katja.spec.BackendBlock[size];
        }

        public katja.spec.BackendBlockList add(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.add(element);
        }

        public katja.spec.BackendBlockList addAll(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.addAll(list);
        }

        public katja.spec.BackendBlockList remove(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.remove(element);
        }

        public katja.spec.BackendBlockList removeAll(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.removeAll(list);
        }

        public katja.spec.BackendBlockList appBack(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.appBack(element);
        }

        public katja.spec.BackendBlockList appFront(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.appFront(element);
        }

        public katja.spec.BackendBlockList conc(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.conc(list);
        }

        public katja.spec.BackendBlockList front() {
            return (katja.spec.BackendBlockList) super.front();
        }

        public katja.spec.BackendBlockList back() {
            return (katja.spec.BackendBlockList) super.back();
        }

        public katja.spec.BackendBlockList reverse() {
            return (katja.spec.BackendBlockList) super.reverse();
        }

        public katja.spec.BackendBlockList sublist(int from, int to) {
            return (katja.spec.BackendBlockList) super.sublist(from, to);
        }

        public katja.spec.BackendBlockList replace(int ith, Object element) {
            return (katja.spec.BackendBlockList) super.replace(ith, element);
        }

        public katja.spec.BackendBlockList toSet() {
            return (katja.spec.BackendBlockList) super.toSet();
        }

        public katja.spec.BackendBlockList setAdd(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.setAdd(element);
        }

        public katja.spec.BackendBlockList setRemove(katja.spec.BackendBlock element) {
            return (katja.spec.BackendBlockList) super.setRemove(element);
        }

        public katja.spec.BackendBlockList setUnion(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.setUnion(list);
        }

        public katja.spec.BackendBlockList setIntersection(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.setIntersection(list);
        }

        public katja.spec.BackendBlockList setWithout(KatjaList<? extends katja.spec.BackendBlock> list) {
            return (katja.spec.BackendBlockList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.BackendBlockList");
            builder.append("( ");
            for(katja.spec.BackendBlock element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("BackendBlockList");
            builder.append("( ");
            for(katja.spec.BackendBlock element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "BackendBlockList";
        }
    }
}

