package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface BackendBlockListPos extends katja.spec.Katja.ListPos<katja.spec.BackendBlockList, katja.spec.BackendBlockPos, katja.spec.BackendBlock> {

    //----- methods of BackendBlockListPos -----

    public katja.spec.BackendBlockList term();
    public katja.spec.BackendBlockListPos add(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos addAll(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockListPos remove(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos removeAll(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockListPos appBack(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos appFront(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos conc(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockListPos reverse();
    public katja.spec.BackendBlockListPos toSet();
    public katja.spec.BackendBlockListPos setAdd(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos setRemove(katja.spec.BackendBlock element);
    public katja.spec.BackendBlockListPos setUnion(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockListPos setWithout(KatjaList<? extends katja.spec.BackendBlock> list);
    public katja.spec.BackendBlockListPos setIntersection(KatjaList<? extends katja.spec.BackendBlock> list);
    public KatjaList<katja.spec.BackendBlockPos> toList();
    public katja.spec.BackendBlockListPos replace(katja.spec.BackendBlockList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.StringPos lsib();
    public katja.spec.RootListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of BackendBlockListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.BackendBlockPos> implements KatjaList<katja.spec.BackendBlockPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.BackendBlockPos... elements) {
            super(elements);

            for(katja.spec.BackendBlockPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort BackendBlockPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.BackendBlockPos> createInstance(katja.spec.BackendBlockPos[] elements, boolean isSet) {
            for(katja.spec.BackendBlockPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort BackendBlockPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.BackendBlockPos[] createArray(int size) {
            return new katja.spec.BackendBlockPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.BackendBlockPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitBackendBlockPos(katja.spec.BackendBlockPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBackendBlockListPos(katja.spec.BackendBlockListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.BackendBlockListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.BackendBlockList, katja.spec.BackendBlockPos, katja.spec.BackendBlock> implements katja.spec.BackendBlockListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.BackendBlockList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.BackendBlockPos getElementInstance(int pos) {
            return katja.spec.Katja.BackendBlockPos(this, _term.get(pos), pos);
        }

        protected katja.spec.BackendBlockPos[] createArray(int size) {
            return new katja.spec.BackendBlockPos[size];
        }

        public katja.spec.BackendBlockListPos add(katja.spec.BackendBlock element) {
            return replace(_term.add(element));
        }

        public katja.spec.BackendBlockListPos addAll(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.BackendBlockListPos remove(katja.spec.BackendBlock element) {
            return replace(_term.remove(element));
        }

        public katja.spec.BackendBlockListPos removeAll(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.BackendBlockListPos appBack(katja.spec.BackendBlock element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.BackendBlockListPos appFront(katja.spec.BackendBlock element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.BackendBlockListPos conc(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.BackendBlockListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.BackendBlockListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.BackendBlockListPos setAdd(katja.spec.BackendBlock element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.BackendBlockListPos setRemove(katja.spec.BackendBlock element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.BackendBlockListPos setUnion(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.BackendBlockListPos setWithout(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.BackendBlockListPos setIntersection(KatjaList<? extends katja.spec.BackendBlock> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.BackendBlockPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new BackendBlockListPos.ListImpl(values);
        }

        public katja.spec.BackendBlockListPos replace(katja.spec.BackendBlockList term) {
            return (katja.spec.BackendBlockListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.StringPos lsib() {
            return (katja.spec.StringPos) super.lsib();
        }

        public katja.spec.RootListPos rsib() {
            return (katja.spec.RootListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "BackendBlockListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.BackendBlockPos> implements KatjaList<katja.spec.BackendBlockPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.BackendBlockPos... elements) {
                super(elements);

                for(katja.spec.BackendBlockPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort BackendBlockPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.BackendBlockPos> createInstance(katja.spec.BackendBlockPos[] elements, boolean isSet) {
                for(katja.spec.BackendBlockPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort BackendBlockPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.BackendBlockPos[] createArray(int size) {
                return new katja.spec.BackendBlockPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.BackendBlockPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

