package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface BackendBlockPos extends katja.spec.Katja.TuplePos<katja.spec.BackendBlock> {

    //----- methods of BackendBlockPos -----

    public katja.spec.BackendBlock term();
    public katja.spec.IntegerPos line();
    public katja.spec.BackendBlockPos replaceLine(java.lang.Integer line);
    public katja.spec.StringPos backendName();
    public katja.spec.BackendBlockPos replaceBackendName(java.lang.String backendName);
    public katja.spec.StringPos content();
    public katja.spec.BackendBlockPos replaceContent(java.lang.String content);
    public katja.spec.Katja.LeafPos<?> get(int i);
    public int size();
    public katja.spec.BackendBlockPos replace(katja.spec.BackendBlock term);
    public katja.spec.BackendBlockListPos parent();
    public katja.spec.BackendBlockPos lsib();
    public katja.spec.BackendBlockPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of BackendBlockPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBackendBlockPos(katja.spec.BackendBlockPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.BackendBlockPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.BackendBlock> implements katja.spec.BackendBlockPos {

        //----- attributes of Impl -----

        private katja.spec.IntegerPos _line = null;
        private katja.spec.StringPos _backendName = null;
        private katja.spec.StringPos _content = null;

        //----- methods of Impl -----

        public katja.spec.IntegerPos line() {
            if(_line == null)
                _line = katja.spec.Katja.IntegerPos(this, _term.line(), 0);

            return _line;
        }

        public katja.spec.BackendBlockPos replaceLine(java.lang.Integer line) {
            return replace(_term.replaceLine(line));
        }

        public katja.spec.StringPos backendName() {
            if(_backendName == null)
                _backendName = katja.spec.Katja.StringPos(this, _term.backendName(), 1);

            return _backendName;
        }

        public katja.spec.BackendBlockPos replaceBackendName(java.lang.String backendName) {
            return replace(_term.replaceBackendName(backendName));
        }

        public katja.spec.StringPos content() {
            if(_content == null)
                _content = katja.spec.Katja.StringPos(this, _term.content(), 2);

            return _content;
        }

        public katja.spec.BackendBlockPos replaceContent(java.lang.String content) {
            return replace(_term.replaceContent(content));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.BackendBlock term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.LeafPos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0:
                    if(_line == null)
                        _line = Katja.IntegerPos(this, _term.line(), 0);
                    
                    return _line;
                case 1:
                    if(_backendName == null)
                        _backendName = Katja.StringPos(this, _term.backendName(), 1);
                    
                    return _backendName;
                case 2:
                    if(_content == null)
                        _content = Katja.StringPos(this, _term.content(), 2);
                    
                    return _content;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort BackendBlockPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort BackendBlockPos invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.BackendBlockPos replace(katja.spec.BackendBlock term) {
            return (katja.spec.BackendBlockPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.BackendBlockListPos parent() {
            return (katja.spec.BackendBlockListPos) super.parent();
        }

        public katja.spec.BackendBlockPos lsib() {
            return (katja.spec.BackendBlockPos) super.lsib();
        }

        public katja.spec.BackendBlockPos rsib() {
            return (katja.spec.BackendBlockPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "BackendBlockPos";
        }
    }
}

