package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface BooleanPos extends katja.spec.Katja.LeafPos<java.lang.Boolean> {

    //----- methods of BooleanPos -----

    public java.lang.Boolean term();
    public katja.spec.Katja.TuplePos<?> parent();
    public katja.spec.Katja.SortPos lsib();
    public katja.spec.StringPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of BooleanPos -----

    static class Impl extends KatjaLeafPosImpl<katja.spec.SpecificationPos, java.lang.Boolean> implements katja.spec.BooleanPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, java.lang.Boolean term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.TuplePos<?> parent() {
            return (katja.spec.Katja.TuplePos<?>) super.parent();
        }

        public katja.spec.Katja.SortPos lsib() {
            return (katja.spec.Katja.SortPos) super.lsib();
        }

        public katja.spec.StringPos rsib() {
            return (katja.spec.StringPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append(term().toString());
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "BooleanPos";
        }
    }
}

