package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface Empty extends katja.spec.SelectorOpt, KatjaTuple {

    //----- methods of Empty -----

    public Object get(int i);
    public int size();
    public katja.spec.Empty replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOpt.Switch<CT, E> switchClass) throws E;

    //----- nested classes of Empty -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitEmpty(katja.spec.Empty term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.Empty.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.Empty {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Empty invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Empty invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.Empty replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Empty invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort Empty invoked with too large parameter "+pos+", sort has only 0 components");


            return (katja.spec.Empty) Katja.unique(new katja.spec.Empty.Impl(
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOpt.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseEmpty(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.Empty");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Empty");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Empty";
        }
    }
}

