package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface EmptyPos extends katja.spec.SelectorOptPos, katja.spec.Katja.TuplePos<katja.spec.Empty> {

    //----- methods of EmptyPos -----

    public katja.spec.Empty termSelectorOpt();
    public katja.spec.Empty term();
    public KatjaSortPos<katja.spec.SpecificationPos> get(int i);
    public int size();
    public katja.spec.EmptyPos replace(katja.spec.Empty term);
    public katja.spec.TupleParamPos parent();
    public katja.spec.SortIdPos lsib();
    public katja.spec.BooleanPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOptPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of EmptyPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.EmptyPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.Empty> implements katja.spec.EmptyPos {

        //----- methods of Impl -----

        public katja.spec.Empty termSelectorOpt() {
            return term();
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.Empty term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<katja.spec.SpecificationPos> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort EmptyPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort EmptyPos invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.EmptyPos replace(katja.spec.Empty term) {
            return (katja.spec.EmptyPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.TupleParamPos parent() {
            return (katja.spec.TupleParamPos) super.parent();
        }

        public katja.spec.SortIdPos lsib() {
            return (katja.spec.SortIdPos) super.lsib();
        }

        public katja.spec.BooleanPos rsib() {
            return (katja.spec.BooleanPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOptPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseEmptyPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "EmptyPos";
        }
    }
}

