package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface ExternalList extends KatjaList<katja.spec.External> {

    //----- methods of ExternalList -----

    public katja.spec.ExternalList add(katja.spec.External element);
    public katja.spec.ExternalList addAll(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalList remove(katja.spec.External element);
    public katja.spec.ExternalList removeAll(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalList appBack(katja.spec.External element);
    public katja.spec.ExternalList appFront(katja.spec.External element);
    public katja.spec.ExternalList conc(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalList front();
    public katja.spec.ExternalList back();
    public katja.spec.ExternalList reverse();
    public katja.spec.ExternalList sublist(int from, int to);
    public katja.spec.ExternalList replace(int ith, Object element);
    public katja.spec.ExternalList toSet();
    public katja.spec.ExternalList setAdd(katja.spec.External element);
    public katja.spec.ExternalList setRemove(katja.spec.External element);
    public katja.spec.ExternalList setUnion(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalList setIntersection(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalList setWithout(KatjaList<? extends katja.spec.External> list);

    //----- nested classes of ExternalList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExternal(katja.spec.External term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitExternalList(katja.spec.ExternalList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ExternalList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.External> implements katja.spec.ExternalList {

        //----- methods of Impl -----

        Impl(katja.spec.External... elements) {
            super(elements);

            for(katja.spec.External element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternalList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.ExternalList createInstance(katja.spec.External[] elements, boolean isSet) {
            for(katja.spec.External element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternalList invoked with null element");

            ExternalList.Impl temp = new katja.spec.ExternalList.Impl();
            temp.values = elements;
            temp = (ExternalList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.External[] createArray(int size) {
            return new katja.spec.External[size];
        }

        public katja.spec.ExternalList add(katja.spec.External element) {
            return (katja.spec.ExternalList) super.add(element);
        }

        public katja.spec.ExternalList addAll(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.addAll(list);
        }

        public katja.spec.ExternalList remove(katja.spec.External element) {
            return (katja.spec.ExternalList) super.remove(element);
        }

        public katja.spec.ExternalList removeAll(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.removeAll(list);
        }

        public katja.spec.ExternalList appBack(katja.spec.External element) {
            return (katja.spec.ExternalList) super.appBack(element);
        }

        public katja.spec.ExternalList appFront(katja.spec.External element) {
            return (katja.spec.ExternalList) super.appFront(element);
        }

        public katja.spec.ExternalList conc(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.conc(list);
        }

        public katja.spec.ExternalList front() {
            return (katja.spec.ExternalList) super.front();
        }

        public katja.spec.ExternalList back() {
            return (katja.spec.ExternalList) super.back();
        }

        public katja.spec.ExternalList reverse() {
            return (katja.spec.ExternalList) super.reverse();
        }

        public katja.spec.ExternalList sublist(int from, int to) {
            return (katja.spec.ExternalList) super.sublist(from, to);
        }

        public katja.spec.ExternalList replace(int ith, Object element) {
            return (katja.spec.ExternalList) super.replace(ith, element);
        }

        public katja.spec.ExternalList toSet() {
            return (katja.spec.ExternalList) super.toSet();
        }

        public katja.spec.ExternalList setAdd(katja.spec.External element) {
            return (katja.spec.ExternalList) super.setAdd(element);
        }

        public katja.spec.ExternalList setRemove(katja.spec.External element) {
            return (katja.spec.ExternalList) super.setRemove(element);
        }

        public katja.spec.ExternalList setUnion(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.setUnion(list);
        }

        public katja.spec.ExternalList setIntersection(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.setIntersection(list);
        }

        public katja.spec.ExternalList setWithout(KatjaList<? extends katja.spec.External> list) {
            return (katja.spec.ExternalList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.ExternalList");
            builder.append("( ");
            for(katja.spec.External element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ExternalList");
            builder.append("( ");
            for(katja.spec.External element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ExternalList";
        }
    }
}

