package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ExternalListPos extends katja.spec.Katja.ListPos<katja.spec.ExternalList, katja.spec.ExternalPos, katja.spec.External> {

    //----- methods of ExternalListPos -----

    public katja.spec.ExternalList term();
    public katja.spec.ExternalListPos add(katja.spec.External element);
    public katja.spec.ExternalListPos addAll(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalListPos remove(katja.spec.External element);
    public katja.spec.ExternalListPos removeAll(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalListPos appBack(katja.spec.External element);
    public katja.spec.ExternalListPos appFront(katja.spec.External element);
    public katja.spec.ExternalListPos conc(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalListPos reverse();
    public katja.spec.ExternalListPos toSet();
    public katja.spec.ExternalListPos setAdd(katja.spec.External element);
    public katja.spec.ExternalListPos setRemove(katja.spec.External element);
    public katja.spec.ExternalListPos setUnion(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalListPos setWithout(KatjaList<? extends katja.spec.External> list);
    public katja.spec.ExternalListPos setIntersection(KatjaList<? extends katja.spec.External> list);
    public KatjaList<katja.spec.ExternalPos> toList();
    public katja.spec.ExternalListPos replace(katja.spec.ExternalList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.RootListPos lsib();
    public katja.spec.ImportListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of ExternalListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.ExternalPos> implements KatjaList<katja.spec.ExternalPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.ExternalPos... elements) {
            super(elements);

            for(katja.spec.ExternalPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ExternalPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.ExternalPos> createInstance(katja.spec.ExternalPos[] elements, boolean isSet) {
            for(katja.spec.ExternalPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ExternalPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.ExternalPos[] createArray(int size) {
            return new katja.spec.ExternalPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.ExternalPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitExternalListPos(katja.spec.ExternalListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ExternalListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.ExternalList, katja.spec.ExternalPos, katja.spec.External> implements katja.spec.ExternalListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.ExternalList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.ExternalPos getElementInstance(int pos) {
            return katja.spec.Katja.ExternalPos(this, _term.get(pos), pos);
        }

        protected katja.spec.ExternalPos[] createArray(int size) {
            return new katja.spec.ExternalPos[size];
        }

        public katja.spec.ExternalListPos add(katja.spec.External element) {
            return replace(_term.add(element));
        }

        public katja.spec.ExternalListPos addAll(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.ExternalListPos remove(katja.spec.External element) {
            return replace(_term.remove(element));
        }

        public katja.spec.ExternalListPos removeAll(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.ExternalListPos appBack(katja.spec.External element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.ExternalListPos appFront(katja.spec.External element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.ExternalListPos conc(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.ExternalListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.ExternalListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.ExternalListPos setAdd(katja.spec.External element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.ExternalListPos setRemove(katja.spec.External element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.ExternalListPos setUnion(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.ExternalListPos setWithout(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.ExternalListPos setIntersection(KatjaList<? extends katja.spec.External> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.ExternalPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new ExternalListPos.ListImpl(values);
        }

        public katja.spec.ExternalListPos replace(katja.spec.ExternalList term) {
            return (katja.spec.ExternalListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.RootListPos lsib() {
            return (katja.spec.RootListPos) super.lsib();
        }

        public katja.spec.ImportListPos rsib() {
            return (katja.spec.ImportListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ExternalListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.ExternalPos> implements KatjaList<katja.spec.ExternalPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.ExternalPos... elements) {
                super(elements);

                for(katja.spec.ExternalPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ExternalPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.ExternalPos> createInstance(katja.spec.ExternalPos[] elements, boolean isSet) {
                for(katja.spec.ExternalPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ExternalPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.ExternalPos[] createArray(int size) {
                return new katja.spec.ExternalPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.ExternalPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

