package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface ExternalPos extends katja.spec.SortSpecPos, katja.spec.Katja.TuplePos<katja.spec.External> {

    //----- methods of ExternalPos -----

    public katja.spec.External termSortSpec();
    public katja.spec.External term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.ExternalPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.SortIdPos get(int i);
    public int size();
    public katja.spec.ExternalPos replace(katja.spec.External term);
    public katja.spec.ExternalListPos parent();
    public katja.spec.ExternalPos lsib();
    public katja.spec.ExternalPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ExternalPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ExternalPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.External> implements katja.spec.ExternalPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;

        //----- methods of Impl -----

        public katja.spec.External termSortSpec() {
            return term();
        }

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.ExternalPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.External term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.SortIdPos get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ExternalPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ExternalPos invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.ExternalPos replace(katja.spec.External term) {
            return (katja.spec.ExternalPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.ExternalListPos parent() {
            return (katja.spec.ExternalListPos) super.parent();
        }

        public katja.spec.ExternalPos lsib() {
            return (katja.spec.ExternalPos) super.lsib();
        }

        public katja.spec.ExternalPos rsib() {
            return (katja.spec.ExternalPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseExternalPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ExternalPos";
        }
    }
}

