package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface FileNameList extends KatjaList<java.lang.String> {

    //----- methods of FileNameList -----

    public katja.spec.FileNameList add(java.lang.String element);
    public katja.spec.FileNameList addAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameList remove(java.lang.String element);
    public katja.spec.FileNameList removeAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameList appBack(java.lang.String element);
    public katja.spec.FileNameList appFront(java.lang.String element);
    public katja.spec.FileNameList conc(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameList front();
    public katja.spec.FileNameList back();
    public katja.spec.FileNameList reverse();
    public katja.spec.FileNameList sublist(int from, int to);
    public katja.spec.FileNameList replace(int ith, Object element);
    public katja.spec.FileNameList toSet();
    public katja.spec.FileNameList setAdd(java.lang.String element);
    public katja.spec.FileNameList setRemove(java.lang.String element);
    public katja.spec.FileNameList setUnion(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameList setIntersection(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameList setWithout(KatjaList<? extends java.lang.String> list);

    //----- nested classes of FileNameList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitFileNameList(katja.spec.FileNameList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.FileNameList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<java.lang.String> implements katja.spec.FileNameList {

        //----- methods of Impl -----

        Impl(java.lang.String... elements) {
            super(elements);

            for(java.lang.String element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort FileNameList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.FileNameList createInstance(java.lang.String[] elements, boolean isSet) {
            for(java.lang.String element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort FileNameList invoked with null element");

            FileNameList.Impl temp = new katja.spec.FileNameList.Impl();
            temp.values = elements;
            temp = (FileNameList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected java.lang.String[] createArray(int size) {
            return new java.lang.String[size];
        }

        public katja.spec.FileNameList add(java.lang.String element) {
            return (katja.spec.FileNameList) super.add(element);
        }

        public katja.spec.FileNameList addAll(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.addAll(list);
        }

        public katja.spec.FileNameList remove(java.lang.String element) {
            return (katja.spec.FileNameList) super.remove(element);
        }

        public katja.spec.FileNameList removeAll(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.removeAll(list);
        }

        public katja.spec.FileNameList appBack(java.lang.String element) {
            return (katja.spec.FileNameList) super.appBack(element);
        }

        public katja.spec.FileNameList appFront(java.lang.String element) {
            return (katja.spec.FileNameList) super.appFront(element);
        }

        public katja.spec.FileNameList conc(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.conc(list);
        }

        public katja.spec.FileNameList front() {
            return (katja.spec.FileNameList) super.front();
        }

        public katja.spec.FileNameList back() {
            return (katja.spec.FileNameList) super.back();
        }

        public katja.spec.FileNameList reverse() {
            return (katja.spec.FileNameList) super.reverse();
        }

        public katja.spec.FileNameList sublist(int from, int to) {
            return (katja.spec.FileNameList) super.sublist(from, to);
        }

        public katja.spec.FileNameList replace(int ith, Object element) {
            return (katja.spec.FileNameList) super.replace(ith, element);
        }

        public katja.spec.FileNameList toSet() {
            return (katja.spec.FileNameList) super.toSet();
        }

        public katja.spec.FileNameList setAdd(java.lang.String element) {
            return (katja.spec.FileNameList) super.setAdd(element);
        }

        public katja.spec.FileNameList setRemove(java.lang.String element) {
            return (katja.spec.FileNameList) super.setRemove(element);
        }

        public katja.spec.FileNameList setUnion(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.setUnion(list);
        }

        public katja.spec.FileNameList setIntersection(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.setIntersection(list);
        }

        public katja.spec.FileNameList setWithout(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.FileNameList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.FileNameList");
            builder.append("( ");
            for(java.lang.String element : values) {
                if(first) first = false;
                else builder.append(", ");
                builder.append("\"").append(element.toString()).append("\"");
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("FileNameList");
            builder.append("( ");
            for(java.lang.String element : values) {
                if(first) first = false;
                else builder.append(", ");
                builder.append("\"").append(element.toString()).append("\"");
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "FileNameList";
        }
    }
}

