package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface FileNameListPos extends katja.spec.Katja.ListPos<katja.spec.FileNameList, katja.spec.StringPos, java.lang.String> {

    //----- methods of FileNameListPos -----

    public katja.spec.FileNameList term();
    public katja.spec.FileNameListPos add(java.lang.String element);
    public katja.spec.FileNameListPos addAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameListPos remove(java.lang.String element);
    public katja.spec.FileNameListPos removeAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameListPos appBack(java.lang.String element);
    public katja.spec.FileNameListPos appFront(java.lang.String element);
    public katja.spec.FileNameListPos conc(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameListPos reverse();
    public katja.spec.FileNameListPos toSet();
    public katja.spec.FileNameListPos setAdd(java.lang.String element);
    public katja.spec.FileNameListPos setRemove(java.lang.String element);
    public katja.spec.FileNameListPos setUnion(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameListPos setWithout(KatjaList<? extends java.lang.String> list);
    public katja.spec.FileNameListPos setIntersection(KatjaList<? extends java.lang.String> list);
    public KatjaList<katja.spec.StringPos> toList();
    public katja.spec.FileNameListPos replace(katja.spec.FileNameList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.ProductionListPos lsib();
    public katja.spec.Katja.SortPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of FileNameListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.StringPos> implements KatjaList<katja.spec.StringPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.StringPos... elements) {
            super(elements);

            for(katja.spec.StringPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StringPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.StringPos> createInstance(katja.spec.StringPos[] elements, boolean isSet) {
            for(katja.spec.StringPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StringPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.StringPos[] createArray(int size) {
            return new katja.spec.StringPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.StringPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitFileNameListPos(katja.spec.FileNameListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.FileNameListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.FileNameList, katja.spec.StringPos, java.lang.String> implements katja.spec.FileNameListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.FileNameList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.StringPos getElementInstance(int pos) {
            return katja.spec.Katja.StringPos(this, _term.get(pos), pos);
        }

        protected katja.spec.StringPos[] createArray(int size) {
            return new katja.spec.StringPos[size];
        }

        public katja.spec.FileNameListPos add(java.lang.String element) {
            return replace(_term.add(element));
        }

        public katja.spec.FileNameListPos addAll(KatjaList<? extends java.lang.String> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.FileNameListPos remove(java.lang.String element) {
            return replace(_term.remove(element));
        }

        public katja.spec.FileNameListPos removeAll(KatjaList<? extends java.lang.String> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.FileNameListPos appBack(java.lang.String element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.FileNameListPos appFront(java.lang.String element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.FileNameListPos conc(KatjaList<? extends java.lang.String> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.FileNameListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.FileNameListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.FileNameListPos setAdd(java.lang.String element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.FileNameListPos setRemove(java.lang.String element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.FileNameListPos setUnion(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.FileNameListPos setWithout(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.FileNameListPos setIntersection(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.StringPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new FileNameListPos.ListImpl(values);
        }

        public katja.spec.FileNameListPos replace(katja.spec.FileNameList term) {
            return (katja.spec.FileNameListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.ProductionListPos lsib() {
            return (katja.spec.ProductionListPos) super.lsib();
        }

        public katja.spec.Katja.SortPos rsib() {
            return (katja.spec.Katja.SortPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "FileNameListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.StringPos> implements KatjaList<katja.spec.StringPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.StringPos... elements) {
                super(elements);

                for(katja.spec.StringPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StringPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.StringPos> createInstance(katja.spec.StringPos[] elements, boolean isSet) {
                for(katja.spec.StringPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StringPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.StringPos[] createArray(int size) {
                return new katja.spec.StringPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.StringPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

