package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface ImportList extends KatjaList<katja.spec.Import> {

    //----- methods of ImportList -----

    public katja.spec.ImportList add(katja.spec.Import element);
    public katja.spec.ImportList addAll(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportList remove(katja.spec.Import element);
    public katja.spec.ImportList removeAll(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportList appBack(katja.spec.Import element);
    public katja.spec.ImportList appFront(katja.spec.Import element);
    public katja.spec.ImportList conc(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportList front();
    public katja.spec.ImportList back();
    public katja.spec.ImportList reverse();
    public katja.spec.ImportList sublist(int from, int to);
    public katja.spec.ImportList replace(int ith, Object element);
    public katja.spec.ImportList toSet();
    public katja.spec.ImportList setAdd(katja.spec.Import element);
    public katja.spec.ImportList setRemove(katja.spec.Import element);
    public katja.spec.ImportList setUnion(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportList setIntersection(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportList setWithout(KatjaList<? extends katja.spec.Import> list);

    //----- nested classes of ImportList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImport(katja.spec.Import term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitImportList(katja.spec.ImportList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ImportList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.Import> implements katja.spec.ImportList {

        //----- methods of Impl -----

        Impl(katja.spec.Import... elements) {
            super(elements);

            for(katja.spec.Import element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ImportList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.ImportList createInstance(katja.spec.Import[] elements, boolean isSet) {
            for(katja.spec.Import element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ImportList invoked with null element");

            ImportList.Impl temp = new katja.spec.ImportList.Impl();
            temp.values = elements;
            temp = (ImportList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.Import[] createArray(int size) {
            return new katja.spec.Import[size];
        }

        public katja.spec.ImportList add(katja.spec.Import element) {
            return (katja.spec.ImportList) super.add(element);
        }

        public katja.spec.ImportList addAll(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.addAll(list);
        }

        public katja.spec.ImportList remove(katja.spec.Import element) {
            return (katja.spec.ImportList) super.remove(element);
        }

        public katja.spec.ImportList removeAll(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.removeAll(list);
        }

        public katja.spec.ImportList appBack(katja.spec.Import element) {
            return (katja.spec.ImportList) super.appBack(element);
        }

        public katja.spec.ImportList appFront(katja.spec.Import element) {
            return (katja.spec.ImportList) super.appFront(element);
        }

        public katja.spec.ImportList conc(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.conc(list);
        }

        public katja.spec.ImportList front() {
            return (katja.spec.ImportList) super.front();
        }

        public katja.spec.ImportList back() {
            return (katja.spec.ImportList) super.back();
        }

        public katja.spec.ImportList reverse() {
            return (katja.spec.ImportList) super.reverse();
        }

        public katja.spec.ImportList sublist(int from, int to) {
            return (katja.spec.ImportList) super.sublist(from, to);
        }

        public katja.spec.ImportList replace(int ith, Object element) {
            return (katja.spec.ImportList) super.replace(ith, element);
        }

        public katja.spec.ImportList toSet() {
            return (katja.spec.ImportList) super.toSet();
        }

        public katja.spec.ImportList setAdd(katja.spec.Import element) {
            return (katja.spec.ImportList) super.setAdd(element);
        }

        public katja.spec.ImportList setRemove(katja.spec.Import element) {
            return (katja.spec.ImportList) super.setRemove(element);
        }

        public katja.spec.ImportList setUnion(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.setUnion(list);
        }

        public katja.spec.ImportList setIntersection(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.setIntersection(list);
        }

        public katja.spec.ImportList setWithout(KatjaList<? extends katja.spec.Import> list) {
            return (katja.spec.ImportList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.ImportList");
            builder.append("( ");
            for(katja.spec.Import element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ImportList");
            builder.append("( ");
            for(katja.spec.Import element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ImportList";
        }
    }
}

