package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ImportListPos extends katja.spec.Katja.ListPos<katja.spec.ImportList, katja.spec.ImportPos, katja.spec.Import> {

    //----- methods of ImportListPos -----

    public katja.spec.ImportList term();
    public katja.spec.ImportListPos add(katja.spec.Import element);
    public katja.spec.ImportListPos addAll(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportListPos remove(katja.spec.Import element);
    public katja.spec.ImportListPos removeAll(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportListPos appBack(katja.spec.Import element);
    public katja.spec.ImportListPos appFront(katja.spec.Import element);
    public katja.spec.ImportListPos conc(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportListPos reverse();
    public katja.spec.ImportListPos toSet();
    public katja.spec.ImportListPos setAdd(katja.spec.Import element);
    public katja.spec.ImportListPos setRemove(katja.spec.Import element);
    public katja.spec.ImportListPos setUnion(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportListPos setWithout(KatjaList<? extends katja.spec.Import> list);
    public katja.spec.ImportListPos setIntersection(KatjaList<? extends katja.spec.Import> list);
    public KatjaList<katja.spec.ImportPos> toList();
    public katja.spec.ImportListPos replace(katja.spec.ImportList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.ExternalListPos lsib();
    public katja.spec.IncludeListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of ImportListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.ImportPos> implements KatjaList<katja.spec.ImportPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.ImportPos... elements) {
            super(elements);

            for(katja.spec.ImportPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ImportPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.ImportPos> createInstance(katja.spec.ImportPos[] elements, boolean isSet) {
            for(katja.spec.ImportPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ImportPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.ImportPos[] createArray(int size) {
            return new katja.spec.ImportPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.ImportPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitImportPos(katja.spec.ImportPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitImportListPos(katja.spec.ImportListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ImportListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.ImportList, katja.spec.ImportPos, katja.spec.Import> implements katja.spec.ImportListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.ImportList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.ImportPos getElementInstance(int pos) {
            return katja.spec.Katja.ImportPos(this, _term.get(pos), pos);
        }

        protected katja.spec.ImportPos[] createArray(int size) {
            return new katja.spec.ImportPos[size];
        }

        public katja.spec.ImportListPos add(katja.spec.Import element) {
            return replace(_term.add(element));
        }

        public katja.spec.ImportListPos addAll(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.ImportListPos remove(katja.spec.Import element) {
            return replace(_term.remove(element));
        }

        public katja.spec.ImportListPos removeAll(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.ImportListPos appBack(katja.spec.Import element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.ImportListPos appFront(katja.spec.Import element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.ImportListPos conc(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.ImportListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.ImportListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.ImportListPos setAdd(katja.spec.Import element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.ImportListPos setRemove(katja.spec.Import element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.ImportListPos setUnion(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.ImportListPos setWithout(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.ImportListPos setIntersection(KatjaList<? extends katja.spec.Import> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.ImportPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new ImportListPos.ListImpl(values);
        }

        public katja.spec.ImportListPos replace(katja.spec.ImportList term) {
            return (katja.spec.ImportListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.ExternalListPos lsib() {
            return (katja.spec.ExternalListPos) super.lsib();
        }

        public katja.spec.IncludeListPos rsib() {
            return (katja.spec.IncludeListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ImportListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.ImportPos> implements KatjaList<katja.spec.ImportPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.ImportPos... elements) {
                super(elements);

                for(katja.spec.ImportPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ImportPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.ImportPos> createInstance(katja.spec.ImportPos[] elements, boolean isSet) {
                for(katja.spec.ImportPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ImportPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.ImportPos[] createArray(int size) {
                return new katja.spec.ImportPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.ImportPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

