package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface ImportPos extends katja.spec.Katja.TuplePos<katja.spec.Import> {

    //----- methods of ImportPos -----

    public katja.spec.Import term();
    public katja.spec.StringPos name();
    public katja.spec.ImportPos replaceName(java.lang.String name);
    public katja.spec.StringPos filename();
    public katja.spec.ImportPos replaceFilename(java.lang.String filename);
    public katja.spec.IntegerPos line();
    public katja.spec.ImportPos replaceLine(java.lang.Integer line);
    public katja.spec.Katja.LeafPos<?> get(int i);
    public int size();
    public katja.spec.ImportPos replace(katja.spec.Import term);
    public katja.spec.ImportListPos parent();
    public katja.spec.ImportPos lsib();
    public katja.spec.ImportPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of ImportPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitImportPos(katja.spec.ImportPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ImportPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.Import> implements katja.spec.ImportPos {

        //----- attributes of Impl -----

        private katja.spec.StringPos _name = null;
        private katja.spec.StringPos _filename = null;
        private katja.spec.IntegerPos _line = null;

        //----- methods of Impl -----

        public katja.spec.StringPos name() {
            if(_name == null)
                _name = katja.spec.Katja.StringPos(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.ImportPos replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.StringPos filename() {
            if(_filename == null)
                _filename = katja.spec.Katja.StringPos(this, _term.filename(), 1);

            return _filename;
        }

        public katja.spec.ImportPos replaceFilename(java.lang.String filename) {
            return replace(_term.replaceFilename(filename));
        }

        public katja.spec.IntegerPos line() {
            if(_line == null)
                _line = katja.spec.Katja.IntegerPos(this, _term.line(), 2);

            return _line;
        }

        public katja.spec.ImportPos replaceLine(java.lang.Integer line) {
            return replace(_term.replaceLine(line));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.Import term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.LeafPos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Katja.StringPos(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_filename == null)
                        _filename = Katja.StringPos(this, _term.filename(), 1);
                    
                    return _filename;
                case 2:
                    if(_line == null)
                        _line = Katja.IntegerPos(this, _term.line(), 2);
                    
                    return _line;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ImportPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ImportPos invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.ImportPos replace(katja.spec.Import term) {
            return (katja.spec.ImportPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.ImportListPos parent() {
            return (katja.spec.ImportListPos) super.parent();
        }

        public katja.spec.ImportPos lsib() {
            return (katja.spec.ImportPos) super.lsib();
        }

        public katja.spec.ImportPos rsib() {
            return (katja.spec.ImportPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ImportPos";
        }
    }
}

