package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface Include extends KatjaTuple {

    //----- methods of Include -----

    public java.lang.String name();
    public katja.spec.Include replaceName(java.lang.String name);
    public java.lang.String filename();
    public katja.spec.Include replaceFilename(java.lang.String filename);
    public java.lang.Integer line();
    public katja.spec.Include replaceLine(java.lang.Integer line);
    public Object get(int i);
    public int size();
    public katja.spec.Include replace(int pos, Object term);

    //----- nested classes of Include -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitInclude(katja.spec.Include term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.Include.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.Include {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private java.lang.String _filename = null;
        private java.lang.Integer _line = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.Include replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public java.lang.String filename() {
            return _filename;
        }

        public katja.spec.Include replaceFilename(java.lang.String filename) {
            return replace(1, filename);
        }

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.Include replaceLine(java.lang.Integer line) {
            return replace(2, line);
        }

        Impl(java.lang.String name, java.lang.String filename, java.lang.Integer line) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort Include invoked with null parameter name");
            if(filename == null)
                throw new IllegalArgumentException("constructor of sort Include invoked with null parameter filename");
            if(line == null)
                throw new IllegalArgumentException("constructor of sort Include invoked with null parameter line");

            this._name = name;
            this._filename = filename;
            this._line = line;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0: return _name;
                case 1: return _filename;
                case 2: return _line;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Include invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Include invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.Include replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Include invoked with negative parameter "+pos);
            if(pos >= 3)
                throw new IllegalArgumentException("replace on sort Include invoked with too large parameter "+pos+", sort has only 3 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Include invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Include invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort Include invoked with term of incorrect sort, Integer expected");

            return (katja.spec.Include) Katja.unique(new katja.spec.Include.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (java.lang.String) term : _filename,
                pos == 2 ? (java.lang.Integer) term : _line
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.Include");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Include");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Include";
        }
    }
}

