package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface IncludeList extends KatjaList<katja.spec.Include> {

    //----- methods of IncludeList -----

    public katja.spec.IncludeList add(katja.spec.Include element);
    public katja.spec.IncludeList addAll(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeList remove(katja.spec.Include element);
    public katja.spec.IncludeList removeAll(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeList appBack(katja.spec.Include element);
    public katja.spec.IncludeList appFront(katja.spec.Include element);
    public katja.spec.IncludeList conc(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeList front();
    public katja.spec.IncludeList back();
    public katja.spec.IncludeList reverse();
    public katja.spec.IncludeList sublist(int from, int to);
    public katja.spec.IncludeList replace(int ith, Object element);
    public katja.spec.IncludeList toSet();
    public katja.spec.IncludeList setAdd(katja.spec.Include element);
    public katja.spec.IncludeList setRemove(katja.spec.Include element);
    public katja.spec.IncludeList setUnion(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeList setIntersection(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeList setWithout(KatjaList<? extends katja.spec.Include> list);

    //----- nested classes of IncludeList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitInclude(katja.spec.Include term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitIncludeList(katja.spec.IncludeList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.IncludeList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.Include> implements katja.spec.IncludeList {

        //----- methods of Impl -----

        Impl(katja.spec.Include... elements) {
            super(elements);

            for(katja.spec.Include element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IncludeList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.IncludeList createInstance(katja.spec.Include[] elements, boolean isSet) {
            for(katja.spec.Include element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IncludeList invoked with null element");

            IncludeList.Impl temp = new katja.spec.IncludeList.Impl();
            temp.values = elements;
            temp = (IncludeList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.Include[] createArray(int size) {
            return new katja.spec.Include[size];
        }

        public katja.spec.IncludeList add(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.add(element);
        }

        public katja.spec.IncludeList addAll(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.addAll(list);
        }

        public katja.spec.IncludeList remove(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.remove(element);
        }

        public katja.spec.IncludeList removeAll(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.removeAll(list);
        }

        public katja.spec.IncludeList appBack(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.appBack(element);
        }

        public katja.spec.IncludeList appFront(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.appFront(element);
        }

        public katja.spec.IncludeList conc(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.conc(list);
        }

        public katja.spec.IncludeList front() {
            return (katja.spec.IncludeList) super.front();
        }

        public katja.spec.IncludeList back() {
            return (katja.spec.IncludeList) super.back();
        }

        public katja.spec.IncludeList reverse() {
            return (katja.spec.IncludeList) super.reverse();
        }

        public katja.spec.IncludeList sublist(int from, int to) {
            return (katja.spec.IncludeList) super.sublist(from, to);
        }

        public katja.spec.IncludeList replace(int ith, Object element) {
            return (katja.spec.IncludeList) super.replace(ith, element);
        }

        public katja.spec.IncludeList toSet() {
            return (katja.spec.IncludeList) super.toSet();
        }

        public katja.spec.IncludeList setAdd(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.setAdd(element);
        }

        public katja.spec.IncludeList setRemove(katja.spec.Include element) {
            return (katja.spec.IncludeList) super.setRemove(element);
        }

        public katja.spec.IncludeList setUnion(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.setUnion(list);
        }

        public katja.spec.IncludeList setIntersection(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.setIntersection(list);
        }

        public katja.spec.IncludeList setWithout(KatjaList<? extends katja.spec.Include> list) {
            return (katja.spec.IncludeList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.IncludeList");
            builder.append("( ");
            for(katja.spec.Include element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("IncludeList");
            builder.append("( ");
            for(katja.spec.Include element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IncludeList";
        }
    }
}

