package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface IncludeListPos extends katja.spec.Katja.ListPos<katja.spec.IncludeList, katja.spec.IncludePos, katja.spec.Include> {

    //----- methods of IncludeListPos -----

    public katja.spec.IncludeList term();
    public katja.spec.IncludeListPos add(katja.spec.Include element);
    public katja.spec.IncludeListPos addAll(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeListPos remove(katja.spec.Include element);
    public katja.spec.IncludeListPos removeAll(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeListPos appBack(katja.spec.Include element);
    public katja.spec.IncludeListPos appFront(katja.spec.Include element);
    public katja.spec.IncludeListPos conc(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeListPos reverse();
    public katja.spec.IncludeListPos toSet();
    public katja.spec.IncludeListPos setAdd(katja.spec.Include element);
    public katja.spec.IncludeListPos setRemove(katja.spec.Include element);
    public katja.spec.IncludeListPos setUnion(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeListPos setWithout(KatjaList<? extends katja.spec.Include> list);
    public katja.spec.IncludeListPos setIntersection(KatjaList<? extends katja.spec.Include> list);
    public KatjaList<katja.spec.IncludePos> toList();
    public katja.spec.IncludeListPos replace(katja.spec.IncludeList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.ImportListPos lsib();
    public katja.spec.ProductionListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of IncludeListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.IncludePos> implements KatjaList<katja.spec.IncludePos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.IncludePos... elements) {
            super(elements);

            for(katja.spec.IncludePos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort IncludePos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.IncludePos> createInstance(katja.spec.IncludePos[] elements, boolean isSet) {
            for(katja.spec.IncludePos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort IncludePos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.IncludePos[] createArray(int size) {
            return new katja.spec.IncludePos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.IncludePos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIncludePos(katja.spec.IncludePos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitIncludeListPos(katja.spec.IncludeListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.IncludeListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.IncludeList, katja.spec.IncludePos, katja.spec.Include> implements katja.spec.IncludeListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.IncludeList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.IncludePos getElementInstance(int pos) {
            return katja.spec.Katja.IncludePos(this, _term.get(pos), pos);
        }

        protected katja.spec.IncludePos[] createArray(int size) {
            return new katja.spec.IncludePos[size];
        }

        public katja.spec.IncludeListPos add(katja.spec.Include element) {
            return replace(_term.add(element));
        }

        public katja.spec.IncludeListPos addAll(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.IncludeListPos remove(katja.spec.Include element) {
            return replace(_term.remove(element));
        }

        public katja.spec.IncludeListPos removeAll(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.IncludeListPos appBack(katja.spec.Include element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.IncludeListPos appFront(katja.spec.Include element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.IncludeListPos conc(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.IncludeListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.IncludeListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.IncludeListPos setAdd(katja.spec.Include element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.IncludeListPos setRemove(katja.spec.Include element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.IncludeListPos setUnion(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.IncludeListPos setWithout(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.IncludeListPos setIntersection(KatjaList<? extends katja.spec.Include> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.IncludePos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new IncludeListPos.ListImpl(values);
        }

        public katja.spec.IncludeListPos replace(katja.spec.IncludeList term) {
            return (katja.spec.IncludeListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.ImportListPos lsib() {
            return (katja.spec.ImportListPos) super.lsib();
        }

        public katja.spec.ProductionListPos rsib() {
            return (katja.spec.ProductionListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "IncludeListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.IncludePos> implements KatjaList<katja.spec.IncludePos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.IncludePos... elements) {
                super(elements);

                for(katja.spec.IncludePos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort IncludePos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.IncludePos> createInstance(katja.spec.IncludePos[] elements, boolean isSet) {
                for(katja.spec.IncludePos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort IncludePos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.IncludePos[] createArray(int size) {
                return new katja.spec.IncludePos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.IncludePos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

