package katja.spec;

import katja.common.*;
import java.util.*;
import java.io.Reader;
import java.io.IOException;
import java.util.List;
import java.util.TreeMap;

public class Katja extends KatjaSpecification {

    //----- attributes of Katja -----

    private static final Map<katja.spec.Specification, katja.spec.SpecificationPos> _Poscache = new TreeMap<katja.spec.Specification, katja.spec.SpecificationPos>();
    private static final Katja$Creator _Katja$Creator = new Katja$Creator();

    //----- methods of Katja -----

    static final KatjaTerm unique(KatjaTerm term) {
        if(_termcache.containsKey(term)) return _termcache.get(term);
        _termcache.put(term, term);

        return term;
    }

    public static final katja.spec.BackendBlock BackendBlock(java.lang.Integer line, java.lang.String backendName, java.lang.String content) {
        katja.spec.BackendBlock _temp = new katja.spec.BackendBlock.Impl(line, backendName, content);
        if(_termcache.containsKey(_temp)) return (katja.spec.BackendBlock) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.BackendBlockList BackendBlockList(katja.spec.BackendBlock... elements) {
        katja.spec.BackendBlockList _temp = new katja.spec.BackendBlockList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.BackendBlockList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.BackendBlockListPos BackendBlockListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.BackendBlockList term, final int pos) {
        return new katja.spec.BackendBlockListPos.Impl(parent, term, pos);
    }

    static final katja.spec.BackendBlockPos BackendBlockPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.BackendBlock term, final int pos) {
        return new katja.spec.BackendBlockPos.Impl(parent, term, pos);
    }

    static final katja.spec.BooleanPos BooleanPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final java.lang.Boolean term, final int pos) {
        return new katja.spec.BooleanPos.Impl(parent, term, pos);
    }

    public static final katja.spec.Empty Empty() {
        katja.spec.Empty _temp = new katja.spec.Empty.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.Empty) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.EmptyPos EmptyPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Empty term, final int pos) {
        return new katja.spec.EmptyPos.Impl(parent, term, pos);
    }

    public static final katja.spec.External External(katja.spec.SortId sortId) {
        katja.spec.External _temp = new katja.spec.External.Impl(sortId);
        if(_termcache.containsKey(_temp)) return (katja.spec.External) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.ExternalList ExternalList(katja.spec.External... elements) {
        katja.spec.ExternalList _temp = new katja.spec.ExternalList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.ExternalList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.ExternalListPos ExternalListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.ExternalList term, final int pos) {
        return new katja.spec.ExternalListPos.Impl(parent, term, pos);
    }

    static final katja.spec.ExternalPos ExternalPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.External term, final int pos) {
        return new katja.spec.ExternalPos.Impl(parent, term, pos);
    }

    public static final katja.spec.FileNameList FileNameList(java.lang.String... elements) {
        katja.spec.FileNameList _temp = new katja.spec.FileNameList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.FileNameList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.FileNameListPos FileNameListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.FileNameList term, final int pos) {
        return new katja.spec.FileNameListPos.Impl(parent, term, pos);
    }

    public static final katja.spec.Import Import(java.lang.String name, java.lang.String filename, java.lang.Integer line) {
        katja.spec.Import _temp = new katja.spec.Import.Impl(name, filename, line);
        if(_termcache.containsKey(_temp)) return (katja.spec.Import) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.ImportList ImportList(katja.spec.Import... elements) {
        katja.spec.ImportList _temp = new katja.spec.ImportList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.ImportList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.ImportListPos ImportListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.ImportList term, final int pos) {
        return new katja.spec.ImportListPos.Impl(parent, term, pos);
    }

    static final katja.spec.ImportPos ImportPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Import term, final int pos) {
        return new katja.spec.ImportPos.Impl(parent, term, pos);
    }

    public static final katja.spec.Include Include(java.lang.String name, java.lang.String filename, java.lang.Integer line) {
        katja.spec.Include _temp = new katja.spec.Include.Impl(name, filename, line);
        if(_termcache.containsKey(_temp)) return (katja.spec.Include) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.IncludeList IncludeList(katja.spec.Include... elements) {
        katja.spec.IncludeList _temp = new katja.spec.IncludeList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.IncludeList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.IncludeListPos IncludeListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.IncludeList term, final int pos) {
        return new katja.spec.IncludeListPos.Impl(parent, term, pos);
    }

    static final katja.spec.IncludePos IncludePos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Include term, final int pos) {
        return new katja.spec.IncludePos.Impl(parent, term, pos);
    }

    static final katja.spec.IntegerPos IntegerPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final java.lang.Integer term, final int pos) {
        return new katja.spec.IntegerPos.Impl(parent, term, pos);
    }

    public static final katja.spec.KatjaErrorList KatjaErrorList(katja.spec.KatjaError... elements) {
        katja.spec.KatjaErrorList _temp = new katja.spec.KatjaErrorList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.KatjaErrorList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.KatjaSpecError KatjaSpecError(java.lang.String message, java.lang.String file, java.lang.Integer line) {
        katja.spec.KatjaSpecError _temp = new katja.spec.KatjaSpecError.Impl(message, file, line);
        if(_termcache.containsKey(_temp)) return (katja.spec.KatjaSpecError) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.KatjaUsageError KatjaUsageError(java.lang.String message) {
        katja.spec.KatjaUsageError _temp = new katja.spec.KatjaUsageError.Impl(message);
        if(_termcache.containsKey(_temp)) return (katja.spec.KatjaUsageError) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.KatjaWarning KatjaWarning(java.lang.String message, java.lang.String file, java.lang.Integer line) {
        katja.spec.KatjaWarning _temp = new katja.spec.KatjaWarning.Impl(message, file, line);
        if(_termcache.containsKey(_temp)) return (katja.spec.KatjaWarning) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.KatjaWarningList KatjaWarningList(katja.spec.KatjaWarning... elements) {
        katja.spec.KatjaWarningList _temp = new katja.spec.KatjaWarningList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.KatjaWarningList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.ListProd ListProd(katja.spec.SortId sortId, katja.spec.SortId param) {
        katja.spec.ListProd _temp = new katja.spec.ListProd.Impl(sortId, param);
        if(_termcache.containsKey(_temp)) return (katja.spec.ListProd) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.ListProdPos ListProdPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.ListProd term, final int pos) {
        return new katja.spec.ListProdPos.Impl(parent, term, pos);
    }

    public static final katja.spec.PackageName PackageName(java.lang.String name) {
        katja.spec.PackageName _temp = new katja.spec.PackageName.Impl(name);
        if(_termcache.containsKey(_temp)) return (katja.spec.PackageName) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.ProductionList ProductionList(katja.spec.Production... elements) {
        katja.spec.ProductionList _temp = new katja.spec.ProductionList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.ProductionList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.ProductionListPos ProductionListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.ProductionList term, final int pos) {
        return new katja.spec.ProductionListPos.Impl(parent, term, pos);
    }

    static final katja.spec.ProductionPos ProductionPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Production term, final int pos) {
        return term.Switch(new katja.spec.Production.Switch<katja.spec.ProductionPos, RuntimeException>() { public final katja.spec.ProductionPos CaseTupleProd(katja.spec.TupleProd term) { return new katja.spec.TupleProdPos.Impl(parent, term, pos); } public final katja.spec.ProductionPos CaseVariantProd(katja.spec.VariantProd term) { return new katja.spec.VariantProdPos.Impl(parent, term, pos); } public final katja.spec.ProductionPos CaseListProd(katja.spec.ListProd term) { return new katja.spec.ListProdPos.Impl(parent, term, pos); } });
    }

    public static final katja.spec.ProductionPosList ProductionPosList(katja.spec.ProductionPos... elements) {
        katja.spec.ProductionPosList _temp = new katja.spec.ProductionPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.ProductionPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.Root Root(katja.spec.SortId sortId, java.lang.String suffix) {
        katja.spec.Root _temp = new katja.spec.Root.Impl(sortId, suffix);
        if(_termcache.containsKey(_temp)) return (katja.spec.Root) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.RootList RootList(katja.spec.Root... elements) {
        katja.spec.RootList _temp = new katja.spec.RootList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.RootList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.RootListPos RootListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.RootList term, final int pos) {
        return new katja.spec.RootListPos.Impl(parent, term, pos);
    }

    static final katja.spec.RootPos RootPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Root term, final int pos) {
        return new katja.spec.RootPos.Impl(parent, term, pos);
    }

    public static final katja.spec.Selector Selector(java.lang.String name) {
        katja.spec.Selector _temp = new katja.spec.Selector.Impl(name);
        if(_termcache.containsKey(_temp)) return (katja.spec.Selector) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.SelectorList SelectorList(katja.spec.Selector... elements) {
        katja.spec.SelectorList _temp = new katja.spec.SelectorList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.SelectorList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.SelectorOptPos SelectorOptPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.SelectorOpt term, final int pos) {
        return term.Switch(new katja.spec.SelectorOpt.Switch<katja.spec.SelectorOptPos, RuntimeException>() { public final katja.spec.SelectorOptPos CaseSelector(katja.spec.Selector term) { return new katja.spec.SelectorPos.Impl(parent, term, pos); } public final katja.spec.SelectorOptPos CaseEmpty(katja.spec.Empty term) { return new katja.spec.EmptyPos.Impl(parent, term, pos); } });
    }

    static final katja.spec.SelectorPos SelectorPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Selector term, final int pos) {
        return new katja.spec.SelectorPos.Impl(parent, term, pos);
    }

    public static final katja.spec.SortId SortId(java.lang.String name, java.lang.Boolean isList, java.lang.String filename, java.lang.Integer line) {
        katja.spec.SortId _temp = new katja.spec.SortId.Impl(name, isList, filename, line);
        if(_termcache.containsKey(_temp)) return (katja.spec.SortId) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.SortIdList SortIdList(katja.spec.SortId... elements) {
        katja.spec.SortIdList _temp = new katja.spec.SortIdList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.SortIdList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.SortIdPos SortIdPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.SortId term, final int pos) {
        return new katja.spec.SortIdPos.Impl(parent, term, pos);
    }

    static final katja.spec.SortSpecPos SortSpecPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.SortSpec term, final int pos) {
        return term.Switch(new katja.spec.SortSpec.Switch<katja.spec.SortSpecPos, RuntimeException>() { public final katja.spec.SortSpecPos CaseExternal(katja.spec.External term) { return new katja.spec.ExternalPos.Impl(parent, term, pos); } public final katja.spec.SortSpecPos CaseTupleProd(katja.spec.TupleProd term) { return new katja.spec.TupleProdPos.Impl(parent, term, pos); } public final katja.spec.SortSpecPos CaseVariantProd(katja.spec.VariantProd term) { return new katja.spec.VariantProdPos.Impl(parent, term, pos); } public final katja.spec.SortSpecPos CaseListProd(katja.spec.ListProd term) { return new katja.spec.ListProdPos.Impl(parent, term, pos); } });
    }

    public static final katja.spec.SortSpecPosList SortSpecPosList(katja.spec.SortSpecPos... elements) {
        katja.spec.SortSpecPosList _temp = new katja.spec.SortSpecPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.SortSpecPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.Specification Specification(java.lang.String name, katja.spec.BackendBlockList backendBlocks, katja.spec.RootList rootlist, katja.spec.ExternalList externalList, katja.spec.ImportList importList, katja.spec.IncludeList includeList, katja.spec.ProductionList prodList, katja.spec.FileNameList filenames) {
        katja.spec.Specification _temp = new katja.spec.Specification.Impl(name, backendBlocks, rootlist, externalList, importList, includeList, prodList, filenames);
        if(_termcache.containsKey(_temp)) return (katja.spec.Specification) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.Specification Specification(java.lang.String name, katja.spec.BackendBlockList backendBlocks, katja.spec.RootList rootlist, katja.spec.ExternalList externalList, katja.spec.ImportList importList, katja.spec.IncludeList includeList, katja.spec.ProductionList prodList, java.lang.String... filenames) {
        katja.spec.FileNameList _list = katja.spec.Katja.FileNameList(filenames);
        katja.spec.Specification _temp = new katja.spec.Specification.Impl(name, backendBlocks, rootlist, externalList, importList, includeList, prodList, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.Specification) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.SpecificationPos SpecificationPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.Specification term, final int pos) {
        return new katja.spec.SpecificationPos.Impl(parent, term, pos);
    }

    public static final katja.spec.SpecificationPos SpecificationPos(katja.spec.Specification term) {
        if(!_Poscache.containsKey(term))
            _Poscache.put(term, new katja.spec.SpecificationPos.Impl(term));

        return _Poscache.get(term);
    }

    public static final katja.spec.SpecificationPosList SpecificationPosList(katja.spec.SpecificationPos... elements) {
        katja.spec.SpecificationPosList _temp = new katja.spec.SpecificationPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.SpecificationPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.StringPos StringPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final java.lang.String term, final int pos) {
        return new katja.spec.StringPos.Impl(parent, term, pos);
    }

    public static final katja.spec.TupleParam TupleParam(katja.spec.SortId sortId, katja.spec.SelectorOpt selector, java.lang.Boolean isOpt) {
        katja.spec.TupleParam _temp = new katja.spec.TupleParam.Impl(sortId, selector, isOpt);
        if(_termcache.containsKey(_temp)) return (katja.spec.TupleParam) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.TupleParamList TupleParamList(katja.spec.TupleParam... elements) {
        katja.spec.TupleParamList _temp = new katja.spec.TupleParamList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.TupleParamList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.TupleParamListPos TupleParamListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.TupleParamList term, final int pos) {
        return new katja.spec.TupleParamListPos.Impl(parent, term, pos);
    }

    static final katja.spec.TupleParamPos TupleParamPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.TupleParam term, final int pos) {
        return new katja.spec.TupleParamPos.Impl(parent, term, pos);
    }

    public static final katja.spec.TupleProd TupleProd(katja.spec.SortId sortId, katja.spec.TupleParamList params) {
        katja.spec.TupleProd _temp = new katja.spec.TupleProd.Impl(sortId, params);
        if(_termcache.containsKey(_temp)) return (katja.spec.TupleProd) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.TupleProd TupleProd(katja.spec.SortId sortId, katja.spec.TupleParam... params) {
        katja.spec.TupleParamList _list = katja.spec.Katja.TupleParamList(params);
        katja.spec.TupleProd _temp = new katja.spec.TupleProd.Impl(sortId, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.TupleProd) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.TupleProdPos TupleProdPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.TupleProd term, final int pos) {
        return new katja.spec.TupleProdPos.Impl(parent, term, pos);
    }

    public static final katja.spec.VariantParamList VariantParamList(katja.spec.VariantParam... elements) {
        katja.spec.VariantParamList _temp = new katja.spec.VariantParamList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.VariantParamList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.VariantParamListPos VariantParamListPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.VariantParamList term, final int pos) {
        return new katja.spec.VariantParamListPos.Impl(parent, term, pos);
    }

    static final katja.spec.VariantParamPos VariantParamPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.VariantParam term, final int pos) {
        return term.Switch(new katja.spec.VariantParam.Switch<katja.spec.VariantParamPos, RuntimeException>() { public final katja.spec.VariantParamPos CaseSortId(katja.spec.SortId term) { return new katja.spec.SortIdPos.Impl(parent, term, pos); } public final katja.spec.VariantParamPos CaseTupleProd(katja.spec.TupleProd term) { return new katja.spec.TupleProdPos.Impl(parent, term, pos); } public final katja.spec.VariantParamPos CaseVariantProd(katja.spec.VariantProd term) { return new katja.spec.VariantProdPos.Impl(parent, term, pos); } public final katja.spec.VariantParamPos CaseListProd(katja.spec.ListProd term) { return new katja.spec.ListProdPos.Impl(parent, term, pos); } });
    }

    public static final katja.spec.VariantParamPosList VariantParamPosList(katja.spec.VariantParamPos... elements) {
        katja.spec.VariantParamPosList _temp = new katja.spec.VariantParamPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.VariantParamPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.VariantPosList VariantPosList(katja.spec.VariantProdPos... elements) {
        katja.spec.VariantPosList _temp = new katja.spec.VariantPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.VariantPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.VariantProd VariantProd(katja.spec.SortId sortId, katja.spec.VariantParamList params) {
        katja.spec.VariantProd _temp = new katja.spec.VariantProd.Impl(sortId, params);
        if(_termcache.containsKey(_temp)) return (katja.spec.VariantProd) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.VariantProd VariantProd(katja.spec.SortId sortId, katja.spec.VariantParam... params) {
        katja.spec.VariantParamList _list = katja.spec.Katja.VariantParamList(params);
        katja.spec.VariantProd _temp = new katja.spec.VariantProd.Impl(sortId, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.VariantProd) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.VariantProdPos VariantProdPos(final KatjaNodePos<katja.spec.SpecificationPos, ?> parent, final katja.spec.VariantProd term, final int pos) {
        return new katja.spec.VariantProdPos.Impl(parent, term, pos);
    }

    public static final KatjaElement fromAssembler(Reader reader) throws IOException {
        return parseInternal(reader, _Katja$Creator);
    }

    //----- nested classes of Katja -----

    public static interface SortPos extends KatjaSortPos<katja.spec.SpecificationPos> {

        //----- methods of SortPos -----

        public Katja.SortPos parent();
        public Katja.SortPos lsib();
        public Katja.SortPos rsib();
        public Katja.SortPos preOrder();
        public Katja.SortPos postOrder();
        public Katja.SortPos postOrderStart();
        public Katja.SortPos follow(List<Integer> path);
    }

    public static interface TermPos<T> extends Katja.SortPos, KatjaTermPos<katja.spec.SpecificationPos, T> {
    }

    public static interface NodePos<T extends KatjaTerm> extends Katja.TermPos<T>, KatjaNodePos<katja.spec.SpecificationPos, T> {
    }

    public static interface LeafPos<T> extends Katja.TermPos<T>, KatjaLeafPos<katja.spec.SpecificationPos, T> {
    }

    public static interface TuplePos<T extends KatjaTuple> extends Katja.NodePos<T>, KatjaTuplePos<katja.spec.SpecificationPos, T> {
    }

    public static interface ListPos<T extends KatjaList<E>, L extends KatjaSortPos<katja.spec.SpecificationPos>, E> extends Katja.NodePos<T>, KatjaListPos<katja.spec.SpecificationPos, T, L, E> {
    }

    private static final class Katja$Creator implements KatjaSpecification.ElementCreator {

        //----- attributes of Katja$Creator -----

        private TreeMap<String, Integer> _sortnumber = new TreeMap<String, Integer>();

        //----- methods of Katja$Creator -----

        Katja$Creator() {
            _sortnumber.put("BackendBlock", 0);
            _sortnumber.put("Empty", 1);
            _sortnumber.put("External", 2);
            _sortnumber.put("Import", 3);
            _sortnumber.put("Include", 4);
            _sortnumber.put("KatjaSpecError", 5);
            _sortnumber.put("KatjaUsageError", 6);
            _sortnumber.put("KatjaWarning", 7);
            _sortnumber.put("ListProd", 8);
            _sortnumber.put("PackageName", 9);
            _sortnumber.put("Root", 10);
            _sortnumber.put("Selector", 11);
            _sortnumber.put("SortId", 12);
            _sortnumber.put("Specification", 13);
            _sortnumber.put("TupleParam", 14);
            _sortnumber.put("TupleProd", 15);
            _sortnumber.put("VariantProd", 16);
            _sortnumber.put("BackendBlockList", 17);
            _sortnumber.put("ExternalList", 18);
            _sortnumber.put("FileNameList", 19);
            _sortnumber.put("ImportList", 20);
            _sortnumber.put("IncludeList", 21);
            _sortnumber.put("KatjaErrorList", 22);
            _sortnumber.put("KatjaWarningList", 23);
            _sortnumber.put("ProductionList", 24);
            _sortnumber.put("ProductionPosList", 25);
            _sortnumber.put("RootList", 26);
            _sortnumber.put("SelectorList", 27);
            _sortnumber.put("SortIdList", 28);
            _sortnumber.put("SortSpecPosList", 29);
            _sortnumber.put("SpecificationPosList", 30);
            _sortnumber.put("TupleParamList", 31);
            _sortnumber.put("VariantParamList", 32);
            _sortnumber.put("VariantParamPosList", 33);
            _sortnumber.put("VariantPosList", 34);
            _sortnumber.put("SpecificationPos", 35);
        }

        public final KatjaElement create(String name, Object[] parameters, int line) {
            if(!_sortnumber.containsKey(name))
                throw new IllegalArgumentException("unknown sort name "+name+", in line "+line);

            switch(_sortnumber.get(name)) {
                case 0:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BackendBlock, in line "+line);

                    if(!(parameters[0] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BackendBlock constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of BackendBlock constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of BackendBlock constructor, in line "+line);
                    return katja.spec.Katja.BackendBlock((java.lang.Integer) parameters[0], (java.lang.String) parameters[1], (java.lang.String) parameters[2]);
                case 1:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Empty, in line "+line);

                    return katja.spec.Katja.Empty();
                case 2:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort External, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of External constructor, in line "+line);
                    return katja.spec.Katja.External((katja.spec.SortId) parameters[0]);
                case 3:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Import, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Import constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Import constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Import constructor, in line "+line);
                    return katja.spec.Katja.Import((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 4:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Include, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Include constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Include constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Include constructor, in line "+line);
                    return katja.spec.Katja.Include((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 5:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaSpecError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaSpecError constructor, in line "+line);
                    return katja.spec.Katja.KatjaSpecError((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 6:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaUsageError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaUsageError constructor, in line "+line);
                    return katja.spec.Katja.KatjaUsageError((java.lang.String) parameters[0]);
                case 7:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaWarning, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaWarning constructor, in line "+line);
                    return katja.spec.Katja.KatjaWarning((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 8:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListProd constructor, in line "+line);
                    return katja.spec.Katja.ListProd((katja.spec.SortId) parameters[0], (katja.spec.SortId) parameters[1]);
                case 9:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PackageName, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PackageName constructor, in line "+line);
                    return katja.spec.Katja.PackageName((java.lang.String) parameters[0]);
                case 10:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Root, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Root constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Root constructor, in line "+line);
                    return katja.spec.Katja.Root((katja.spec.SortId) parameters[0], (java.lang.String) parameters[1]);
                case 11:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Selector, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Selector constructor, in line "+line);
                    return katja.spec.Katja.Selector((java.lang.String) parameters[0]);
                case 12:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort SortId, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of SortId constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of SortId constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of SortId constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of SortId constructor, in line "+line);
                    return katja.spec.Katja.SortId((java.lang.String) parameters[0], (java.lang.Boolean) parameters[1], (java.lang.String) parameters[2], (java.lang.Integer) parameters[3]);
                case 13:
                    if(parameters.length != 8)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Specification, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Specification constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.BackendBlockList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Specification constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.RootList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Specification constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.ExternalList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of Specification constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.ImportList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of Specification constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.IncludeList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of Specification constructor, in line "+line);
                    if(!(parameters[6] instanceof katja.spec.ProductionList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 7 of Specification constructor, in line "+line);
                    if(!(parameters[7] instanceof katja.spec.FileNameList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 8 of Specification constructor, in line "+line);
                    return katja.spec.Katja.Specification((java.lang.String) parameters[0], (katja.spec.BackendBlockList) parameters[1], (katja.spec.RootList) parameters[2], (katja.spec.ExternalList) parameters[3], (katja.spec.ImportList) parameters[4], (katja.spec.IncludeList) parameters[5], (katja.spec.ProductionList) parameters[6], (katja.spec.FileNameList) parameters[7]);
                case 14:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleParam, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleParam constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SelectorOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleParam constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of TupleParam constructor, in line "+line);
                    return katja.spec.Katja.TupleParam((katja.spec.SortId) parameters[0], (katja.spec.SelectorOpt) parameters[1], (java.lang.Boolean) parameters[2]);
                case 15:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.TupleParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleProd constructor, in line "+line);
                    return katja.spec.Katja.TupleProd((katja.spec.SortId) parameters[0], (katja.spec.TupleParamList) parameters[1]);
                case 16:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort VariantProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of VariantProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.VariantParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of VariantProd constructor, in line "+line);
                    return katja.spec.Katja.VariantProd((katja.spec.SortId) parameters[0], (katja.spec.VariantParamList) parameters[1]);
                case 17:
                    katja.spec.BackendBlock[] _BackendBlockList$array = new katja.spec.BackendBlock[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.BackendBlock))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for BackendBlockList constructor, in line "+line);
                        _BackendBlockList$array[i] = (katja.spec.BackendBlock) parameters[i];
                    }

                    return katja.spec.Katja.BackendBlockList(_BackendBlockList$array);
                case 18:
                    katja.spec.External[] _ExternalList$array = new katja.spec.External[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.External))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternalList constructor, in line "+line);
                        _ExternalList$array[i] = (katja.spec.External) parameters[i];
                    }

                    return katja.spec.Katja.ExternalList(_ExternalList$array);
                case 19:
                    java.lang.String[] _FileNameList$array = new java.lang.String[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof java.lang.String))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for FileNameList constructor, in line "+line);
                        _FileNameList$array[i] = (java.lang.String) parameters[i];
                    }

                    return katja.spec.Katja.FileNameList(_FileNameList$array);
                case 20:
                    katja.spec.Import[] _ImportList$array = new katja.spec.Import[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Import))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ImportList constructor, in line "+line);
                        _ImportList$array[i] = (katja.spec.Import) parameters[i];
                    }

                    return katja.spec.Katja.ImportList(_ImportList$array);
                case 21:
                    katja.spec.Include[] _IncludeList$array = new katja.spec.Include[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Include))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IncludeList constructor, in line "+line);
                        _IncludeList$array[i] = (katja.spec.Include) parameters[i];
                    }

                    return katja.spec.Katja.IncludeList(_IncludeList$array);
                case 22:
                    katja.spec.KatjaError[] _KatjaErrorList$array = new katja.spec.KatjaError[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaError))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaErrorList constructor, in line "+line);
                        _KatjaErrorList$array[i] = (katja.spec.KatjaError) parameters[i];
                    }

                    return katja.spec.Katja.KatjaErrorList(_KatjaErrorList$array);
                case 23:
                    katja.spec.KatjaWarning[] _KatjaWarningList$array = new katja.spec.KatjaWarning[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaWarning))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaWarningList constructor, in line "+line);
                        _KatjaWarningList$array[i] = (katja.spec.KatjaWarning) parameters[i];
                    }

                    return katja.spec.Katja.KatjaWarningList(_KatjaWarningList$array);
                case 24:
                    katja.spec.Production[] _ProductionList$array = new katja.spec.Production[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Production))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionList constructor, in line "+line);
                        _ProductionList$array[i] = (katja.spec.Production) parameters[i];
                    }

                    return katja.spec.Katja.ProductionList(_ProductionList$array);
                case 25:
                    katja.spec.ProductionPos[] _ProductionPosList$array = new katja.spec.ProductionPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.ProductionPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionPosList constructor, in line "+line);
                        _ProductionPosList$array[i] = (katja.spec.ProductionPos) parameters[i];
                    }

                    return katja.spec.Katja.ProductionPosList(_ProductionPosList$array);
                case 26:
                    katja.spec.Root[] _RootList$array = new katja.spec.Root[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Root))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for RootList constructor, in line "+line);
                        _RootList$array[i] = (katja.spec.Root) parameters[i];
                    }

                    return katja.spec.Katja.RootList(_RootList$array);
                case 27:
                    katja.spec.Selector[] _SelectorList$array = new katja.spec.Selector[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Selector))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SelectorList constructor, in line "+line);
                        _SelectorList$array[i] = (katja.spec.Selector) parameters[i];
                    }

                    return katja.spec.Katja.SelectorList(_SelectorList$array);
                case 28:
                    katja.spec.SortId[] _SortIdList$array = new katja.spec.SortId[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortId))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortIdList constructor, in line "+line);
                        _SortIdList$array[i] = (katja.spec.SortId) parameters[i];
                    }

                    return katja.spec.Katja.SortIdList(_SortIdList$array);
                case 29:
                    katja.spec.SortSpecPos[] _SortSpecPosList$array = new katja.spec.SortSpecPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortSpecPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortSpecPosList constructor, in line "+line);
                        _SortSpecPosList$array[i] = (katja.spec.SortSpecPos) parameters[i];
                    }

                    return katja.spec.Katja.SortSpecPosList(_SortSpecPosList$array);
                case 30:
                    katja.spec.SpecificationPos[] _SpecificationPosList$array = new katja.spec.SpecificationPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SpecificationPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SpecificationPosList constructor, in line "+line);
                        _SpecificationPosList$array[i] = (katja.spec.SpecificationPos) parameters[i];
                    }

                    return katja.spec.Katja.SpecificationPosList(_SpecificationPosList$array);
                case 31:
                    katja.spec.TupleParam[] _TupleParamList$array = new katja.spec.TupleParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.TupleParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleParamList constructor, in line "+line);
                        _TupleParamList$array[i] = (katja.spec.TupleParam) parameters[i];
                    }

                    return katja.spec.Katja.TupleParamList(_TupleParamList$array);
                case 32:
                    katja.spec.VariantParam[] _VariantParamList$array = new katja.spec.VariantParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamList constructor, in line "+line);
                        _VariantParamList$array[i] = (katja.spec.VariantParam) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamList(_VariantParamList$array);
                case 33:
                    katja.spec.VariantParamPos[] _VariantParamPosList$array = new katja.spec.VariantParamPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParamPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamPosList constructor, in line "+line);
                        _VariantParamPosList$array[i] = (katja.spec.VariantParamPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamPosList(_VariantParamPosList$array);
                case 34:
                    katja.spec.VariantProdPos[] _VariantPosList$array = new katja.spec.VariantProdPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantProdPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantPosList constructor, in line "+line);
                        _VariantPosList$array[i] = (katja.spec.VariantProdPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantPosList(_VariantPosList$array);
                case 35:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given root position SpecificationPos, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.Specification))
                        throw new IllegalArgumentException("wrong sort on stack as parameter for SpecificationPos constructor, in line "+line);

                    return katja.spec.Katja.SpecificationPos((katja.spec.Specification) parameters[0]);
                default:
                    throw new IllegalStateException("impossible state");
            }
        }
    }
}

