package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface KatjaErrorList extends KatjaList<katja.spec.KatjaError> {

    //----- methods of KatjaErrorList -----

    public katja.spec.KatjaErrorList add(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList addAll(KatjaList<? extends katja.spec.KatjaError> list);
    public katja.spec.KatjaErrorList remove(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList removeAll(KatjaList<? extends katja.spec.KatjaError> list);
    public katja.spec.KatjaErrorList appBack(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList appFront(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList conc(KatjaList<? extends katja.spec.KatjaError> list);
    public katja.spec.KatjaErrorList front();
    public katja.spec.KatjaErrorList back();
    public katja.spec.KatjaErrorList reverse();
    public katja.spec.KatjaErrorList sublist(int from, int to);
    public katja.spec.KatjaErrorList replace(int ith, Object element);
    public katja.spec.KatjaErrorList toSet();
    public katja.spec.KatjaErrorList setAdd(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList setRemove(katja.spec.KatjaError element);
    public katja.spec.KatjaErrorList setUnion(KatjaList<? extends katja.spec.KatjaError> list);
    public katja.spec.KatjaErrorList setIntersection(KatjaList<? extends katja.spec.KatjaError> list);
    public katja.spec.KatjaErrorList setWithout(KatjaList<? extends katja.spec.KatjaError> list);

    //----- nested classes of KatjaErrorList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitKatjaError(katja.spec.KatjaError term) throws E;
        public void visitKatjaSpecError(katja.spec.KatjaSpecError term) throws E;
        public void visitKatjaUsageError(katja.spec.KatjaUsageError term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitKatjaErrorList(katja.spec.KatjaErrorList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.KatjaErrorList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.KatjaError.Switch<Object, E> variantVisit$KatjaError = new katja.spec.KatjaError.Switch<Object, E>() { public final Object CaseKatjaSpecError(katja.spec.KatjaSpecError term) throws E { visitKatjaSpecError(term); return null; } public final Object CaseKatjaUsageError(katja.spec.KatjaUsageError term) throws E { visitKatjaUsageError(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitKatjaError(katja.spec.KatjaError term) throws E {
            term.Switch(variantVisit$KatjaError);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.KatjaError> implements katja.spec.KatjaErrorList {

        //----- methods of Impl -----

        Impl(katja.spec.KatjaError... elements) {
            super(elements);

            for(katja.spec.KatjaError element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort KatjaErrorList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.KatjaErrorList createInstance(katja.spec.KatjaError[] elements, boolean isSet) {
            for(katja.spec.KatjaError element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort KatjaErrorList invoked with null element");

            KatjaErrorList.Impl temp = new katja.spec.KatjaErrorList.Impl();
            temp.values = elements;
            temp = (KatjaErrorList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.KatjaError[] createArray(int size) {
            return new katja.spec.KatjaError[size];
        }

        public katja.spec.KatjaErrorList add(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.add(element);
        }

        public katja.spec.KatjaErrorList addAll(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.addAll(list);
        }

        public katja.spec.KatjaErrorList remove(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.remove(element);
        }

        public katja.spec.KatjaErrorList removeAll(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.removeAll(list);
        }

        public katja.spec.KatjaErrorList appBack(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.appBack(element);
        }

        public katja.spec.KatjaErrorList appFront(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.appFront(element);
        }

        public katja.spec.KatjaErrorList conc(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.conc(list);
        }

        public katja.spec.KatjaErrorList front() {
            return (katja.spec.KatjaErrorList) super.front();
        }

        public katja.spec.KatjaErrorList back() {
            return (katja.spec.KatjaErrorList) super.back();
        }

        public katja.spec.KatjaErrorList reverse() {
            return (katja.spec.KatjaErrorList) super.reverse();
        }

        public katja.spec.KatjaErrorList sublist(int from, int to) {
            return (katja.spec.KatjaErrorList) super.sublist(from, to);
        }

        public katja.spec.KatjaErrorList replace(int ith, Object element) {
            return (katja.spec.KatjaErrorList) super.replace(ith, element);
        }

        public katja.spec.KatjaErrorList toSet() {
            return (katja.spec.KatjaErrorList) super.toSet();
        }

        public katja.spec.KatjaErrorList setAdd(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.setAdd(element);
        }

        public katja.spec.KatjaErrorList setRemove(katja.spec.KatjaError element) {
            return (katja.spec.KatjaErrorList) super.setRemove(element);
        }

        public katja.spec.KatjaErrorList setUnion(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.setUnion(list);
        }

        public katja.spec.KatjaErrorList setIntersection(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.setIntersection(list);
        }

        public katja.spec.KatjaErrorList setWithout(KatjaList<? extends katja.spec.KatjaError> list) {
            return (katja.spec.KatjaErrorList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.KatjaErrorList");
            builder.append("( ");
            for(katja.spec.KatjaError element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaErrorList");
            builder.append("( ");
            for(katja.spec.KatjaError element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "KatjaErrorList";
        }
    }
}

