package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface KatjaUsageError extends katja.spec.KatjaError, KatjaTuple {

    //----- methods of KatjaUsageError -----

    public java.lang.String message();
    public katja.spec.KatjaUsageError replaceMessage(java.lang.String message);
    public java.lang.String get(int i);
    public int size();
    public katja.spec.KatjaUsageError replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.KatjaError.Switch<CT, E> switchClass) throws E;

    //----- nested classes of KatjaUsageError -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitKatjaUsageError(katja.spec.KatjaUsageError term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.KatjaUsageError.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.KatjaUsageError {

        //----- attributes of Impl -----

        private java.lang.String _message = null;

        //----- methods of Impl -----

        public java.lang.String message() {
            return _message;
        }

        public katja.spec.KatjaUsageError replaceMessage(java.lang.String message) {
            return replace(0, message);
        }

        Impl(java.lang.String message) {
            if(message == null)
                throw new IllegalArgumentException("constructor of sort KatjaUsageError invoked with null parameter message");

            this._message = message;
        }

        public java.lang.String get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _message;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort KatjaUsageError invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort KatjaUsageError invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.KatjaUsageError replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort KatjaUsageError invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort KatjaUsageError invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort KatjaUsageError invoked with term of incorrect sort, String expected");

            return (katja.spec.KatjaUsageError) Katja.unique(new katja.spec.KatjaUsageError.Impl(
                pos == 0 ? (java.lang.String) term : _message
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.KatjaError.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseKatjaUsageError(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.KatjaUsageError");
            builder.append("( ");
            builder.append("\"").append(_message.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("KatjaUsageError");
            builder.append("( ");
            builder.append("\"").append(_message.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "KatjaUsageError";
        }
    }
}

