package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface KatjaWarning extends KatjaTuple {

    //----- methods of KatjaWarning -----

    public java.lang.String message();
    public katja.spec.KatjaWarning replaceMessage(java.lang.String message);
    public java.lang.String file();
    public katja.spec.KatjaWarning replaceFile(java.lang.String file);
    public java.lang.Integer line();
    public katja.spec.KatjaWarning replaceLine(java.lang.Integer line);
    public Object get(int i);
    public int size();
    public katja.spec.KatjaWarning replace(int pos, Object term);

    //----- nested classes of KatjaWarning -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitKatjaWarning(katja.spec.KatjaWarning term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.KatjaWarning.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.KatjaWarning {

        //----- attributes of Impl -----

        private java.lang.String _message = null;
        private java.lang.String _file = null;
        private java.lang.Integer _line = null;

        //----- methods of Impl -----

        public java.lang.String message() {
            return _message;
        }

        public katja.spec.KatjaWarning replaceMessage(java.lang.String message) {
            return replace(0, message);
        }

        public java.lang.String file() {
            return _file;
        }

        public katja.spec.KatjaWarning replaceFile(java.lang.String file) {
            return replace(1, file);
        }

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.KatjaWarning replaceLine(java.lang.Integer line) {
            return replace(2, line);
        }

        Impl(java.lang.String message, java.lang.String file, java.lang.Integer line) {
            if(message == null)
                throw new IllegalArgumentException("constructor of sort KatjaWarning invoked with null parameter message");
            if(file == null)
                throw new IllegalArgumentException("constructor of sort KatjaWarning invoked with null parameter file");
            if(line == null)
                throw new IllegalArgumentException("constructor of sort KatjaWarning invoked with null parameter line");

            this._message = message;
            this._file = file;
            this._line = line;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0: return _message;
                case 1: return _file;
                case 2: return _line;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort KatjaWarning invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort KatjaWarning invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.KatjaWarning replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort KatjaWarning invoked with negative parameter "+pos);
            if(pos >= 3)
                throw new IllegalArgumentException("replace on sort KatjaWarning invoked with too large parameter "+pos+", sort has only 3 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort KatjaWarning invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort KatjaWarning invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort KatjaWarning invoked with term of incorrect sort, Integer expected");

            return (katja.spec.KatjaWarning) Katja.unique(new katja.spec.KatjaWarning.Impl(
                pos == 0 ? (java.lang.String) term : _message,
                pos == 1 ? (java.lang.String) term : _file,
                pos == 2 ? (java.lang.Integer) term : _line
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.KatjaWarning");
            builder.append("( ");
            builder.append("\"").append(_message.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_file.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("KatjaWarning");
            builder.append("( ");
            builder.append("\"").append(_message.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_file.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "KatjaWarning";
        }
    }
}

