package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface KatjaWarningList extends KatjaList<katja.spec.KatjaWarning> {

    //----- methods of KatjaWarningList -----

    public katja.spec.KatjaWarningList add(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList addAll(KatjaList<? extends katja.spec.KatjaWarning> list);
    public katja.spec.KatjaWarningList remove(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList removeAll(KatjaList<? extends katja.spec.KatjaWarning> list);
    public katja.spec.KatjaWarningList appBack(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList appFront(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList conc(KatjaList<? extends katja.spec.KatjaWarning> list);
    public katja.spec.KatjaWarningList front();
    public katja.spec.KatjaWarningList back();
    public katja.spec.KatjaWarningList reverse();
    public katja.spec.KatjaWarningList sublist(int from, int to);
    public katja.spec.KatjaWarningList replace(int ith, Object element);
    public katja.spec.KatjaWarningList toSet();
    public katja.spec.KatjaWarningList setAdd(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList setRemove(katja.spec.KatjaWarning element);
    public katja.spec.KatjaWarningList setUnion(KatjaList<? extends katja.spec.KatjaWarning> list);
    public katja.spec.KatjaWarningList setIntersection(KatjaList<? extends katja.spec.KatjaWarning> list);
    public katja.spec.KatjaWarningList setWithout(KatjaList<? extends katja.spec.KatjaWarning> list);

    //----- nested classes of KatjaWarningList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitKatjaWarning(katja.spec.KatjaWarning term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitKatjaWarningList(katja.spec.KatjaWarningList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.KatjaWarningList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.KatjaWarning> implements katja.spec.KatjaWarningList {

        //----- methods of Impl -----

        Impl(katja.spec.KatjaWarning... elements) {
            super(elements);

            for(katja.spec.KatjaWarning element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort KatjaWarningList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.KatjaWarningList createInstance(katja.spec.KatjaWarning[] elements, boolean isSet) {
            for(katja.spec.KatjaWarning element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort KatjaWarningList invoked with null element");

            KatjaWarningList.Impl temp = new katja.spec.KatjaWarningList.Impl();
            temp.values = elements;
            temp = (KatjaWarningList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.KatjaWarning[] createArray(int size) {
            return new katja.spec.KatjaWarning[size];
        }

        public katja.spec.KatjaWarningList add(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.add(element);
        }

        public katja.spec.KatjaWarningList addAll(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.addAll(list);
        }

        public katja.spec.KatjaWarningList remove(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.remove(element);
        }

        public katja.spec.KatjaWarningList removeAll(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.removeAll(list);
        }

        public katja.spec.KatjaWarningList appBack(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.appBack(element);
        }

        public katja.spec.KatjaWarningList appFront(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.appFront(element);
        }

        public katja.spec.KatjaWarningList conc(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.conc(list);
        }

        public katja.spec.KatjaWarningList front() {
            return (katja.spec.KatjaWarningList) super.front();
        }

        public katja.spec.KatjaWarningList back() {
            return (katja.spec.KatjaWarningList) super.back();
        }

        public katja.spec.KatjaWarningList reverse() {
            return (katja.spec.KatjaWarningList) super.reverse();
        }

        public katja.spec.KatjaWarningList sublist(int from, int to) {
            return (katja.spec.KatjaWarningList) super.sublist(from, to);
        }

        public katja.spec.KatjaWarningList replace(int ith, Object element) {
            return (katja.spec.KatjaWarningList) super.replace(ith, element);
        }

        public katja.spec.KatjaWarningList toSet() {
            return (katja.spec.KatjaWarningList) super.toSet();
        }

        public katja.spec.KatjaWarningList setAdd(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.setAdd(element);
        }

        public katja.spec.KatjaWarningList setRemove(katja.spec.KatjaWarning element) {
            return (katja.spec.KatjaWarningList) super.setRemove(element);
        }

        public katja.spec.KatjaWarningList setUnion(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.setUnion(list);
        }

        public katja.spec.KatjaWarningList setIntersection(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.setIntersection(list);
        }

        public katja.spec.KatjaWarningList setWithout(KatjaList<? extends katja.spec.KatjaWarning> list) {
            return (katja.spec.KatjaWarningList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.KatjaWarningList");
            builder.append("( ");
            for(katja.spec.KatjaWarning element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaWarningList");
            builder.append("( ");
            for(katja.spec.KatjaWarning element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "KatjaWarningList";
        }
    }
}

