package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface ListProdPos extends katja.spec.ProductionPos, katja.spec.Katja.TuplePos<katja.spec.ListProd> {

    //----- methods of ListProdPos -----

    public katja.spec.ListProd termProduction();
    public katja.spec.ListProd termSortSpec();
    public katja.spec.ListProd termVariantParam();
    public katja.spec.ListProd term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.ListProdPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.SortIdPos param();
    public katja.spec.ListProdPos replaceParam(katja.spec.SortId param);
    public katja.spec.SortIdPos get(int i);
    public int size();
    public katja.spec.ListProdPos replace(katja.spec.ListProd term);
    public katja.spec.Katja.ListPos<?, ?, ?> parent();
    public katja.spec.VariantParamPos lsib();
    public katja.spec.VariantParamPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ListProdPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ListProdPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.ListProd> implements katja.spec.ListProdPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;
        private katja.spec.SortIdPos _param = null;

        //----- methods of Impl -----

        public katja.spec.ListProd termProduction() {
            return term();
        }

        public katja.spec.ListProd termSortSpec() {
            return term();
        }

        public katja.spec.ListProd termVariantParam() {
            return term();
        }

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.ListProdPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        public katja.spec.SortIdPos param() {
            if(_param == null)
                _param = katja.spec.Katja.SortIdPos(this, _term.param(), 1);

            return _param;
        }

        public katja.spec.ListProdPos replaceParam(katja.spec.SortId param) {
            return replace(_term.replaceParam(param));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.ListProd term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.SortIdPos get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                case 1:
                    if(_param == null)
                        _param = Katja.SortIdPos(this, _term.param(), 1);
                    
                    return _param;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ListProdPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ListProdPos invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.ListProdPos replace(katja.spec.ListProd term) {
            return (katja.spec.ListProdPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.ListPos<?, ?, ?> parent() {
            return (katja.spec.Katja.ListPos<?, ?, ?>) super.parent();
        }

        public katja.spec.VariantParamPos lsib() {
            return (katja.spec.VariantParamPos) super.lsib();
        }

        public katja.spec.VariantParamPos rsib() {
            return (katja.spec.VariantParamPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseListProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseListProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseListProdPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ListProdPos";
        }
    }
}

