package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface PackageName extends katja.spec.PackageDcl, KatjaTuple {

    //----- methods of PackageName -----

    public java.lang.String name();
    public katja.spec.PackageName replaceName(java.lang.String name);
    public java.lang.String get(int i);
    public int size();
    public katja.spec.PackageName replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.PackageDcl.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PackageName -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitPackageName(katja.spec.PackageName term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.PackageName.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.PackageName {

        //----- attributes of Impl -----

        private java.lang.String _name = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.PackageName replaceName(java.lang.String name) {
            return replace(0, name);
        }

        Impl(java.lang.String name) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort PackageName invoked with null parameter name");

            this._name = name;
        }

        public java.lang.String get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _name;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PackageName invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PackageName invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.PackageName replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort PackageName invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort PackageName invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort PackageName invoked with term of incorrect sort, String expected");

            return (katja.spec.PackageName) Katja.unique(new katja.spec.PackageName.Impl(
                pos == 0 ? (java.lang.String) term : _name
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.PackageDcl.Switch<CT, E> switchClass) throws E {
            return switchClass.CasePackageName(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.PackageName");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("PackageName");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PackageName";
        }
    }
}

