package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface ProductionList extends KatjaList<katja.spec.Production> {

    //----- methods of ProductionList -----

    public katja.spec.ProductionList add(katja.spec.Production element);
    public katja.spec.ProductionList addAll(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionList remove(katja.spec.Production element);
    public katja.spec.ProductionList removeAll(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionList appBack(katja.spec.Production element);
    public katja.spec.ProductionList appFront(katja.spec.Production element);
    public katja.spec.ProductionList conc(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionList front();
    public katja.spec.ProductionList back();
    public katja.spec.ProductionList reverse();
    public katja.spec.ProductionList sublist(int from, int to);
    public katja.spec.ProductionList replace(int ith, Object element);
    public katja.spec.ProductionList toSet();
    public katja.spec.ProductionList setAdd(katja.spec.Production element);
    public katja.spec.ProductionList setRemove(katja.spec.Production element);
    public katja.spec.ProductionList setUnion(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionList setIntersection(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionList setWithout(KatjaList<? extends katja.spec.Production> list);

    //----- nested classes of ProductionList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitProduction(katja.spec.Production term) throws E;
        public void visitTupleProd(katja.spec.TupleProd term) throws E;
        public void visitVariantProd(katja.spec.VariantProd term) throws E;
        public void visitListProd(katja.spec.ListProd term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
        public void visitVariantParamList(katja.spec.VariantParamList term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitVariantParam(katja.spec.VariantParam term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
        public void visitProductionList(katja.spec.ProductionList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ProductionList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };
        private final katja.spec.VariantParam.Switch<Object, E> variantVisit$VariantParam = new katja.spec.VariantParam.Switch<Object, E>() { public final Object CaseSortId(katja.spec.SortId term) throws E { visitSortId(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProduction(katja.spec.Production term) throws E {
            term.Switch(variantVisit$VariantParam);
        }

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }

        public final void visitVariantParam(katja.spec.VariantParam term) throws E {
            term.Switch(variantVisit$VariantParam);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.Production> implements katja.spec.ProductionList {

        //----- methods of Impl -----

        Impl(katja.spec.Production... elements) {
            super(elements);

            for(katja.spec.Production element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ProductionList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.ProductionList createInstance(katja.spec.Production[] elements, boolean isSet) {
            for(katja.spec.Production element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ProductionList invoked with null element");

            ProductionList.Impl temp = new katja.spec.ProductionList.Impl();
            temp.values = elements;
            temp = (ProductionList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.Production[] createArray(int size) {
            return new katja.spec.Production[size];
        }

        public katja.spec.ProductionList add(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.add(element);
        }

        public katja.spec.ProductionList addAll(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.addAll(list);
        }

        public katja.spec.ProductionList remove(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.remove(element);
        }

        public katja.spec.ProductionList removeAll(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.removeAll(list);
        }

        public katja.spec.ProductionList appBack(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.appBack(element);
        }

        public katja.spec.ProductionList appFront(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.appFront(element);
        }

        public katja.spec.ProductionList conc(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.conc(list);
        }

        public katja.spec.ProductionList front() {
            return (katja.spec.ProductionList) super.front();
        }

        public katja.spec.ProductionList back() {
            return (katja.spec.ProductionList) super.back();
        }

        public katja.spec.ProductionList reverse() {
            return (katja.spec.ProductionList) super.reverse();
        }

        public katja.spec.ProductionList sublist(int from, int to) {
            return (katja.spec.ProductionList) super.sublist(from, to);
        }

        public katja.spec.ProductionList replace(int ith, Object element) {
            return (katja.spec.ProductionList) super.replace(ith, element);
        }

        public katja.spec.ProductionList toSet() {
            return (katja.spec.ProductionList) super.toSet();
        }

        public katja.spec.ProductionList setAdd(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.setAdd(element);
        }

        public katja.spec.ProductionList setRemove(katja.spec.Production element) {
            return (katja.spec.ProductionList) super.setRemove(element);
        }

        public katja.spec.ProductionList setUnion(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.setUnion(list);
        }

        public katja.spec.ProductionList setIntersection(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.setIntersection(list);
        }

        public katja.spec.ProductionList setWithout(KatjaList<? extends katja.spec.Production> list) {
            return (katja.spec.ProductionList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.ProductionList");
            builder.append("( ");
            for(katja.spec.Production element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ProductionList");
            builder.append("( ");
            for(katja.spec.Production element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ProductionList";
        }
    }
}

