package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ProductionListPos extends katja.spec.Katja.ListPos<katja.spec.ProductionList, katja.spec.ProductionPos, katja.spec.Production> {

    //----- methods of ProductionListPos -----

    public katja.spec.ProductionList term();
    public katja.spec.ProductionListPos add(katja.spec.Production element);
    public katja.spec.ProductionListPos addAll(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionListPos remove(katja.spec.Production element);
    public katja.spec.ProductionListPos removeAll(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionListPos appBack(katja.spec.Production element);
    public katja.spec.ProductionListPos appFront(katja.spec.Production element);
    public katja.spec.ProductionListPos conc(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionListPos reverse();
    public katja.spec.ProductionListPos toSet();
    public katja.spec.ProductionListPos setAdd(katja.spec.Production element);
    public katja.spec.ProductionListPos setRemove(katja.spec.Production element);
    public katja.spec.ProductionListPos setUnion(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionListPos setWithout(KatjaList<? extends katja.spec.Production> list);
    public katja.spec.ProductionListPos setIntersection(KatjaList<? extends katja.spec.Production> list);
    public KatjaList<katja.spec.ProductionPos> toList();
    public katja.spec.ProductionListPos replace(katja.spec.ProductionList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.IncludeListPos lsib();
    public katja.spec.FileNameListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of ProductionListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.ProductionPos> implements KatjaList<katja.spec.ProductionPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.ProductionPos... elements) {
            super(elements);

            for(katja.spec.ProductionPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ProductionPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.ProductionPos> createInstance(katja.spec.ProductionPos[] elements, boolean isSet) {
            for(katja.spec.ProductionPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort ProductionPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.ProductionPos[] createArray(int size) {
            return new katja.spec.ProductionPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.ProductionPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitProductionListPos(katja.spec.ProductionListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ProductionListPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.ProductionList, katja.spec.ProductionPos, katja.spec.Production> implements katja.spec.ProductionListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.ProductionList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.ProductionPos getElementInstance(int pos) {
            return katja.spec.Katja.ProductionPos(this, _term.get(pos), pos);
        }

        protected katja.spec.ProductionPos[] createArray(int size) {
            return new katja.spec.ProductionPos[size];
        }

        public katja.spec.ProductionListPos add(katja.spec.Production element) {
            return replace(_term.add(element));
        }

        public katja.spec.ProductionListPos addAll(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.ProductionListPos remove(katja.spec.Production element) {
            return replace(_term.remove(element));
        }

        public katja.spec.ProductionListPos removeAll(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.ProductionListPos appBack(katja.spec.Production element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.ProductionListPos appFront(katja.spec.Production element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.ProductionListPos conc(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.ProductionListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.ProductionListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.ProductionListPos setAdd(katja.spec.Production element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.ProductionListPos setRemove(katja.spec.Production element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.ProductionListPos setUnion(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.ProductionListPos setWithout(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.ProductionListPos setIntersection(KatjaList<? extends katja.spec.Production> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.ProductionPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new ProductionListPos.ListImpl(values);
        }

        public katja.spec.ProductionListPos replace(katja.spec.ProductionList term) {
            return (katja.spec.ProductionListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.IncludeListPos lsib() {
            return (katja.spec.IncludeListPos) super.lsib();
        }

        public katja.spec.FileNameListPos rsib() {
            return (katja.spec.FileNameListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ProductionListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.ProductionPos> implements KatjaList<katja.spec.ProductionPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.ProductionPos... elements) {
                super(elements);

                for(katja.spec.ProductionPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ProductionPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.ProductionPos> createInstance(katja.spec.ProductionPos[] elements, boolean isSet) {
                for(katja.spec.ProductionPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort ProductionPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.ProductionPos[] createArray(int size) {
                return new katja.spec.ProductionPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.ProductionPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

