package katja.spec;

import katja.common.*;

public interface ProductionPos extends katja.spec.SortSpecPos, katja.spec.VariantParamPos, katja.spec.Katja.SortPos {

    //----- methods of ProductionPos -----

    public katja.spec.Production termSortSpec();
    public katja.spec.Production termVariantParam();
    public KatjaSort term();
    public katja.spec.Production termProduction();
    public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ProductionPos -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public CT CaseVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public CT CaseListProdPos(katja.spec.ListProdPos term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ProductionPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.ProductionPos.Switch<Object, E> variantVisit$ProductionPos = new katja.spec.ProductionPos.Switch<Object, E>() { public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$ProductionPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }
}

