package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface ProductionPosList extends KatjaList<katja.spec.ProductionPos> {

    //----- methods of ProductionPosList -----

    public katja.spec.ProductionPosList add(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList addAll(KatjaList<? extends katja.spec.ProductionPos> list);
    public katja.spec.ProductionPosList remove(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList removeAll(KatjaList<? extends katja.spec.ProductionPos> list);
    public katja.spec.ProductionPosList appBack(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList appFront(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList conc(KatjaList<? extends katja.spec.ProductionPos> list);
    public katja.spec.ProductionPosList front();
    public katja.spec.ProductionPosList back();
    public katja.spec.ProductionPosList reverse();
    public katja.spec.ProductionPosList sublist(int from, int to);
    public katja.spec.ProductionPosList replace(int ith, Object element);
    public katja.spec.ProductionPosList toSet();
    public katja.spec.ProductionPosList setAdd(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList setRemove(katja.spec.ProductionPos element);
    public katja.spec.ProductionPosList setUnion(KatjaList<? extends katja.spec.ProductionPos> list);
    public katja.spec.ProductionPosList setIntersection(KatjaList<? extends katja.spec.ProductionPos> list);
    public katja.spec.ProductionPosList setWithout(KatjaList<? extends katja.spec.ProductionPos> list);

    //----- nested classes of ProductionPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitProductionPosList(katja.spec.ProductionPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.ProductionPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.ProductionPos> implements katja.spec.ProductionPosList {

        //----- methods of Impl -----

        Impl(katja.spec.ProductionPos... elements) {
            super(elements);

            for(katja.spec.ProductionPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ProductionPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.ProductionPosList createInstance(katja.spec.ProductionPos[] elements, boolean isSet) {
            for(katja.spec.ProductionPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ProductionPosList invoked with null element");

            ProductionPosList.Impl temp = new katja.spec.ProductionPosList.Impl();
            temp.values = elements;
            temp = (ProductionPosList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.ProductionPos[] createArray(int size) {
            return new katja.spec.ProductionPos[size];
        }

        public katja.spec.ProductionPosList add(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.add(element);
        }

        public katja.spec.ProductionPosList addAll(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.addAll(list);
        }

        public katja.spec.ProductionPosList remove(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.remove(element);
        }

        public katja.spec.ProductionPosList removeAll(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.removeAll(list);
        }

        public katja.spec.ProductionPosList appBack(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.appBack(element);
        }

        public katja.spec.ProductionPosList appFront(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.appFront(element);
        }

        public katja.spec.ProductionPosList conc(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.conc(list);
        }

        public katja.spec.ProductionPosList front() {
            return (katja.spec.ProductionPosList) super.front();
        }

        public katja.spec.ProductionPosList back() {
            return (katja.spec.ProductionPosList) super.back();
        }

        public katja.spec.ProductionPosList reverse() {
            return (katja.spec.ProductionPosList) super.reverse();
        }

        public katja.spec.ProductionPosList sublist(int from, int to) {
            return (katja.spec.ProductionPosList) super.sublist(from, to);
        }

        public katja.spec.ProductionPosList replace(int ith, Object element) {
            return (katja.spec.ProductionPosList) super.replace(ith, element);
        }

        public katja.spec.ProductionPosList toSet() {
            return (katja.spec.ProductionPosList) super.toSet();
        }

        public katja.spec.ProductionPosList setAdd(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.setAdd(element);
        }

        public katja.spec.ProductionPosList setRemove(katja.spec.ProductionPos element) {
            return (katja.spec.ProductionPosList) super.setRemove(element);
        }

        public katja.spec.ProductionPosList setUnion(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.setUnion(list);
        }

        public katja.spec.ProductionPosList setIntersection(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.setIntersection(list);
        }

        public katja.spec.ProductionPosList setWithout(KatjaList<? extends katja.spec.ProductionPos> list) {
            return (katja.spec.ProductionPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.ProductionPosList");
            builder.append("( ");
            for(katja.spec.ProductionPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ProductionPosList");
            builder.append("( ");
            for(katja.spec.ProductionPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ProductionPosList";
        }
    }
}

