package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface Root extends KatjaTuple {

    //----- methods of Root -----

    public katja.spec.SortId sortId();
    public katja.spec.Root replaceSortId(katja.spec.SortId sortId);
    public java.lang.String suffix();
    public katja.spec.Root replaceSuffix(java.lang.String suffix);
    public Object get(int i);
    public int size();
    public katja.spec.Root replace(int pos, Object term);

    //----- nested classes of Root -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitRoot(katja.spec.Root term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.Root.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.Root {

        //----- attributes of Impl -----

        private katja.spec.SortId _sortId = null;
        private java.lang.String _suffix = null;

        //----- methods of Impl -----

        public katja.spec.SortId sortId() {
            return _sortId;
        }

        public katja.spec.Root replaceSortId(katja.spec.SortId sortId) {
            return replace(0, sortId);
        }

        public java.lang.String suffix() {
            return _suffix;
        }

        public katja.spec.Root replaceSuffix(java.lang.String suffix) {
            return replace(1, suffix);
        }

        Impl(katja.spec.SortId sortId, java.lang.String suffix) {
            if(sortId == null)
                throw new IllegalArgumentException("constructor of sort Root invoked with null parameter sortId");
            if(suffix == null)
                throw new IllegalArgumentException("constructor of sort Root invoked with null parameter suffix");

            this._sortId = sortId;
            this._suffix = suffix;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _sortId;
                case 1: return _suffix;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Root invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Root invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.Root replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Root invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort Root invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.SortId))
                throw new IllegalArgumentException("replace on sort Root invoked with term of incorrect sort, SortId expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Root invoked with term of incorrect sort, String expected");

            return (katja.spec.Root) Katja.unique(new katja.spec.Root.Impl(
                pos == 0 ? (katja.spec.SortId) term : _sortId,
                pos == 1 ? (java.lang.String) term : _suffix
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.Root");
            builder.append("( ");
            _sortId.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_suffix.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Root");
            builder.append("( ");
            _sortId.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_suffix.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Root";
        }
    }
}

