package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface RootList extends KatjaList<katja.spec.Root> {

    //----- methods of RootList -----

    public katja.spec.RootList add(katja.spec.Root element);
    public katja.spec.RootList addAll(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootList remove(katja.spec.Root element);
    public katja.spec.RootList removeAll(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootList appBack(katja.spec.Root element);
    public katja.spec.RootList appFront(katja.spec.Root element);
    public katja.spec.RootList conc(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootList front();
    public katja.spec.RootList back();
    public katja.spec.RootList reverse();
    public katja.spec.RootList sublist(int from, int to);
    public katja.spec.RootList replace(int ith, Object element);
    public katja.spec.RootList toSet();
    public katja.spec.RootList setAdd(katja.spec.Root element);
    public katja.spec.RootList setRemove(katja.spec.Root element);
    public katja.spec.RootList setUnion(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootList setIntersection(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootList setWithout(KatjaList<? extends katja.spec.Root> list);

    //----- nested classes of RootList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitRoot(katja.spec.Root term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitRootList(katja.spec.RootList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.RootList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.Root> implements katja.spec.RootList {

        //----- methods of Impl -----

        Impl(katja.spec.Root... elements) {
            super(elements);

            for(katja.spec.Root element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort RootList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.RootList createInstance(katja.spec.Root[] elements, boolean isSet) {
            for(katja.spec.Root element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort RootList invoked with null element");

            RootList.Impl temp = new katja.spec.RootList.Impl();
            temp.values = elements;
            temp = (RootList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.Root[] createArray(int size) {
            return new katja.spec.Root[size];
        }

        public katja.spec.RootList add(katja.spec.Root element) {
            return (katja.spec.RootList) super.add(element);
        }

        public katja.spec.RootList addAll(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.addAll(list);
        }

        public katja.spec.RootList remove(katja.spec.Root element) {
            return (katja.spec.RootList) super.remove(element);
        }

        public katja.spec.RootList removeAll(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.removeAll(list);
        }

        public katja.spec.RootList appBack(katja.spec.Root element) {
            return (katja.spec.RootList) super.appBack(element);
        }

        public katja.spec.RootList appFront(katja.spec.Root element) {
            return (katja.spec.RootList) super.appFront(element);
        }

        public katja.spec.RootList conc(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.conc(list);
        }

        public katja.spec.RootList front() {
            return (katja.spec.RootList) super.front();
        }

        public katja.spec.RootList back() {
            return (katja.spec.RootList) super.back();
        }

        public katja.spec.RootList reverse() {
            return (katja.spec.RootList) super.reverse();
        }

        public katja.spec.RootList sublist(int from, int to) {
            return (katja.spec.RootList) super.sublist(from, to);
        }

        public katja.spec.RootList replace(int ith, Object element) {
            return (katja.spec.RootList) super.replace(ith, element);
        }

        public katja.spec.RootList toSet() {
            return (katja.spec.RootList) super.toSet();
        }

        public katja.spec.RootList setAdd(katja.spec.Root element) {
            return (katja.spec.RootList) super.setAdd(element);
        }

        public katja.spec.RootList setRemove(katja.spec.Root element) {
            return (katja.spec.RootList) super.setRemove(element);
        }

        public katja.spec.RootList setUnion(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.setUnion(list);
        }

        public katja.spec.RootList setIntersection(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.setIntersection(list);
        }

        public katja.spec.RootList setWithout(KatjaList<? extends katja.spec.Root> list) {
            return (katja.spec.RootList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.RootList");
            builder.append("( ");
            for(katja.spec.Root element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("RootList");
            builder.append("( ");
            for(katja.spec.Root element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "RootList";
        }
    }
}

