package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface RootListPos extends katja.spec.Katja.ListPos<katja.spec.RootList, katja.spec.RootPos, katja.spec.Root> {

    //----- methods of RootListPos -----

    public katja.spec.RootList term();
    public katja.spec.RootListPos add(katja.spec.Root element);
    public katja.spec.RootListPos addAll(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootListPos remove(katja.spec.Root element);
    public katja.spec.RootListPos removeAll(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootListPos appBack(katja.spec.Root element);
    public katja.spec.RootListPos appFront(katja.spec.Root element);
    public katja.spec.RootListPos conc(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootListPos reverse();
    public katja.spec.RootListPos toSet();
    public katja.spec.RootListPos setAdd(katja.spec.Root element);
    public katja.spec.RootListPos setRemove(katja.spec.Root element);
    public katja.spec.RootListPos setUnion(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootListPos setWithout(KatjaList<? extends katja.spec.Root> list);
    public katja.spec.RootListPos setIntersection(KatjaList<? extends katja.spec.Root> list);
    public KatjaList<katja.spec.RootPos> toList();
    public katja.spec.RootListPos replace(katja.spec.RootList term);
    public katja.spec.SpecificationPos parent();
    public katja.spec.BackendBlockListPos lsib();
    public katja.spec.ExternalListPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of RootListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.RootPos> implements KatjaList<katja.spec.RootPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.RootPos... elements) {
            super(elements);

            for(katja.spec.RootPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort RootPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.RootPos> createInstance(katja.spec.RootPos[] elements, boolean isSet) {
            for(katja.spec.RootPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort RootPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.RootPos[] createArray(int size) {
            return new katja.spec.RootPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.RootPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitRootPos(katja.spec.RootPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitRootListPos(katja.spec.RootListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.RootListPos.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.RootList, katja.spec.RootPos, katja.spec.Root> implements katja.spec.RootListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.RootList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.RootPos getElementInstance(int pos) {
            return katja.spec.Katja.RootPos(this, _term.get(pos), pos);
        }

        protected katja.spec.RootPos[] createArray(int size) {
            return new katja.spec.RootPos[size];
        }

        public katja.spec.RootListPos add(katja.spec.Root element) {
            return replace(_term.add(element));
        }

        public katja.spec.RootListPos addAll(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.RootListPos remove(katja.spec.Root element) {
            return replace(_term.remove(element));
        }

        public katja.spec.RootListPos removeAll(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.RootListPos appBack(katja.spec.Root element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.RootListPos appFront(katja.spec.Root element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.RootListPos conc(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.RootListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.RootListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.RootListPos setAdd(katja.spec.Root element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.RootListPos setRemove(katja.spec.Root element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.RootListPos setUnion(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.RootListPos setWithout(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.RootListPos setIntersection(KatjaList<? extends katja.spec.Root> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.RootPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new RootListPos.ListImpl(values);
        }

        public katja.spec.RootListPos replace(katja.spec.RootList term) {
            return (katja.spec.RootListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.SpecificationPos parent() {
            return (katja.spec.SpecificationPos) super.parent();
        }

        public katja.spec.BackendBlockListPos lsib() {
            return (katja.spec.BackendBlockListPos) super.lsib();
        }

        public katja.spec.ExternalListPos rsib() {
            return (katja.spec.ExternalListPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "RootListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.RootPos> implements KatjaList<katja.spec.RootPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.RootPos... elements) {
                super(elements);

                for(katja.spec.RootPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort RootPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.RootPos> createInstance(katja.spec.RootPos[] elements, boolean isSet) {
                for(katja.spec.RootPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort RootPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.RootPos[] createArray(int size) {
                return new katja.spec.RootPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.RootPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

