package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface RootPos extends katja.spec.Katja.TuplePos<katja.spec.Root> {

    //----- methods of RootPos -----

    public katja.spec.Root term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.RootPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.StringPos suffix();
    public katja.spec.RootPos replaceSuffix(java.lang.String suffix);
    public katja.spec.Katja.TermPos<?> get(int i);
    public int size();
    public katja.spec.RootPos replace(katja.spec.Root term);
    public katja.spec.RootListPos parent();
    public katja.spec.RootPos lsib();
    public katja.spec.RootPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of RootPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitRootPos(katja.spec.RootPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.RootPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.Root> implements katja.spec.RootPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;
        private katja.spec.StringPos _suffix = null;

        //----- methods of Impl -----

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.RootPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        public katja.spec.StringPos suffix() {
            if(_suffix == null)
                _suffix = katja.spec.Katja.StringPos(this, _term.suffix(), 1);

            return _suffix;
        }

        public katja.spec.RootPos replaceSuffix(java.lang.String suffix) {
            return replace(_term.replaceSuffix(suffix));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.Root term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.TermPos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                case 1:
                    if(_suffix == null)
                        _suffix = Katja.StringPos(this, _term.suffix(), 1);
                    
                    return _suffix;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort RootPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort RootPos invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.RootPos replace(katja.spec.Root term) {
            return (katja.spec.RootPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.RootListPos parent() {
            return (katja.spec.RootListPos) super.parent();
        }

        public katja.spec.RootPos lsib() {
            return (katja.spec.RootPos) super.lsib();
        }

        public katja.spec.RootPos rsib() {
            return (katja.spec.RootPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "RootPos";
        }
    }
}

