package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface SelectorList extends KatjaList<katja.spec.Selector> {

    //----- methods of SelectorList -----

    public katja.spec.SelectorList add(katja.spec.Selector element);
    public katja.spec.SelectorList addAll(KatjaList<? extends katja.spec.Selector> list);
    public katja.spec.SelectorList remove(katja.spec.Selector element);
    public katja.spec.SelectorList removeAll(KatjaList<? extends katja.spec.Selector> list);
    public katja.spec.SelectorList appBack(katja.spec.Selector element);
    public katja.spec.SelectorList appFront(katja.spec.Selector element);
    public katja.spec.SelectorList conc(KatjaList<? extends katja.spec.Selector> list);
    public katja.spec.SelectorList front();
    public katja.spec.SelectorList back();
    public katja.spec.SelectorList reverse();
    public katja.spec.SelectorList sublist(int from, int to);
    public katja.spec.SelectorList replace(int ith, Object element);
    public katja.spec.SelectorList toSet();
    public katja.spec.SelectorList setAdd(katja.spec.Selector element);
    public katja.spec.SelectorList setRemove(katja.spec.Selector element);
    public katja.spec.SelectorList setUnion(KatjaList<? extends katja.spec.Selector> list);
    public katja.spec.SelectorList setIntersection(KatjaList<? extends katja.spec.Selector> list);
    public katja.spec.SelectorList setWithout(KatjaList<? extends katja.spec.Selector> list);

    //----- nested classes of SelectorList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitSelectorList(katja.spec.SelectorList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SelectorList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.Selector> implements katja.spec.SelectorList {

        //----- methods of Impl -----

        Impl(katja.spec.Selector... elements) {
            super(elements);

            for(katja.spec.Selector element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SelectorList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.SelectorList createInstance(katja.spec.Selector[] elements, boolean isSet) {
            for(katja.spec.Selector element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SelectorList invoked with null element");

            SelectorList.Impl temp = new katja.spec.SelectorList.Impl();
            temp.values = elements;
            temp = (SelectorList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.Selector[] createArray(int size) {
            return new katja.spec.Selector[size];
        }

        public katja.spec.SelectorList add(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.add(element);
        }

        public katja.spec.SelectorList addAll(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.addAll(list);
        }

        public katja.spec.SelectorList remove(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.remove(element);
        }

        public katja.spec.SelectorList removeAll(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.removeAll(list);
        }

        public katja.spec.SelectorList appBack(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.appBack(element);
        }

        public katja.spec.SelectorList appFront(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.appFront(element);
        }

        public katja.spec.SelectorList conc(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.conc(list);
        }

        public katja.spec.SelectorList front() {
            return (katja.spec.SelectorList) super.front();
        }

        public katja.spec.SelectorList back() {
            return (katja.spec.SelectorList) super.back();
        }

        public katja.spec.SelectorList reverse() {
            return (katja.spec.SelectorList) super.reverse();
        }

        public katja.spec.SelectorList sublist(int from, int to) {
            return (katja.spec.SelectorList) super.sublist(from, to);
        }

        public katja.spec.SelectorList replace(int ith, Object element) {
            return (katja.spec.SelectorList) super.replace(ith, element);
        }

        public katja.spec.SelectorList toSet() {
            return (katja.spec.SelectorList) super.toSet();
        }

        public katja.spec.SelectorList setAdd(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.setAdd(element);
        }

        public katja.spec.SelectorList setRemove(katja.spec.Selector element) {
            return (katja.spec.SelectorList) super.setRemove(element);
        }

        public katja.spec.SelectorList setUnion(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.setUnion(list);
        }

        public katja.spec.SelectorList setIntersection(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.setIntersection(list);
        }

        public katja.spec.SelectorList setWithout(KatjaList<? extends katja.spec.Selector> list) {
            return (katja.spec.SelectorList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.SelectorList");
            builder.append("( ");
            for(katja.spec.Selector element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SelectorList");
            builder.append("( ");
            for(katja.spec.Selector element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SelectorList";
        }
    }
}

