package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface SelectorPos extends katja.spec.SelectorOptPos, katja.spec.Katja.TuplePos<katja.spec.Selector> {

    //----- methods of SelectorPos -----

    public katja.spec.Selector termSelectorOpt();
    public katja.spec.Selector term();
    public katja.spec.StringPos name();
    public katja.spec.SelectorPos replaceName(java.lang.String name);
    public katja.spec.StringPos get(int i);
    public int size();
    public katja.spec.SelectorPos replace(katja.spec.Selector term);
    public katja.spec.TupleParamPos parent();
    public katja.spec.SortIdPos lsib();
    public katja.spec.BooleanPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOptPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SelectorPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SelectorPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.Selector> implements katja.spec.SelectorPos {

        //----- attributes of Impl -----

        private katja.spec.StringPos _name = null;

        //----- methods of Impl -----

        public katja.spec.Selector termSelectorOpt() {
            return term();
        }

        public katja.spec.StringPos name() {
            if(_name == null)
                _name = katja.spec.Katja.StringPos(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.SelectorPos replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.Selector term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.StringPos get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Katja.StringPos(this, _term.name(), 0);
                    
                    return _name;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort SelectorPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort SelectorPos invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.SelectorPos replace(katja.spec.Selector term) {
            return (katja.spec.SelectorPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.TupleParamPos parent() {
            return (katja.spec.TupleParamPos) super.parent();
        }

        public katja.spec.SortIdPos lsib() {
            return (katja.spec.SortIdPos) super.lsib();
        }

        public katja.spec.BooleanPos rsib() {
            return (katja.spec.BooleanPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SelectorOptPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseSelectorPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "SelectorPos";
        }
    }
}

