package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface SortId extends katja.spec.VariantParam, KatjaTuple {

    //----- methods of SortId -----

    public java.lang.String name();
    public katja.spec.SortId replaceName(java.lang.String name);
    public java.lang.Boolean isList();
    public katja.spec.SortId replaceIsList(java.lang.Boolean isList);
    public java.lang.String filename();
    public katja.spec.SortId replaceFilename(java.lang.String filename);
    public java.lang.Integer line();
    public katja.spec.SortId replaceLine(java.lang.Integer line);
    public Object get(int i);
    public int size();
    public katja.spec.SortId replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParam.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SortId -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SortId.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.SortId {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private java.lang.Boolean _isList = null;
        private java.lang.String _filename = null;
        private java.lang.Integer _line = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.SortId replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public java.lang.Boolean isList() {
            return _isList;
        }

        public katja.spec.SortId replaceIsList(java.lang.Boolean isList) {
            return replace(1, isList);
        }

        public java.lang.String filename() {
            return _filename;
        }

        public katja.spec.SortId replaceFilename(java.lang.String filename) {
            return replace(2, filename);
        }

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.SortId replaceLine(java.lang.Integer line) {
            return replace(3, line);
        }

        Impl(java.lang.String name, java.lang.Boolean isList, java.lang.String filename, java.lang.Integer line) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort SortId invoked with null parameter name");
            if(isList == null)
                throw new IllegalArgumentException("constructor of sort SortId invoked with null parameter isList");
            if(filename == null)
                throw new IllegalArgumentException("constructor of sort SortId invoked with null parameter filename");
            if(line == null)
                throw new IllegalArgumentException("constructor of sort SortId invoked with null parameter line");

            this._name = name;
            this._isList = isList;
            this._filename = filename;
            this._line = line;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0: return _name;
                case 1: return _isList;
                case 2: return _filename;
                case 3: return _line;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort SortId invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort SortId invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.SortId replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort SortId invoked with negative parameter "+pos);
            if(pos >= 4)
                throw new IllegalArgumentException("replace on sort SortId invoked with too large parameter "+pos+", sort has only 4 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort SortId invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.Boolean))
                throw new IllegalArgumentException("replace on sort SortId invoked with term of incorrect sort, Boolean expected");
            if(pos == 2 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort SortId invoked with term of incorrect sort, String expected");
            if(pos == 3 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort SortId invoked with term of incorrect sort, Integer expected");

            return (katja.spec.SortId) Katja.unique(new katja.spec.SortId.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (java.lang.Boolean) term : _isList,
                pos == 2 ? (java.lang.String) term : _filename,
                pos == 3 ? (java.lang.Integer) term : _line
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParam.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseSortId(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SortId");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append(_isList.toString());
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("SortId");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append(_isList.toString());
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SortId";
        }
    }
}

