package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface SortIdList extends KatjaList<katja.spec.SortId> {

    //----- methods of SortIdList -----

    public katja.spec.SortIdList add(katja.spec.SortId element);
    public katja.spec.SortIdList addAll(KatjaList<? extends katja.spec.SortId> list);
    public katja.spec.SortIdList remove(katja.spec.SortId element);
    public katja.spec.SortIdList removeAll(KatjaList<? extends katja.spec.SortId> list);
    public katja.spec.SortIdList appBack(katja.spec.SortId element);
    public katja.spec.SortIdList appFront(katja.spec.SortId element);
    public katja.spec.SortIdList conc(KatjaList<? extends katja.spec.SortId> list);
    public katja.spec.SortIdList front();
    public katja.spec.SortIdList back();
    public katja.spec.SortIdList reverse();
    public katja.spec.SortIdList sublist(int from, int to);
    public katja.spec.SortIdList replace(int ith, Object element);
    public katja.spec.SortIdList toSet();
    public katja.spec.SortIdList setAdd(katja.spec.SortId element);
    public katja.spec.SortIdList setRemove(katja.spec.SortId element);
    public katja.spec.SortIdList setUnion(KatjaList<? extends katja.spec.SortId> list);
    public katja.spec.SortIdList setIntersection(KatjaList<? extends katja.spec.SortId> list);
    public katja.spec.SortIdList setWithout(KatjaList<? extends katja.spec.SortId> list);

    //----- nested classes of SortIdList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitSortIdList(katja.spec.SortIdList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SortIdList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.SortId> implements katja.spec.SortIdList {

        //----- methods of Impl -----

        Impl(katja.spec.SortId... elements) {
            super(elements);

            for(katja.spec.SortId element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortIdList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.SortIdList createInstance(katja.spec.SortId[] elements, boolean isSet) {
            for(katja.spec.SortId element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortIdList invoked with null element");

            SortIdList.Impl temp = new katja.spec.SortIdList.Impl();
            temp.values = elements;
            temp = (SortIdList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.SortId[] createArray(int size) {
            return new katja.spec.SortId[size];
        }

        public katja.spec.SortIdList add(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.add(element);
        }

        public katja.spec.SortIdList addAll(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.addAll(list);
        }

        public katja.spec.SortIdList remove(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.remove(element);
        }

        public katja.spec.SortIdList removeAll(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.removeAll(list);
        }

        public katja.spec.SortIdList appBack(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.appBack(element);
        }

        public katja.spec.SortIdList appFront(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.appFront(element);
        }

        public katja.spec.SortIdList conc(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.conc(list);
        }

        public katja.spec.SortIdList front() {
            return (katja.spec.SortIdList) super.front();
        }

        public katja.spec.SortIdList back() {
            return (katja.spec.SortIdList) super.back();
        }

        public katja.spec.SortIdList reverse() {
            return (katja.spec.SortIdList) super.reverse();
        }

        public katja.spec.SortIdList sublist(int from, int to) {
            return (katja.spec.SortIdList) super.sublist(from, to);
        }

        public katja.spec.SortIdList replace(int ith, Object element) {
            return (katja.spec.SortIdList) super.replace(ith, element);
        }

        public katja.spec.SortIdList toSet() {
            return (katja.spec.SortIdList) super.toSet();
        }

        public katja.spec.SortIdList setAdd(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.setAdd(element);
        }

        public katja.spec.SortIdList setRemove(katja.spec.SortId element) {
            return (katja.spec.SortIdList) super.setRemove(element);
        }

        public katja.spec.SortIdList setUnion(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.setUnion(list);
        }

        public katja.spec.SortIdList setIntersection(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.setIntersection(list);
        }

        public katja.spec.SortIdList setWithout(KatjaList<? extends katja.spec.SortId> list) {
            return (katja.spec.SortIdList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.SortIdList");
            builder.append("( ");
            for(katja.spec.SortId element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SortIdList");
            builder.append("( ");
            for(katja.spec.SortId element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SortIdList";
        }
    }
}

