package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface SortIdPos extends katja.spec.VariantParamPos, katja.spec.Katja.TuplePos<katja.spec.SortId> {

    //----- methods of SortIdPos -----

    public katja.spec.SortId termVariantParam();
    public katja.spec.SortId term();
    public katja.spec.StringPos name();
    public katja.spec.SortIdPos replaceName(java.lang.String name);
    public katja.spec.BooleanPos isList();
    public katja.spec.SortIdPos replaceIsList(java.lang.Boolean isList);
    public katja.spec.StringPos filename();
    public katja.spec.SortIdPos replaceFilename(java.lang.String filename);
    public katja.spec.IntegerPos line();
    public katja.spec.SortIdPos replaceLine(java.lang.Integer line);
    public katja.spec.Katja.LeafPos<?> get(int i);
    public int size();
    public katja.spec.SortIdPos replace(katja.spec.SortId term);
    public katja.spec.Katja.NodePos<?> parent();
    public katja.spec.VariantParamPos lsib();
    public katja.spec.Katja.SortPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SortIdPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SortIdPos.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.SortId> implements katja.spec.SortIdPos {

        //----- attributes of Impl -----

        private katja.spec.StringPos _name = null;
        private katja.spec.BooleanPos _isList = null;
        private katja.spec.StringPos _filename = null;
        private katja.spec.IntegerPos _line = null;

        //----- methods of Impl -----

        public katja.spec.SortId termVariantParam() {
            return term();
        }

        public katja.spec.StringPos name() {
            if(_name == null)
                _name = katja.spec.Katja.StringPos(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.SortIdPos replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.BooleanPos isList() {
            if(_isList == null)
                _isList = katja.spec.Katja.BooleanPos(this, _term.isList(), 1);

            return _isList;
        }

        public katja.spec.SortIdPos replaceIsList(java.lang.Boolean isList) {
            return replace(_term.replaceIsList(isList));
        }

        public katja.spec.StringPos filename() {
            if(_filename == null)
                _filename = katja.spec.Katja.StringPos(this, _term.filename(), 2);

            return _filename;
        }

        public katja.spec.SortIdPos replaceFilename(java.lang.String filename) {
            return replace(_term.replaceFilename(filename));
        }

        public katja.spec.IntegerPos line() {
            if(_line == null)
                _line = katja.spec.Katja.IntegerPos(this, _term.line(), 3);

            return _line;
        }

        public katja.spec.SortIdPos replaceLine(java.lang.Integer line) {
            return replace(_term.replaceLine(line));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.SortId term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.LeafPos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Katja.StringPos(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_isList == null)
                        _isList = Katja.BooleanPos(this, _term.isList(), 1);
                    
                    return _isList;
                case 2:
                    if(_filename == null)
                        _filename = Katja.StringPos(this, _term.filename(), 2);
                    
                    return _filename;
                case 3:
                    if(_line == null)
                        _line = Katja.IntegerPos(this, _term.line(), 3);
                    
                    return _line;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort SortIdPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort SortIdPos invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.SortIdPos replace(katja.spec.SortId term) {
            return (katja.spec.SortIdPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.NodePos<?> parent() {
            return (katja.spec.Katja.NodePos<?>) super.parent();
        }

        public katja.spec.VariantParamPos lsib() {
            return (katja.spec.VariantParamPos) super.lsib();
        }

        public katja.spec.Katja.SortPos rsib() {
            return (katja.spec.Katja.SortPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseSortIdPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "SortIdPos";
        }
    }
}

