package katja.spec;

import katja.common.*;

public interface SortSpec extends KatjaSort {

    //----- methods of SortSpec -----

    public katja.spec.SortId sortId();
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpec.Switch<CT, E> switchClass) throws E;

    //----- nested classes of SortSpec -----

    public static interface Switch<CT, E extends Throwable> extends katja.spec.Production.Switch<CT, E> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CaseExternal(katja.spec.External term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
        public void visitVariantParamList(katja.spec.VariantParamList term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitVariantParam(katja.spec.VariantParam term) throws E;
        public void visitProduction(katja.spec.Production term) throws E;
        public void visitTupleProd(katja.spec.TupleProd term) throws E;
        public void visitVariantProd(katja.spec.VariantProd term) throws E;
        public void visitListProd(katja.spec.ListProd term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
        public void visitSortSpec(katja.spec.SortSpec term) throws E;
        public void visitExternal(katja.spec.External term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SortSpec.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };
        private final katja.spec.SortSpec.Switch<Object, E> variantVisit$SortSpec = new katja.spec.SortSpec.Switch<Object, E>() { public final Object CaseExternal(katja.spec.External term) throws E { visitExternal(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };
        private final katja.spec.VariantParam.Switch<Object, E> variantVisit$VariantParam = new katja.spec.VariantParam.Switch<Object, E>() { public final Object CaseSortId(katja.spec.SortId term) throws E { visitSortId(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProduction(katja.spec.Production term) throws E {
            term.Switch(variantVisit$SortSpec);
        }

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }

        public final void visitSortSpec(katja.spec.SortSpec term) throws E {
            term.Switch(variantVisit$SortSpec);
        }

        public final void visitVariantParam(katja.spec.VariantParam term) throws E {
            term.Switch(variantVisit$VariantParam);
        }
    }
}

