package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface SortSpecPosList extends KatjaList<katja.spec.SortSpecPos> {

    //----- methods of SortSpecPosList -----

    public katja.spec.SortSpecPosList add(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList addAll(KatjaList<? extends katja.spec.SortSpecPos> list);
    public katja.spec.SortSpecPosList remove(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList removeAll(KatjaList<? extends katja.spec.SortSpecPos> list);
    public katja.spec.SortSpecPosList appBack(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList appFront(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList conc(KatjaList<? extends katja.spec.SortSpecPos> list);
    public katja.spec.SortSpecPosList front();
    public katja.spec.SortSpecPosList back();
    public katja.spec.SortSpecPosList reverse();
    public katja.spec.SortSpecPosList sublist(int from, int to);
    public katja.spec.SortSpecPosList replace(int ith, Object element);
    public katja.spec.SortSpecPosList toSet();
    public katja.spec.SortSpecPosList setAdd(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList setRemove(katja.spec.SortSpecPos element);
    public katja.spec.SortSpecPosList setUnion(KatjaList<? extends katja.spec.SortSpecPos> list);
    public katja.spec.SortSpecPosList setIntersection(KatjaList<? extends katja.spec.SortSpecPos> list);
    public katja.spec.SortSpecPosList setWithout(KatjaList<? extends katja.spec.SortSpecPos> list);

    //----- nested classes of SortSpecPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortSpecPos(katja.spec.SortSpecPos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitSortSpecPosList(katja.spec.SortSpecPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SortSpecPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.SortSpecPos.Switch<Object, E> variantVisit$SortSpecPos = new katja.spec.SortSpecPos.Switch<Object, E>() { public final Object CaseExternalPos(katja.spec.ExternalPos term) throws E { visitExternalPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitSortSpecPos(katja.spec.SortSpecPos term) throws E {
            term.Switch(variantVisit$SortSpecPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.SortSpecPos> implements katja.spec.SortSpecPosList {

        //----- methods of Impl -----

        Impl(katja.spec.SortSpecPos... elements) {
            super(elements);

            for(katja.spec.SortSpecPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortSpecPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.SortSpecPosList createInstance(katja.spec.SortSpecPos[] elements, boolean isSet) {
            for(katja.spec.SortSpecPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortSpecPosList invoked with null element");

            SortSpecPosList.Impl temp = new katja.spec.SortSpecPosList.Impl();
            temp.values = elements;
            temp = (SortSpecPosList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.SortSpecPos[] createArray(int size) {
            return new katja.spec.SortSpecPos[size];
        }

        public katja.spec.SortSpecPosList add(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.add(element);
        }

        public katja.spec.SortSpecPosList addAll(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.addAll(list);
        }

        public katja.spec.SortSpecPosList remove(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.remove(element);
        }

        public katja.spec.SortSpecPosList removeAll(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.removeAll(list);
        }

        public katja.spec.SortSpecPosList appBack(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.appBack(element);
        }

        public katja.spec.SortSpecPosList appFront(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.appFront(element);
        }

        public katja.spec.SortSpecPosList conc(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.conc(list);
        }

        public katja.spec.SortSpecPosList front() {
            return (katja.spec.SortSpecPosList) super.front();
        }

        public katja.spec.SortSpecPosList back() {
            return (katja.spec.SortSpecPosList) super.back();
        }

        public katja.spec.SortSpecPosList reverse() {
            return (katja.spec.SortSpecPosList) super.reverse();
        }

        public katja.spec.SortSpecPosList sublist(int from, int to) {
            return (katja.spec.SortSpecPosList) super.sublist(from, to);
        }

        public katja.spec.SortSpecPosList replace(int ith, Object element) {
            return (katja.spec.SortSpecPosList) super.replace(ith, element);
        }

        public katja.spec.SortSpecPosList toSet() {
            return (katja.spec.SortSpecPosList) super.toSet();
        }

        public katja.spec.SortSpecPosList setAdd(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.setAdd(element);
        }

        public katja.spec.SortSpecPosList setRemove(katja.spec.SortSpecPos element) {
            return (katja.spec.SortSpecPosList) super.setRemove(element);
        }

        public katja.spec.SortSpecPosList setUnion(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.setUnion(list);
        }

        public katja.spec.SortSpecPosList setIntersection(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.setIntersection(list);
        }

        public katja.spec.SortSpecPosList setWithout(KatjaList<? extends katja.spec.SortSpecPos> list) {
            return (katja.spec.SortSpecPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.SortSpecPosList");
            builder.append("( ");
            for(katja.spec.SortSpecPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SortSpecPosList");
            builder.append("( ");
            for(katja.spec.SortSpecPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SortSpecPosList";
        }
    }
}

