package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface Specification extends KatjaTuple {

    //----- methods of Specification -----

    public java.lang.String name();
    public katja.spec.Specification replaceName(java.lang.String name);
    public katja.spec.BackendBlockList backendBlocks();
    public katja.spec.Specification replaceBackendBlocks(katja.spec.BackendBlockList backendBlocks);
    public katja.spec.RootList rootlist();
    public katja.spec.Specification replaceRootlist(katja.spec.RootList rootlist);
    public katja.spec.ExternalList externalList();
    public katja.spec.Specification replaceExternalList(katja.spec.ExternalList externalList);
    public katja.spec.ImportList importList();
    public katja.spec.Specification replaceImportList(katja.spec.ImportList importList);
    public katja.spec.IncludeList includeList();
    public katja.spec.Specification replaceIncludeList(katja.spec.IncludeList includeList);
    public katja.spec.ProductionList prodList();
    public katja.spec.Specification replaceProdList(katja.spec.ProductionList prodList);
    public katja.spec.FileNameList filenames();
    public katja.spec.Specification replaceFilenames(katja.spec.FileNameList filenames);
    public Object get(int i);
    public int size();
    public katja.spec.Specification replace(int pos, Object term);

    //----- nested classes of Specification -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitBackendBlockList(katja.spec.BackendBlockList term) throws E;
        public void visitRootList(katja.spec.RootList term) throws E;
        public void visitExternalList(katja.spec.ExternalList term) throws E;
        public void visitImportList(katja.spec.ImportList term) throws E;
        public void visitIncludeList(katja.spec.IncludeList term) throws E;
        public void visitProductionList(katja.spec.ProductionList term) throws E;
        public void visitFileNameList(katja.spec.FileNameList term) throws E;
        public void visitBackendBlock(katja.spec.BackendBlock term) throws E;
        public void visitRoot(katja.spec.Root term) throws E;
        public void visitExternal(katja.spec.External term) throws E;
        public void visitImport(katja.spec.Import term) throws E;
        public void visitInclude(katja.spec.Include term) throws E;
        public void visitProduction(katja.spec.Production term) throws E;
        public void visitTupleProd(katja.spec.TupleProd term) throws E;
        public void visitVariantProd(katja.spec.VariantProd term) throws E;
        public void visitListProd(katja.spec.ListProd term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
        public void visitVariantParamList(katja.spec.VariantParamList term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitVariantParam(katja.spec.VariantParam term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
        public void visitSpecification(katja.spec.Specification term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.Specification.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };
        private final katja.spec.VariantParam.Switch<Object, E> variantVisit$VariantParam = new katja.spec.VariantParam.Switch<Object, E>() { public final Object CaseSortId(katja.spec.SortId term) throws E { visitSortId(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProduction(katja.spec.Production term) throws E {
            term.Switch(variantVisit$VariantParam);
        }

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }

        public final void visitVariantParam(katja.spec.VariantParam term) throws E {
            term.Switch(variantVisit$VariantParam);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.Specification {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private katja.spec.BackendBlockList _backendBlocks = null;
        private katja.spec.RootList _rootlist = null;
        private katja.spec.ExternalList _externalList = null;
        private katja.spec.ImportList _importList = null;
        private katja.spec.IncludeList _includeList = null;
        private katja.spec.ProductionList _prodList = null;
        private katja.spec.FileNameList _filenames = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.Specification replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public katja.spec.BackendBlockList backendBlocks() {
            return _backendBlocks;
        }

        public katja.spec.Specification replaceBackendBlocks(katja.spec.BackendBlockList backendBlocks) {
            return replace(1, backendBlocks);
        }

        public katja.spec.RootList rootlist() {
            return _rootlist;
        }

        public katja.spec.Specification replaceRootlist(katja.spec.RootList rootlist) {
            return replace(2, rootlist);
        }

        public katja.spec.ExternalList externalList() {
            return _externalList;
        }

        public katja.spec.Specification replaceExternalList(katja.spec.ExternalList externalList) {
            return replace(3, externalList);
        }

        public katja.spec.ImportList importList() {
            return _importList;
        }

        public katja.spec.Specification replaceImportList(katja.spec.ImportList importList) {
            return replace(4, importList);
        }

        public katja.spec.IncludeList includeList() {
            return _includeList;
        }

        public katja.spec.Specification replaceIncludeList(katja.spec.IncludeList includeList) {
            return replace(5, includeList);
        }

        public katja.spec.ProductionList prodList() {
            return _prodList;
        }

        public katja.spec.Specification replaceProdList(katja.spec.ProductionList prodList) {
            return replace(6, prodList);
        }

        public katja.spec.FileNameList filenames() {
            return _filenames;
        }

        public katja.spec.Specification replaceFilenames(katja.spec.FileNameList filenames) {
            return replace(7, filenames);
        }

        Impl(java.lang.String name, katja.spec.BackendBlockList backendBlocks, katja.spec.RootList rootlist, katja.spec.ExternalList externalList, katja.spec.ImportList importList, katja.spec.IncludeList includeList, katja.spec.ProductionList prodList, katja.spec.FileNameList filenames) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter name");
            if(backendBlocks == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter backendBlocks");
            if(rootlist == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter rootlist");
            if(externalList == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter externalList");
            if(importList == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter importList");
            if(includeList == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter includeList");
            if(prodList == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter prodList");
            if(filenames == null)
                throw new IllegalArgumentException("constructor of sort Specification invoked with null parameter filenames");

            this._name = name;
            this._backendBlocks = backendBlocks;
            this._rootlist = rootlist;
            this._externalList = externalList;
            this._importList = importList;
            this._includeList = includeList;
            this._prodList = prodList;
            this._filenames = filenames;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 8;

            switch(ith) {
                case 0: return _name;
                case 1: return _backendBlocks;
                case 2: return _rootlist;
                case 3: return _externalList;
                case 4: return _importList;
                case 5: return _includeList;
                case 6: return _prodList;
                case 7: return _filenames;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort Specification invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort Specification invoked with too large parameter "+i+", sort has only 8 components");
                    }
            }
        }

        public int size() {
            return 8;
        }

        public katja.spec.Specification replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort Specification invoked with negative parameter "+pos);
            if(pos >= 8)
                throw new IllegalArgumentException("replace on sort Specification invoked with too large parameter "+pos+", sort has only 8 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof katja.spec.BackendBlockList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, BackendBlockList expected");
            if(pos == 2 && !(term instanceof katja.spec.RootList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, RootList expected");
            if(pos == 3 && !(term instanceof katja.spec.ExternalList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, ExternalList expected");
            if(pos == 4 && !(term instanceof katja.spec.ImportList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, ImportList expected");
            if(pos == 5 && !(term instanceof katja.spec.IncludeList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, IncludeList expected");
            if(pos == 6 && !(term instanceof katja.spec.ProductionList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, ProductionList expected");
            if(pos == 7 && !(term instanceof katja.spec.FileNameList))
                throw new IllegalArgumentException("replace on sort Specification invoked with term of incorrect sort, FileNameList expected");

            return (katja.spec.Specification) Katja.unique(new katja.spec.Specification.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (katja.spec.BackendBlockList) term : _backendBlocks,
                pos == 2 ? (katja.spec.RootList) term : _rootlist,
                pos == 3 ? (katja.spec.ExternalList) term : _externalList,
                pos == 4 ? (katja.spec.ImportList) term : _importList,
                pos == 5 ? (katja.spec.IncludeList) term : _includeList,
                pos == 6 ? (katja.spec.ProductionList) term : _prodList,
                pos == 7 ? (katja.spec.FileNameList) term : _filenames
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.Specification");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _backendBlocks.toJavaCode(builder);
            builder.append(", ");
            _rootlist.toJavaCode(builder);
            builder.append(", ");
            _externalList.toJavaCode(builder);
            builder.append(", ");
            _importList.toJavaCode(builder);
            builder.append(", ");
            _includeList.toJavaCode(builder);
            builder.append(", ");
            _prodList.toJavaCode(builder);
            builder.append(", ");
            _filenames.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("Specification");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _backendBlocks.toString(builder);
            builder.append(", ");
            _rootlist.toString(builder);
            builder.append(", ");
            _externalList.toString(builder);
            builder.append(", ");
            _importList.toString(builder);
            builder.append(", ");
            _includeList.toString(builder);
            builder.append(", ");
            _prodList.toString(builder);
            builder.append(", ");
            _filenames.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Specification";
        }
    }
}

