package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface SpecificationPos extends katja.spec.Katja.TuplePos<katja.spec.Specification> {

    //----- methods of SpecificationPos -----

    public katja.spec.Specification term();
    public katja.spec.StringPos name();
    public katja.spec.SpecificationPos replaceName(java.lang.String name);
    public katja.spec.BackendBlockListPos backendBlocks();
    public katja.spec.SpecificationPos replaceBackendBlocks(katja.spec.BackendBlockList backendBlocks);
    public katja.spec.RootListPos rootlist();
    public katja.spec.SpecificationPos replaceRootlist(katja.spec.RootList rootlist);
    public katja.spec.ExternalListPos externalList();
    public katja.spec.SpecificationPos replaceExternalList(katja.spec.ExternalList externalList);
    public katja.spec.ImportListPos importList();
    public katja.spec.SpecificationPos replaceImportList(katja.spec.ImportList importList);
    public katja.spec.IncludeListPos includeList();
    public katja.spec.SpecificationPos replaceIncludeList(katja.spec.IncludeList includeList);
    public katja.spec.ProductionListPos prodList();
    public katja.spec.SpecificationPos replaceProdList(katja.spec.ProductionList prodList);
    public katja.spec.FileNameListPos filenames();
    public katja.spec.SpecificationPos replaceFilenames(katja.spec.FileNameList filenames);
    public katja.spec.Katja.TermPos<?> get(int i);
    public int size();
    public katja.spec.SpecificationPos replace(katja.spec.Specification term);
    public katja.spec.Katja.SortPos parent();
    public katja.spec.Katja.SortPos lsib();
    public katja.spec.Katja.SortPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of SpecificationPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBackendBlockListPos(katja.spec.BackendBlockListPos term) throws E;
        public void visitRootListPos(katja.spec.RootListPos term) throws E;
        public void visitExternalListPos(katja.spec.ExternalListPos term) throws E;
        public void visitImportListPos(katja.spec.ImportListPos term) throws E;
        public void visitIncludeListPos(katja.spec.IncludeListPos term) throws E;
        public void visitProductionListPos(katja.spec.ProductionListPos term) throws E;
        public void visitFileNameListPos(katja.spec.FileNameListPos term) throws E;
        public void visitBackendBlockPos(katja.spec.BackendBlockPos term) throws E;
        public void visitRootPos(katja.spec.RootPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitImportPos(katja.spec.ImportPos term) throws E;
        public void visitIncludePos(katja.spec.IncludePos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitSpecificationPos(katja.spec.SpecificationPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SpecificationPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    public static abstract class DefaultVisitor<E extends Throwable> extends katja.spec.SpecificationPos.Visitor<E> {

        //----- methods of DefaultVisitor<E extends Throwable> -----

        public void visitStringPos(katja.spec.StringPos term) throws E {
        }

        public void visitBackendBlockListPos(katja.spec.BackendBlockListPos term) throws E {
            for(katja.spec.BackendBlockPos element : term)
                visitBackendBlockPos(element);
        }

        public void visitRootListPos(katja.spec.RootListPos term) throws E {
            for(katja.spec.RootPos element : term)
                visitRootPos(element);
        }

        public void visitExternalListPos(katja.spec.ExternalListPos term) throws E {
            for(katja.spec.ExternalPos element : term)
                visitExternalPos(element);
        }

        public void visitImportListPos(katja.spec.ImportListPos term) throws E {
            for(katja.spec.ImportPos element : term)
                visitImportPos(element);
        }

        public void visitIncludeListPos(katja.spec.IncludeListPos term) throws E {
            for(katja.spec.IncludePos element : term)
                visitIncludePos(element);
        }

        public void visitProductionListPos(katja.spec.ProductionListPos term) throws E {
            for(katja.spec.ProductionPos element : term)
                visitProductionPos(element);
        }

        public void visitFileNameListPos(katja.spec.FileNameListPos term) throws E {
            for(katja.spec.StringPos element : term)
                visitStringPos(element);
        }

        public void visitBackendBlockPos(katja.spec.BackendBlockPos term) throws E {
            visitIntegerPos(term.line());
            visitStringPos(term.backendName());
            visitStringPos(term.content());
        }

        public void visitRootPos(katja.spec.RootPos term) throws E {
            visitSortIdPos(term.sortId());
            visitStringPos(term.suffix());
        }

        public void visitExternalPos(katja.spec.ExternalPos term) throws E {
            visitSortIdPos(term.sortId());
        }

        public void visitImportPos(katja.spec.ImportPos term) throws E {
            visitStringPos(term.name());
            visitStringPos(term.filename());
            visitIntegerPos(term.line());
        }

        public void visitIncludePos(katja.spec.IncludePos term) throws E {
            visitStringPos(term.name());
            visitStringPos(term.filename());
            visitIntegerPos(term.line());
        }

        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E {
            visitSortIdPos(term.sortId());
            visitTupleParamListPos(term.params());
        }

        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E {
            visitSortIdPos(term.sortId());
            visitVariantParamListPos(term.params());
        }

        public void visitListProdPos(katja.spec.ListProdPos term) throws E {
            visitSortIdPos(term.sortId());
            visitSortIdPos(term.param());
        }

        public void visitIntegerPos(katja.spec.IntegerPos term) throws E {
        }

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E {
            visitStringPos(term.name());
            visitBooleanPos(term.isList());
            visitStringPos(term.filename());
            visitIntegerPos(term.line());
        }

        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E {
            for(katja.spec.TupleParamPos element : term)
                visitTupleParamPos(element);
        }

        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E {
            for(katja.spec.VariantParamPos element : term)
                visitVariantParamPos(element);
        }

        public void visitBooleanPos(katja.spec.BooleanPos term) throws E {
        }

        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E {
            visitSortIdPos(term.sortId());
            visitSelectorOptPos(term.selector());
            visitBooleanPos(term.isOpt());
        }

        public void visitSelectorPos(katja.spec.SelectorPos term) throws E {
            visitStringPos(term.name());
        }

        public void visitEmptyPos(katja.spec.EmptyPos term) throws E {
        }

        public void visitSpecificationPos(katja.spec.SpecificationPos term) throws E {
            visitStringPos(term.name());
            visitBackendBlockListPos(term.backendBlocks());
            visitRootListPos(term.rootlist());
            visitExternalListPos(term.externalList());
            visitImportListPos(term.importList());
            visitIncludeListPos(term.includeList());
            visitProductionListPos(term.prodList());
            visitFileNameListPos(term.filenames());
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.Specification> implements katja.spec.SpecificationPos {

        //----- attributes of Impl -----

        private katja.spec.StringPos _name = null;
        private katja.spec.BackendBlockListPos _backendBlocks = null;
        private katja.spec.RootListPos _rootlist = null;
        private katja.spec.ExternalListPos _externalList = null;
        private katja.spec.ImportListPos _importList = null;
        private katja.spec.IncludeListPos _includeList = null;
        private katja.spec.ProductionListPos _prodList = null;
        private katja.spec.FileNameListPos _filenames = null;

        //----- methods of Impl -----

        public katja.spec.StringPos name() {
            if(_name == null)
                _name = katja.spec.Katja.StringPos(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.SpecificationPos replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.BackendBlockListPos backendBlocks() {
            if(_backendBlocks == null)
                _backendBlocks = katja.spec.Katja.BackendBlockListPos(this, _term.backendBlocks(), 1);

            return _backendBlocks;
        }

        public katja.spec.SpecificationPos replaceBackendBlocks(katja.spec.BackendBlockList backendBlocks) {
            return replace(_term.replaceBackendBlocks(backendBlocks));
        }

        public katja.spec.RootListPos rootlist() {
            if(_rootlist == null)
                _rootlist = katja.spec.Katja.RootListPos(this, _term.rootlist(), 2);

            return _rootlist;
        }

        public katja.spec.SpecificationPos replaceRootlist(katja.spec.RootList rootlist) {
            return replace(_term.replaceRootlist(rootlist));
        }

        public katja.spec.ExternalListPos externalList() {
            if(_externalList == null)
                _externalList = katja.spec.Katja.ExternalListPos(this, _term.externalList(), 3);

            return _externalList;
        }

        public katja.spec.SpecificationPos replaceExternalList(katja.spec.ExternalList externalList) {
            return replace(_term.replaceExternalList(externalList));
        }

        public katja.spec.ImportListPos importList() {
            if(_importList == null)
                _importList = katja.spec.Katja.ImportListPos(this, _term.importList(), 4);

            return _importList;
        }

        public katja.spec.SpecificationPos replaceImportList(katja.spec.ImportList importList) {
            return replace(_term.replaceImportList(importList));
        }

        public katja.spec.IncludeListPos includeList() {
            if(_includeList == null)
                _includeList = katja.spec.Katja.IncludeListPos(this, _term.includeList(), 5);

            return _includeList;
        }

        public katja.spec.SpecificationPos replaceIncludeList(katja.spec.IncludeList includeList) {
            return replace(_term.replaceIncludeList(includeList));
        }

        public katja.spec.ProductionListPos prodList() {
            if(_prodList == null)
                _prodList = katja.spec.Katja.ProductionListPos(this, _term.prodList(), 6);

            return _prodList;
        }

        public katja.spec.SpecificationPos replaceProdList(katja.spec.ProductionList prodList) {
            return replace(_term.replaceProdList(prodList));
        }

        public katja.spec.FileNameListPos filenames() {
            if(_filenames == null)
                _filenames = katja.spec.Katja.FileNameListPos(this, _term.filenames(), 7);

            return _filenames;
        }

        public katja.spec.SpecificationPos replaceFilenames(katja.spec.FileNameList filenames) {
            return replace(_term.replaceFilenames(filenames));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.Specification term, int pos) {
            super(parent, term, pos);
        }

        Impl(katja.spec.Specification term) {
            super(term);
        }

        public katja.spec.Katja.TermPos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 8;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Katja.StringPos(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_backendBlocks == null)
                        _backendBlocks = Katja.BackendBlockListPos(this, _term.backendBlocks(), 1);
                    
                    return _backendBlocks;
                case 2:
                    if(_rootlist == null)
                        _rootlist = Katja.RootListPos(this, _term.rootlist(), 2);
                    
                    return _rootlist;
                case 3:
                    if(_externalList == null)
                        _externalList = Katja.ExternalListPos(this, _term.externalList(), 3);
                    
                    return _externalList;
                case 4:
                    if(_importList == null)
                        _importList = Katja.ImportListPos(this, _term.importList(), 4);
                    
                    return _importList;
                case 5:
                    if(_includeList == null)
                        _includeList = Katja.IncludeListPos(this, _term.includeList(), 5);
                    
                    return _includeList;
                case 6:
                    if(_prodList == null)
                        _prodList = Katja.ProductionListPos(this, _term.prodList(), 6);
                    
                    return _prodList;
                case 7:
                    if(_filenames == null)
                        _filenames = Katja.FileNameListPos(this, _term.filenames(), 7);
                    
                    return _filenames;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort SpecificationPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort SpecificationPos invoked with too large parameter "+i+", sort has only 8 components");
                    }
            }
        }

        public int size() {
            return 8;
        }

        public katja.spec.SpecificationPos replace(katja.spec.Specification term) {
            return (katja.spec.SpecificationPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.SortPos parent() {
            return (katja.spec.Katja.SortPos) super.parent();
        }

        public katja.spec.Katja.SortPos lsib() {
            return (katja.spec.Katja.SortPos) super.lsib();
        }

        public katja.spec.Katja.SortPos rsib() {
            return (katja.spec.Katja.SortPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "SpecificationPos";
        }
    }
}

