package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface SpecificationPosList extends KatjaList<katja.spec.SpecificationPos> {

    //----- methods of SpecificationPosList -----

    public katja.spec.SpecificationPosList add(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList addAll(KatjaList<? extends katja.spec.SpecificationPos> list);
    public katja.spec.SpecificationPosList remove(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList removeAll(KatjaList<? extends katja.spec.SpecificationPos> list);
    public katja.spec.SpecificationPosList appBack(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList appFront(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList conc(KatjaList<? extends katja.spec.SpecificationPos> list);
    public katja.spec.SpecificationPosList front();
    public katja.spec.SpecificationPosList back();
    public katja.spec.SpecificationPosList reverse();
    public katja.spec.SpecificationPosList sublist(int from, int to);
    public katja.spec.SpecificationPosList replace(int ith, Object element);
    public katja.spec.SpecificationPosList toSet();
    public katja.spec.SpecificationPosList setAdd(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList setRemove(katja.spec.SpecificationPos element);
    public katja.spec.SpecificationPosList setUnion(KatjaList<? extends katja.spec.SpecificationPos> list);
    public katja.spec.SpecificationPosList setIntersection(KatjaList<? extends katja.spec.SpecificationPos> list);
    public katja.spec.SpecificationPosList setWithout(KatjaList<? extends katja.spec.SpecificationPos> list);

    //----- nested classes of SpecificationPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSpecificationPos(katja.spec.SpecificationPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBackendBlockListPos(katja.spec.BackendBlockListPos term) throws E;
        public void visitRootListPos(katja.spec.RootListPos term) throws E;
        public void visitExternalListPos(katja.spec.ExternalListPos term) throws E;
        public void visitImportListPos(katja.spec.ImportListPos term) throws E;
        public void visitIncludeListPos(katja.spec.IncludeListPos term) throws E;
        public void visitProductionListPos(katja.spec.ProductionListPos term) throws E;
        public void visitFileNameListPos(katja.spec.FileNameListPos term) throws E;
        public void visitBackendBlockPos(katja.spec.BackendBlockPos term) throws E;
        public void visitRootPos(katja.spec.RootPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitImportPos(katja.spec.ImportPos term) throws E;
        public void visitIncludePos(katja.spec.IncludePos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitSpecificationPosList(katja.spec.SpecificationPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.SpecificationPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.SpecificationPos> implements katja.spec.SpecificationPosList {

        //----- methods of Impl -----

        Impl(katja.spec.SpecificationPos... elements) {
            super(elements);

            for(katja.spec.SpecificationPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SpecificationPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.SpecificationPosList createInstance(katja.spec.SpecificationPos[] elements, boolean isSet) {
            for(katja.spec.SpecificationPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SpecificationPosList invoked with null element");

            SpecificationPosList.Impl temp = new katja.spec.SpecificationPosList.Impl();
            temp.values = elements;
            temp = (SpecificationPosList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.SpecificationPos[] createArray(int size) {
            return new katja.spec.SpecificationPos[size];
        }

        public katja.spec.SpecificationPosList add(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.add(element);
        }

        public katja.spec.SpecificationPosList addAll(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.addAll(list);
        }

        public katja.spec.SpecificationPosList remove(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.remove(element);
        }

        public katja.spec.SpecificationPosList removeAll(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.removeAll(list);
        }

        public katja.spec.SpecificationPosList appBack(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.appBack(element);
        }

        public katja.spec.SpecificationPosList appFront(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.appFront(element);
        }

        public katja.spec.SpecificationPosList conc(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.conc(list);
        }

        public katja.spec.SpecificationPosList front() {
            return (katja.spec.SpecificationPosList) super.front();
        }

        public katja.spec.SpecificationPosList back() {
            return (katja.spec.SpecificationPosList) super.back();
        }

        public katja.spec.SpecificationPosList reverse() {
            return (katja.spec.SpecificationPosList) super.reverse();
        }

        public katja.spec.SpecificationPosList sublist(int from, int to) {
            return (katja.spec.SpecificationPosList) super.sublist(from, to);
        }

        public katja.spec.SpecificationPosList replace(int ith, Object element) {
            return (katja.spec.SpecificationPosList) super.replace(ith, element);
        }

        public katja.spec.SpecificationPosList toSet() {
            return (katja.spec.SpecificationPosList) super.toSet();
        }

        public katja.spec.SpecificationPosList setAdd(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.setAdd(element);
        }

        public katja.spec.SpecificationPosList setRemove(katja.spec.SpecificationPos element) {
            return (katja.spec.SpecificationPosList) super.setRemove(element);
        }

        public katja.spec.SpecificationPosList setUnion(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.setUnion(list);
        }

        public katja.spec.SpecificationPosList setIntersection(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.setIntersection(list);
        }

        public katja.spec.SpecificationPosList setWithout(KatjaList<? extends katja.spec.SpecificationPos> list) {
            return (katja.spec.SpecificationPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.SpecificationPosList");
            builder.append("( ");
            for(katja.spec.SpecificationPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SpecificationPosList");
            builder.append("( ");
            for(katja.spec.SpecificationPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SpecificationPosList";
        }
    }
}

