package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface StringPos extends katja.spec.Katja.LeafPos<java.lang.String> {

    //----- methods of StringPos -----

    public java.lang.String term();
    public katja.spec.Katja.NodePos<?> parent();
    public katja.spec.Katja.TermPos<?> lsib();
    public katja.spec.Katja.TermPos<?> rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of StringPos -----

    static class Impl extends KatjaLeafPosImpl<katja.spec.SpecificationPos, java.lang.String> implements katja.spec.StringPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, java.lang.String term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.NodePos<?> parent() {
            return (katja.spec.Katja.NodePos<?>) super.parent();
        }

        public katja.spec.Katja.TermPos<?> lsib() {
            return (katja.spec.Katja.TermPos<?>) super.lsib();
        }

        public katja.spec.Katja.TermPos<?> rsib() {
            return (katja.spec.Katja.TermPos<?>) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("\"").append(term().toString()).append("\"");
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StringPos";
        }
    }
}

