package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface TupleParamList extends KatjaList<katja.spec.TupleParam> {

    //----- methods of TupleParamList -----

    public katja.spec.TupleParamList add(katja.spec.TupleParam element);
    public katja.spec.TupleParamList addAll(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamList remove(katja.spec.TupleParam element);
    public katja.spec.TupleParamList removeAll(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamList appBack(katja.spec.TupleParam element);
    public katja.spec.TupleParamList appFront(katja.spec.TupleParam element);
    public katja.spec.TupleParamList conc(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamList front();
    public katja.spec.TupleParamList back();
    public katja.spec.TupleParamList reverse();
    public katja.spec.TupleParamList sublist(int from, int to);
    public katja.spec.TupleParamList replace(int ith, Object element);
    public katja.spec.TupleParamList toSet();
    public katja.spec.TupleParamList setAdd(katja.spec.TupleParam element);
    public katja.spec.TupleParamList setRemove(katja.spec.TupleParam element);
    public katja.spec.TupleParamList setUnion(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamList setIntersection(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamList setWithout(KatjaList<? extends katja.spec.TupleParam> list);

    //----- nested classes of TupleParamList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.TupleParamList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.TupleParam> implements katja.spec.TupleParamList {

        //----- methods of Impl -----

        Impl(katja.spec.TupleParam... elements) {
            super(elements);

            for(katja.spec.TupleParam element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleParamList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.TupleParamList createInstance(katja.spec.TupleParam[] elements, boolean isSet) {
            for(katja.spec.TupleParam element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleParamList invoked with null element");

            TupleParamList.Impl temp = new katja.spec.TupleParamList.Impl();
            temp.values = elements;
            temp = (TupleParamList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.TupleParam[] createArray(int size) {
            return new katja.spec.TupleParam[size];
        }

        public katja.spec.TupleParamList add(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.add(element);
        }

        public katja.spec.TupleParamList addAll(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.addAll(list);
        }

        public katja.spec.TupleParamList remove(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.remove(element);
        }

        public katja.spec.TupleParamList removeAll(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.removeAll(list);
        }

        public katja.spec.TupleParamList appBack(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.appBack(element);
        }

        public katja.spec.TupleParamList appFront(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.appFront(element);
        }

        public katja.spec.TupleParamList conc(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.conc(list);
        }

        public katja.spec.TupleParamList front() {
            return (katja.spec.TupleParamList) super.front();
        }

        public katja.spec.TupleParamList back() {
            return (katja.spec.TupleParamList) super.back();
        }

        public katja.spec.TupleParamList reverse() {
            return (katja.spec.TupleParamList) super.reverse();
        }

        public katja.spec.TupleParamList sublist(int from, int to) {
            return (katja.spec.TupleParamList) super.sublist(from, to);
        }

        public katja.spec.TupleParamList replace(int ith, Object element) {
            return (katja.spec.TupleParamList) super.replace(ith, element);
        }

        public katja.spec.TupleParamList toSet() {
            return (katja.spec.TupleParamList) super.toSet();
        }

        public katja.spec.TupleParamList setAdd(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.setAdd(element);
        }

        public katja.spec.TupleParamList setRemove(katja.spec.TupleParam element) {
            return (katja.spec.TupleParamList) super.setRemove(element);
        }

        public katja.spec.TupleParamList setUnion(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.setUnion(list);
        }

        public katja.spec.TupleParamList setIntersection(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.setIntersection(list);
        }

        public katja.spec.TupleParamList setWithout(KatjaList<? extends katja.spec.TupleParam> list) {
            return (katja.spec.TupleParamList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.TupleParamList");
            builder.append("( ");
            for(katja.spec.TupleParam element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TupleParamList");
            builder.append("( ");
            for(katja.spec.TupleParam element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TupleParamList";
        }
    }
}

