package katja.spec;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface TupleParamListPos extends katja.spec.Katja.ListPos<katja.spec.TupleParamList, katja.spec.TupleParamPos, katja.spec.TupleParam> {

    //----- methods of TupleParamListPos -----

    public katja.spec.TupleParamList term();
    public katja.spec.TupleParamListPos add(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos addAll(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamListPos remove(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos removeAll(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamListPos appBack(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos appFront(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos conc(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamListPos reverse();
    public katja.spec.TupleParamListPos toSet();
    public katja.spec.TupleParamListPos setAdd(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos setRemove(katja.spec.TupleParam element);
    public katja.spec.TupleParamListPos setUnion(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamListPos setWithout(KatjaList<? extends katja.spec.TupleParam> list);
    public katja.spec.TupleParamListPos setIntersection(KatjaList<? extends katja.spec.TupleParam> list);
    public KatjaList<katja.spec.TupleParamPos> toList();
    public katja.spec.TupleParamListPos replace(katja.spec.TupleParamList term);
    public katja.spec.TupleProdPos parent();
    public katja.spec.SortIdPos lsib();
    public katja.spec.Katja.SortPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of TupleParamListPos -----

    static class ListImpl extends KatjaListImpl<katja.spec.TupleParamPos> implements KatjaList<katja.spec.TupleParamPos> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.TupleParamPos... elements) {
            super(elements);

            for(katja.spec.TupleParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort TupleParamPos invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.TupleParamPos> createInstance(katja.spec.TupleParamPos[] elements, boolean isSet) {
            for(katja.spec.TupleParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort TupleParamPos invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.TupleParamPos[] createArray(int size) {
            return new katja.spec.TupleParamPos[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.TupleParamPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.TupleParamListPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }
    }

    static class Impl extends KatjaListPosImpl<katja.spec.SpecificationPos, katja.spec.TupleParamList, katja.spec.TupleParamPos, katja.spec.TupleParam> implements katja.spec.TupleParamListPos {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.TupleParamList term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.TupleParamPos getElementInstance(int pos) {
            return katja.spec.Katja.TupleParamPos(this, _term.get(pos), pos);
        }

        protected katja.spec.TupleParamPos[] createArray(int size) {
            return new katja.spec.TupleParamPos[size];
        }

        public katja.spec.TupleParamListPos add(katja.spec.TupleParam element) {
            return replace(_term.add(element));
        }

        public katja.spec.TupleParamListPos addAll(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.TupleParamListPos remove(katja.spec.TupleParam element) {
            return replace(_term.remove(element));
        }

        public katja.spec.TupleParamListPos removeAll(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.TupleParamListPos appBack(katja.spec.TupleParam element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.TupleParamListPos appFront(katja.spec.TupleParam element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.TupleParamListPos conc(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.TupleParamListPos reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.TupleParamListPos toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.TupleParamListPos setAdd(katja.spec.TupleParam element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.TupleParamListPos setRemove(katja.spec.TupleParam element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.TupleParamListPos setUnion(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.TupleParamListPos setWithout(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.TupleParamListPos setIntersection(KatjaList<? extends katja.spec.TupleParam> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.TupleParamPos> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new TupleParamListPos.ListImpl(values);
        }

        public katja.spec.TupleParamListPos replace(katja.spec.TupleParamList term) {
            return (katja.spec.TupleParamListPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.TupleProdPos parent() {
            return (katja.spec.TupleProdPos) super.parent();
        }

        public katja.spec.SortIdPos lsib() {
            return (katja.spec.SortIdPos) super.lsib();
        }

        public katja.spec.Katja.SortPos rsib() {
            return (katja.spec.Katja.SortPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "TupleParamListPos";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.TupleParamPos> implements KatjaList<katja.spec.TupleParamPos> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.TupleParamPos... elements) {
                super(elements);

                for(katja.spec.TupleParamPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort TupleParamPos invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.TupleParamPos> createInstance(katja.spec.TupleParamPos[] elements, boolean isSet) {
                for(katja.spec.TupleParamPos element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort TupleParamPos invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Katja.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.TupleParamPos[] createArray(int size) {
                return new katja.spec.TupleParamPos[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.TupleParamPos element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

