package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface TupleParamPos extends katja.spec.Katja.TuplePos<katja.spec.TupleParam> {

    //----- methods of TupleParamPos -----

    public katja.spec.TupleParam term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.TupleParamPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.SelectorOptPos selector();
    public katja.spec.TupleParamPos replaceSelector(katja.spec.SelectorOpt selector);
    public katja.spec.BooleanPos isOpt();
    public katja.spec.TupleParamPos replaceIsOpt(java.lang.Boolean isOpt);
    public katja.spec.Katja.SortPos get(int i);
    public int size();
    public katja.spec.TupleParamPos replace(katja.spec.TupleParam term);
    public katja.spec.TupleParamListPos parent();
    public katja.spec.TupleParamPos lsib();
    public katja.spec.TupleParamPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);

    //----- nested classes of TupleParamPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.TupleParamPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.TupleParam> implements katja.spec.TupleParamPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;
        private katja.spec.SelectorOptPos _selector = null;
        private katja.spec.BooleanPos _isOpt = null;

        //----- methods of Impl -----

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.TupleParamPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        public katja.spec.SelectorOptPos selector() {
            if(_selector == null)
                _selector = katja.spec.Katja.SelectorOptPos(this, _term.selector(), 1);

            return _selector;
        }

        public katja.spec.TupleParamPos replaceSelector(katja.spec.SelectorOpt selector) {
            return replace(_term.replaceSelector(selector));
        }

        public katja.spec.BooleanPos isOpt() {
            if(_isOpt == null)
                _isOpt = katja.spec.Katja.BooleanPos(this, _term.isOpt(), 2);

            return _isOpt;
        }

        public katja.spec.TupleParamPos replaceIsOpt(java.lang.Boolean isOpt) {
            return replace(_term.replaceIsOpt(isOpt));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.TupleParam term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.SortPos get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                case 1:
                    if(_selector == null)
                        _selector = Katja.SelectorOptPos(this, _term.selector(), 1);
                    
                    return _selector;
                case 2:
                    if(_isOpt == null)
                        _isOpt = Katja.BooleanPos(this, _term.isOpt(), 2);
                    
                    return _isOpt;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort TupleParamPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort TupleParamPos invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.TupleParamPos replace(katja.spec.TupleParam term) {
            return (katja.spec.TupleParamPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.TupleParamListPos parent() {
            return (katja.spec.TupleParamListPos) super.parent();
        }

        public katja.spec.TupleParamPos lsib() {
            return (katja.spec.TupleParamPos) super.lsib();
        }

        public katja.spec.TupleParamPos rsib() {
            return (katja.spec.TupleParamPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "TupleParamPos";
        }
    }
}

