package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface TupleProdPos extends katja.spec.ProductionPos, katja.spec.Katja.TuplePos<katja.spec.TupleProd> {

    //----- methods of TupleProdPos -----

    public katja.spec.TupleProd termProduction();
    public katja.spec.TupleProd termSortSpec();
    public katja.spec.TupleProd termVariantParam();
    public katja.spec.TupleProd term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.TupleProdPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.TupleParamListPos params();
    public katja.spec.TupleProdPos replaceParams(katja.spec.TupleParamList params);
    public katja.spec.Katja.NodePos<?> get(int i);
    public int size();
    public katja.spec.TupleProdPos replace(katja.spec.TupleProd term);
    public katja.spec.Katja.ListPos<?, ?, ?> parent();
    public katja.spec.VariantParamPos lsib();
    public katja.spec.VariantParamPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TupleProdPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.TupleProdPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.TupleProd> implements katja.spec.TupleProdPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;
        private katja.spec.TupleParamListPos _params = null;

        //----- methods of Impl -----

        public katja.spec.TupleProd termProduction() {
            return term();
        }

        public katja.spec.TupleProd termSortSpec() {
            return term();
        }

        public katja.spec.TupleProd termVariantParam() {
            return term();
        }

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.TupleProdPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        public katja.spec.TupleParamListPos params() {
            if(_params == null)
                _params = katja.spec.Katja.TupleParamListPos(this, _term.params(), 1);

            return _params;
        }

        public katja.spec.TupleProdPos replaceParams(katja.spec.TupleParamList params) {
            return replace(_term.replaceParams(params));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.TupleProd term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.NodePos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                case 1:
                    if(_params == null)
                        _params = Katja.TupleParamListPos(this, _term.params(), 1);
                    
                    return _params;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort TupleProdPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort TupleProdPos invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.TupleProdPos replace(katja.spec.TupleProd term) {
            return (katja.spec.TupleProdPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.ListPos<?, ?, ?> parent() {
            return (katja.spec.Katja.ListPos<?, ?, ?>) super.parent();
        }

        public katja.spec.VariantParamPos lsib() {
            return (katja.spec.VariantParamPos) super.lsib();
        }

        public katja.spec.VariantParamPos rsib() {
            return (katja.spec.VariantParamPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTupleProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTupleProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTupleProdPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "TupleProdPos";
        }
    }
}

