package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface VariantParamList extends KatjaList<katja.spec.VariantParam> {

    //----- methods of VariantParamList -----

    public katja.spec.VariantParamList add(katja.spec.VariantParam element);
    public katja.spec.VariantParamList addAll(KatjaList<? extends katja.spec.VariantParam> list);
    public katja.spec.VariantParamList remove(katja.spec.VariantParam element);
    public katja.spec.VariantParamList removeAll(KatjaList<? extends katja.spec.VariantParam> list);
    public katja.spec.VariantParamList appBack(katja.spec.VariantParam element);
    public katja.spec.VariantParamList appFront(katja.spec.VariantParam element);
    public katja.spec.VariantParamList conc(KatjaList<? extends katja.spec.VariantParam> list);
    public katja.spec.VariantParamList front();
    public katja.spec.VariantParamList back();
    public katja.spec.VariantParamList reverse();
    public katja.spec.VariantParamList sublist(int from, int to);
    public katja.spec.VariantParamList replace(int ith, Object element);
    public katja.spec.VariantParamList toSet();
    public katja.spec.VariantParamList setAdd(katja.spec.VariantParam element);
    public katja.spec.VariantParamList setRemove(katja.spec.VariantParam element);
    public katja.spec.VariantParamList setUnion(KatjaList<? extends katja.spec.VariantParam> list);
    public katja.spec.VariantParamList setIntersection(KatjaList<? extends katja.spec.VariantParam> list);
    public katja.spec.VariantParamList setWithout(KatjaList<? extends katja.spec.VariantParam> list);

    //----- nested classes of VariantParamList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitVariantParam(katja.spec.VariantParam term) throws E;
        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitProduction(katja.spec.Production term) throws E;
        public void visitTupleProd(katja.spec.TupleProd term) throws E;
        public void visitVariantProd(katja.spec.VariantProd term) throws E;
        public void visitListProd(katja.spec.ListProd term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
        public void visitVariantParamList(katja.spec.VariantParamList term) throws E;
        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.VariantParamList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.Production.Switch<Object, E> variantVisit$Production = new katja.spec.Production.Switch<Object, E>() { public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };
        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };
        private final katja.spec.VariantParam.Switch<Object, E> variantVisit$VariantParam = new katja.spec.VariantParam.Switch<Object, E>() { public final Object CaseSortId(katja.spec.SortId term) throws E { visitSortId(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProduction(katja.spec.Production term) throws E {
            term.Switch(variantVisit$Production);
        }

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }

        public final void visitVariantParam(katja.spec.VariantParam term) throws E {
            term.Switch(variantVisit$VariantParam);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.VariantParam> implements katja.spec.VariantParamList {

        //----- methods of Impl -----

        Impl(katja.spec.VariantParam... elements) {
            super(elements);

            for(katja.spec.VariantParam element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantParamList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.VariantParamList createInstance(katja.spec.VariantParam[] elements, boolean isSet) {
            for(katja.spec.VariantParam element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantParamList invoked with null element");

            VariantParamList.Impl temp = new katja.spec.VariantParamList.Impl();
            temp.values = elements;
            temp = (VariantParamList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.VariantParam[] createArray(int size) {
            return new katja.spec.VariantParam[size];
        }

        public katja.spec.VariantParamList add(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.add(element);
        }

        public katja.spec.VariantParamList addAll(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.addAll(list);
        }

        public katja.spec.VariantParamList remove(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.remove(element);
        }

        public katja.spec.VariantParamList removeAll(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.removeAll(list);
        }

        public katja.spec.VariantParamList appBack(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.appBack(element);
        }

        public katja.spec.VariantParamList appFront(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.appFront(element);
        }

        public katja.spec.VariantParamList conc(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.conc(list);
        }

        public katja.spec.VariantParamList front() {
            return (katja.spec.VariantParamList) super.front();
        }

        public katja.spec.VariantParamList back() {
            return (katja.spec.VariantParamList) super.back();
        }

        public katja.spec.VariantParamList reverse() {
            return (katja.spec.VariantParamList) super.reverse();
        }

        public katja.spec.VariantParamList sublist(int from, int to) {
            return (katja.spec.VariantParamList) super.sublist(from, to);
        }

        public katja.spec.VariantParamList replace(int ith, Object element) {
            return (katja.spec.VariantParamList) super.replace(ith, element);
        }

        public katja.spec.VariantParamList toSet() {
            return (katja.spec.VariantParamList) super.toSet();
        }

        public katja.spec.VariantParamList setAdd(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.setAdd(element);
        }

        public katja.spec.VariantParamList setRemove(katja.spec.VariantParam element) {
            return (katja.spec.VariantParamList) super.setRemove(element);
        }

        public katja.spec.VariantParamList setUnion(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.setUnion(list);
        }

        public katja.spec.VariantParamList setIntersection(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.setIntersection(list);
        }

        public katja.spec.VariantParamList setWithout(KatjaList<? extends katja.spec.VariantParam> list) {
            return (katja.spec.VariantParamList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.VariantParamList");
            builder.append("( ");
            for(katja.spec.VariantParam element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("VariantParamList");
            builder.append("( ");
            for(katja.spec.VariantParam element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "VariantParamList";
        }
    }
}

