package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface VariantParamPosList extends KatjaList<katja.spec.VariantParamPos> {

    //----- methods of VariantParamPosList -----

    public katja.spec.VariantParamPosList add(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList addAll(KatjaList<? extends katja.spec.VariantParamPos> list);
    public katja.spec.VariantParamPosList remove(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList removeAll(KatjaList<? extends katja.spec.VariantParamPos> list);
    public katja.spec.VariantParamPosList appBack(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList appFront(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList conc(KatjaList<? extends katja.spec.VariantParamPos> list);
    public katja.spec.VariantParamPosList front();
    public katja.spec.VariantParamPosList back();
    public katja.spec.VariantParamPosList reverse();
    public katja.spec.VariantParamPosList sublist(int from, int to);
    public katja.spec.VariantParamPosList replace(int ith, Object element);
    public katja.spec.VariantParamPosList toSet();
    public katja.spec.VariantParamPosList setAdd(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList setRemove(katja.spec.VariantParamPos element);
    public katja.spec.VariantParamPosList setUnion(KatjaList<? extends katja.spec.VariantParamPos> list);
    public katja.spec.VariantParamPosList setIntersection(KatjaList<? extends katja.spec.VariantParamPos> list);
    public katja.spec.VariantParamPosList setWithout(KatjaList<? extends katja.spec.VariantParamPos> list);

    //----- nested classes of VariantParamPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitVariantParamPosList(katja.spec.VariantParamPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.VariantParamPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.ProductionPos.Switch<Object, E> variantVisit$ProductionPos = new katja.spec.ProductionPos.Switch<Object, E>() { public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$ProductionPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.VariantParamPos> implements katja.spec.VariantParamPosList {

        //----- methods of Impl -----

        Impl(katja.spec.VariantParamPos... elements) {
            super(elements);

            for(katja.spec.VariantParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantParamPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.VariantParamPosList createInstance(katja.spec.VariantParamPos[] elements, boolean isSet) {
            for(katja.spec.VariantParamPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantParamPosList invoked with null element");

            VariantParamPosList.Impl temp = new katja.spec.VariantParamPosList.Impl();
            temp.values = elements;
            temp = (VariantParamPosList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.VariantParamPos[] createArray(int size) {
            return new katja.spec.VariantParamPos[size];
        }

        public katja.spec.VariantParamPosList add(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.add(element);
        }

        public katja.spec.VariantParamPosList addAll(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.addAll(list);
        }

        public katja.spec.VariantParamPosList remove(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.remove(element);
        }

        public katja.spec.VariantParamPosList removeAll(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.removeAll(list);
        }

        public katja.spec.VariantParamPosList appBack(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.appBack(element);
        }

        public katja.spec.VariantParamPosList appFront(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.appFront(element);
        }

        public katja.spec.VariantParamPosList conc(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.conc(list);
        }

        public katja.spec.VariantParamPosList front() {
            return (katja.spec.VariantParamPosList) super.front();
        }

        public katja.spec.VariantParamPosList back() {
            return (katja.spec.VariantParamPosList) super.back();
        }

        public katja.spec.VariantParamPosList reverse() {
            return (katja.spec.VariantParamPosList) super.reverse();
        }

        public katja.spec.VariantParamPosList sublist(int from, int to) {
            return (katja.spec.VariantParamPosList) super.sublist(from, to);
        }

        public katja.spec.VariantParamPosList replace(int ith, Object element) {
            return (katja.spec.VariantParamPosList) super.replace(ith, element);
        }

        public katja.spec.VariantParamPosList toSet() {
            return (katja.spec.VariantParamPosList) super.toSet();
        }

        public katja.spec.VariantParamPosList setAdd(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.setAdd(element);
        }

        public katja.spec.VariantParamPosList setRemove(katja.spec.VariantParamPos element) {
            return (katja.spec.VariantParamPosList) super.setRemove(element);
        }

        public katja.spec.VariantParamPosList setUnion(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.setUnion(list);
        }

        public katja.spec.VariantParamPosList setIntersection(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.setIntersection(list);
        }

        public katja.spec.VariantParamPosList setWithout(KatjaList<? extends katja.spec.VariantParamPos> list) {
            return (katja.spec.VariantParamPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.VariantParamPosList");
            builder.append("( ");
            for(katja.spec.VariantParamPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("VariantParamPosList");
            builder.append("( ");
            for(katja.spec.VariantParamPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "VariantParamPosList";
        }
    }
}

