package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface VariantPosList extends KatjaList<katja.spec.VariantProdPos> {

    //----- methods of VariantPosList -----

    public katja.spec.VariantPosList add(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList addAll(KatjaList<? extends katja.spec.VariantProdPos> list);
    public katja.spec.VariantPosList remove(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList removeAll(KatjaList<? extends katja.spec.VariantProdPos> list);
    public katja.spec.VariantPosList appBack(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList appFront(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList conc(KatjaList<? extends katja.spec.VariantProdPos> list);
    public katja.spec.VariantPosList front();
    public katja.spec.VariantPosList back();
    public katja.spec.VariantPosList reverse();
    public katja.spec.VariantPosList sublist(int from, int to);
    public katja.spec.VariantPosList replace(int ith, Object element);
    public katja.spec.VariantPosList toSet();
    public katja.spec.VariantPosList setAdd(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList setRemove(katja.spec.VariantProdPos element);
    public katja.spec.VariantPosList setUnion(KatjaList<? extends katja.spec.VariantProdPos> list);
    public katja.spec.VariantPosList setIntersection(KatjaList<? extends katja.spec.VariantProdPos> list);
    public katja.spec.VariantPosList setWithout(KatjaList<? extends katja.spec.VariantProdPos> list);

    //----- nested classes of VariantPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitVariantPosList(katja.spec.VariantPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.VariantPosList.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.ProductionPos.Switch<Object, E> variantVisit$ProductionPos = new katja.spec.ProductionPos.Switch<Object, E>() { public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$ProductionPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.VariantProdPos> implements katja.spec.VariantPosList {

        //----- methods of Impl -----

        Impl(katja.spec.VariantProdPos... elements) {
            super(elements);

            for(katja.spec.VariantProdPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.VariantPosList createInstance(katja.spec.VariantProdPos[] elements, boolean isSet) {
            for(katja.spec.VariantProdPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort VariantPosList invoked with null element");

            VariantPosList.Impl temp = new katja.spec.VariantPosList.Impl();
            temp.values = elements;
            temp = (VariantPosList.Impl) Katja.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.VariantProdPos[] createArray(int size) {
            return new katja.spec.VariantProdPos[size];
        }

        public katja.spec.VariantPosList add(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.add(element);
        }

        public katja.spec.VariantPosList addAll(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.addAll(list);
        }

        public katja.spec.VariantPosList remove(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.remove(element);
        }

        public katja.spec.VariantPosList removeAll(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.removeAll(list);
        }

        public katja.spec.VariantPosList appBack(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.appBack(element);
        }

        public katja.spec.VariantPosList appFront(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.appFront(element);
        }

        public katja.spec.VariantPosList conc(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.conc(list);
        }

        public katja.spec.VariantPosList front() {
            return (katja.spec.VariantPosList) super.front();
        }

        public katja.spec.VariantPosList back() {
            return (katja.spec.VariantPosList) super.back();
        }

        public katja.spec.VariantPosList reverse() {
            return (katja.spec.VariantPosList) super.reverse();
        }

        public katja.spec.VariantPosList sublist(int from, int to) {
            return (katja.spec.VariantPosList) super.sublist(from, to);
        }

        public katja.spec.VariantPosList replace(int ith, Object element) {
            return (katja.spec.VariantPosList) super.replace(ith, element);
        }

        public katja.spec.VariantPosList toSet() {
            return (katja.spec.VariantPosList) super.toSet();
        }

        public katja.spec.VariantPosList setAdd(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.setAdd(element);
        }

        public katja.spec.VariantPosList setRemove(katja.spec.VariantProdPos element) {
            return (katja.spec.VariantPosList) super.setRemove(element);
        }

        public katja.spec.VariantPosList setUnion(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.setUnion(list);
        }

        public katja.spec.VariantPosList setIntersection(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.setIntersection(list);
        }

        public katja.spec.VariantPosList setWithout(KatjaList<? extends katja.spec.VariantProdPos> list) {
            return (katja.spec.VariantPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Katja.VariantPosList");
            builder.append("( ");
            for(katja.spec.VariantProdPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("VariantPosList");
            builder.append("( ");
            for(katja.spec.VariantProdPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "VariantPosList";
        }
    }
}

