package katja.spec;

import katja.common.*;
import java.io.IOException;

public interface VariantProd extends katja.spec.Production, KatjaTuple {

    //----- methods of VariantProd -----

    public katja.spec.SortId sortId();
    public katja.spec.VariantProd replaceSortId(katja.spec.SortId sortId);
    public katja.spec.VariantParamList params();
    public katja.spec.VariantProd replaceParams(katja.spec.VariantParamList params);
    public KatjaTerm get(int i);
    public int size();
    public katja.spec.VariantProd replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.Production.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpec.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParam.Switch<CT, E> switchClass) throws E;

    //----- nested classes of VariantProd -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortId(katja.spec.SortId term) throws E;
        public void visitVariantParamList(katja.spec.VariantParamList term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitVariantParam(katja.spec.VariantParam term) throws E;
        public void visitProduction(katja.spec.Production term) throws E;
        public void visitTupleProd(katja.spec.TupleProd term) throws E;
        public void visitVariantProd(katja.spec.VariantProd term) throws E;
        public void visitListProd(katja.spec.ListProd term) throws E;
        public void visitTupleParamList(katja.spec.TupleParamList term) throws E;
        public void visitTupleParam(katja.spec.TupleParam term) throws E;
        public void visitSelectorOpt(katja.spec.SelectorOpt term) throws E;
        public void visitSelector(katja.spec.Selector term) throws E;
        public void visitEmpty(katja.spec.Empty term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.VariantProd.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.Production.Switch<Object, E> variantVisit$Production = new katja.spec.Production.Switch<Object, E>() { public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };
        private final katja.spec.SelectorOpt.Switch<Object, E> variantVisit$SelectorOpt = new katja.spec.SelectorOpt.Switch<Object, E>() { public final Object CaseSelector(katja.spec.Selector term) throws E { visitSelector(term); return null; } public final Object CaseEmpty(katja.spec.Empty term) throws E { visitEmpty(term); return null; } };
        private final katja.spec.VariantParam.Switch<Object, E> variantVisit$VariantParam = new katja.spec.VariantParam.Switch<Object, E>() { public final Object CaseSortId(katja.spec.SortId term) throws E { visitSortId(term); return null; } public final Object CaseTupleProd(katja.spec.TupleProd term) throws E { visitTupleProd(term); return null; } public final Object CaseVariantProd(katja.spec.VariantProd term) throws E { visitVariantProd(term); return null; } public final Object CaseListProd(katja.spec.ListProd term) throws E { visitListProd(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProduction(katja.spec.Production term) throws E {
            term.Switch(variantVisit$Production);
        }

        public final void visitSelectorOpt(katja.spec.SelectorOpt term) throws E {
            term.Switch(variantVisit$SelectorOpt);
        }

        public final void visitVariantParam(katja.spec.VariantParam term) throws E {
            term.Switch(variantVisit$VariantParam);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.VariantProd {

        //----- attributes of Impl -----

        private katja.spec.SortId _sortId = null;
        private katja.spec.VariantParamList _params = null;

        //----- methods of Impl -----

        public katja.spec.SortId sortId() {
            return _sortId;
        }

        public katja.spec.VariantProd replaceSortId(katja.spec.SortId sortId) {
            return replace(0, sortId);
        }

        public katja.spec.VariantParamList params() {
            return _params;
        }

        public katja.spec.VariantProd replaceParams(katja.spec.VariantParamList params) {
            return replace(1, params);
        }

        Impl(katja.spec.SortId sortId, katja.spec.VariantParamList params) {
            if(sortId == null)
                throw new IllegalArgumentException("constructor of sort VariantProd invoked with null parameter sortId");
            if(params == null)
                throw new IllegalArgumentException("constructor of sort VariantProd invoked with null parameter params");

            this._sortId = sortId;
            this._params = params;
        }

        public KatjaTerm get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _sortId;
                case 1: return _params;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort VariantProd invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort VariantProd invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.VariantProd replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort VariantProd invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort VariantProd invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.SortId))
                throw new IllegalArgumentException("replace on sort VariantProd invoked with term of incorrect sort, SortId expected");
            if(pos == 1 && !(term instanceof katja.spec.VariantParamList))
                throw new IllegalArgumentException("replace on sort VariantProd invoked with term of incorrect sort, VariantParamList expected");

            return (katja.spec.VariantProd) Katja.unique(new katja.spec.VariantProd.Impl(
                pos == 0 ? (katja.spec.SortId) term : _sortId,
                pos == 1 ? (katja.spec.VariantParamList) term : _params
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.Production.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProd(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SortSpec.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProd(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParam.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProd(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.VariantProd");
            builder.append("( ");
            _sortId.toJavaCode(builder);
            builder.append(", ");
            _params.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("VariantProd");
            builder.append("( ");
            _sortId.toString(builder);
            builder.append(", ");
            _params.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "VariantProd";
        }
    }
}

