package katja.spec;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface VariantProdPos extends katja.spec.ProductionPos, katja.spec.Katja.TuplePos<katja.spec.VariantProd> {

    //----- methods of VariantProdPos -----

    public katja.spec.VariantProd termProduction();
    public katja.spec.VariantProd termSortSpec();
    public katja.spec.VariantProd termVariantParam();
    public katja.spec.VariantProd term();
    public katja.spec.SortIdPos sortId();
    public katja.spec.VariantProdPos replaceSortId(katja.spec.SortId sortId);
    public katja.spec.VariantParamListPos params();
    public katja.spec.VariantProdPos replaceParams(katja.spec.VariantParamList params);
    public katja.spec.Katja.NodePos<?> get(int i);
    public int size();
    public katja.spec.VariantProdPos replace(katja.spec.VariantProd term);
    public katja.spec.Katja.ListPos<?, ?, ?> parent();
    public katja.spec.VariantParamPos lsib();
    public katja.spec.VariantParamPos rsib();
    public katja.spec.Katja.SortPos preOrder();
    public katja.spec.Katja.SortPos postOrder();
    public katja.spec.Katja.SortPos postOrderStart();
    public katja.spec.Katja.SortPos follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E;

    //----- nested classes of VariantProdPos -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.VariantProdPos.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.ProductionPos.Switch<Object, E> variantVisit$ProductionPos = new katja.spec.ProductionPos.Switch<Object, E>() { public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$ProductionPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.SpecificationPos, katja.spec.VariantProd> implements katja.spec.VariantProdPos {

        //----- attributes of Impl -----

        private katja.spec.SortIdPos _sortId = null;
        private katja.spec.VariantParamListPos _params = null;

        //----- methods of Impl -----

        public katja.spec.VariantProd termProduction() {
            return term();
        }

        public katja.spec.VariantProd termSortSpec() {
            return term();
        }

        public katja.spec.VariantProd termVariantParam() {
            return term();
        }

        public katja.spec.SortIdPos sortId() {
            if(_sortId == null)
                _sortId = katja.spec.Katja.SortIdPos(this, _term.sortId(), 0);

            return _sortId;
        }

        public katja.spec.VariantProdPos replaceSortId(katja.spec.SortId sortId) {
            return replace(_term.replaceSortId(sortId));
        }

        public katja.spec.VariantParamListPos params() {
            if(_params == null)
                _params = katja.spec.Katja.VariantParamListPos(this, _term.params(), 1);

            return _params;
        }

        public katja.spec.VariantProdPos replaceParams(katja.spec.VariantParamList params) {
            return replace(_term.replaceParams(params));
        }

        Impl(KatjaNodePos<katja.spec.SpecificationPos, ?> parent, katja.spec.VariantProd term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.Katja.NodePos<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_sortId == null)
                        _sortId = Katja.SortIdPos(this, _term.sortId(), 0);
                    
                    return _sortId;
                case 1:
                    if(_params == null)
                        _params = Katja.VariantParamListPos(this, _term.params(), 1);
                    
                    return _params;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort VariantProdPos invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort VariantProdPos invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.VariantProdPos replace(katja.spec.VariantProd term) {
            return (katja.spec.VariantProdPos) super.replace(term);
        }

        protected katja.spec.SpecificationPos freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.Specification))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort Specification");

            return Katja.SpecificationPos((Specification) term);
        }

        public katja.spec.Katja.ListPos<?, ?, ?> parent() {
            return (katja.spec.Katja.ListPos<?, ?, ?>) super.parent();
        }

        public katja.spec.VariantParamPos lsib() {
            return (katja.spec.VariantParamPos) super.lsib();
        }

        public katja.spec.VariantParamPos rsib() {
            return (katja.spec.VariantParamPos) super.rsib();
        }

        public katja.spec.Katja.SortPos preOrder() {
            return (katja.spec.Katja.SortPos) super.preOrder();
        }

        public katja.spec.Katja.SortPos postOrder() {
            return (katja.spec.Katja.SortPos) super.postOrder();
        }

        public katja.spec.Katja.SortPos postOrderStart() {
            return (katja.spec.Katja.SortPos) super.postOrderStart();
        }

        public katja.spec.Katja.SortPos follow(List<Integer> path) {
            return (katja.spec.Katja.SortPos) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.ProductionPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.SortSpecPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProdPos(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.VariantParamPos.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantProdPos(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Katja.SpecificationPos");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@Specification");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "VariantProdPos";
        }
    }
}

