package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface PosSortDescriptor extends katja.spec.descriptors.SortDescriptor, KatjaTuple {

    //----- methods of PosSortDescriptor -----

    public java.lang.String name();
    public katja.spec.descriptors.PosSortDescriptor replaceName(java.lang.String name);
    public java.lang.String filename();
    public katja.spec.descriptors.PosSortDescriptor replaceFilename(java.lang.String filename);
    public java.lang.Integer line();
    public katja.spec.descriptors.PosSortDescriptor replaceLine(java.lang.Integer line);
    public java.lang.Boolean imported();
    public katja.spec.descriptors.PosSortDescriptor replaceImported(java.lang.Boolean imported);
    public katja.spec.descriptors.TermSortDescriptor baseSort();
    public katja.spec.descriptors.PosSortDescriptor replaceBaseSort(katja.spec.descriptors.TermSortDescriptor baseSort);
    public katja.spec.descriptors.PosStructDescriptor struct();
    public katja.spec.descriptors.PosSortDescriptor replaceStruct(katja.spec.descriptors.PosStructDescriptor struct);
    public Object get(int i);
    public int size();
    public katja.spec.descriptors.PosSortDescriptor replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.SortDescriptor.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PosSortDescriptor -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.PosSortDescriptor.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.descriptors.PosSortDescriptor {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private java.lang.String _filename = null;
        private java.lang.Integer _line = null;
        private java.lang.Boolean _imported = null;
        private katja.spec.descriptors.TermSortDescriptor _baseSort = null;
        private katja.spec.descriptors.PosStructDescriptor _struct = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public java.lang.String filename() {
            return _filename;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceFilename(java.lang.String filename) {
            return replace(1, filename);
        }

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceLine(java.lang.Integer line) {
            return replace(2, line);
        }

        public java.lang.Boolean imported() {
            return _imported;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceImported(java.lang.Boolean imported) {
            return replace(3, imported);
        }

        public katja.spec.descriptors.TermSortDescriptor baseSort() {
            return _baseSort;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceBaseSort(katja.spec.descriptors.TermSortDescriptor baseSort) {
            return replace(4, baseSort);
        }

        public katja.spec.descriptors.PosStructDescriptor struct() {
            return _struct;
        }

        public katja.spec.descriptors.PosSortDescriptor replaceStruct(katja.spec.descriptors.PosStructDescriptor struct) {
            return replace(5, struct);
        }

        Impl(java.lang.String name, java.lang.String filename, java.lang.Integer line, java.lang.Boolean imported, katja.spec.descriptors.TermSortDescriptor baseSort, katja.spec.descriptors.PosStructDescriptor struct) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter name");
            if(filename == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter filename");
            if(line == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter line");
            if(imported == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter imported");
            if(baseSort == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter baseSort");
            if(struct == null)
                throw new IllegalArgumentException("constructor of sort PosSortDescriptor invoked with null parameter struct");

            this._name = name;
            this._filename = filename;
            this._line = line;
            this._imported = imported;
            this._baseSort = baseSort;
            this._struct = struct;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 6;

            switch(ith) {
                case 0: return _name;
                case 1: return _filename;
                case 2: return _line;
                case 3: return _imported;
                case 4: return _baseSort;
                case 5: return _struct;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PosSortDescriptor invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PosSortDescriptor invoked with too large parameter "+i+", sort has only 6 components");
                    }
            }
        }

        public int size() {
            return 6;
        }

        public katja.spec.descriptors.PosSortDescriptor replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with negative parameter "+pos);
            if(pos >= 6)
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with too large parameter "+pos+", sort has only 6 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, Integer expected");
            if(pos == 3 && !(term instanceof java.lang.Boolean))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, Boolean expected");
            if(pos == 4 && !(term instanceof katja.spec.descriptors.TermSortDescriptor))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, TermSortDescriptor expected");
            if(pos == 5 && !(term instanceof katja.spec.descriptors.PosStructDescriptor))
                throw new IllegalArgumentException("replace on sort PosSortDescriptor invoked with term of incorrect sort, PosStructDescriptor expected");

            return (katja.spec.descriptors.PosSortDescriptor) Descriptors.unique(new katja.spec.descriptors.PosSortDescriptor.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (java.lang.String) term : _filename,
                pos == 2 ? (java.lang.Integer) term : _line,
                pos == 3 ? (java.lang.Boolean) term : _imported,
                pos == 4 ? (katja.spec.descriptors.TermSortDescriptor) term : _baseSort,
                pos == 5 ? (katja.spec.descriptors.PosStructDescriptor) term : _struct
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.SortDescriptor.Switch<CT, E> switchClass) throws E {
            return switchClass.CasePosSortDescriptor(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Descriptors.PosSortDescriptor");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append(_imported.toString());
            builder.append(", ");
            _baseSort.toJavaCode(builder);
            builder.append(", ");
            _struct.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("PosSortDescriptor");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append(_imported.toString());
            builder.append(", ");
            _baseSort.toString(builder);
            builder.append(", ");
            _struct.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PosSortDescriptor";
        }
    }
}

