package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface PosSortDescriptors extends KatjaList<katja.spec.descriptors.PosSortDescriptor> {

    //----- methods of PosSortDescriptors -----

    public katja.spec.descriptors.PosSortDescriptors add(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);
    public katja.spec.descriptors.PosSortDescriptors remove(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);
    public katja.spec.descriptors.PosSortDescriptors appBack(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors appFront(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);
    public katja.spec.descriptors.PosSortDescriptors front();
    public katja.spec.descriptors.PosSortDescriptors back();
    public katja.spec.descriptors.PosSortDescriptors reverse();
    public katja.spec.descriptors.PosSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.PosSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.PosSortDescriptors toSet();
    public katja.spec.descriptors.PosSortDescriptors setAdd(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors setRemove(katja.spec.descriptors.PosSortDescriptor element);
    public katja.spec.descriptors.PosSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);
    public katja.spec.descriptors.PosSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);
    public katja.spec.descriptors.PosSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list);

    //----- nested classes of PosSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitPosSortDescriptors(katja.spec.descriptors.PosSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.PosSortDescriptors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.PosSortDescriptor> implements katja.spec.descriptors.PosSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.PosSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.PosSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort PosSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.PosSortDescriptors createInstance(katja.spec.descriptors.PosSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.PosSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort PosSortDescriptors invoked with null element");

            PosSortDescriptors.Impl temp = new katja.spec.descriptors.PosSortDescriptors.Impl();
            temp.values = elements;
            temp = (PosSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.PosSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.PosSortDescriptor[size];
        }

        public katja.spec.descriptors.PosSortDescriptors add(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.PosSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.PosSortDescriptors remove(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.PosSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.PosSortDescriptors appBack(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.PosSortDescriptors appFront(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.PosSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.PosSortDescriptors front() {
            return (katja.spec.descriptors.PosSortDescriptors) super.front();
        }

        public katja.spec.descriptors.PosSortDescriptors back() {
            return (katja.spec.descriptors.PosSortDescriptors) super.back();
        }

        public katja.spec.descriptors.PosSortDescriptors reverse() {
            return (katja.spec.descriptors.PosSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.PosSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.PosSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.PosSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.PosSortDescriptors toSet() {
            return (katja.spec.descriptors.PosSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.PosSortDescriptors setAdd(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.PosSortDescriptors setRemove(katja.spec.descriptors.PosSortDescriptor element) {
            return (katja.spec.descriptors.PosSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.PosSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.PosSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.PosSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.PosSortDescriptor> list) {
            return (katja.spec.descriptors.PosSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.PosSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.PosSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("PosSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.PosSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PosSortDescriptors";
        }
    }
}

