package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface PosStructDescriptor extends KatjaTuple {

    //----- methods of PosStructDescriptor -----

    public katja.spec.descriptors.TermSortDescriptor rootSort();
    public katja.spec.descriptors.PosStructDescriptor replaceRootSort(katja.spec.descriptors.TermSortDescriptor rootSort);
    public java.lang.String suffix();
    public katja.spec.descriptors.PosStructDescriptor replaceSuffix(java.lang.String suffix);
    public Object get(int i);
    public int size();
    public katja.spec.descriptors.PosStructDescriptor replace(int pos, Object term);

    //----- nested classes of PosStructDescriptor -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.PosStructDescriptor.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.descriptors.PosStructDescriptor {

        //----- attributes of Impl -----

        private katja.spec.descriptors.TermSortDescriptor _rootSort = null;
        private java.lang.String _suffix = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.TermSortDescriptor rootSort() {
            return _rootSort;
        }

        public katja.spec.descriptors.PosStructDescriptor replaceRootSort(katja.spec.descriptors.TermSortDescriptor rootSort) {
            return replace(0, rootSort);
        }

        public java.lang.String suffix() {
            return _suffix;
        }

        public katja.spec.descriptors.PosStructDescriptor replaceSuffix(java.lang.String suffix) {
            return replace(1, suffix);
        }

        Impl(katja.spec.descriptors.TermSortDescriptor rootSort, java.lang.String suffix) {
            if(rootSort == null)
                throw new IllegalArgumentException("constructor of sort PosStructDescriptor invoked with null parameter rootSort");
            if(suffix == null)
                throw new IllegalArgumentException("constructor of sort PosStructDescriptor invoked with null parameter suffix");

            this._rootSort = rootSort;
            this._suffix = suffix;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _rootSort;
                case 1: return _suffix;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PosStructDescriptor invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PosStructDescriptor invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.descriptors.PosStructDescriptor replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort PosStructDescriptor invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort PosStructDescriptor invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.TermSortDescriptor))
                throw new IllegalArgumentException("replace on sort PosStructDescriptor invoked with term of incorrect sort, TermSortDescriptor expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort PosStructDescriptor invoked with term of incorrect sort, String expected");

            return (katja.spec.descriptors.PosStructDescriptor) Descriptors.unique(new katja.spec.descriptors.PosStructDescriptor.Impl(
                pos == 0 ? (katja.spec.descriptors.TermSortDescriptor) term : _rootSort,
                pos == 1 ? (java.lang.String) term : _suffix
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Descriptors.PosStructDescriptor");
            builder.append("( ");
            _rootSort.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_suffix.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("PosStructDescriptor");
            builder.append("( ");
            _rootSort.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_suffix.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PosStructDescriptor";
        }
    }
}

