package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface PosStructDescriptors extends KatjaList<katja.spec.descriptors.PosStructDescriptor> {

    //----- methods of PosStructDescriptors -----

    public katja.spec.descriptors.PosStructDescriptors add(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors addAll(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);
    public katja.spec.descriptors.PosStructDescriptors remove(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);
    public katja.spec.descriptors.PosStructDescriptors appBack(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors appFront(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors conc(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);
    public katja.spec.descriptors.PosStructDescriptors front();
    public katja.spec.descriptors.PosStructDescriptors back();
    public katja.spec.descriptors.PosStructDescriptors reverse();
    public katja.spec.descriptors.PosStructDescriptors sublist(int from, int to);
    public katja.spec.descriptors.PosStructDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.PosStructDescriptors toSet();
    public katja.spec.descriptors.PosStructDescriptors setAdd(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors setRemove(katja.spec.descriptors.PosStructDescriptor element);
    public katja.spec.descriptors.PosStructDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);
    public katja.spec.descriptors.PosStructDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);
    public katja.spec.descriptors.PosStructDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list);

    //----- nested classes of PosStructDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptors(katja.spec.descriptors.PosStructDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.PosStructDescriptors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.PosStructDescriptor> implements katja.spec.descriptors.PosStructDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.PosStructDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.PosStructDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort PosStructDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.PosStructDescriptors createInstance(katja.spec.descriptors.PosStructDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.PosStructDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort PosStructDescriptors invoked with null element");

            PosStructDescriptors.Impl temp = new katja.spec.descriptors.PosStructDescriptors.Impl();
            temp.values = elements;
            temp = (PosStructDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.PosStructDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.PosStructDescriptor[size];
        }

        public katja.spec.descriptors.PosStructDescriptors add(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.add(element);
        }

        public katja.spec.descriptors.PosStructDescriptors addAll(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.PosStructDescriptors remove(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.PosStructDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.PosStructDescriptors appBack(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.PosStructDescriptors appFront(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.PosStructDescriptors conc(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.PosStructDescriptors front() {
            return (katja.spec.descriptors.PosStructDescriptors) super.front();
        }

        public katja.spec.descriptors.PosStructDescriptors back() {
            return (katja.spec.descriptors.PosStructDescriptors) super.back();
        }

        public katja.spec.descriptors.PosStructDescriptors reverse() {
            return (katja.spec.descriptors.PosStructDescriptors) super.reverse();
        }

        public katja.spec.descriptors.PosStructDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.PosStructDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.PosStructDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.PosStructDescriptors toSet() {
            return (katja.spec.descriptors.PosStructDescriptors) super.toSet();
        }

        public katja.spec.descriptors.PosStructDescriptors setAdd(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.PosStructDescriptors setRemove(katja.spec.descriptors.PosStructDescriptor element) {
            return (katja.spec.descriptors.PosStructDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.PosStructDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.PosStructDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.PosStructDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.PosStructDescriptor> list) {
            return (katja.spec.descriptors.PosStructDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.PosStructDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.PosStructDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("PosStructDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.PosStructDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PosStructDescriptors";
        }
    }
}

