package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface SelectorDescriptor extends KatjaTuple {

    //----- methods of SelectorDescriptor -----

    public katja.spec.descriptors.SortDescriptor parentSort();
    public katja.spec.descriptors.SelectorDescriptor replaceParentSort(katja.spec.descriptors.SortDescriptor parentSort);
    public java.lang.Integer count();
    public katja.spec.descriptors.SelectorDescriptor replaceCount(java.lang.Integer count);
    public java.lang.String name();
    public katja.spec.descriptors.SelectorDescriptor replaceName(java.lang.String name);
    public katja.spec.descriptors.SortDescriptor paramSort();
    public katja.spec.descriptors.SelectorDescriptor replaceParamSort(katja.spec.descriptors.SortDescriptor paramSort);
    public Object get(int i);
    public int size();
    public katja.spec.descriptors.SelectorDescriptor replace(int pos, Object term);

    //----- nested classes of SelectorDescriptor -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitSelectorDescriptor(katja.spec.descriptors.SelectorDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.SelectorDescriptor.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.descriptors.SelectorDescriptor {

        //----- attributes of Impl -----

        private katja.spec.descriptors.SortDescriptor _parentSort = null;
        private java.lang.Integer _count = null;
        private java.lang.String _name = null;
        private katja.spec.descriptors.SortDescriptor _paramSort = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.SortDescriptor parentSort() {
            return _parentSort;
        }

        public katja.spec.descriptors.SelectorDescriptor replaceParentSort(katja.spec.descriptors.SortDescriptor parentSort) {
            return replace(0, parentSort);
        }

        public java.lang.Integer count() {
            return _count;
        }

        public katja.spec.descriptors.SelectorDescriptor replaceCount(java.lang.Integer count) {
            return replace(1, count);
        }

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.descriptors.SelectorDescriptor replaceName(java.lang.String name) {
            return replace(2, name);
        }

        public katja.spec.descriptors.SortDescriptor paramSort() {
            return _paramSort;
        }

        public katja.spec.descriptors.SelectorDescriptor replaceParamSort(katja.spec.descriptors.SortDescriptor paramSort) {
            return replace(3, paramSort);
        }

        Impl(katja.spec.descriptors.SortDescriptor parentSort, java.lang.Integer count, java.lang.String name, katja.spec.descriptors.SortDescriptor paramSort) {
            if(parentSort == null)
                throw new IllegalArgumentException("constructor of sort SelectorDescriptor invoked with null parameter parentSort");
            if(count == null)
                throw new IllegalArgumentException("constructor of sort SelectorDescriptor invoked with null parameter count");
            if(name == null)
                throw new IllegalArgumentException("constructor of sort SelectorDescriptor invoked with null parameter name");
            if(paramSort == null)
                throw new IllegalArgumentException("constructor of sort SelectorDescriptor invoked with null parameter paramSort");

            this._parentSort = parentSort;
            this._count = count;
            this._name = name;
            this._paramSort = paramSort;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0: return _parentSort;
                case 1: return _count;
                case 2: return _name;
                case 3: return _paramSort;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort SelectorDescriptor invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort SelectorDescriptor invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.descriptors.SelectorDescriptor replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with negative parameter "+pos);
            if(pos >= 4)
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with too large parameter "+pos+", sort has only 4 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with term of incorrect sort, SortDescriptor expected");
            if(pos == 1 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with term of incorrect sort, Integer expected");
            if(pos == 2 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with term of incorrect sort, String expected");
            if(pos == 3 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort SelectorDescriptor invoked with term of incorrect sort, SortDescriptor expected");

            return (katja.spec.descriptors.SelectorDescriptor) Descriptors.unique(new katja.spec.descriptors.SelectorDescriptor.Impl(
                pos == 0 ? (katja.spec.descriptors.SortDescriptor) term : _parentSort,
                pos == 1 ? (java.lang.Integer) term : _count,
                pos == 2 ? (java.lang.String) term : _name,
                pos == 3 ? (katja.spec.descriptors.SortDescriptor) term : _paramSort
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Descriptors.SelectorDescriptor");
            builder.append("( ");
            _parentSort.toJavaCode(builder);
            builder.append(", ");
            builder.append(_count.toString());
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _paramSort.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("SelectorDescriptor");
            builder.append("( ");
            _parentSort.toString(builder);
            builder.append(", ");
            builder.append(_count.toString());
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _paramSort.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SelectorDescriptor";
        }
    }
}

