package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface SelectorDescriptors extends KatjaList<katja.spec.descriptors.SelectorDescriptor> {

    //----- methods of SelectorDescriptors -----

    public katja.spec.descriptors.SelectorDescriptors add(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors addAll(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);
    public katja.spec.descriptors.SelectorDescriptors remove(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);
    public katja.spec.descriptors.SelectorDescriptors appBack(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors appFront(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors conc(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);
    public katja.spec.descriptors.SelectorDescriptors front();
    public katja.spec.descriptors.SelectorDescriptors back();
    public katja.spec.descriptors.SelectorDescriptors reverse();
    public katja.spec.descriptors.SelectorDescriptors sublist(int from, int to);
    public katja.spec.descriptors.SelectorDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.SelectorDescriptors toSet();
    public katja.spec.descriptors.SelectorDescriptors setAdd(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors setRemove(katja.spec.descriptors.SelectorDescriptor element);
    public katja.spec.descriptors.SelectorDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);
    public katja.spec.descriptors.SelectorDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);
    public katja.spec.descriptors.SelectorDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list);

    //----- nested classes of SelectorDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSelectorDescriptor(katja.spec.descriptors.SelectorDescriptor term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitSelectorDescriptors(katja.spec.descriptors.SelectorDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.SelectorDescriptors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.SelectorDescriptor> implements katja.spec.descriptors.SelectorDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.SelectorDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.SelectorDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SelectorDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.SelectorDescriptors createInstance(katja.spec.descriptors.SelectorDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.SelectorDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SelectorDescriptors invoked with null element");

            SelectorDescriptors.Impl temp = new katja.spec.descriptors.SelectorDescriptors.Impl();
            temp.values = elements;
            temp = (SelectorDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.SelectorDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.SelectorDescriptor[size];
        }

        public katja.spec.descriptors.SelectorDescriptors add(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.add(element);
        }

        public katja.spec.descriptors.SelectorDescriptors addAll(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.SelectorDescriptors remove(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.SelectorDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.SelectorDescriptors appBack(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.SelectorDescriptors appFront(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.SelectorDescriptors conc(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.SelectorDescriptors front() {
            return (katja.spec.descriptors.SelectorDescriptors) super.front();
        }

        public katja.spec.descriptors.SelectorDescriptors back() {
            return (katja.spec.descriptors.SelectorDescriptors) super.back();
        }

        public katja.spec.descriptors.SelectorDescriptors reverse() {
            return (katja.spec.descriptors.SelectorDescriptors) super.reverse();
        }

        public katja.spec.descriptors.SelectorDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.SelectorDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.SelectorDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.SelectorDescriptors toSet() {
            return (katja.spec.descriptors.SelectorDescriptors) super.toSet();
        }

        public katja.spec.descriptors.SelectorDescriptors setAdd(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.SelectorDescriptors setRemove(katja.spec.descriptors.SelectorDescriptor element) {
            return (katja.spec.descriptors.SelectorDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.SelectorDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.SelectorDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.SelectorDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.SelectorDescriptor> list) {
            return (katja.spec.descriptors.SelectorDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.SelectorDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.SelectorDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SelectorDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.SelectorDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SelectorDescriptors";
        }
    }
}

