package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface SortDescriptors extends KatjaList<katja.spec.descriptors.SortDescriptor> {

    //----- methods of SortDescriptors -----

    public katja.spec.descriptors.SortDescriptors add(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);
    public katja.spec.descriptors.SortDescriptors remove(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);
    public katja.spec.descriptors.SortDescriptors appBack(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors appFront(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors conc(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);
    public katja.spec.descriptors.SortDescriptors front();
    public katja.spec.descriptors.SortDescriptors back();
    public katja.spec.descriptors.SortDescriptors reverse();
    public katja.spec.descriptors.SortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.SortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.SortDescriptors toSet();
    public katja.spec.descriptors.SortDescriptors setAdd(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors setRemove(katja.spec.descriptors.SortDescriptor element);
    public katja.spec.descriptors.SortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);
    public katja.spec.descriptors.SortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);
    public katja.spec.descriptors.SortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list);

    //----- nested classes of SortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitSortDescriptors(katja.spec.descriptors.SortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.SortDescriptors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.SortDescriptor> implements katja.spec.descriptors.SortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.SortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.SortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.SortDescriptors createInstance(katja.spec.descriptors.SortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.SortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort SortDescriptors invoked with null element");

            SortDescriptors.Impl temp = new katja.spec.descriptors.SortDescriptors.Impl();
            temp.values = elements;
            temp = (SortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.SortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.SortDescriptor[size];
        }

        public katja.spec.descriptors.SortDescriptors add(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.SortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.SortDescriptors remove(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.SortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.SortDescriptors appBack(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.SortDescriptors appFront(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.SortDescriptors conc(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.SortDescriptors front() {
            return (katja.spec.descriptors.SortDescriptors) super.front();
        }

        public katja.spec.descriptors.SortDescriptors back() {
            return (katja.spec.descriptors.SortDescriptors) super.back();
        }

        public katja.spec.descriptors.SortDescriptors reverse() {
            return (katja.spec.descriptors.SortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.SortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.SortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.SortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.SortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.SortDescriptors toSet() {
            return (katja.spec.descriptors.SortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.SortDescriptors setAdd(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.SortDescriptors setRemove(katja.spec.descriptors.SortDescriptor element) {
            return (katja.spec.descriptors.SortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.SortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.SortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.SortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.SortDescriptor> list) {
            return (katja.spec.descriptors.SortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.SortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.SortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("SortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.SortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "SortDescriptors";
        }
    }
}

