package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface TermSortDescriptors extends KatjaList<katja.spec.descriptors.TermSortDescriptor> {

    //----- methods of TermSortDescriptors -----

    public katja.spec.descriptors.TermSortDescriptors add(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);
    public katja.spec.descriptors.TermSortDescriptors remove(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);
    public katja.spec.descriptors.TermSortDescriptors appBack(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors appFront(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);
    public katja.spec.descriptors.TermSortDescriptors front();
    public katja.spec.descriptors.TermSortDescriptors back();
    public katja.spec.descriptors.TermSortDescriptors reverse();
    public katja.spec.descriptors.TermSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.TermSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.TermSortDescriptors toSet();
    public katja.spec.descriptors.TermSortDescriptors setAdd(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors setRemove(katja.spec.descriptors.TermSortDescriptor element);
    public katja.spec.descriptors.TermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);
    public katja.spec.descriptors.TermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);
    public katja.spec.descriptors.TermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list);

    //----- nested classes of TermSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTermSortDescriptors(katja.spec.descriptors.TermSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.TermSortDescriptors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.TermSortDescriptor> implements katja.spec.descriptors.TermSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.TermSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.TermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TermSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.TermSortDescriptors createInstance(katja.spec.descriptors.TermSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.TermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TermSortDescriptors invoked with null element");

            TermSortDescriptors.Impl temp = new katja.spec.descriptors.TermSortDescriptors.Impl();
            temp.values = elements;
            temp = (TermSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.TermSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.TermSortDescriptor[size];
        }

        public katja.spec.descriptors.TermSortDescriptors add(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.TermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.TermSortDescriptors remove(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.TermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.TermSortDescriptors appBack(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.TermSortDescriptors appFront(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.TermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.TermSortDescriptors front() {
            return (katja.spec.descriptors.TermSortDescriptors) super.front();
        }

        public katja.spec.descriptors.TermSortDescriptors back() {
            return (katja.spec.descriptors.TermSortDescriptors) super.back();
        }

        public katja.spec.descriptors.TermSortDescriptors reverse() {
            return (katja.spec.descriptors.TermSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.TermSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.TermSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.TermSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.TermSortDescriptors toSet() {
            return (katja.spec.descriptors.TermSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.TermSortDescriptors setAdd(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.TermSortDescriptors setRemove(katja.spec.descriptors.TermSortDescriptor element) {
            return (katja.spec.descriptors.TermSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.TermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.TermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.TermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.TermSortDescriptor> list) {
            return (katja.spec.descriptors.TermSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.TermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.TermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.TermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TermSortDescriptors";
        }
    }
}

