package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface TupleTermSortDescriptor extends katja.spec.descriptors.TermSortDescriptor, KatjaTuple {

    //----- methods of TupleTermSortDescriptor -----

    public java.lang.String name();
    public katja.spec.descriptors.TupleTermSortDescriptor replaceName(java.lang.String name);
    public java.lang.String filename();
    public katja.spec.descriptors.TupleTermSortDescriptor replaceFilename(java.lang.String filename);
    public java.lang.Integer line();
    public katja.spec.descriptors.TupleTermSortDescriptor replaceLine(java.lang.Integer line);
    public java.lang.Boolean imported();
    public katja.spec.descriptors.TupleTermSortDescriptor replaceImported(java.lang.Boolean imported);
    public Object get(int i);
    public int size();
    public katja.spec.descriptors.TupleTermSortDescriptor replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.TermSortDescriptor.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.SortDescriptor.Switch<CT, E> switchClass) throws E;

    //----- nested classes of TupleTermSortDescriptor -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.TupleTermSortDescriptor.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.descriptors.TupleTermSortDescriptor {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private java.lang.String _filename = null;
        private java.lang.Integer _line = null;
        private java.lang.Boolean _imported = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.descriptors.TupleTermSortDescriptor replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public java.lang.String filename() {
            return _filename;
        }

        public katja.spec.descriptors.TupleTermSortDescriptor replaceFilename(java.lang.String filename) {
            return replace(1, filename);
        }

        public java.lang.Integer line() {
            return _line;
        }

        public katja.spec.descriptors.TupleTermSortDescriptor replaceLine(java.lang.Integer line) {
            return replace(2, line);
        }

        public java.lang.Boolean imported() {
            return _imported;
        }

        public katja.spec.descriptors.TupleTermSortDescriptor replaceImported(java.lang.Boolean imported) {
            return replace(3, imported);
        }

        Impl(java.lang.String name, java.lang.String filename, java.lang.Integer line, java.lang.Boolean imported) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptor invoked with null parameter name");
            if(filename == null)
                throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptor invoked with null parameter filename");
            if(line == null)
                throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptor invoked with null parameter line");
            if(imported == null)
                throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptor invoked with null parameter imported");

            this._name = name;
            this._filename = filename;
            this._line = line;
            this._imported = imported;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0: return _name;
                case 1: return _filename;
                case 2: return _line;
                case 3: return _imported;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort TupleTermSortDescriptor invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort TupleTermSortDescriptor invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.descriptors.TupleTermSortDescriptor replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with negative parameter "+pos);
            if(pos >= 4)
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with too large parameter "+pos+", sort has only 4 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof java.lang.Integer))
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with term of incorrect sort, Integer expected");
            if(pos == 3 && !(term instanceof java.lang.Boolean))
                throw new IllegalArgumentException("replace on sort TupleTermSortDescriptor invoked with term of incorrect sort, Boolean expected");

            return (katja.spec.descriptors.TupleTermSortDescriptor) Descriptors.unique(new katja.spec.descriptors.TupleTermSortDescriptor.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (java.lang.String) term : _filename,
                pos == 2 ? (java.lang.Integer) term : _line,
                pos == 3 ? (java.lang.Boolean) term : _imported
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.TermSortDescriptor.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTupleTermSortDescriptor(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.descriptors.SortDescriptor.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseTupleTermSortDescriptor(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Descriptors.TupleTermSortDescriptor");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append(_imported.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("TupleTermSortDescriptor");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_filename.toString()).append("\"");
            builder.append(", ");
            builder.append(_line.toString());
            builder.append(", ");
            builder.append(_imported.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TupleTermSortDescriptor";
        }
    }
}

