package katja.spec.descriptors;

import katja.common.*;
import java.io.IOException;

public interface TupleTermSortDescriptors extends KatjaList<katja.spec.descriptors.TupleTermSortDescriptor> {

    //----- methods of TupleTermSortDescriptors -----

    public katja.spec.descriptors.TupleTermSortDescriptors add(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);
    public katja.spec.descriptors.TupleTermSortDescriptors remove(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);
    public katja.spec.descriptors.TupleTermSortDescriptors appBack(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors appFront(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);
    public katja.spec.descriptors.TupleTermSortDescriptors front();
    public katja.spec.descriptors.TupleTermSortDescriptors back();
    public katja.spec.descriptors.TupleTermSortDescriptors reverse();
    public katja.spec.descriptors.TupleTermSortDescriptors sublist(int from, int to);
    public katja.spec.descriptors.TupleTermSortDescriptors replace(int ith, Object element);
    public katja.spec.descriptors.TupleTermSortDescriptors toSet();
    public katja.spec.descriptors.TupleTermSortDescriptors setAdd(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors setRemove(katja.spec.descriptors.TupleTermSortDescriptor element);
    public katja.spec.descriptors.TupleTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);
    public katja.spec.descriptors.TupleTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);
    public katja.spec.descriptors.TupleTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list);

    //----- nested classes of TupleTermSortDescriptors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitTupleTermSortDescriptors(katja.spec.descriptors.TupleTermSortDescriptors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.descriptors.TupleTermSortDescriptors.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.descriptors.TupleTermSortDescriptor> implements katja.spec.descriptors.TupleTermSortDescriptors {

        //----- methods of Impl -----

        Impl(katja.spec.descriptors.TupleTermSortDescriptor... elements) {
            super(elements);

            for(katja.spec.descriptors.TupleTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.descriptors.TupleTermSortDescriptors createInstance(katja.spec.descriptors.TupleTermSortDescriptor[] elements, boolean isSet) {
            for(katja.spec.descriptors.TupleTermSortDescriptor element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleTermSortDescriptors invoked with null element");

            TupleTermSortDescriptors.Impl temp = new katja.spec.descriptors.TupleTermSortDescriptors.Impl();
            temp.values = elements;
            temp = (TupleTermSortDescriptors.Impl) Descriptors.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.descriptors.TupleTermSortDescriptor[] createArray(int size) {
            return new katja.spec.descriptors.TupleTermSortDescriptor[size];
        }

        public katja.spec.descriptors.TupleTermSortDescriptors add(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.add(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors addAll(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.addAll(list);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors remove(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.remove(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors removeAll(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.removeAll(list);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors appBack(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.appBack(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors appFront(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.appFront(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors conc(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.conc(list);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors front() {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.front();
        }

        public katja.spec.descriptors.TupleTermSortDescriptors back() {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.back();
        }

        public katja.spec.descriptors.TupleTermSortDescriptors reverse() {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.reverse();
        }

        public katja.spec.descriptors.TupleTermSortDescriptors sublist(int from, int to) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.sublist(from, to);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors replace(int ith, Object element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.replace(ith, element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors toSet() {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.toSet();
        }

        public katja.spec.descriptors.TupleTermSortDescriptors setAdd(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.setAdd(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors setRemove(katja.spec.descriptors.TupleTermSortDescriptor element) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.setRemove(element);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors setUnion(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.setUnion(list);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors setIntersection(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.setIntersection(list);
        }

        public katja.spec.descriptors.TupleTermSortDescriptors setWithout(KatjaList<? extends katja.spec.descriptors.TupleTermSortDescriptor> list) {
            return (katja.spec.descriptors.TupleTermSortDescriptors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Descriptors.TupleTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.TupleTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TupleTermSortDescriptors");
            builder.append("( ");
            for(katja.spec.descriptors.TupleTermSortDescriptor element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TupleTermSortDescriptors";
        }
    }
}

