package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface EmptyListWitness extends katja.spec.isabelle.Witness, KatjaTuple {

    //----- methods of EmptyListWitness -----

    public katja.spec.descriptors.SortDescriptor witnessSort();
    public katja.spec.isabelle.EmptyListWitness replaceWitnessSort(katja.spec.descriptors.SortDescriptor witnessSort);
    public katja.spec.descriptors.SortDescriptor get(int i);
    public int size();
    public katja.spec.isabelle.EmptyListWitness replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.Witness.Switch<CT, E> switchClass) throws E;

    //----- nested classes of EmptyListWitness -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.EmptyListWitness.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.isabelle.EmptyListWitness {

        //----- attributes of Impl -----

        private katja.spec.descriptors.SortDescriptor _witnessSort = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.SortDescriptor witnessSort() {
            return _witnessSort;
        }

        public katja.spec.isabelle.EmptyListWitness replaceWitnessSort(katja.spec.descriptors.SortDescriptor witnessSort) {
            return replace(0, witnessSort);
        }

        Impl(katja.spec.descriptors.SortDescriptor witnessSort) {
            if(witnessSort == null)
                throw new IllegalArgumentException("constructor of sort EmptyListWitness invoked with null parameter witnessSort");

            this._witnessSort = witnessSort;
        }

        public katja.spec.descriptors.SortDescriptor get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _witnessSort;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort EmptyListWitness invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort EmptyListWitness invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.isabelle.EmptyListWitness replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort EmptyListWitness invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort EmptyListWitness invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort EmptyListWitness invoked with term of incorrect sort, SortDescriptor expected");

            return (katja.spec.isabelle.EmptyListWitness) Isabelle.unique(new katja.spec.isabelle.EmptyListWitness.Impl(
                pos == 0 ? (katja.spec.descriptors.SortDescriptor) term : _witnessSort
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.Witness.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseEmptyListWitness(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Isabelle.EmptyListWitness");
            builder.append("( ");
            _witnessSort.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("EmptyListWitness");
            builder.append("( ");
            _witnessSort.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "EmptyListWitness";
        }
    }
}

