package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface ExternalPosList extends KatjaList<katja.spec.ExternalPos> {

    //----- methods of ExternalPosList -----

    public katja.spec.isabelle.ExternalPosList add(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList addAll(KatjaList<? extends katja.spec.ExternalPos> list);
    public katja.spec.isabelle.ExternalPosList remove(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList removeAll(KatjaList<? extends katja.spec.ExternalPos> list);
    public katja.spec.isabelle.ExternalPosList appBack(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList appFront(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList conc(KatjaList<? extends katja.spec.ExternalPos> list);
    public katja.spec.isabelle.ExternalPosList front();
    public katja.spec.isabelle.ExternalPosList back();
    public katja.spec.isabelle.ExternalPosList reverse();
    public katja.spec.isabelle.ExternalPosList sublist(int from, int to);
    public katja.spec.isabelle.ExternalPosList replace(int ith, Object element);
    public katja.spec.isabelle.ExternalPosList toSet();
    public katja.spec.isabelle.ExternalPosList setAdd(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList setRemove(katja.spec.ExternalPos element);
    public katja.spec.isabelle.ExternalPosList setUnion(KatjaList<? extends katja.spec.ExternalPos> list);
    public katja.spec.isabelle.ExternalPosList setIntersection(KatjaList<? extends katja.spec.ExternalPos> list);
    public katja.spec.isabelle.ExternalPosList setWithout(KatjaList<? extends katja.spec.ExternalPos> list);

    //----- nested classes of ExternalPosList -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitExternalPosList(katja.spec.isabelle.ExternalPosList term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.ExternalPosList.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<katja.spec.ExternalPos> implements katja.spec.isabelle.ExternalPosList {

        //----- methods of Impl -----

        Impl(katja.spec.ExternalPos... elements) {
            super(elements);

            for(katja.spec.ExternalPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternalPosList invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.isabelle.ExternalPosList createInstance(katja.spec.ExternalPos[] elements, boolean isSet) {
            for(katja.spec.ExternalPos element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort ExternalPosList invoked with null element");

            ExternalPosList.Impl temp = new katja.spec.isabelle.ExternalPosList.Impl();
            temp.values = elements;
            temp = (ExternalPosList.Impl) Isabelle.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.ExternalPos[] createArray(int size) {
            return new katja.spec.ExternalPos[size];
        }

        public katja.spec.isabelle.ExternalPosList add(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.add(element);
        }

        public katja.spec.isabelle.ExternalPosList addAll(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.addAll(list);
        }

        public katja.spec.isabelle.ExternalPosList remove(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.remove(element);
        }

        public katja.spec.isabelle.ExternalPosList removeAll(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.removeAll(list);
        }

        public katja.spec.isabelle.ExternalPosList appBack(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.appBack(element);
        }

        public katja.spec.isabelle.ExternalPosList appFront(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.appFront(element);
        }

        public katja.spec.isabelle.ExternalPosList conc(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.conc(list);
        }

        public katja.spec.isabelle.ExternalPosList front() {
            return (katja.spec.isabelle.ExternalPosList) super.front();
        }

        public katja.spec.isabelle.ExternalPosList back() {
            return (katja.spec.isabelle.ExternalPosList) super.back();
        }

        public katja.spec.isabelle.ExternalPosList reverse() {
            return (katja.spec.isabelle.ExternalPosList) super.reverse();
        }

        public katja.spec.isabelle.ExternalPosList sublist(int from, int to) {
            return (katja.spec.isabelle.ExternalPosList) super.sublist(from, to);
        }

        public katja.spec.isabelle.ExternalPosList replace(int ith, Object element) {
            return (katja.spec.isabelle.ExternalPosList) super.replace(ith, element);
        }

        public katja.spec.isabelle.ExternalPosList toSet() {
            return (katja.spec.isabelle.ExternalPosList) super.toSet();
        }

        public katja.spec.isabelle.ExternalPosList setAdd(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.setAdd(element);
        }

        public katja.spec.isabelle.ExternalPosList setRemove(katja.spec.ExternalPos element) {
            return (katja.spec.isabelle.ExternalPosList) super.setRemove(element);
        }

        public katja.spec.isabelle.ExternalPosList setUnion(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.setUnion(list);
        }

        public katja.spec.isabelle.ExternalPosList setIntersection(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.setIntersection(list);
        }

        public katja.spec.isabelle.ExternalPosList setWithout(KatjaList<? extends katja.spec.ExternalPos> list) {
            return (katja.spec.isabelle.ExternalPosList) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Isabelle.ExternalPosList");
            builder.append("( ");
            for(katja.spec.ExternalPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("ExternalPosList");
            builder.append("( ");
            for(katja.spec.ExternalPos element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ExternalPosList";
        }
    }
}

