package katja.spec.isabelle;

import katja.common.*;
import java.io.Reader;
import java.io.IOException;
import java.util.TreeMap;

public class Isabelle extends KatjaSpecification {

    //----- attributes of Isabelle -----

    private static final Isabelle$Creator _Isabelle$Creator = new Isabelle$Creator();

    //----- methods of Isabelle -----

    static final KatjaTerm unique(KatjaTerm term) {
        if(_termcache.containsKey(term)) return _termcache.get(term);
        _termcache.put(term, term);

        return term;
    }

    public static final katja.spec.isabelle.EmptyListWitness EmptyListWitness(katja.spec.descriptors.SortDescriptor witnessSort) {
        katja.spec.isabelle.EmptyListWitness _temp = new katja.spec.isabelle.EmptyListWitness.Impl(witnessSort);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.EmptyListWitness) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.ExternWitness ExternWitness(katja.spec.descriptors.SortDescriptor witnessSort) {
        katja.spec.isabelle.ExternWitness _temp = new katja.spec.isabelle.ExternWitness.Impl(witnessSort);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.ExternWitness) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.ExternalPosList ExternalPosList(katja.spec.ExternalPos... elements) {
        katja.spec.isabelle.ExternalPosList _temp = new katja.spec.isabelle.ExternalPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.ExternalPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.IsabelleSelector IsabelleSelector(java.lang.String name, katja.spec.SortSpecPos def, katja.spec.SortSpecPos arg, katja.spec.SortSpecPos dest, java.lang.Boolean isList) {
        katja.spec.isabelle.IsabelleSelector _temp = new katja.spec.isabelle.IsabelleSelector.Impl(name, def, arg, dest, isList);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.IsabelleSelector) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.IsabelleSelectors IsabelleSelectors(katja.spec.isabelle.IsabelleSelector... elements) {
        katja.spec.isabelle.IsabelleSelectors _temp = new katja.spec.isabelle.IsabelleSelectors.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.IsabelleSelectors) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.ListSelector ListSelector(katja.spec.descriptors.TermSortDescriptor parentList, java.lang.String constructorName, katja.spec.descriptors.SortDescriptor child) {
        katja.spec.isabelle.ListSelector _temp = new katja.spec.isabelle.ListSelector.Impl(parentList, constructorName, child);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.ListSelector) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.ListWitness ListWitness(katja.spec.descriptors.SortDescriptor witnessSort, katja.spec.isabelle.Witness element) {
        katja.spec.isabelle.ListWitness _temp = new katja.spec.isabelle.ListWitness.Impl(witnessSort, element);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.ListWitness) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.PositionConstructor PositionConstructor(katja.spec.isabelle.Witness rootWitness) {
        katja.spec.isabelle.PositionConstructor _temp = new katja.spec.isabelle.PositionConstructor.Impl(rootWitness);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.PositionConstructor) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.PositionSelectorCall PositionSelectorCall(katja.spec.isabelle.PositionWitness posWit, katja.spec.isabelle.PositionSelector selector) {
        katja.spec.isabelle.PositionSelectorCall _temp = new katja.spec.isabelle.PositionSelectorCall.Impl(posWit, selector);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.PositionSelectorCall) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.TupleParamPosList TupleParamPosList(katja.spec.TupleParamPos... elements) {
        katja.spec.isabelle.TupleParamPosList _temp = new katja.spec.isabelle.TupleParamPosList.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.TupleParamPosList) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.TupleSelector TupleSelector(katja.spec.descriptors.SelectorDescriptor selector) {
        katja.spec.isabelle.TupleSelector _temp = new katja.spec.isabelle.TupleSelector.Impl(selector);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.TupleSelector) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.TupleWitness TupleWitness(katja.spec.descriptors.SortDescriptor witnessSort, katja.spec.isabelle.TupleWitnessParams params) {
        katja.spec.isabelle.TupleWitness _temp = new katja.spec.isabelle.TupleWitness.Impl(witnessSort, params);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.TupleWitness) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.TupleWitness TupleWitness(katja.spec.descriptors.SortDescriptor witnessSort, katja.spec.isabelle.Witness... params) {
        katja.spec.isabelle.TupleWitnessParams _list = katja.spec.isabelle.Isabelle.TupleWitnessParams(params);
        katja.spec.isabelle.TupleWitness _temp = new katja.spec.isabelle.TupleWitness.Impl(witnessSort, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.TupleWitness) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.isabelle.TupleWitnessParams TupleWitnessParams(katja.spec.isabelle.Witness... elements) {
        katja.spec.isabelle.TupleWitnessParams _temp = new katja.spec.isabelle.TupleWitnessParams.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.isabelle.TupleWitnessParams) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final KatjaElement fromAssembler(Reader reader) throws IOException {
        return parseInternal(reader, _Isabelle$Creator);
    }

    //----- nested classes of Isabelle -----

    private static final class Isabelle$Creator implements KatjaSpecification.ElementCreator {

        //----- attributes of Isabelle$Creator -----

        private TreeMap<String, Integer> _sortnumber = new TreeMap<String, Integer>();

        //----- methods of Isabelle$Creator -----

        Isabelle$Creator() {
            _sortnumber.put("BackendBlock", 0);
            _sortnumber.put("Empty", 1);
            _sortnumber.put("EmptyListWitness", 2);
            _sortnumber.put("ExternTermSortDescriptor", 3);
            _sortnumber.put("ExternWitness", 4);
            _sortnumber.put("External", 5);
            _sortnumber.put("Import", 6);
            _sortnumber.put("Include", 7);
            _sortnumber.put("IsabelleSelector", 8);
            _sortnumber.put("KatjaSpecError", 9);
            _sortnumber.put("KatjaUsageError", 10);
            _sortnumber.put("KatjaWarning", 11);
            _sortnumber.put("ListProd", 12);
            _sortnumber.put("ListSelector", 13);
            _sortnumber.put("ListTermSortDescriptor", 14);
            _sortnumber.put("ListWitness", 15);
            _sortnumber.put("PackageName", 16);
            _sortnumber.put("PosSortDescriptor", 17);
            _sortnumber.put("PosStructDescriptor", 18);
            _sortnumber.put("PositionConstructor", 19);
            _sortnumber.put("PositionSelectorCall", 20);
            _sortnumber.put("Root", 21);
            _sortnumber.put("Selector", 22);
            _sortnumber.put("SelectorDescriptor", 23);
            _sortnumber.put("SortId", 24);
            _sortnumber.put("Specification", 25);
            _sortnumber.put("TupleParam", 26);
            _sortnumber.put("TupleProd", 27);
            _sortnumber.put("TupleSelector", 28);
            _sortnumber.put("TupleTermSortDescriptor", 29);
            _sortnumber.put("TupleWitness", 30);
            _sortnumber.put("VariantProd", 31);
            _sortnumber.put("VariantTermSortDescriptor", 32);
            _sortnumber.put("BackendBlockList", 33);
            _sortnumber.put("ExternTermSortDescriptors", 34);
            _sortnumber.put("ExternalList", 35);
            _sortnumber.put("ExternalPosList", 36);
            _sortnumber.put("FileNameList", 37);
            _sortnumber.put("ImportList", 38);
            _sortnumber.put("IncludeList", 39);
            _sortnumber.put("IsabelleSelectors", 40);
            _sortnumber.put("KatjaErrorList", 41);
            _sortnumber.put("KatjaWarningList", 42);
            _sortnumber.put("ListTermSortDescriptors", 43);
            _sortnumber.put("PosSortDescriptors", 44);
            _sortnumber.put("PosStructDescriptors", 45);
            _sortnumber.put("ProductionList", 46);
            _sortnumber.put("ProductionPosList", 47);
            _sortnumber.put("RootList", 48);
            _sortnumber.put("SelectorDescriptors", 49);
            _sortnumber.put("SelectorList", 50);
            _sortnumber.put("SortDescriptors", 51);
            _sortnumber.put("SortIdList", 52);
            _sortnumber.put("SortSpecPosList", 53);
            _sortnumber.put("SpecificationPosList", 54);
            _sortnumber.put("TermSortDescriptors", 55);
            _sortnumber.put("TupleParamList", 56);
            _sortnumber.put("TupleParamPosList", 57);
            _sortnumber.put("TupleTermSortDescriptors", 58);
            _sortnumber.put("TupleWitnessParams", 59);
            _sortnumber.put("VariantParamList", 60);
            _sortnumber.put("VariantParamPosList", 61);
            _sortnumber.put("VariantPosList", 62);
            _sortnumber.put("VariantTermSortDescriptors", 63);
            _sortnumber.put("SpecificationPos", 64);
        }

        public final KatjaElement create(String name, Object[] parameters, int line) {
            if(!_sortnumber.containsKey(name))
                throw new IllegalArgumentException("unknown sort name "+name+", in line "+line);

            switch(_sortnumber.get(name)) {
                case 0:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BackendBlock, in line "+line);

                    if(!(parameters[0] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BackendBlock constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of BackendBlock constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of BackendBlock constructor, in line "+line);
                    return katja.spec.Katja.BackendBlock((java.lang.Integer) parameters[0], (java.lang.String) parameters[1], (java.lang.String) parameters[2]);
                case 1:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Empty, in line "+line);

                    return katja.spec.Katja.Empty();
                case 2:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort EmptyListWitness, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of EmptyListWitness constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.EmptyListWitness((katja.spec.descriptors.SortDescriptor) parameters[0]);
                case 3:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ExternTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of ExternTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.ExternTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 4:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ExternWitness, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ExternWitness constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.ExternWitness((katja.spec.descriptors.SortDescriptor) parameters[0]);
                case 5:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort External, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of External constructor, in line "+line);
                    return katja.spec.Katja.External((katja.spec.SortId) parameters[0]);
                case 6:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Import, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Import constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Import constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Import constructor, in line "+line);
                    return katja.spec.Katja.Import((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 7:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Include, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Include constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Include constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Include constructor, in line "+line);
                    return katja.spec.Katja.Include((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 8:
                    if(parameters.length != 5)
                        throw new IllegalArgumentException("wrong number of arguments given for sort IsabelleSelector, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of IsabelleSelector constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SortSpecPos))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of IsabelleSelector constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.SortSpecPos))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of IsabelleSelector constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.SortSpecPos))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of IsabelleSelector constructor, in line "+line);
                    if(!(parameters[4] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of IsabelleSelector constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.IsabelleSelector((java.lang.String) parameters[0], (katja.spec.SortSpecPos) parameters[1], (katja.spec.SortSpecPos) parameters[2], (katja.spec.SortSpecPos) parameters[3], (java.lang.Boolean) parameters[4]);
                case 9:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaSpecError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaSpecError constructor, in line "+line);
                    return katja.spec.Katja.KatjaSpecError((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 10:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaUsageError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaUsageError constructor, in line "+line);
                    return katja.spec.Katja.KatjaUsageError((java.lang.String) parameters[0]);
                case 11:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaWarning, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaWarning constructor, in line "+line);
                    return katja.spec.Katja.KatjaWarning((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 12:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListProd constructor, in line "+line);
                    return katja.spec.Katja.ListProd((katja.spec.SortId) parameters[0], (katja.spec.SortId) parameters[1]);
                case 13:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListSelector, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.TermSortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListSelector constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListSelector constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of ListSelector constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.ListSelector((katja.spec.descriptors.TermSortDescriptor) parameters[0], (java.lang.String) parameters[1], (katja.spec.descriptors.SortDescriptor) parameters[2]);
                case 14:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of ListTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.ListTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 15:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListWitness, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListWitness constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.isabelle.Witness))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListWitness constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.ListWitness((katja.spec.descriptors.SortDescriptor) parameters[0], (katja.spec.isabelle.Witness) parameters[1]);
                case 16:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PackageName, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PackageName constructor, in line "+line);
                    return katja.spec.Katja.PackageName((java.lang.String) parameters[0]);
                case 17:
                    if(parameters.length != 6)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PosSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.descriptors.TermSortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.descriptors.PosStructDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of PosSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.PosSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3], (katja.spec.descriptors.TermSortDescriptor) parameters[4], (katja.spec.descriptors.PosStructDescriptor) parameters[5]);
                case 18:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PosStructDescriptor, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.TermSortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PosStructDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of PosStructDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.PosStructDescriptor((katja.spec.descriptors.TermSortDescriptor) parameters[0], (java.lang.String) parameters[1]);
                case 19:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PositionConstructor, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.isabelle.Witness))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PositionConstructor constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.PositionConstructor((katja.spec.isabelle.Witness) parameters[0]);
                case 20:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PositionSelectorCall, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.isabelle.PositionWitness))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PositionSelectorCall constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.isabelle.PositionSelector))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of PositionSelectorCall constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.PositionSelectorCall((katja.spec.isabelle.PositionWitness) parameters[0], (katja.spec.isabelle.PositionSelector) parameters[1]);
                case 21:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Root, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Root constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Root constructor, in line "+line);
                    return katja.spec.Katja.Root((katja.spec.SortId) parameters[0], (java.lang.String) parameters[1]);
                case 22:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Selector, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Selector constructor, in line "+line);
                    return katja.spec.Katja.Selector((java.lang.String) parameters[0]);
                case 23:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort SelectorDescriptor, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of SelectorDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.SelectorDescriptor((katja.spec.descriptors.SortDescriptor) parameters[0], (java.lang.Integer) parameters[1], (java.lang.String) parameters[2], (katja.spec.descriptors.SortDescriptor) parameters[3]);
                case 24:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort SortId, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of SortId constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of SortId constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of SortId constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of SortId constructor, in line "+line);
                    return katja.spec.Katja.SortId((java.lang.String) parameters[0], (java.lang.Boolean) parameters[1], (java.lang.String) parameters[2], (java.lang.Integer) parameters[3]);
                case 25:
                    if(parameters.length != 8)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Specification, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Specification constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.BackendBlockList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Specification constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.RootList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Specification constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.ExternalList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of Specification constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.ImportList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of Specification constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.IncludeList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of Specification constructor, in line "+line);
                    if(!(parameters[6] instanceof katja.spec.ProductionList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 7 of Specification constructor, in line "+line);
                    if(!(parameters[7] instanceof katja.spec.FileNameList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 8 of Specification constructor, in line "+line);
                    return katja.spec.Katja.Specification((java.lang.String) parameters[0], (katja.spec.BackendBlockList) parameters[1], (katja.spec.RootList) parameters[2], (katja.spec.ExternalList) parameters[3], (katja.spec.ImportList) parameters[4], (katja.spec.IncludeList) parameters[5], (katja.spec.ProductionList) parameters[6], (katja.spec.FileNameList) parameters[7]);
                case 26:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleParam, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleParam constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SelectorOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleParam constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of TupleParam constructor, in line "+line);
                    return katja.spec.Katja.TupleParam((katja.spec.SortId) parameters[0], (katja.spec.SelectorOpt) parameters[1], (java.lang.Boolean) parameters[2]);
                case 27:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.TupleParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleProd constructor, in line "+line);
                    return katja.spec.Katja.TupleProd((katja.spec.SortId) parameters[0], (katja.spec.TupleParamList) parameters[1]);
                case 28:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleSelector, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SelectorDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleSelector constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.TupleSelector((katja.spec.descriptors.SelectorDescriptor) parameters[0]);
                case 29:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of TupleTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.TupleTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 30:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleWitness, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleWitness constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.isabelle.TupleWitnessParams))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleWitness constructor, in line "+line);
                    return katja.spec.isabelle.Isabelle.TupleWitness((katja.spec.descriptors.SortDescriptor) parameters[0], (katja.spec.isabelle.TupleWitnessParams) parameters[1]);
                case 31:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort VariantProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of VariantProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.VariantParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of VariantProd constructor, in line "+line);
                    return katja.spec.Katja.VariantProd((katja.spec.SortId) parameters[0], (katja.spec.VariantParamList) parameters[1]);
                case 32:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort VariantTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of VariantTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.VariantTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 33:
                    katja.spec.BackendBlock[] _BackendBlockList$array = new katja.spec.BackendBlock[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.BackendBlock))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for BackendBlockList constructor, in line "+line);
                        _BackendBlockList$array[i] = (katja.spec.BackendBlock) parameters[i];
                    }

                    return katja.spec.Katja.BackendBlockList(_BackendBlockList$array);
                case 34:
                    katja.spec.descriptors.ExternTermSortDescriptor[] _ExternTermSortDescriptors$array = new katja.spec.descriptors.ExternTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.ExternTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternTermSortDescriptors constructor, in line "+line);
                        _ExternTermSortDescriptors$array[i] = (katja.spec.descriptors.ExternTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.ExternTermSortDescriptors(_ExternTermSortDescriptors$array);
                case 35:
                    katja.spec.External[] _ExternalList$array = new katja.spec.External[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.External))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternalList constructor, in line "+line);
                        _ExternalList$array[i] = (katja.spec.External) parameters[i];
                    }

                    return katja.spec.Katja.ExternalList(_ExternalList$array);
                case 36:
                    katja.spec.ExternalPos[] _ExternalPosList$array = new katja.spec.ExternalPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.ExternalPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternalPosList constructor, in line "+line);
                        _ExternalPosList$array[i] = (katja.spec.ExternalPos) parameters[i];
                    }

                    return katja.spec.isabelle.Isabelle.ExternalPosList(_ExternalPosList$array);
                case 37:
                    java.lang.String[] _FileNameList$array = new java.lang.String[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof java.lang.String))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for FileNameList constructor, in line "+line);
                        _FileNameList$array[i] = (java.lang.String) parameters[i];
                    }

                    return katja.spec.Katja.FileNameList(_FileNameList$array);
                case 38:
                    katja.spec.Import[] _ImportList$array = new katja.spec.Import[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Import))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ImportList constructor, in line "+line);
                        _ImportList$array[i] = (katja.spec.Import) parameters[i];
                    }

                    return katja.spec.Katja.ImportList(_ImportList$array);
                case 39:
                    katja.spec.Include[] _IncludeList$array = new katja.spec.Include[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Include))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IncludeList constructor, in line "+line);
                        _IncludeList$array[i] = (katja.spec.Include) parameters[i];
                    }

                    return katja.spec.Katja.IncludeList(_IncludeList$array);
                case 40:
                    katja.spec.isabelle.IsabelleSelector[] _IsabelleSelectors$array = new katja.spec.isabelle.IsabelleSelector[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.isabelle.IsabelleSelector))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IsabelleSelectors constructor, in line "+line);
                        _IsabelleSelectors$array[i] = (katja.spec.isabelle.IsabelleSelector) parameters[i];
                    }

                    return katja.spec.isabelle.Isabelle.IsabelleSelectors(_IsabelleSelectors$array);
                case 41:
                    katja.spec.KatjaError[] _KatjaErrorList$array = new katja.spec.KatjaError[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaError))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaErrorList constructor, in line "+line);
                        _KatjaErrorList$array[i] = (katja.spec.KatjaError) parameters[i];
                    }

                    return katja.spec.Katja.KatjaErrorList(_KatjaErrorList$array);
                case 42:
                    katja.spec.KatjaWarning[] _KatjaWarningList$array = new katja.spec.KatjaWarning[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaWarning))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaWarningList constructor, in line "+line);
                        _KatjaWarningList$array[i] = (katja.spec.KatjaWarning) parameters[i];
                    }

                    return katja.spec.Katja.KatjaWarningList(_KatjaWarningList$array);
                case 43:
                    katja.spec.descriptors.ListTermSortDescriptor[] _ListTermSortDescriptors$array = new katja.spec.descriptors.ListTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.ListTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ListTermSortDescriptors constructor, in line "+line);
                        _ListTermSortDescriptors$array[i] = (katja.spec.descriptors.ListTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.ListTermSortDescriptors(_ListTermSortDescriptors$array);
                case 44:
                    katja.spec.descriptors.PosSortDescriptor[] _PosSortDescriptors$array = new katja.spec.descriptors.PosSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.PosSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for PosSortDescriptors constructor, in line "+line);
                        _PosSortDescriptors$array[i] = (katja.spec.descriptors.PosSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.PosSortDescriptors(_PosSortDescriptors$array);
                case 45:
                    katja.spec.descriptors.PosStructDescriptor[] _PosStructDescriptors$array = new katja.spec.descriptors.PosStructDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.PosStructDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for PosStructDescriptors constructor, in line "+line);
                        _PosStructDescriptors$array[i] = (katja.spec.descriptors.PosStructDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.PosStructDescriptors(_PosStructDescriptors$array);
                case 46:
                    katja.spec.Production[] _ProductionList$array = new katja.spec.Production[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Production))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionList constructor, in line "+line);
                        _ProductionList$array[i] = (katja.spec.Production) parameters[i];
                    }

                    return katja.spec.Katja.ProductionList(_ProductionList$array);
                case 47:
                    katja.spec.ProductionPos[] _ProductionPosList$array = new katja.spec.ProductionPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.ProductionPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionPosList constructor, in line "+line);
                        _ProductionPosList$array[i] = (katja.spec.ProductionPos) parameters[i];
                    }

                    return katja.spec.Katja.ProductionPosList(_ProductionPosList$array);
                case 48:
                    katja.spec.Root[] _RootList$array = new katja.spec.Root[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Root))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for RootList constructor, in line "+line);
                        _RootList$array[i] = (katja.spec.Root) parameters[i];
                    }

                    return katja.spec.Katja.RootList(_RootList$array);
                case 49:
                    katja.spec.descriptors.SelectorDescriptor[] _SelectorDescriptors$array = new katja.spec.descriptors.SelectorDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.SelectorDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SelectorDescriptors constructor, in line "+line);
                        _SelectorDescriptors$array[i] = (katja.spec.descriptors.SelectorDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.SelectorDescriptors(_SelectorDescriptors$array);
                case 50:
                    katja.spec.Selector[] _SelectorList$array = new katja.spec.Selector[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Selector))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SelectorList constructor, in line "+line);
                        _SelectorList$array[i] = (katja.spec.Selector) parameters[i];
                    }

                    return katja.spec.Katja.SelectorList(_SelectorList$array);
                case 51:
                    katja.spec.descriptors.SortDescriptor[] _SortDescriptors$array = new katja.spec.descriptors.SortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.SortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortDescriptors constructor, in line "+line);
                        _SortDescriptors$array[i] = (katja.spec.descriptors.SortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.SortDescriptors(_SortDescriptors$array);
                case 52:
                    katja.spec.SortId[] _SortIdList$array = new katja.spec.SortId[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortId))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortIdList constructor, in line "+line);
                        _SortIdList$array[i] = (katja.spec.SortId) parameters[i];
                    }

                    return katja.spec.Katja.SortIdList(_SortIdList$array);
                case 53:
                    katja.spec.SortSpecPos[] _SortSpecPosList$array = new katja.spec.SortSpecPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortSpecPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortSpecPosList constructor, in line "+line);
                        _SortSpecPosList$array[i] = (katja.spec.SortSpecPos) parameters[i];
                    }

                    return katja.spec.Katja.SortSpecPosList(_SortSpecPosList$array);
                case 54:
                    katja.spec.SpecificationPos[] _SpecificationPosList$array = new katja.spec.SpecificationPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SpecificationPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SpecificationPosList constructor, in line "+line);
                        _SpecificationPosList$array[i] = (katja.spec.SpecificationPos) parameters[i];
                    }

                    return katja.spec.Katja.SpecificationPosList(_SpecificationPosList$array);
                case 55:
                    katja.spec.descriptors.TermSortDescriptor[] _TermSortDescriptors$array = new katja.spec.descriptors.TermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.TermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TermSortDescriptors constructor, in line "+line);
                        _TermSortDescriptors$array[i] = (katja.spec.descriptors.TermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.TermSortDescriptors(_TermSortDescriptors$array);
                case 56:
                    katja.spec.TupleParam[] _TupleParamList$array = new katja.spec.TupleParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.TupleParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleParamList constructor, in line "+line);
                        _TupleParamList$array[i] = (katja.spec.TupleParam) parameters[i];
                    }

                    return katja.spec.Katja.TupleParamList(_TupleParamList$array);
                case 57:
                    katja.spec.TupleParamPos[] _TupleParamPosList$array = new katja.spec.TupleParamPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.TupleParamPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleParamPosList constructor, in line "+line);
                        _TupleParamPosList$array[i] = (katja.spec.TupleParamPos) parameters[i];
                    }

                    return katja.spec.isabelle.Isabelle.TupleParamPosList(_TupleParamPosList$array);
                case 58:
                    katja.spec.descriptors.TupleTermSortDescriptor[] _TupleTermSortDescriptors$array = new katja.spec.descriptors.TupleTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.TupleTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleTermSortDescriptors constructor, in line "+line);
                        _TupleTermSortDescriptors$array[i] = (katja.spec.descriptors.TupleTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.TupleTermSortDescriptors(_TupleTermSortDescriptors$array);
                case 59:
                    katja.spec.isabelle.Witness[] _TupleWitnessParams$array = new katja.spec.isabelle.Witness[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.isabelle.Witness))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleWitnessParams constructor, in line "+line);
                        _TupleWitnessParams$array[i] = (katja.spec.isabelle.Witness) parameters[i];
                    }

                    return katja.spec.isabelle.Isabelle.TupleWitnessParams(_TupleWitnessParams$array);
                case 60:
                    katja.spec.VariantParam[] _VariantParamList$array = new katja.spec.VariantParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamList constructor, in line "+line);
                        _VariantParamList$array[i] = (katja.spec.VariantParam) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamList(_VariantParamList$array);
                case 61:
                    katja.spec.VariantParamPos[] _VariantParamPosList$array = new katja.spec.VariantParamPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParamPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamPosList constructor, in line "+line);
                        _VariantParamPosList$array[i] = (katja.spec.VariantParamPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamPosList(_VariantParamPosList$array);
                case 62:
                    katja.spec.VariantProdPos[] _VariantPosList$array = new katja.spec.VariantProdPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantProdPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantPosList constructor, in line "+line);
                        _VariantPosList$array[i] = (katja.spec.VariantProdPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantPosList(_VariantPosList$array);
                case 63:
                    katja.spec.descriptors.VariantTermSortDescriptor[] _VariantTermSortDescriptors$array = new katja.spec.descriptors.VariantTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.VariantTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantTermSortDescriptors constructor, in line "+line);
                        _VariantTermSortDescriptors$array[i] = (katja.spec.descriptors.VariantTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.VariantTermSortDescriptors(_VariantTermSortDescriptors$array);
                case 64:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given root position SpecificationPos, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.Specification))
                        throw new IllegalArgumentException("wrong sort on stack as parameter for SpecificationPos constructor, in line "+line);

                    return katja.spec.Katja.SpecificationPos((katja.spec.Specification) parameters[0]);
                default:
                    throw new IllegalStateException("impossible state");
            }
        }
    }
}

