package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface IsabelleSelector extends KatjaTuple {

    //----- methods of IsabelleSelector -----

    public java.lang.String name();
    public katja.spec.isabelle.IsabelleSelector replaceName(java.lang.String name);
    public katja.spec.SortSpecPos def();
    public katja.spec.isabelle.IsabelleSelector replaceDef(katja.spec.SortSpecPos def);
    public katja.spec.SortSpecPos arg();
    public katja.spec.isabelle.IsabelleSelector replaceArg(katja.spec.SortSpecPos arg);
    public katja.spec.SortSpecPos dest();
    public katja.spec.isabelle.IsabelleSelector replaceDest(katja.spec.SortSpecPos dest);
    public java.lang.Boolean isList();
    public katja.spec.isabelle.IsabelleSelector replaceIsList(java.lang.Boolean isList);
    public Object get(int i);
    public int size();
    public katja.spec.isabelle.IsabelleSelector replace(int pos, Object term);

    //----- nested classes of IsabelleSelector -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitSortSpecPos(katja.spec.SortSpecPos term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitIsabelleSelector(katja.spec.isabelle.IsabelleSelector term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.IsabelleSelector.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.SortSpecPos.Switch<Object, E> variantVisit$SortSpecPos = new katja.spec.SortSpecPos.Switch<Object, E>() { public final Object CaseExternalPos(katja.spec.ExternalPos term) throws E { visitExternalPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitSortSpecPos(katja.spec.SortSpecPos term) throws E {
            term.Switch(variantVisit$SortSpecPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.isabelle.IsabelleSelector {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private katja.spec.SortSpecPos _def = null;
        private katja.spec.SortSpecPos _arg = null;
        private katja.spec.SortSpecPos _dest = null;
        private java.lang.Boolean _isList = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.isabelle.IsabelleSelector replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public katja.spec.SortSpecPos def() {
            return _def;
        }

        public katja.spec.isabelle.IsabelleSelector replaceDef(katja.spec.SortSpecPos def) {
            return replace(1, def);
        }

        public katja.spec.SortSpecPos arg() {
            return _arg;
        }

        public katja.spec.isabelle.IsabelleSelector replaceArg(katja.spec.SortSpecPos arg) {
            return replace(2, arg);
        }

        public katja.spec.SortSpecPos dest() {
            return _dest;
        }

        public katja.spec.isabelle.IsabelleSelector replaceDest(katja.spec.SortSpecPos dest) {
            return replace(3, dest);
        }

        public java.lang.Boolean isList() {
            return _isList;
        }

        public katja.spec.isabelle.IsabelleSelector replaceIsList(java.lang.Boolean isList) {
            return replace(4, isList);
        }

        Impl(java.lang.String name, katja.spec.SortSpecPos def, katja.spec.SortSpecPos arg, katja.spec.SortSpecPos dest, java.lang.Boolean isList) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort IsabelleSelector invoked with null parameter name");
            if(def == null)
                throw new IllegalArgumentException("constructor of sort IsabelleSelector invoked with null parameter def");
            if(arg == null)
                throw new IllegalArgumentException("constructor of sort IsabelleSelector invoked with null parameter arg");
            if(dest == null)
                throw new IllegalArgumentException("constructor of sort IsabelleSelector invoked with null parameter dest");
            if(isList == null)
                throw new IllegalArgumentException("constructor of sort IsabelleSelector invoked with null parameter isList");

            this._name = name;
            this._def = def;
            this._arg = arg;
            this._dest = dest;
            this._isList = isList;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 5;

            switch(ith) {
                case 0: return _name;
                case 1: return _def;
                case 2: return _arg;
                case 3: return _dest;
                case 4: return _isList;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort IsabelleSelector invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort IsabelleSelector invoked with too large parameter "+i+", sort has only 5 components");
                    }
            }
        }

        public int size() {
            return 5;
        }

        public katja.spec.isabelle.IsabelleSelector replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with negative parameter "+pos);
            if(pos >= 5)
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with too large parameter "+pos+", sort has only 5 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof katja.spec.SortSpecPos))
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with term of incorrect sort, SortSpecPos expected");
            if(pos == 2 && !(term instanceof katja.spec.SortSpecPos))
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with term of incorrect sort, SortSpecPos expected");
            if(pos == 3 && !(term instanceof katja.spec.SortSpecPos))
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with term of incorrect sort, SortSpecPos expected");
            if(pos == 4 && !(term instanceof java.lang.Boolean))
                throw new IllegalArgumentException("replace on sort IsabelleSelector invoked with term of incorrect sort, Boolean expected");

            return (katja.spec.isabelle.IsabelleSelector) Isabelle.unique(new katja.spec.isabelle.IsabelleSelector.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (katja.spec.SortSpecPos) term : _def,
                pos == 2 ? (katja.spec.SortSpecPos) term : _arg,
                pos == 3 ? (katja.spec.SortSpecPos) term : _dest,
                pos == 4 ? (java.lang.Boolean) term : _isList
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Isabelle.IsabelleSelector");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _def.toJavaCode(builder);
            builder.append(", ");
            _arg.toJavaCode(builder);
            builder.append(", ");
            _dest.toJavaCode(builder);
            builder.append(", ");
            builder.append(_isList.toString());
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("IsabelleSelector");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _def.toString(builder);
            builder.append(", ");
            _arg.toString(builder);
            builder.append(", ");
            _dest.toString(builder);
            builder.append(", ");
            builder.append(_isList.toString());
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IsabelleSelector";
        }
    }
}

