package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface IsabelleSelectors extends KatjaList<katja.spec.isabelle.IsabelleSelector> {

    //----- methods of IsabelleSelectors -----

    public katja.spec.isabelle.IsabelleSelectors add(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors addAll(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);
    public katja.spec.isabelle.IsabelleSelectors remove(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors removeAll(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);
    public katja.spec.isabelle.IsabelleSelectors appBack(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors appFront(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors conc(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);
    public katja.spec.isabelle.IsabelleSelectors front();
    public katja.spec.isabelle.IsabelleSelectors back();
    public katja.spec.isabelle.IsabelleSelectors reverse();
    public katja.spec.isabelle.IsabelleSelectors sublist(int from, int to);
    public katja.spec.isabelle.IsabelleSelectors replace(int ith, Object element);
    public katja.spec.isabelle.IsabelleSelectors toSet();
    public katja.spec.isabelle.IsabelleSelectors setAdd(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors setRemove(katja.spec.isabelle.IsabelleSelector element);
    public katja.spec.isabelle.IsabelleSelectors setUnion(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);
    public katja.spec.isabelle.IsabelleSelectors setIntersection(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);
    public katja.spec.isabelle.IsabelleSelectors setWithout(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list);

    //----- nested classes of IsabelleSelectors -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitIsabelleSelector(katja.spec.isabelle.IsabelleSelector term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitSortSpecPos(katja.spec.SortSpecPos term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitProductionPos(katja.spec.ProductionPos term) throws E;
        public void visitExternalPos(katja.spec.ExternalPos term) throws E;
        public void visitTupleProdPos(katja.spec.TupleProdPos term) throws E;
        public void visitVariantProdPos(katja.spec.VariantProdPos term) throws E;
        public void visitListProdPos(katja.spec.ListProdPos term) throws E;
        public void visitSortIdPos(katja.spec.SortIdPos term) throws E;
        public void visitTupleParamListPos(katja.spec.TupleParamListPos term) throws E;
        public void visitVariantParamListPos(katja.spec.VariantParamListPos term) throws E;
        public void visitStringPos(katja.spec.StringPos term) throws E;
        public void visitBooleanPos(katja.spec.BooleanPos term) throws E;
        public void visitIntegerPos(katja.spec.IntegerPos term) throws E;
        public void visitTupleParamPos(katja.spec.TupleParamPos term) throws E;
        public void visitVariantParamPos(katja.spec.VariantParamPos term) throws E;
        public void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E;
        public void visitSelectorPos(katja.spec.SelectorPos term) throws E;
        public void visitEmptyPos(katja.spec.EmptyPos term) throws E;
        public void visitIsabelleSelectors(katja.spec.isabelle.IsabelleSelectors term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.IsabelleSelectors.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.SelectorOptPos.Switch<Object, E> variantVisit$SelectorOptPos = new katja.spec.SelectorOptPos.Switch<Object, E>() { public final Object CaseSelectorPos(katja.spec.SelectorPos term) throws E { visitSelectorPos(term); return null; } public final Object CaseEmptyPos(katja.spec.EmptyPos term) throws E { visitEmptyPos(term); return null; } };
        private final katja.spec.SortSpecPos.Switch<Object, E> variantVisit$SortSpecPos = new katja.spec.SortSpecPos.Switch<Object, E>() { public final Object CaseExternalPos(katja.spec.ExternalPos term) throws E { visitExternalPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };
        private final katja.spec.VariantParamPos.Switch<Object, E> variantVisit$VariantParamPos = new katja.spec.VariantParamPos.Switch<Object, E>() { public final Object CaseSortIdPos(katja.spec.SortIdPos term) throws E { visitSortIdPos(term); return null; } public final Object CaseTupleProdPos(katja.spec.TupleProdPos term) throws E { visitTupleProdPos(term); return null; } public final Object CaseVariantProdPos(katja.spec.VariantProdPos term) throws E { visitVariantProdPos(term); return null; } public final Object CaseListProdPos(katja.spec.ListProdPos term) throws E { visitListProdPos(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitProductionPos(katja.spec.ProductionPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }

        public final void visitSelectorOptPos(katja.spec.SelectorOptPos term) throws E {
            term.Switch(variantVisit$SelectorOptPos);
        }

        public final void visitSortSpecPos(katja.spec.SortSpecPos term) throws E {
            term.Switch(variantVisit$SortSpecPos);
        }

        public final void visitVariantParamPos(katja.spec.VariantParamPos term) throws E {
            term.Switch(variantVisit$VariantParamPos);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.isabelle.IsabelleSelector> implements katja.spec.isabelle.IsabelleSelectors {

        //----- methods of Impl -----

        Impl(katja.spec.isabelle.IsabelleSelector... elements) {
            super(elements);

            for(katja.spec.isabelle.IsabelleSelector element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IsabelleSelectors invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.isabelle.IsabelleSelectors createInstance(katja.spec.isabelle.IsabelleSelector[] elements, boolean isSet) {
            for(katja.spec.isabelle.IsabelleSelector element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort IsabelleSelectors invoked with null element");

            IsabelleSelectors.Impl temp = new katja.spec.isabelle.IsabelleSelectors.Impl();
            temp.values = elements;
            temp = (IsabelleSelectors.Impl) Isabelle.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.isabelle.IsabelleSelector[] createArray(int size) {
            return new katja.spec.isabelle.IsabelleSelector[size];
        }

        public katja.spec.isabelle.IsabelleSelectors add(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.add(element);
        }

        public katja.spec.isabelle.IsabelleSelectors addAll(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.addAll(list);
        }

        public katja.spec.isabelle.IsabelleSelectors remove(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.remove(element);
        }

        public katja.spec.isabelle.IsabelleSelectors removeAll(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.removeAll(list);
        }

        public katja.spec.isabelle.IsabelleSelectors appBack(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.appBack(element);
        }

        public katja.spec.isabelle.IsabelleSelectors appFront(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.appFront(element);
        }

        public katja.spec.isabelle.IsabelleSelectors conc(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.conc(list);
        }

        public katja.spec.isabelle.IsabelleSelectors front() {
            return (katja.spec.isabelle.IsabelleSelectors) super.front();
        }

        public katja.spec.isabelle.IsabelleSelectors back() {
            return (katja.spec.isabelle.IsabelleSelectors) super.back();
        }

        public katja.spec.isabelle.IsabelleSelectors reverse() {
            return (katja.spec.isabelle.IsabelleSelectors) super.reverse();
        }

        public katja.spec.isabelle.IsabelleSelectors sublist(int from, int to) {
            return (katja.spec.isabelle.IsabelleSelectors) super.sublist(from, to);
        }

        public katja.spec.isabelle.IsabelleSelectors replace(int ith, Object element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.replace(ith, element);
        }

        public katja.spec.isabelle.IsabelleSelectors toSet() {
            return (katja.spec.isabelle.IsabelleSelectors) super.toSet();
        }

        public katja.spec.isabelle.IsabelleSelectors setAdd(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.setAdd(element);
        }

        public katja.spec.isabelle.IsabelleSelectors setRemove(katja.spec.isabelle.IsabelleSelector element) {
            return (katja.spec.isabelle.IsabelleSelectors) super.setRemove(element);
        }

        public katja.spec.isabelle.IsabelleSelectors setUnion(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.setUnion(list);
        }

        public katja.spec.isabelle.IsabelleSelectors setIntersection(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.setIntersection(list);
        }

        public katja.spec.isabelle.IsabelleSelectors setWithout(KatjaList<? extends katja.spec.isabelle.IsabelleSelector> list) {
            return (katja.spec.isabelle.IsabelleSelectors) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Isabelle.IsabelleSelectors");
            builder.append("( ");
            for(katja.spec.isabelle.IsabelleSelector element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("IsabelleSelectors");
            builder.append("( ");
            for(katja.spec.isabelle.IsabelleSelector element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "IsabelleSelectors";
        }
    }
}

