package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface ListSelector extends katja.spec.isabelle.PositionSelector, KatjaTuple {

    //----- methods of ListSelector -----

    public katja.spec.descriptors.TermSortDescriptor parentList();
    public katja.spec.isabelle.ListSelector replaceParentList(katja.spec.descriptors.TermSortDescriptor parentList);
    public java.lang.String constructorName();
    public katja.spec.isabelle.ListSelector replaceConstructorName(java.lang.String constructorName);
    public katja.spec.descriptors.SortDescriptor child();
    public katja.spec.isabelle.ListSelector replaceChild(katja.spec.descriptors.SortDescriptor child);
    public Object get(int i);
    public int size();
    public katja.spec.isabelle.ListSelector replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.PositionSelector.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ListSelector -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitListSelector(katja.spec.isabelle.ListSelector term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.ListSelector.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.isabelle.ListSelector {

        //----- attributes of Impl -----

        private katja.spec.descriptors.TermSortDescriptor _parentList = null;
        private java.lang.String _constructorName = null;
        private katja.spec.descriptors.SortDescriptor _child = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.TermSortDescriptor parentList() {
            return _parentList;
        }

        public katja.spec.isabelle.ListSelector replaceParentList(katja.spec.descriptors.TermSortDescriptor parentList) {
            return replace(0, parentList);
        }

        public java.lang.String constructorName() {
            return _constructorName;
        }

        public katja.spec.isabelle.ListSelector replaceConstructorName(java.lang.String constructorName) {
            return replace(1, constructorName);
        }

        public katja.spec.descriptors.SortDescriptor child() {
            return _child;
        }

        public katja.spec.isabelle.ListSelector replaceChild(katja.spec.descriptors.SortDescriptor child) {
            return replace(2, child);
        }

        Impl(katja.spec.descriptors.TermSortDescriptor parentList, java.lang.String constructorName, katja.spec.descriptors.SortDescriptor child) {
            if(parentList == null)
                throw new IllegalArgumentException("constructor of sort ListSelector invoked with null parameter parentList");
            if(constructorName == null)
                throw new IllegalArgumentException("constructor of sort ListSelector invoked with null parameter constructorName");
            if(child == null)
                throw new IllegalArgumentException("constructor of sort ListSelector invoked with null parameter child");

            this._parentList = parentList;
            this._constructorName = constructorName;
            this._child = child;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0: return _parentList;
                case 1: return _constructorName;
                case 2: return _child;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ListSelector invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ListSelector invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.isabelle.ListSelector replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort ListSelector invoked with negative parameter "+pos);
            if(pos >= 3)
                throw new IllegalArgumentException("replace on sort ListSelector invoked with too large parameter "+pos+", sort has only 3 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.TermSortDescriptor))
                throw new IllegalArgumentException("replace on sort ListSelector invoked with term of incorrect sort, TermSortDescriptor expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort ListSelector invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort ListSelector invoked with term of incorrect sort, SortDescriptor expected");

            return (katja.spec.isabelle.ListSelector) Isabelle.unique(new katja.spec.isabelle.ListSelector.Impl(
                pos == 0 ? (katja.spec.descriptors.TermSortDescriptor) term : _parentList,
                pos == 1 ? (java.lang.String) term : _constructorName,
                pos == 2 ? (katja.spec.descriptors.SortDescriptor) term : _child
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.PositionSelector.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseListSelector(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Isabelle.ListSelector");
            builder.append("( ");
            _parentList.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_constructorName.toString()).append("\"");
            builder.append(", ");
            _child.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("ListSelector");
            builder.append("( ");
            _parentList.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_constructorName.toString()).append("\"");
            builder.append(", ");
            _child.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ListSelector";
        }
    }
}

