package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface ListWitness extends katja.spec.isabelle.Witness, KatjaTuple {

    //----- methods of ListWitness -----

    public katja.spec.descriptors.SortDescriptor witnessSort();
    public katja.spec.isabelle.ListWitness replaceWitnessSort(katja.spec.descriptors.SortDescriptor witnessSort);
    public katja.spec.isabelle.Witness element();
    public katja.spec.isabelle.ListWitness replaceElement(katja.spec.isabelle.Witness element);
    public KatjaSort get(int i);
    public int size();
    public katja.spec.isabelle.ListWitness replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.Witness.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ListWitness -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitWitness(katja.spec.isabelle.Witness term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitTupleWitness(katja.spec.isabelle.TupleWitness term) throws E;
        public void visitListWitness(katja.spec.isabelle.ListWitness term) throws E;
        public void visitEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E;
        public void visitExternWitness(katja.spec.isabelle.ExternWitness term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitTupleWitnessParams(katja.spec.isabelle.TupleWitnessParams term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.ListWitness.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.isabelle.Witness.Switch<Object, E> variantVisit$Witness = new katja.spec.isabelle.Witness.Switch<Object, E>() { public final Object CaseTupleWitness(katja.spec.isabelle.TupleWitness term) throws E { visitTupleWitness(term); return null; } public final Object CaseListWitness(katja.spec.isabelle.ListWitness term) throws E { visitListWitness(term); return null; } public final Object CaseEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E { visitEmptyListWitness(term); return null; } public final Object CaseExternWitness(katja.spec.isabelle.ExternWitness term) throws E { visitExternWitness(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitWitness(katja.spec.isabelle.Witness term) throws E {
            term.Switch(variantVisit$Witness);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.isabelle.ListWitness {

        //----- attributes of Impl -----

        private katja.spec.descriptors.SortDescriptor _witnessSort = null;
        private katja.spec.isabelle.Witness _element = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.SortDescriptor witnessSort() {
            return _witnessSort;
        }

        public katja.spec.isabelle.ListWitness replaceWitnessSort(katja.spec.descriptors.SortDescriptor witnessSort) {
            return replace(0, witnessSort);
        }

        public katja.spec.isabelle.Witness element() {
            return _element;
        }

        public katja.spec.isabelle.ListWitness replaceElement(katja.spec.isabelle.Witness element) {
            return replace(1, element);
        }

        Impl(katja.spec.descriptors.SortDescriptor witnessSort, katja.spec.isabelle.Witness element) {
            if(witnessSort == null)
                throw new IllegalArgumentException("constructor of sort ListWitness invoked with null parameter witnessSort");
            if(element == null)
                throw new IllegalArgumentException("constructor of sort ListWitness invoked with null parameter element");

            this._witnessSort = witnessSort;
            this._element = element;
        }

        public KatjaSort get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _witnessSort;
                case 1: return _element;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ListWitness invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ListWitness invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.isabelle.ListWitness replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort ListWitness invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort ListWitness invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort ListWitness invoked with term of incorrect sort, SortDescriptor expected");
            if(pos == 1 && !(term instanceof katja.spec.isabelle.Witness))
                throw new IllegalArgumentException("replace on sort ListWitness invoked with term of incorrect sort, Witness expected");

            return (katja.spec.isabelle.ListWitness) Isabelle.unique(new katja.spec.isabelle.ListWitness.Impl(
                pos == 0 ? (katja.spec.descriptors.SortDescriptor) term : _witnessSort,
                pos == 1 ? (katja.spec.isabelle.Witness) term : _element
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.Witness.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseListWitness(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Isabelle.ListWitness");
            builder.append("( ");
            _witnessSort.toJavaCode(builder);
            builder.append(", ");
            _element.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("ListWitness");
            builder.append("( ");
            _witnessSort.toString(builder);
            builder.append(", ");
            _element.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "ListWitness";
        }
    }
}

