package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface PositionSelectorCall extends katja.spec.isabelle.PositionWitness, KatjaTuple {

    //----- methods of PositionSelectorCall -----

    public katja.spec.isabelle.PositionWitness posWit();
    public katja.spec.isabelle.PositionSelectorCall replacePosWit(katja.spec.isabelle.PositionWitness posWit);
    public katja.spec.isabelle.PositionSelector selector();
    public katja.spec.isabelle.PositionSelectorCall replaceSelector(katja.spec.isabelle.PositionSelector selector);
    public KatjaSort get(int i);
    public int size();
    public katja.spec.isabelle.PositionSelectorCall replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.PositionWitness.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PositionSelectorCall -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitPositionWitness(katja.spec.isabelle.PositionWitness term) throws E;
        public void visitPositionSelector(katja.spec.isabelle.PositionSelector term) throws E;
        public void visitPositionConstructor(katja.spec.isabelle.PositionConstructor term) throws E;
        public void visitPositionSelectorCall(katja.spec.isabelle.PositionSelectorCall term) throws E;
        public void visitTupleSelector(katja.spec.isabelle.TupleSelector term) throws E;
        public void visitListSelector(katja.spec.isabelle.ListSelector term) throws E;
        public void visitWitness(katja.spec.isabelle.Witness term) throws E;
        public void visitSelectorDescriptor(katja.spec.descriptors.SelectorDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTupleWitness(katja.spec.isabelle.TupleWitness term) throws E;
        public void visitListWitness(katja.spec.isabelle.ListWitness term) throws E;
        public void visitEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E;
        public void visitExternWitness(katja.spec.isabelle.ExternWitness term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitTupleWitnessParams(katja.spec.isabelle.TupleWitnessParams term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.PositionSelectorCall.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.isabelle.PositionSelector.Switch<Object, E> variantVisit$PositionSelector = new katja.spec.isabelle.PositionSelector.Switch<Object, E>() { public final Object CaseTupleSelector(katja.spec.isabelle.TupleSelector term) throws E { visitTupleSelector(term); return null; } public final Object CaseListSelector(katja.spec.isabelle.ListSelector term) throws E { visitListSelector(term); return null; } };
        private final katja.spec.isabelle.PositionWitness.Switch<Object, E> variantVisit$PositionWitness = new katja.spec.isabelle.PositionWitness.Switch<Object, E>() { public final Object CasePositionConstructor(katja.spec.isabelle.PositionConstructor term) throws E { visitPositionConstructor(term); return null; } public final Object CasePositionSelectorCall(katja.spec.isabelle.PositionSelectorCall term) throws E { visitPositionSelectorCall(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.descriptors.TermSortDescriptor.Switch<Object, E> variantVisit$TermSortDescriptor = new katja.spec.descriptors.TermSortDescriptor.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.isabelle.Witness.Switch<Object, E> variantVisit$Witness = new katja.spec.isabelle.Witness.Switch<Object, E>() { public final Object CaseTupleWitness(katja.spec.isabelle.TupleWitness term) throws E { visitTupleWitness(term); return null; } public final Object CaseListWitness(katja.spec.isabelle.ListWitness term) throws E { visitListWitness(term); return null; } public final Object CaseEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E { visitEmptyListWitness(term); return null; } public final Object CaseExternWitness(katja.spec.isabelle.ExternWitness term) throws E { visitExternWitness(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitPositionSelector(katja.spec.isabelle.PositionSelector term) throws E {
            term.Switch(variantVisit$PositionSelector);
        }

        public final void visitPositionWitness(katja.spec.isabelle.PositionWitness term) throws E {
            term.Switch(variantVisit$PositionWitness);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$TermSortDescriptor);
        }

        public final void visitWitness(katja.spec.isabelle.Witness term) throws E {
            term.Switch(variantVisit$Witness);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.isabelle.PositionSelectorCall {

        //----- attributes of Impl -----

        private katja.spec.isabelle.PositionWitness _posWit = null;
        private katja.spec.isabelle.PositionSelector _selector = null;

        //----- methods of Impl -----

        public katja.spec.isabelle.PositionWitness posWit() {
            return _posWit;
        }

        public katja.spec.isabelle.PositionSelectorCall replacePosWit(katja.spec.isabelle.PositionWitness posWit) {
            return replace(0, posWit);
        }

        public katja.spec.isabelle.PositionSelector selector() {
            return _selector;
        }

        public katja.spec.isabelle.PositionSelectorCall replaceSelector(katja.spec.isabelle.PositionSelector selector) {
            return replace(1, selector);
        }

        Impl(katja.spec.isabelle.PositionWitness posWit, katja.spec.isabelle.PositionSelector selector) {
            if(posWit == null)
                throw new IllegalArgumentException("constructor of sort PositionSelectorCall invoked with null parameter posWit");
            if(selector == null)
                throw new IllegalArgumentException("constructor of sort PositionSelectorCall invoked with null parameter selector");

            this._posWit = posWit;
            this._selector = selector;
        }

        public KatjaSort get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _posWit;
                case 1: return _selector;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PositionSelectorCall invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PositionSelectorCall invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.isabelle.PositionSelectorCall replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort PositionSelectorCall invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort PositionSelectorCall invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.isabelle.PositionWitness))
                throw new IllegalArgumentException("replace on sort PositionSelectorCall invoked with term of incorrect sort, PositionWitness expected");
            if(pos == 1 && !(term instanceof katja.spec.isabelle.PositionSelector))
                throw new IllegalArgumentException("replace on sort PositionSelectorCall invoked with term of incorrect sort, PositionSelector expected");

            return (katja.spec.isabelle.PositionSelectorCall) Isabelle.unique(new katja.spec.isabelle.PositionSelectorCall.Impl(
                pos == 0 ? (katja.spec.isabelle.PositionWitness) term : _posWit,
                pos == 1 ? (katja.spec.isabelle.PositionSelector) term : _selector
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.PositionWitness.Switch<CT, E> switchClass) throws E {
            return switchClass.CasePositionSelectorCall(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Isabelle.PositionSelectorCall");
            builder.append("( ");
            _posWit.toJavaCode(builder);
            builder.append(", ");
            _selector.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("PositionSelectorCall");
            builder.append("( ");
            _posWit.toString(builder);
            builder.append(", ");
            _selector.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "PositionSelectorCall";
        }
    }
}

