package katja.spec.isabelle;

import katja.common.*;

public interface PositionWitness extends KatjaSort {

    //----- methods of PositionWitness -----

    public <CT, E extends Throwable> CT Switch(katja.spec.isabelle.PositionWitness.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PositionWitness -----

    public static interface Switch<CT, E extends Throwable> {

        //----- methods of Switch<CT, E extends Throwable> -----

        public CT CasePositionConstructor(katja.spec.isabelle.PositionConstructor term) throws E;
        public CT CasePositionSelectorCall(katja.spec.isabelle.PositionSelectorCall term) throws E;
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitWitness(katja.spec.isabelle.Witness term) throws E;
        public void visitPositionWitness(katja.spec.isabelle.PositionWitness term) throws E;
        public void visitPositionSelector(katja.spec.isabelle.PositionSelector term) throws E;
        public void visitTupleWitness(katja.spec.isabelle.TupleWitness term) throws E;
        public void visitListWitness(katja.spec.isabelle.ListWitness term) throws E;
        public void visitEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E;
        public void visitExternWitness(katja.spec.isabelle.ExternWitness term) throws E;
        public void visitPositionConstructor(katja.spec.isabelle.PositionConstructor term) throws E;
        public void visitPositionSelectorCall(katja.spec.isabelle.PositionSelectorCall term) throws E;
        public void visitTupleSelector(katja.spec.isabelle.TupleSelector term) throws E;
        public void visitListSelector(katja.spec.isabelle.ListSelector term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTupleWitnessParams(katja.spec.isabelle.TupleWitnessParams term) throws E;
        public void visitSelectorDescriptor(katja.spec.descriptors.SelectorDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.PositionWitness.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.isabelle.PositionSelector.Switch<Object, E> variantVisit$PositionSelector = new katja.spec.isabelle.PositionSelector.Switch<Object, E>() { public final Object CaseTupleSelector(katja.spec.isabelle.TupleSelector term) throws E { visitTupleSelector(term); return null; } public final Object CaseListSelector(katja.spec.isabelle.ListSelector term) throws E { visitListSelector(term); return null; } };
        private final katja.spec.isabelle.PositionWitness.Switch<Object, E> variantVisit$PositionWitness = new katja.spec.isabelle.PositionWitness.Switch<Object, E>() { public final Object CasePositionConstructor(katja.spec.isabelle.PositionConstructor term) throws E { visitPositionConstructor(term); return null; } public final Object CasePositionSelectorCall(katja.spec.isabelle.PositionSelectorCall term) throws E { visitPositionSelectorCall(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.isabelle.Witness.Switch<Object, E> variantVisit$Witness = new katja.spec.isabelle.Witness.Switch<Object, E>() { public final Object CaseTupleWitness(katja.spec.isabelle.TupleWitness term) throws E { visitTupleWitness(term); return null; } public final Object CaseListWitness(katja.spec.isabelle.ListWitness term) throws E { visitListWitness(term); return null; } public final Object CaseEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E { visitEmptyListWitness(term); return null; } public final Object CaseExternWitness(katja.spec.isabelle.ExternWitness term) throws E { visitExternWitness(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitPositionSelector(katja.spec.isabelle.PositionSelector term) throws E {
            term.Switch(variantVisit$PositionSelector);
        }

        public final void visitPositionWitness(katja.spec.isabelle.PositionWitness term) throws E {
            term.Switch(variantVisit$PositionWitness);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitWitness(katja.spec.isabelle.Witness term) throws E {
            term.Switch(variantVisit$Witness);
        }
    }
}

