package katja.spec.isabelle;

import katja.common.*;
import java.io.IOException;

public interface TupleWitnessParams extends KatjaList<katja.spec.isabelle.Witness> {

    //----- methods of TupleWitnessParams -----

    public katja.spec.isabelle.TupleWitnessParams add(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams addAll(KatjaList<? extends katja.spec.isabelle.Witness> list);
    public katja.spec.isabelle.TupleWitnessParams remove(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams removeAll(KatjaList<? extends katja.spec.isabelle.Witness> list);
    public katja.spec.isabelle.TupleWitnessParams appBack(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams appFront(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams conc(KatjaList<? extends katja.spec.isabelle.Witness> list);
    public katja.spec.isabelle.TupleWitnessParams front();
    public katja.spec.isabelle.TupleWitnessParams back();
    public katja.spec.isabelle.TupleWitnessParams reverse();
    public katja.spec.isabelle.TupleWitnessParams sublist(int from, int to);
    public katja.spec.isabelle.TupleWitnessParams replace(int ith, Object element);
    public katja.spec.isabelle.TupleWitnessParams toSet();
    public katja.spec.isabelle.TupleWitnessParams setAdd(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams setRemove(katja.spec.isabelle.Witness element);
    public katja.spec.isabelle.TupleWitnessParams setUnion(KatjaList<? extends katja.spec.isabelle.Witness> list);
    public katja.spec.isabelle.TupleWitnessParams setIntersection(KatjaList<? extends katja.spec.isabelle.Witness> list);
    public katja.spec.isabelle.TupleWitnessParams setWithout(KatjaList<? extends katja.spec.isabelle.Witness> list);

    //----- nested classes of TupleWitnessParams -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitWitness(katja.spec.isabelle.Witness term) throws E;
        public void visitTupleWitness(katja.spec.isabelle.TupleWitness term) throws E;
        public void visitListWitness(katja.spec.isabelle.ListWitness term) throws E;
        public void visitEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E;
        public void visitExternWitness(katja.spec.isabelle.ExternWitness term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTupleWitnessParams(katja.spec.isabelle.TupleWitnessParams term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.isabelle.TupleWitnessParams.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };
        private final katja.spec.isabelle.Witness.Switch<Object, E> variantVisit$Witness = new katja.spec.isabelle.Witness.Switch<Object, E>() { public final Object CaseTupleWitness(katja.spec.isabelle.TupleWitness term) throws E { visitTupleWitness(term); return null; } public final Object CaseListWitness(katja.spec.isabelle.ListWitness term) throws E { visitListWitness(term); return null; } public final Object CaseEmptyListWitness(katja.spec.isabelle.EmptyListWitness term) throws E { visitEmptyListWitness(term); return null; } public final Object CaseExternWitness(katja.spec.isabelle.ExternWitness term) throws E { visitExternWitness(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitWitness(katja.spec.isabelle.Witness term) throws E {
            term.Switch(variantVisit$Witness);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.isabelle.Witness> implements katja.spec.isabelle.TupleWitnessParams {

        //----- methods of Impl -----

        Impl(katja.spec.isabelle.Witness... elements) {
            super(elements);

            for(katja.spec.isabelle.Witness element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleWitnessParams invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.isabelle.TupleWitnessParams createInstance(katja.spec.isabelle.Witness[] elements, boolean isSet) {
            for(katja.spec.isabelle.Witness element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort TupleWitnessParams invoked with null element");

            TupleWitnessParams.Impl temp = new katja.spec.isabelle.TupleWitnessParams.Impl();
            temp.values = elements;
            temp = (TupleWitnessParams.Impl) Isabelle.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.isabelle.Witness[] createArray(int size) {
            return new katja.spec.isabelle.Witness[size];
        }

        public katja.spec.isabelle.TupleWitnessParams add(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.add(element);
        }

        public katja.spec.isabelle.TupleWitnessParams addAll(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.addAll(list);
        }

        public katja.spec.isabelle.TupleWitnessParams remove(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.remove(element);
        }

        public katja.spec.isabelle.TupleWitnessParams removeAll(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.removeAll(list);
        }

        public katja.spec.isabelle.TupleWitnessParams appBack(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.appBack(element);
        }

        public katja.spec.isabelle.TupleWitnessParams appFront(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.appFront(element);
        }

        public katja.spec.isabelle.TupleWitnessParams conc(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.conc(list);
        }

        public katja.spec.isabelle.TupleWitnessParams front() {
            return (katja.spec.isabelle.TupleWitnessParams) super.front();
        }

        public katja.spec.isabelle.TupleWitnessParams back() {
            return (katja.spec.isabelle.TupleWitnessParams) super.back();
        }

        public katja.spec.isabelle.TupleWitnessParams reverse() {
            return (katja.spec.isabelle.TupleWitnessParams) super.reverse();
        }

        public katja.spec.isabelle.TupleWitnessParams sublist(int from, int to) {
            return (katja.spec.isabelle.TupleWitnessParams) super.sublist(from, to);
        }

        public katja.spec.isabelle.TupleWitnessParams replace(int ith, Object element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.replace(ith, element);
        }

        public katja.spec.isabelle.TupleWitnessParams toSet() {
            return (katja.spec.isabelle.TupleWitnessParams) super.toSet();
        }

        public katja.spec.isabelle.TupleWitnessParams setAdd(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.setAdd(element);
        }

        public katja.spec.isabelle.TupleWitnessParams setRemove(katja.spec.isabelle.Witness element) {
            return (katja.spec.isabelle.TupleWitnessParams) super.setRemove(element);
        }

        public katja.spec.isabelle.TupleWitnessParams setUnion(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.setUnion(list);
        }

        public katja.spec.isabelle.TupleWitnessParams setIntersection(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.setIntersection(list);
        }

        public katja.spec.isabelle.TupleWitnessParams setWithout(KatjaList<? extends katja.spec.isabelle.Witness> list) {
            return (katja.spec.isabelle.TupleWitnessParams) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Isabelle.TupleWitnessParams");
            builder.append("( ");
            for(katja.spec.isabelle.Witness element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("TupleWitnessParams");
            builder.append("( ");
            for(katja.spec.isabelle.Witness element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "TupleWitnessParams";
        }
    }
}

