package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface ABSTRACTInFile extends katja.spec.model.MModifierInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.ABSTRACT> {

    //----- methods of ABSTRACTInFile -----

    public katja.spec.model.ABSTRACT termMModifier();
    public katja.spec.model.ABSTRACT term();
    public KatjaSortPos<katja.spec.model.MFileInFile> get(int i);
    public int size();
    public katja.spec.model.ABSTRACTInFile replace(katja.spec.model.ABSTRACT term);
    public katja.spec.model.MModifiersInFile parent();
    public katja.spec.model.MModifierInFile lsib();
    public katja.spec.model.MModifierInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MModifierInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of ABSTRACTInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.ABSTRACTInFile.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.ABSTRACT> implements katja.spec.model.ABSTRACTInFile {

        //----- methods of Impl -----

        public katja.spec.model.ABSTRACT termMModifier() {
            return term();
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.ABSTRACT term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<katja.spec.model.MFileInFile> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort ABSTRACTInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort ABSTRACTInFile invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.model.ABSTRACTInFile replace(katja.spec.model.ABSTRACT term) {
            return (katja.spec.model.ABSTRACTInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MModifiersInFile parent() {
            return (katja.spec.model.MModifiersInFile) super.parent();
        }

        public katja.spec.model.MModifierInFile lsib() {
            return (katja.spec.model.MModifierInFile) super.lsib();
        }

        public katja.spec.model.MModifierInFile rsib() {
            return (katja.spec.model.MModifierInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MModifierInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseABSTRACTInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "ABSTRACTInFile";
        }
    }
}

