package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface CLASS extends katja.spec.model.MClassType, KatjaTuple {

    //----- methods of CLASS -----

    public Object get(int i);
    public int size();
    public katja.spec.model.CLASS replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MClassType.Switch<CT, E> switchClass) throws E;

    //----- nested classes of CLASS -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitCLASS(katja.spec.model.CLASS term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.CLASS.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.CLASS {

        //----- methods of Impl -----

        Impl() {

        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort CLASS invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort CLASS invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.model.CLASS replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort CLASS invoked with negative parameter "+pos);
            if(pos >= 0)
                throw new IllegalArgumentException("replace on sort CLASS invoked with too large parameter "+pos+", sort has only 0 components");


            return (katja.spec.model.CLASS) Model.unique(new katja.spec.model.CLASS.Impl(
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MClassType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseCLASS(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.CLASS");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("CLASS");
            builder.append("( ");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "CLASS";
        }
    }
}

