package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MAttribute extends KatjaTuple {

    //----- methods of MAttribute -----

    public katja.spec.model.MModifiers modifiers();
    public katja.spec.model.MAttribute replaceModifiers(katja.spec.model.MModifiers modifiers);
    public katja.spec.model.MAnyType type();
    public katja.spec.model.MAttribute replaceType(katja.spec.model.MAnyType type);
    public java.lang.String name();
    public katja.spec.model.MAttribute replaceName(java.lang.String name);
    public katja.spec.model.MCodeFragment initial();
    public katja.spec.model.MAttribute replaceInitial(katja.spec.model.MCodeFragment initial);
    public Object get(int i);
    public int size();
    public katja.spec.model.MAttribute replace(int pos, Object term);

    //----- nested classes of MAttribute -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMCodeFragment(katja.spec.model.MCodeFragment term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMAttribute(katja.spec.model.MAttribute term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MAttribute.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MAttribute {

        //----- attributes of Impl -----

        private katja.spec.model.MModifiers _modifiers = null;
        private katja.spec.model.MAnyType _type = null;
        private java.lang.String _name = null;
        private katja.spec.model.MCodeFragment _initial = null;

        //----- methods of Impl -----

        public katja.spec.model.MModifiers modifiers() {
            return _modifiers;
        }

        public katja.spec.model.MAttribute replaceModifiers(katja.spec.model.MModifiers modifiers) {
            return replace(0, modifiers);
        }

        public katja.spec.model.MAnyType type() {
            return _type;
        }

        public katja.spec.model.MAttribute replaceType(katja.spec.model.MAnyType type) {
            return replace(1, type);
        }

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.model.MAttribute replaceName(java.lang.String name) {
            return replace(2, name);
        }

        public katja.spec.model.MCodeFragment initial() {
            return _initial;
        }

        public katja.spec.model.MAttribute replaceInitial(katja.spec.model.MCodeFragment initial) {
            return replace(3, initial);
        }

        Impl(katja.spec.model.MModifiers modifiers, katja.spec.model.MAnyType type, java.lang.String name, katja.spec.model.MCodeFragment initial) {
            if(modifiers == null)
                throw new IllegalArgumentException("constructor of sort MAttribute invoked with null parameter modifiers");
            if(type == null)
                throw new IllegalArgumentException("constructor of sort MAttribute invoked with null parameter type");
            if(name == null)
                throw new IllegalArgumentException("constructor of sort MAttribute invoked with null parameter name");
            if(initial == null)
                throw new IllegalArgumentException("constructor of sort MAttribute invoked with null parameter initial");

            this._modifiers = modifiers;
            this._type = type;
            this._name = name;
            this._initial = initial;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0: return _modifiers;
                case 1: return _type;
                case 2: return _name;
                case 3: return _initial;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MAttribute invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MAttribute invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.model.MAttribute replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MAttribute invoked with negative parameter "+pos);
            if(pos >= 4)
                throw new IllegalArgumentException("replace on sort MAttribute invoked with too large parameter "+pos+", sort has only 4 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MModifiers))
                throw new IllegalArgumentException("replace on sort MAttribute invoked with term of incorrect sort, MModifiers expected");
            if(pos == 1 && !(term instanceof katja.spec.model.MAnyType))
                throw new IllegalArgumentException("replace on sort MAttribute invoked with term of incorrect sort, MAnyType expected");
            if(pos == 2 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MAttribute invoked with term of incorrect sort, String expected");
            if(pos == 3 && !(term instanceof katja.spec.model.MCodeFragment))
                throw new IllegalArgumentException("replace on sort MAttribute invoked with term of incorrect sort, MCodeFragment expected");

            return (katja.spec.model.MAttribute) Model.unique(new katja.spec.model.MAttribute.Impl(
                pos == 0 ? (katja.spec.model.MModifiers) term : _modifiers,
                pos == 1 ? (katja.spec.model.MAnyType) term : _type,
                pos == 2 ? (java.lang.String) term : _name,
                pos == 3 ? (katja.spec.model.MCodeFragment) term : _initial
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MAttribute");
            builder.append("( ");
            _modifiers.toJavaCode(builder);
            builder.append(", ");
            _type.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _initial.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MAttribute");
            builder.append("( ");
            _modifiers.toString(builder);
            builder.append(", ");
            _type.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _initial.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MAttribute";
        }
    }
}

