package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MAttributes extends KatjaList<katja.spec.model.MAttribute> {

    //----- methods of MAttributes -----

    public katja.spec.model.MAttributes add(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes addAll(KatjaList<? extends katja.spec.model.MAttribute> list);
    public katja.spec.model.MAttributes remove(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes removeAll(KatjaList<? extends katja.spec.model.MAttribute> list);
    public katja.spec.model.MAttributes appBack(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes appFront(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes conc(KatjaList<? extends katja.spec.model.MAttribute> list);
    public katja.spec.model.MAttributes front();
    public katja.spec.model.MAttributes back();
    public katja.spec.model.MAttributes reverse();
    public katja.spec.model.MAttributes sublist(int from, int to);
    public katja.spec.model.MAttributes replace(int ith, Object element);
    public katja.spec.model.MAttributes toSet();
    public katja.spec.model.MAttributes setAdd(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes setRemove(katja.spec.model.MAttribute element);
    public katja.spec.model.MAttributes setUnion(KatjaList<? extends katja.spec.model.MAttribute> list);
    public katja.spec.model.MAttributes setIntersection(KatjaList<? extends katja.spec.model.MAttribute> list);
    public katja.spec.model.MAttributes setWithout(KatjaList<? extends katja.spec.model.MAttribute> list);

    //----- nested classes of MAttributes -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMAttribute(katja.spec.model.MAttribute term) throws E;
        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMCodeFragment(katja.spec.model.MCodeFragment term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMAttributes(katja.spec.model.MAttributes term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MAttributes.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MAttribute> implements katja.spec.model.MAttributes {

        //----- methods of Impl -----

        Impl(katja.spec.model.MAttribute... elements) {
            super(elements);

            for(katja.spec.model.MAttribute element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MAttributes invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MAttributes createInstance(katja.spec.model.MAttribute[] elements, boolean isSet) {
            for(katja.spec.model.MAttribute element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MAttributes invoked with null element");

            MAttributes.Impl temp = new katja.spec.model.MAttributes.Impl();
            temp.values = elements;
            temp = (MAttributes.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MAttribute[] createArray(int size) {
            return new katja.spec.model.MAttribute[size];
        }

        public katja.spec.model.MAttributes add(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.add(element);
        }

        public katja.spec.model.MAttributes addAll(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.addAll(list);
        }

        public katja.spec.model.MAttributes remove(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.remove(element);
        }

        public katja.spec.model.MAttributes removeAll(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.removeAll(list);
        }

        public katja.spec.model.MAttributes appBack(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.appBack(element);
        }

        public katja.spec.model.MAttributes appFront(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.appFront(element);
        }

        public katja.spec.model.MAttributes conc(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.conc(list);
        }

        public katja.spec.model.MAttributes front() {
            return (katja.spec.model.MAttributes) super.front();
        }

        public katja.spec.model.MAttributes back() {
            return (katja.spec.model.MAttributes) super.back();
        }

        public katja.spec.model.MAttributes reverse() {
            return (katja.spec.model.MAttributes) super.reverse();
        }

        public katja.spec.model.MAttributes sublist(int from, int to) {
            return (katja.spec.model.MAttributes) super.sublist(from, to);
        }

        public katja.spec.model.MAttributes replace(int ith, Object element) {
            return (katja.spec.model.MAttributes) super.replace(ith, element);
        }

        public katja.spec.model.MAttributes toSet() {
            return (katja.spec.model.MAttributes) super.toSet();
        }

        public katja.spec.model.MAttributes setAdd(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.setAdd(element);
        }

        public katja.spec.model.MAttributes setRemove(katja.spec.model.MAttribute element) {
            return (katja.spec.model.MAttributes) super.setRemove(element);
        }

        public katja.spec.model.MAttributes setUnion(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.setUnion(list);
        }

        public katja.spec.model.MAttributes setIntersection(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.setIntersection(list);
        }

        public katja.spec.model.MAttributes setWithout(KatjaList<? extends katja.spec.model.MAttribute> list) {
            return (katja.spec.model.MAttributes) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MAttributes");
            builder.append("( ");
            for(katja.spec.model.MAttribute element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MAttributes");
            builder.append("( ");
            for(katja.spec.model.MAttribute element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MAttributes";
        }
    }
}

