package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MCodeInFile extends katja.spec.model.Model.TupleInFile<katja.spec.model.MCode> {

    //----- methods of MCodeInFile -----

    public katja.spec.model.MCode term();
    public katja.spec.model.StringsInFile lines();
    public katja.spec.model.MCodeInFile replaceLines(katja.spec.model.Strings lines);
    public katja.spec.model.MTypesInFile needed();
    public katja.spec.model.MCodeInFile replaceNeeded(katja.spec.model.MTypes needed);
    public katja.spec.model.Model.ListInFile<?, ?, ?> get(int i);
    public int size();
    public katja.spec.model.MCodeInFile replace(katja.spec.model.MCode term);
    public katja.spec.model.MMethodInFile parent();
    public katja.spec.model.MTypesInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MCodeInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMCodeInFile(katja.spec.model.MCodeInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MCodeInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MCode> implements katja.spec.model.MCodeInFile {

        //----- attributes of Impl -----

        private katja.spec.model.StringsInFile _lines = null;
        private katja.spec.model.MTypesInFile _needed = null;

        //----- methods of Impl -----

        public katja.spec.model.StringsInFile lines() {
            if(_lines == null)
                _lines = katja.spec.model.Model.StringsInFile(this, _term.lines(), 0);

            return _lines;
        }

        public katja.spec.model.MCodeInFile replaceLines(katja.spec.model.Strings lines) {
            return replace(_term.replaceLines(lines));
        }

        public katja.spec.model.MTypesInFile needed() {
            if(_needed == null)
                _needed = katja.spec.model.Model.MTypesInFile(this, _term.needed(), 1);

            return _needed;
        }

        public katja.spec.model.MCodeInFile replaceNeeded(katja.spec.model.MTypes needed) {
            return replace(_term.replaceNeeded(needed));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MCode term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.ListInFile<?, ?, ?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_lines == null)
                        _lines = Model.StringsInFile(this, _term.lines(), 0);
                    
                    return _lines;
                case 1:
                    if(_needed == null)
                        _needed = Model.MTypesInFile(this, _term.needed(), 1);
                    
                    return _needed;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MCodeInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MCodeInFile invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MCodeInFile replace(katja.spec.model.MCode term) {
            return (katja.spec.model.MCodeInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MMethodInFile parent() {
            return (katja.spec.model.MMethodInFile) super.parent();
        }

        public katja.spec.model.MTypesInFile lsib() {
            return (katja.spec.model.MTypesInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MCodeInFile";
        }
    }
}

