package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MFile extends KatjaTuple {

    //----- methods of MFile -----

    public java.lang.String name();
    public katja.spec.model.MFile replaceName(java.lang.String name);
    public java.lang.String packageName();
    public katja.spec.model.MFile replacePackageName(java.lang.String packageName);
    public katja.spec.model.MClasses classes();
    public katja.spec.model.MFile replaceClasses(katja.spec.model.MClasses classes);
    public Object get(int i);
    public int size();
    public katja.spec.model.MFile replace(int pos, Object term);

    //----- nested classes of MFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitMClasses(katja.spec.model.MClasses term) throws E;
        public void visitMClass(katja.spec.model.MClass term) throws E;
        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
        public void visitMClassType(katja.spec.model.MClassType term) throws E;
        public void visitMTypeDef(katja.spec.model.MTypeDef term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMAttributes(katja.spec.model.MAttributes term) throws E;
        public void visitMMethods(katja.spec.model.MMethods term) throws E;
        public void visitINTERFACE(katja.spec.model.INTERFACE term) throws E;
        public void visitCLASS(katja.spec.model.CLASS term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMGenericTypeDef(katja.spec.model.MGenericTypeDef term) throws E;
        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMAttribute(katja.spec.model.MAttribute term) throws E;
        public void visitMMethod(katja.spec.model.MMethod term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitMTypeVariables(katja.spec.model.MTypeVariables term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMCodeFragment(katja.spec.model.MCodeFragment term) throws E;
        public void visitMReturnType(katja.spec.model.MReturnType term) throws E;
        public void visitMParameters(katja.spec.model.MParameters term) throws E;
        public void visitMCode(katja.spec.model.MCode term) throws E;
        public void visitMTypeVariable(katja.spec.model.MTypeVariable term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNone(katja.spec.model.MNone term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMParameter(katja.spec.model.MParameter term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E;
        public void visitMParamtype(katja.spec.model.MParamtype term) throws E;
        public void visitMFinal(katja.spec.model.MFinal term) throws E;
        public void visitMVararg(katja.spec.model.MVararg term) throws E;
        public void visitMFile(katja.spec.model.MFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MClassType.Switch<Object, E> variantVisit$MClassType = new katja.spec.model.MClassType.Switch<Object, E>() { public final Object CaseINTERFACE(katja.spec.model.INTERFACE term) throws E { visitINTERFACE(term); return null; } public final Object CaseCLASS(katja.spec.model.CLASS term) throws E { visitCLASS(term); return null; } };
        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };
        private final katja.spec.model.MParamtype.Switch<Object, E> variantVisit$MParamtype = new katja.spec.model.MParamtype.Switch<Object, E>() { public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtypeDecl.Switch<Object, E> variantVisit$MParamtypeDecl = new katja.spec.model.MParamtypeDecl.Switch<Object, E>() { public final Object CaseMFinal(katja.spec.model.MFinal term) throws E { visitMFinal(term); return null; } public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MReturnType.Switch<Object, E> variantVisit$MReturnType = new katja.spec.model.MReturnType.Switch<Object, E>() { public final Object CaseMNone(katja.spec.model.MNone term) throws E { visitMNone(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeDef.Switch<Object, E> variantVisit$MTypeDef = new katja.spec.model.MTypeDef.Switch<Object, E>() { public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMGenericTypeDef(katja.spec.model.MGenericTypeDef term) throws E { visitMGenericTypeDef(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMClassType(katja.spec.model.MClassType term) throws E {
            term.Switch(variantVisit$MClassType);
        }

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMParamtype(katja.spec.model.MParamtype term) throws E {
            term.Switch(variantVisit$MParamtype);
        }

        public final void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMReturnType(katja.spec.model.MReturnType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMTypeDef(katja.spec.model.MTypeDef term) throws E {
            term.Switch(variantVisit$MTypeDef);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MFile {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private java.lang.String _packageName = null;
        private katja.spec.model.MClasses _classes = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.model.MFile replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public java.lang.String packageName() {
            return _packageName;
        }

        public katja.spec.model.MFile replacePackageName(java.lang.String packageName) {
            return replace(1, packageName);
        }

        public katja.spec.model.MClasses classes() {
            return _classes;
        }

        public katja.spec.model.MFile replaceClasses(katja.spec.model.MClasses classes) {
            return replace(2, classes);
        }

        Impl(java.lang.String name, java.lang.String packageName, katja.spec.model.MClasses classes) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort MFile invoked with null parameter name");
            if(packageName == null)
                throw new IllegalArgumentException("constructor of sort MFile invoked with null parameter packageName");
            if(classes == null)
                throw new IllegalArgumentException("constructor of sort MFile invoked with null parameter classes");

            this._name = name;
            this._packageName = packageName;
            this._classes = classes;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0: return _name;
                case 1: return _packageName;
                case 2: return _classes;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MFile invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.model.MFile replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MFile invoked with negative parameter "+pos);
            if(pos >= 3)
                throw new IllegalArgumentException("replace on sort MFile invoked with too large parameter "+pos+", sort has only 3 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MFile invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MFile invoked with term of incorrect sort, String expected");
            if(pos == 2 && !(term instanceof katja.spec.model.MClasses))
                throw new IllegalArgumentException("replace on sort MFile invoked with term of incorrect sort, MClasses expected");

            return (katja.spec.model.MFile) Model.unique(new katja.spec.model.MFile.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (java.lang.String) term : _packageName,
                pos == 2 ? (katja.spec.model.MClasses) term : _classes
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFile");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_packageName.toString()).append("\"");
            builder.append(", ");
            _classes.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MFile");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            builder.append("\"").append(_packageName.toString()).append("\"");
            builder.append(", ");
            _classes.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MFile";
        }
    }
}

