package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MFileInFile extends katja.spec.model.Model.TupleInFile<katja.spec.model.MFile> {

    //----- methods of MFileInFile -----

    public katja.spec.model.MFile term();
    public katja.spec.model.StringInFile name();
    public katja.spec.model.MFileInFile replaceName(java.lang.String name);
    public katja.spec.model.StringInFile packageName();
    public katja.spec.model.MFileInFile replacePackageName(java.lang.String packageName);
    public katja.spec.model.MClassesInFile classes();
    public katja.spec.model.MFileInFile replaceClasses(katja.spec.model.MClasses classes);
    public katja.spec.model.Model.TermInFile<?> get(int i);
    public int size();
    public katja.spec.model.MFileInFile replace(katja.spec.model.MFile term);
    public katja.spec.model.Model.SortInFile parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MFileInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMClassesInFile(katja.spec.model.MClassesInFile term) throws E;
        public void visitMClassInFile(katja.spec.model.MClassInFile term) throws E;
        public void visitMModifiersInFile(katja.spec.model.MModifiersInFile term) throws E;
        public void visitMClassTypeInFile(katja.spec.model.MClassTypeInFile term) throws E;
        public void visitMTypeDefInFile(katja.spec.model.MTypeDefInFile term) throws E;
        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E;
        public void visitMAttributesInFile(katja.spec.model.MAttributesInFile term) throws E;
        public void visitMMethodsInFile(katja.spec.model.MMethodsInFile term) throws E;
        public void visitINTERFACEInFile(katja.spec.model.INTERFACEInFile term) throws E;
        public void visitCLASSInFile(katja.spec.model.CLASSInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMGenericTypeDefInFile(katja.spec.model.MGenericTypeDefInFile term) throws E;
        public void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMAttributeInFile(katja.spec.model.MAttributeInFile term) throws E;
        public void visitMMethodInFile(katja.spec.model.MMethodInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitMTypeVariablesInFile(katja.spec.model.MTypeVariablesInFile term) throws E;
        public void visitPROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E;
        public void visitPRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E;
        public void visitPUBLICInFile(katja.spec.model.PUBLICInFile term) throws E;
        public void visitSTATICInFile(katja.spec.model.STATICInFile term) throws E;
        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E;
        public void visitFINALInFile(katja.spec.model.FINALInFile term) throws E;
        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E;
        public void visitMCodeFragmentInFile(katja.spec.model.MCodeFragmentInFile term) throws E;
        public void visitMReturnTypeInFile(katja.spec.model.MReturnTypeInFile term) throws E;
        public void visitMParametersInFile(katja.spec.model.MParametersInFile term) throws E;
        public void visitMCodeInFile(katja.spec.model.MCodeInFile term) throws E;
        public void visitMTypeVariableInFile(katja.spec.model.MTypeVariableInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E;
        public void visitMNoneInFile(katja.spec.model.MNoneInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitMParameterInFile(katja.spec.model.MParameterInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMParamtypeDeclInFile(katja.spec.model.MParamtypeDeclInFile term) throws E;
        public void visitMParamtypeInFile(katja.spec.model.MParamtypeInFile term) throws E;
        public void visitMFinalInFile(katja.spec.model.MFinalInFile term) throws E;
        public void visitMVarargInFile(katja.spec.model.MVarargInFile term) throws E;
        public void visitMFileInFile(katja.spec.model.MFileInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MFileInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MClassTypeInFile.Switch<Object, E> variantVisit$MClassTypeInFile = new katja.spec.model.MClassTypeInFile.Switch<Object, E>() { public final Object CaseINTERFACEInFile(katja.spec.model.INTERFACEInFile term) throws E { visitINTERFACEInFile(term); return null; } public final Object CaseCLASSInFile(katja.spec.model.CLASSInFile term) throws E { visitCLASSInFile(term); return null; } };
        private final katja.spec.model.MModifierInFile.Switch<Object, E> variantVisit$MModifierInFile = new katja.spec.model.MModifierInFile.Switch<Object, E>() { public final Object CasePROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E { visitPROTECTEDInFile(term); return null; } public final Object CasePRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E { visitPRIVATEInFile(term); return null; } public final Object CasePUBLICInFile(katja.spec.model.PUBLICInFile term) throws E { visitPUBLICInFile(term); return null; } public final Object CaseSTATICInFile(katja.spec.model.STATICInFile term) throws E { visitSTATICInFile(term); return null; } public final Object CaseABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E { visitABSTRACTInFile(term); return null; } public final Object CaseFINALInFile(katja.spec.model.FINALInFile term) throws E { visitFINALInFile(term); return null; } };
        private final katja.spec.model.MParamtypeDeclInFile.Switch<Object, E> variantVisit$MParamtypeDeclInFile = new katja.spec.model.MParamtypeDeclInFile.Switch<Object, E>() { public final Object CaseMFinalInFile(katja.spec.model.MFinalInFile term) throws E { visitMFinalInFile(term); return null; } public final Object CaseMVarargInFile(katja.spec.model.MVarargInFile term) throws E { visitMVarargInFile(term); return null; } public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MReturnTypeInFile.Switch<Object, E> variantVisit$MReturnTypeInFile = new katja.spec.model.MReturnTypeInFile.Switch<Object, E>() { public final Object CaseMNoneInFile(katja.spec.model.MNoneInFile term) throws E { visitMNoneInFile(term); return null; } public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MTypeDefInFile.Switch<Object, E> variantVisit$MTypeDefInFile = new katja.spec.model.MTypeDefInFile.Switch<Object, E>() { public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMGenericTypeDefInFile(katja.spec.model.MGenericTypeDefInFile term) throws E { visitMGenericTypeDefInFile(term); return null; } };
        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E {
            term.Switch(variantVisit$MReturnTypeInFile);
        }

        public final void visitMClassTypeInFile(katja.spec.model.MClassTypeInFile term) throws E {
            term.Switch(variantVisit$MClassTypeInFile);
        }

        public final void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E {
            term.Switch(variantVisit$MModifierInFile);
        }

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MReturnTypeInFile);
        }

        public final void visitMParamtypeDeclInFile(katja.spec.model.MParamtypeDeclInFile term) throws E {
            term.Switch(variantVisit$MParamtypeDeclInFile);
        }

        public final void visitMParamtypeInFile(katja.spec.model.MParamtypeInFile term) throws E {
            term.Switch(variantVisit$MParamtypeDeclInFile);
        }

        public final void visitMReturnTypeInFile(katja.spec.model.MReturnTypeInFile term) throws E {
            term.Switch(variantVisit$MReturnTypeInFile);
        }

        public final void visitMTypeDefInFile(katja.spec.model.MTypeDefInFile term) throws E {
            term.Switch(variantVisit$MTypeDefInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    public static abstract class DefaultVisitor<E extends Throwable> extends katja.spec.model.MFileInFile.Visitor<E> {

        //----- methods of DefaultVisitor<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E {
        }

        public void visitMClassesInFile(katja.spec.model.MClassesInFile term) throws E {
            for(katja.spec.model.MClassInFile element : term)
                visitMClassInFile(element);
        }

        public void visitMClassInFile(katja.spec.model.MClassInFile term) throws E {
            visitMModifiersInFile(term.modifiers());
            visitMClassTypeInFile(term.type());
            visitMTypeDefInFile(term.name());
            visitMTypesInFile(term.extend());
            visitMTypesInFile(term.implement());
            visitMAttributesInFile(term.attributes());
            visitMMethodsInFile(term.methods());
            visitMClassesInFile(term.nested());
        }

        public void visitMModifiersInFile(katja.spec.model.MModifiersInFile term) throws E {
            for(katja.spec.model.MModifierInFile element : term)
                visitMModifierInFile(element);
        }

        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E {
            for(katja.spec.model.MTypeInFile element : term)
                visitMTypeInFile(element);
        }

        public void visitMAttributesInFile(katja.spec.model.MAttributesInFile term) throws E {
            for(katja.spec.model.MAttributeInFile element : term)
                visitMAttributeInFile(element);
        }

        public void visitMMethodsInFile(katja.spec.model.MMethodsInFile term) throws E {
            for(katja.spec.model.MMethodInFile element : term)
                visitMMethodInFile(element);
        }

        public void visitINTERFACEInFile(katja.spec.model.INTERFACEInFile term) throws E {
        }

        public void visitCLASSInFile(katja.spec.model.CLASSInFile term) throws E {
        }

        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E {
            visitStringInFile(term.name());
            visitStringsInFile(term.importNames());
        }

        public void visitMGenericTypeDefInFile(katja.spec.model.MGenericTypeDefInFile term) throws E {
            visitMJavaTypeInFile(term.type());
            visitMTypeVariablesInFile(term.typeVars());
        }

        public void visitMAttributeInFile(katja.spec.model.MAttributeInFile term) throws E {
            visitMModifiersInFile(term.modifiers());
            visitMAnyTypeInFile(term.type());
            visitStringInFile(term.name());
            visitMCodeFragmentInFile(term.initial());
        }

        public void visitMMethodInFile(katja.spec.model.MMethodInFile term) throws E {
            visitMModifiersInFile(term.modifiers());
            visitMTypeVariablesInFile(term.generics());
            visitMReturnTypeInFile(term.returnType());
            visitStringInFile(term.name());
            visitMParametersInFile(term.parameter());
            visitMTypesInFile(term.exceptions());
            visitMCodeInFile(term.body());
        }

        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E {
            for(katja.spec.model.StringInFile element : term)
                visitStringInFile(element);
        }

        public void visitMTypeVariablesInFile(katja.spec.model.MTypeVariablesInFile term) throws E {
            for(katja.spec.model.MTypeVariableInFile element : term)
                visitMTypeVariableInFile(element);
        }

        public void visitPROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E {
        }

        public void visitPRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E {
        }

        public void visitPUBLICInFile(katja.spec.model.PUBLICInFile term) throws E {
        }

        public void visitSTATICInFile(katja.spec.model.STATICInFile term) throws E {
        }

        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E {
        }

        public void visitFINALInFile(katja.spec.model.FINALInFile term) throws E {
        }

        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E {
            visitMNonGenericTypeInFile(term.type());
            visitMTypeOrWildcardsInFile(term.types());
        }

        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E {
            visitSortDescriptorInFile(term.sortDesc());
        }

        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E {
            visitMNonGenericTypeInFile(term.outerClass());
            visitStringInFile(term.innerClass());
        }

        public void visitMCodeFragmentInFile(katja.spec.model.MCodeFragmentInFile term) throws E {
            visitStringInFile(term.part());
            visitMTypesInFile(term.needed());
        }

        public void visitMParametersInFile(katja.spec.model.MParametersInFile term) throws E {
            for(katja.spec.model.MParameterInFile element : term)
                visitMParameterInFile(element);
        }

        public void visitMCodeInFile(katja.spec.model.MCodeInFile term) throws E {
            visitStringsInFile(term.lines());
            visitMTypesInFile(term.needed());
        }

        public void visitMTypeVariableInFile(katja.spec.model.MTypeVariableInFile term) throws E {
            visitStringInFile(term.name());
            visitMTypesInFile(term.bounds());
        }

        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E {
            for(katja.spec.model.MTypeOrWildcardInFile element : term)
                visitMTypeOrWildcardInFile(element);
        }

        public void visitMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E {
            visitMAnyTypeInFile(term.type());
        }

        public void visitMNoneInFile(katja.spec.model.MNoneInFile term) throws E {
        }

        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.filename());
            visitIntegerInFile(term.line());
            visitBooleanInFile(term.imported());
            visitTermSortDescriptorInFile(term.baseSort());
            visitPosStructDescriptorInFile(term.struct());
        }

        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.filename());
            visitIntegerInFile(term.line());
            visitBooleanInFile(term.imported());
        }

        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.filename());
            visitIntegerInFile(term.line());
            visitBooleanInFile(term.imported());
        }

        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.filename());
            visitIntegerInFile(term.line());
            visitBooleanInFile(term.imported());
        }

        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.filename());
            visitIntegerInFile(term.line());
            visitBooleanInFile(term.imported());
        }

        public void visitMParameterInFile(katja.spec.model.MParameterInFile term) throws E {
            visitMParamtypeDeclInFile(term.decl());
            visitStringInFile(term.name());
        }

        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E {
        }

        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E {
        }

        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E {
            visitTermSortDescriptorInFile(term.rootSort());
            visitStringInFile(term.suffix());
        }

        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E {
        }

        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E {
            visitMTypeInFile(term.bound());
        }

        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E {
            visitMTypeInFile(term.bound());
        }

        public void visitMFinalInFile(katja.spec.model.MFinalInFile term) throws E {
            visitMParamtypeInFile(term.type());
        }

        public void visitMVarargInFile(katja.spec.model.MVarargInFile term) throws E {
            visitMAnyTypeInFile(term.type());
        }

        public void visitMFileInFile(katja.spec.model.MFileInFile term) throws E {
            visitStringInFile(term.name());
            visitStringInFile(term.packageName());
            visitMClassesInFile(term.classes());
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MFile> implements katja.spec.model.MFileInFile {

        //----- attributes of Impl -----

        private katja.spec.model.StringInFile _name = null;
        private katja.spec.model.StringInFile _packageName = null;
        private katja.spec.model.MClassesInFile _classes = null;

        //----- methods of Impl -----

        public katja.spec.model.StringInFile name() {
            if(_name == null)
                _name = katja.spec.model.Model.StringInFile(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.model.MFileInFile replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.model.StringInFile packageName() {
            if(_packageName == null)
                _packageName = katja.spec.model.Model.StringInFile(this, _term.packageName(), 1);

            return _packageName;
        }

        public katja.spec.model.MFileInFile replacePackageName(java.lang.String packageName) {
            return replace(_term.replacePackageName(packageName));
        }

        public katja.spec.model.MClassesInFile classes() {
            if(_classes == null)
                _classes = katja.spec.model.Model.MClassesInFile(this, _term.classes(), 2);

            return _classes;
        }

        public katja.spec.model.MFileInFile replaceClasses(katja.spec.model.MClasses classes) {
            return replace(_term.replaceClasses(classes));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MFile term, int pos) {
            super(parent, term, pos);
        }

        Impl(katja.spec.model.MFile term) {
            super(term);
        }

        public katja.spec.model.Model.TermInFile<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 3;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Model.StringInFile(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_packageName == null)
                        _packageName = Model.StringInFile(this, _term.packageName(), 1);
                    
                    return _packageName;
                case 2:
                    if(_classes == null)
                        _classes = Model.MClassesInFile(this, _term.classes(), 2);
                    
                    return _classes;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MFileInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MFileInFile invoked with too large parameter "+i+", sort has only 3 components");
                    }
            }
        }

        public int size() {
            return 3;
        }

        public katja.spec.model.MFileInFile replace(katja.spec.model.MFile term) {
            return (katja.spec.model.MFileInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.SortInFile parent() {
            return (katja.spec.model.Model.SortInFile) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MFileInFile";
        }
    }
}

