package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MGenericTypeDef extends katja.spec.model.MTypeDef, KatjaTuple {

    //----- methods of MGenericTypeDef -----

    public katja.spec.model.MJavaType type();
    public katja.spec.model.MGenericTypeDef replaceType(katja.spec.model.MJavaType type);
    public katja.spec.model.MTypeVariables typeVars();
    public katja.spec.model.MGenericTypeDef replaceTypeVars(katja.spec.model.MTypeVariables typeVars);
    public KatjaTerm get(int i);
    public int size();
    public katja.spec.model.MGenericTypeDef replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDef.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MGenericTypeDef -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMTypeVariables(katja.spec.model.MTypeVariables term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitMTypeVariable(katja.spec.model.MTypeVariable term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMGenericTypeDef(katja.spec.model.MGenericTypeDef term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MGenericTypeDef.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MGenericTypeDef {

        //----- attributes of Impl -----

        private katja.spec.model.MJavaType _type = null;
        private katja.spec.model.MTypeVariables _typeVars = null;

        //----- methods of Impl -----

        public katja.spec.model.MJavaType type() {
            return _type;
        }

        public katja.spec.model.MGenericTypeDef replaceType(katja.spec.model.MJavaType type) {
            return replace(0, type);
        }

        public katja.spec.model.MTypeVariables typeVars() {
            return _typeVars;
        }

        public katja.spec.model.MGenericTypeDef replaceTypeVars(katja.spec.model.MTypeVariables typeVars) {
            return replace(1, typeVars);
        }

        Impl(katja.spec.model.MJavaType type, katja.spec.model.MTypeVariables typeVars) {
            if(type == null)
                throw new IllegalArgumentException("constructor of sort MGenericTypeDef invoked with null parameter type");
            if(typeVars == null)
                throw new IllegalArgumentException("constructor of sort MGenericTypeDef invoked with null parameter typeVars");

            this._type = type;
            this._typeVars = typeVars;
        }

        public KatjaTerm get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _type;
                case 1: return _typeVars;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MGenericTypeDef invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MGenericTypeDef invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MGenericTypeDef replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MGenericTypeDef invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort MGenericTypeDef invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MJavaType))
                throw new IllegalArgumentException("replace on sort MGenericTypeDef invoked with term of incorrect sort, MJavaType expected");
            if(pos == 1 && !(term instanceof katja.spec.model.MTypeVariables))
                throw new IllegalArgumentException("replace on sort MGenericTypeDef invoked with term of incorrect sort, MTypeVariables expected");

            return (katja.spec.model.MGenericTypeDef) Model.unique(new katja.spec.model.MGenericTypeDef.Impl(
                pos == 0 ? (katja.spec.model.MJavaType) term : _type,
                pos == 1 ? (katja.spec.model.MTypeVariables) term : _typeVars
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDef.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMGenericTypeDef(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MGenericTypeDef");
            builder.append("( ");
            _type.toJavaCode(builder);
            builder.append(", ");
            _typeVars.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MGenericTypeDef");
            builder.append("( ");
            _type.toString(builder);
            builder.append(", ");
            _typeVars.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MGenericTypeDef";
        }
    }
}

