package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MInnerType extends katja.spec.model.MNonGenericType, KatjaTuple {

    //----- methods of MInnerType -----

    public katja.spec.model.MNonGenericType outerClass();
    public katja.spec.model.MInnerType replaceOuterClass(katja.spec.model.MNonGenericType outerClass);
    public java.lang.String innerClass();
    public katja.spec.model.MInnerType replaceInnerClass(java.lang.String innerClass);
    public Object get(int i);
    public int size();
    public katja.spec.model.MInnerType replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MInnerType -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MInnerType.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MNonGenericType.Switch<Object, E> variantVisit$MNonGenericType = new katja.spec.model.MNonGenericType.Switch<Object, E>() { public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MNonGenericType);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MInnerType {

        //----- attributes of Impl -----

        private katja.spec.model.MNonGenericType _outerClass = null;
        private java.lang.String _innerClass = null;

        //----- methods of Impl -----

        public katja.spec.model.MNonGenericType outerClass() {
            return _outerClass;
        }

        public katja.spec.model.MInnerType replaceOuterClass(katja.spec.model.MNonGenericType outerClass) {
            return replace(0, outerClass);
        }

        public java.lang.String innerClass() {
            return _innerClass;
        }

        public katja.spec.model.MInnerType replaceInnerClass(java.lang.String innerClass) {
            return replace(1, innerClass);
        }

        Impl(katja.spec.model.MNonGenericType outerClass, java.lang.String innerClass) {
            if(outerClass == null)
                throw new IllegalArgumentException("constructor of sort MInnerType invoked with null parameter outerClass");
            if(innerClass == null)
                throw new IllegalArgumentException("constructor of sort MInnerType invoked with null parameter innerClass");

            this._outerClass = outerClass;
            this._innerClass = innerClass;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _outerClass;
                case 1: return _innerClass;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MInnerType invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MInnerType invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MInnerType replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MInnerType invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort MInnerType invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MNonGenericType))
                throw new IllegalArgumentException("replace on sort MInnerType invoked with term of incorrect sort, MNonGenericType expected");
            if(pos == 1 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MInnerType invoked with term of incorrect sort, String expected");

            return (katja.spec.model.MInnerType) Model.unique(new katja.spec.model.MInnerType.Impl(
                pos == 0 ? (katja.spec.model.MNonGenericType) term : _outerClass,
                pos == 1 ? (java.lang.String) term : _innerClass
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMInnerType(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MInnerType");
            builder.append("( ");
            _outerClass.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_innerClass.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MInnerType");
            builder.append("( ");
            _outerClass.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_innerClass.toString()).append("\"");
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MInnerType";
        }
    }
}

