package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MJavaType extends katja.spec.model.MNonGenericType, katja.spec.model.MTypeDef, KatjaTuple {

    //----- methods of MJavaType -----

    public java.lang.String name();
    public katja.spec.model.MJavaType replaceName(java.lang.String name);
    public katja.spec.model.Strings importNames();
    public katja.spec.model.MJavaType replaceImportNames(katja.spec.model.Strings importNames);
    public Object get(int i);
    public int size();
    public katja.spec.model.MJavaType replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDef.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MJavaType -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MJavaType.VisitorType<E> {
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MJavaType {

        //----- attributes of Impl -----

        private java.lang.String _name = null;
        private katja.spec.model.Strings _importNames = null;

        //----- methods of Impl -----

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.model.MJavaType replaceName(java.lang.String name) {
            return replace(0, name);
        }

        public katja.spec.model.Strings importNames() {
            return _importNames;
        }

        public katja.spec.model.MJavaType replaceImportNames(katja.spec.model.Strings importNames) {
            return replace(1, importNames);
        }

        Impl(java.lang.String name, katja.spec.model.Strings importNames) {
            if(name == null)
                throw new IllegalArgumentException("constructor of sort MJavaType invoked with null parameter name");
            if(importNames == null)
                throw new IllegalArgumentException("constructor of sort MJavaType invoked with null parameter importNames");

            this._name = name;
            this._importNames = importNames;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0: return _name;
                case 1: return _importNames;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MJavaType invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MJavaType invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MJavaType replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MJavaType invoked with negative parameter "+pos);
            if(pos >= 2)
                throw new IllegalArgumentException("replace on sort MJavaType invoked with too large parameter "+pos+", sort has only 2 components");

            if(pos == 0 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MJavaType invoked with term of incorrect sort, String expected");
            if(pos == 1 && !(term instanceof katja.spec.model.Strings))
                throw new IllegalArgumentException("replace on sort MJavaType invoked with term of incorrect sort, Strings expected");

            return (katja.spec.model.MJavaType) Model.unique(new katja.spec.model.MJavaType.Impl(
                pos == 0 ? (java.lang.String) term : _name,
                pos == 1 ? (katja.spec.model.Strings) term : _importNames
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDef.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaType(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MJavaType");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _importNames.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MJavaType");
            builder.append("( ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _importNames.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MJavaType";
        }
    }
}

