package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface MJavaTypeInFile extends katja.spec.model.MNonGenericTypeInFile, katja.spec.model.MTypeDefInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MJavaType> {

    //----- methods of MJavaTypeInFile -----

    public katja.spec.model.MJavaType termMNonGenericType();
    public katja.spec.model.MJavaType termMTypeDef();
    public katja.spec.model.MJavaType termMType();
    public katja.spec.model.MJavaType termMAnyType();
    public katja.spec.model.MJavaType termMTypeOrWildcard();
    public katja.spec.model.MJavaType termMParamtype();
    public katja.spec.model.MJavaType termMReturnType();
    public katja.spec.model.MJavaType termMParamtypeDecl();
    public katja.spec.model.MJavaType term();
    public katja.spec.model.StringInFile name();
    public katja.spec.model.MJavaTypeInFile replaceName(java.lang.String name);
    public katja.spec.model.StringsInFile importNames();
    public katja.spec.model.MJavaTypeInFile replaceImportNames(katja.spec.model.Strings importNames);
    public katja.spec.model.Model.TermInFile<?> get(int i);
    public int size();
    public katja.spec.model.MJavaTypeInFile replace(katja.spec.model.MJavaType term);
    public katja.spec.model.Model.NodeInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDefInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MJavaTypeInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MJavaTypeInFile.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MJavaType> implements katja.spec.model.MJavaTypeInFile {

        //----- attributes of Impl -----

        private katja.spec.model.StringInFile _name = null;
        private katja.spec.model.StringsInFile _importNames = null;

        //----- methods of Impl -----

        public katja.spec.model.MJavaType termMNonGenericType() {
            return term();
        }

        public katja.spec.model.MJavaType termMTypeDef() {
            return term();
        }

        public katja.spec.model.MJavaType termMType() {
            return term();
        }

        public katja.spec.model.MJavaType termMAnyType() {
            return term();
        }

        public katja.spec.model.MJavaType termMTypeOrWildcard() {
            return term();
        }

        public katja.spec.model.MJavaType termMParamtype() {
            return term();
        }

        public katja.spec.model.MJavaType termMReturnType() {
            return term();
        }

        public katja.spec.model.MJavaType termMParamtypeDecl() {
            return term();
        }

        public katja.spec.model.StringInFile name() {
            if(_name == null)
                _name = katja.spec.model.Model.StringInFile(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.model.MJavaTypeInFile replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.model.StringsInFile importNames() {
            if(_importNames == null)
                _importNames = katja.spec.model.Model.StringsInFile(this, _term.importNames(), 1);

            return _importNames;
        }

        public katja.spec.model.MJavaTypeInFile replaceImportNames(katja.spec.model.Strings importNames) {
            return replace(_term.replaceImportNames(importNames));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MJavaType term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.TermInFile<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Model.StringInFile(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_importNames == null)
                        _importNames = Model.StringsInFile(this, _term.importNames(), 1);
                    
                    return _importNames;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MJavaTypeInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MJavaTypeInFile invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.MJavaTypeInFile replace(katja.spec.model.MJavaType term) {
            return (katja.spec.model.MJavaTypeInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.NodeInFile<?> parent() {
            return (katja.spec.model.Model.NodeInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeDefInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnTypeInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDeclInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMJavaTypeInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MJavaTypeInFile";
        }
    }
}

