package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MKatjaType extends katja.spec.model.MNonGenericType, KatjaTuple {

    //----- methods of MKatjaType -----

    public katja.spec.descriptors.SortDescriptor sortDesc();
    public katja.spec.model.MKatjaType replaceSortDesc(katja.spec.descriptors.SortDescriptor sortDesc);
    public katja.spec.descriptors.SortDescriptor get(int i);
    public int size();
    public katja.spec.model.MKatjaType replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MKatjaType -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MKatjaType.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MKatjaType {

        //----- attributes of Impl -----

        private katja.spec.descriptors.SortDescriptor _sortDesc = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.SortDescriptor sortDesc() {
            return _sortDesc;
        }

        public katja.spec.model.MKatjaType replaceSortDesc(katja.spec.descriptors.SortDescriptor sortDesc) {
            return replace(0, sortDesc);
        }

        Impl(katja.spec.descriptors.SortDescriptor sortDesc) {
            if(sortDesc == null)
                throw new IllegalArgumentException("constructor of sort MKatjaType invoked with null parameter sortDesc");

            this._sortDesc = sortDesc;
        }

        public katja.spec.descriptors.SortDescriptor get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _sortDesc;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MKatjaType invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MKatjaType invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.model.MKatjaType replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MKatjaType invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort MKatjaType invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof katja.spec.descriptors.SortDescriptor))
                throw new IllegalArgumentException("replace on sort MKatjaType invoked with term of incorrect sort, SortDescriptor expected");

            return (katja.spec.model.MKatjaType) Model.unique(new katja.spec.model.MKatjaType.Impl(
                pos == 0 ? (katja.spec.descriptors.SortDescriptor) term : _sortDesc
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MNonGenericType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MAnyType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtype.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MReturnType.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MParamtypeDecl.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMKatjaType(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MKatjaType");
            builder.append("( ");
            _sortDesc.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MKatjaType");
            builder.append("( ");
            _sortDesc.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MKatjaType";
        }
    }
}

