package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MMethod extends KatjaTuple {

    //----- methods of MMethod -----

    public katja.spec.model.MModifiers modifiers();
    public katja.spec.model.MMethod replaceModifiers(katja.spec.model.MModifiers modifiers);
    public katja.spec.model.MTypeVariables generics();
    public katja.spec.model.MMethod replaceGenerics(katja.spec.model.MTypeVariables generics);
    public katja.spec.model.MReturnType returnType();
    public katja.spec.model.MMethod replaceReturnType(katja.spec.model.MReturnType returnType);
    public java.lang.String name();
    public katja.spec.model.MMethod replaceName(java.lang.String name);
    public katja.spec.model.MParameters parameter();
    public katja.spec.model.MMethod replaceParameter(katja.spec.model.MParameters parameter);
    public katja.spec.model.MTypes exceptions();
    public katja.spec.model.MMethod replaceExceptions(katja.spec.model.MTypes exceptions);
    public katja.spec.model.MCode body();
    public katja.spec.model.MMethod replaceBody(katja.spec.model.MCode body);
    public Object get(int i);
    public int size();
    public katja.spec.model.MMethod replace(int pos, Object term);

    //----- nested classes of MMethod -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMModifiers(katja.spec.model.MModifiers term) throws E;
        public void visitMTypeVariables(katja.spec.model.MTypeVariables term) throws E;
        public void visitMReturnType(katja.spec.model.MReturnType term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMParameters(katja.spec.model.MParameters term) throws E;
        public void visitMTypes(katja.spec.model.MTypes term) throws E;
        public void visitMCode(katja.spec.model.MCode term) throws E;
        public void visitMNone(katja.spec.model.MNone term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMModifier(katja.spec.model.MModifier term) throws E;
        public void visitMTypeVariable(katja.spec.model.MTypeVariable term) throws E;
        public void visitMParameter(katja.spec.model.MParameter term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitPROTECTED(katja.spec.model.PROTECTED term) throws E;
        public void visitPRIVATE(katja.spec.model.PRIVATE term) throws E;
        public void visitPUBLIC(katja.spec.model.PUBLIC term) throws E;
        public void visitSTATIC(katja.spec.model.STATIC term) throws E;
        public void visitABSTRACT(katja.spec.model.ABSTRACT term) throws E;
        public void visitFINAL(katja.spec.model.FINAL term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMParamtype(katja.spec.model.MParamtype term) throws E;
        public void visitMFinal(katja.spec.model.MFinal term) throws E;
        public void visitMVararg(katja.spec.model.MVararg term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMMethod(katja.spec.model.MMethod term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MMethod.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MModifier.Switch<Object, E> variantVisit$MModifier = new katja.spec.model.MModifier.Switch<Object, E>() { public final Object CasePROTECTED(katja.spec.model.PROTECTED term) throws E { visitPROTECTED(term); return null; } public final Object CasePRIVATE(katja.spec.model.PRIVATE term) throws E { visitPRIVATE(term); return null; } public final Object CasePUBLIC(katja.spec.model.PUBLIC term) throws E { visitPUBLIC(term); return null; } public final Object CaseSTATIC(katja.spec.model.STATIC term) throws E { visitSTATIC(term); return null; } public final Object CaseABSTRACT(katja.spec.model.ABSTRACT term) throws E { visitABSTRACT(term); return null; } public final Object CaseFINAL(katja.spec.model.FINAL term) throws E { visitFINAL(term); return null; } };
        private final katja.spec.model.MParamtypeDecl.Switch<Object, E> variantVisit$MParamtypeDecl = new katja.spec.model.MParamtypeDecl.Switch<Object, E>() { public final Object CaseMFinal(katja.spec.model.MFinal term) throws E { visitMFinal(term); return null; } public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MReturnType.Switch<Object, E> variantVisit$MReturnType = new katja.spec.model.MReturnType.Switch<Object, E>() { public final Object CaseMNone(katja.spec.model.MNone term) throws E { visitMNone(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMModifier(katja.spec.model.MModifier term) throws E {
            term.Switch(variantVisit$MModifier);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMParamtype(katja.spec.model.MParamtype term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMReturnType(katja.spec.model.MReturnType term) throws E {
            term.Switch(variantVisit$MReturnType);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MMethod {

        //----- attributes of Impl -----

        private katja.spec.model.MModifiers _modifiers = null;
        private katja.spec.model.MTypeVariables _generics = null;
        private katja.spec.model.MReturnType _returnType = null;
        private java.lang.String _name = null;
        private katja.spec.model.MParameters _parameter = null;
        private katja.spec.model.MTypes _exceptions = null;
        private katja.spec.model.MCode _body = null;

        //----- methods of Impl -----

        public katja.spec.model.MModifiers modifiers() {
            return _modifiers;
        }

        public katja.spec.model.MMethod replaceModifiers(katja.spec.model.MModifiers modifiers) {
            return replace(0, modifiers);
        }

        public katja.spec.model.MTypeVariables generics() {
            return _generics;
        }

        public katja.spec.model.MMethod replaceGenerics(katja.spec.model.MTypeVariables generics) {
            return replace(1, generics);
        }

        public katja.spec.model.MReturnType returnType() {
            return _returnType;
        }

        public katja.spec.model.MMethod replaceReturnType(katja.spec.model.MReturnType returnType) {
            return replace(2, returnType);
        }

        public java.lang.String name() {
            return _name;
        }

        public katja.spec.model.MMethod replaceName(java.lang.String name) {
            return replace(3, name);
        }

        public katja.spec.model.MParameters parameter() {
            return _parameter;
        }

        public katja.spec.model.MMethod replaceParameter(katja.spec.model.MParameters parameter) {
            return replace(4, parameter);
        }

        public katja.spec.model.MTypes exceptions() {
            return _exceptions;
        }

        public katja.spec.model.MMethod replaceExceptions(katja.spec.model.MTypes exceptions) {
            return replace(5, exceptions);
        }

        public katja.spec.model.MCode body() {
            return _body;
        }

        public katja.spec.model.MMethod replaceBody(katja.spec.model.MCode body) {
            return replace(6, body);
        }

        Impl(katja.spec.model.MModifiers modifiers, katja.spec.model.MTypeVariables generics, katja.spec.model.MReturnType returnType, java.lang.String name, katja.spec.model.MParameters parameter, katja.spec.model.MTypes exceptions, katja.spec.model.MCode body) {
            if(modifiers == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter modifiers");
            if(generics == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter generics");
            if(returnType == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter returnType");
            if(name == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter name");
            if(parameter == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter parameter");
            if(exceptions == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter exceptions");
            if(body == null)
                throw new IllegalArgumentException("constructor of sort MMethod invoked with null parameter body");

            this._modifiers = modifiers;
            this._generics = generics;
            this._returnType = returnType;
            this._name = name;
            this._parameter = parameter;
            this._exceptions = exceptions;
            this._body = body;
        }

        public Object get(int i) {
            int ith = i;

            if(ith < 0) ith += 7;

            switch(ith) {
                case 0: return _modifiers;
                case 1: return _generics;
                case 2: return _returnType;
                case 3: return _name;
                case 4: return _parameter;
                case 5: return _exceptions;
                case 6: return _body;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MMethod invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MMethod invoked with too large parameter "+i+", sort has only 7 components");
                    }
            }
        }

        public int size() {
            return 7;
        }

        public katja.spec.model.MMethod replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MMethod invoked with negative parameter "+pos);
            if(pos >= 7)
                throw new IllegalArgumentException("replace on sort MMethod invoked with too large parameter "+pos+", sort has only 7 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MModifiers))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MModifiers expected");
            if(pos == 1 && !(term instanceof katja.spec.model.MTypeVariables))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MTypeVariables expected");
            if(pos == 2 && !(term instanceof katja.spec.model.MReturnType))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MReturnType expected");
            if(pos == 3 && !(term instanceof java.lang.String))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, String expected");
            if(pos == 4 && !(term instanceof katja.spec.model.MParameters))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MParameters expected");
            if(pos == 5 && !(term instanceof katja.spec.model.MTypes))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MTypes expected");
            if(pos == 6 && !(term instanceof katja.spec.model.MCode))
                throw new IllegalArgumentException("replace on sort MMethod invoked with term of incorrect sort, MCode expected");

            return (katja.spec.model.MMethod) Model.unique(new katja.spec.model.MMethod.Impl(
                pos == 0 ? (katja.spec.model.MModifiers) term : _modifiers,
                pos == 1 ? (katja.spec.model.MTypeVariables) term : _generics,
                pos == 2 ? (katja.spec.model.MReturnType) term : _returnType,
                pos == 3 ? (java.lang.String) term : _name,
                pos == 4 ? (katja.spec.model.MParameters) term : _parameter,
                pos == 5 ? (katja.spec.model.MTypes) term : _exceptions,
                pos == 6 ? (katja.spec.model.MCode) term : _body
            ));
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MMethod");
            builder.append("( ");
            _modifiers.toJavaCode(builder);
            builder.append(", ");
            _generics.toJavaCode(builder);
            builder.append(", ");
            _returnType.toJavaCode(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _parameter.toJavaCode(builder);
            builder.append(", ");
            _exceptions.toJavaCode(builder);
            builder.append(", ");
            _body.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MMethod");
            builder.append("( ");
            _modifiers.toString(builder);
            builder.append(", ");
            _generics.toString(builder);
            builder.append(", ");
            _returnType.toString(builder);
            builder.append(", ");
            builder.append("\"").append(_name.toString()).append("\"");
            builder.append(", ");
            _parameter.toString(builder);
            builder.append(", ");
            _exceptions.toString(builder);
            builder.append(", ");
            _body.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MMethod";
        }
    }
}

