package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MMethodsInFile extends katja.spec.model.Model.ListInFile<katja.spec.model.MMethods, katja.spec.model.MMethodInFile, katja.spec.model.MMethod> {

    //----- methods of MMethodsInFile -----

    public katja.spec.model.MMethods term();
    public katja.spec.model.MMethodsInFile add(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile addAll(KatjaList<? extends katja.spec.model.MMethod> list);
    public katja.spec.model.MMethodsInFile remove(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile removeAll(KatjaList<? extends katja.spec.model.MMethod> list);
    public katja.spec.model.MMethodsInFile appBack(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile appFront(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile conc(KatjaList<? extends katja.spec.model.MMethod> list);
    public katja.spec.model.MMethodsInFile reverse();
    public katja.spec.model.MMethodsInFile toSet();
    public katja.spec.model.MMethodsInFile setAdd(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile setRemove(katja.spec.model.MMethod element);
    public katja.spec.model.MMethodsInFile setUnion(KatjaList<? extends katja.spec.model.MMethod> list);
    public katja.spec.model.MMethodsInFile setWithout(KatjaList<? extends katja.spec.model.MMethod> list);
    public katja.spec.model.MMethodsInFile setIntersection(KatjaList<? extends katja.spec.model.MMethod> list);
    public KatjaList<katja.spec.model.MMethodInFile> toList();
    public katja.spec.model.MMethodsInFile replace(katja.spec.model.MMethods term);
    public katja.spec.model.MClassInFile parent();
    public katja.spec.model.MAttributesInFile lsib();
    public katja.spec.model.MClassesInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of MMethodsInFile -----

    static class ListImpl extends KatjaListImpl<katja.spec.model.MMethodInFile> implements KatjaList<katja.spec.model.MMethodInFile> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.model.MMethodInFile... elements) {
            super(elements);

            for(katja.spec.model.MMethodInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MMethodInFile invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.model.MMethodInFile> createInstance(katja.spec.model.MMethodInFile[] elements, boolean isSet) {
            for(katja.spec.model.MMethodInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort MMethodInFile invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MMethodInFile[] createArray(int size) {
            return new katja.spec.model.MMethodInFile[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.model.MMethodInFile element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMMethodInFile(katja.spec.model.MMethodInFile term) throws E;
        public void visitMModifiersInFile(katja.spec.model.MModifiersInFile term) throws E;
        public void visitMTypeVariablesInFile(katja.spec.model.MTypeVariablesInFile term) throws E;
        public void visitMReturnTypeInFile(katja.spec.model.MReturnTypeInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitMParametersInFile(katja.spec.model.MParametersInFile term) throws E;
        public void visitMTypesInFile(katja.spec.model.MTypesInFile term) throws E;
        public void visitMCodeInFile(katja.spec.model.MCodeInFile term) throws E;
        public void visitMNoneInFile(katja.spec.model.MNoneInFile term) throws E;
        public void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E;
        public void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E;
        public void visitMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E;
        public void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E;
        public void visitMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E;
        public void visitMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E;
        public void visitMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E;
        public void visitMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E;
        public void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E;
        public void visitMTypeVariableInFile(katja.spec.model.MTypeVariableInFile term) throws E;
        public void visitMParameterInFile(katja.spec.model.MParameterInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
        public void visitMTypeOrWildcardsInFile(katja.spec.model.MTypeOrWildcardsInFile term) throws E;
        public void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E;
        public void visitPROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E;
        public void visitPRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E;
        public void visitPUBLICInFile(katja.spec.model.PUBLICInFile term) throws E;
        public void visitSTATICInFile(katja.spec.model.STATICInFile term) throws E;
        public void visitABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E;
        public void visitFINALInFile(katja.spec.model.FINALInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitMParamtypeDeclInFile(katja.spec.model.MParamtypeDeclInFile term) throws E;
        public void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitMParamtypeInFile(katja.spec.model.MParamtypeInFile term) throws E;
        public void visitMFinalInFile(katja.spec.model.MFinalInFile term) throws E;
        public void visitMVarargInFile(katja.spec.model.MVarargInFile term) throws E;
        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
        public void visitMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E;
        public void visitMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E;
        public void visitMMethodsInFile(katja.spec.model.MMethodsInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MMethodsInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyTypeInFile.Switch<Object, E> variantVisit$MAnyTypeInFile = new katja.spec.model.MAnyTypeInFile.Switch<Object, E>() { public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MModifierInFile.Switch<Object, E> variantVisit$MModifierInFile = new katja.spec.model.MModifierInFile.Switch<Object, E>() { public final Object CasePROTECTEDInFile(katja.spec.model.PROTECTEDInFile term) throws E { visitPROTECTEDInFile(term); return null; } public final Object CasePRIVATEInFile(katja.spec.model.PRIVATEInFile term) throws E { visitPRIVATEInFile(term); return null; } public final Object CasePUBLICInFile(katja.spec.model.PUBLICInFile term) throws E { visitPUBLICInFile(term); return null; } public final Object CaseSTATICInFile(katja.spec.model.STATICInFile term) throws E { visitSTATICInFile(term); return null; } public final Object CaseABSTRACTInFile(katja.spec.model.ABSTRACTInFile term) throws E { visitABSTRACTInFile(term); return null; } public final Object CaseFINALInFile(katja.spec.model.FINALInFile term) throws E { visitFINALInFile(term); return null; } };
        private final katja.spec.model.MParamtypeDeclInFile.Switch<Object, E> variantVisit$MParamtypeDeclInFile = new katja.spec.model.MParamtypeDeclInFile.Switch<Object, E>() { public final Object CaseMFinalInFile(katja.spec.model.MFinalInFile term) throws E { visitMFinalInFile(term); return null; } public final Object CaseMVarargInFile(katja.spec.model.MVarargInFile term) throws E { visitMVarargInFile(term); return null; } public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MReturnTypeInFile.Switch<Object, E> variantVisit$MReturnTypeInFile = new katja.spec.model.MReturnTypeInFile.Switch<Object, E>() { public final Object CaseMNoneInFile(katja.spec.model.MNoneInFile term) throws E { visitMNoneInFile(term); return null; } public final Object CaseMArrayTypeInFile(katja.spec.model.MArrayTypeInFile term) throws E { visitMArrayTypeInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E> variantVisit$MTypeOrWildcardInFile = new katja.spec.model.MTypeOrWildcardInFile.Switch<Object, E>() { public final Object CaseMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E { visitMWildcardInFile(term); return null; } public final Object CaseMWildcardLBInFile(katja.spec.model.MWildcardLBInFile term) throws E { visitMWildcardLBInFile(term); return null; } public final Object CaseMWildcardUBInFile(katja.spec.model.MWildcardUBInFile term) throws E { visitMWildcardUBInFile(term); return null; } public final Object CaseMGenericTypeAppInFile(katja.spec.model.MGenericTypeAppInFile term) throws E { visitMGenericTypeAppInFile(term); return null; } public final Object CaseMJavaTypeInFile(katja.spec.model.MJavaTypeInFile term) throws E { visitMJavaTypeInFile(term); return null; } public final Object CaseMKatjaTypeInFile(katja.spec.model.MKatjaTypeInFile term) throws E { visitMKatjaTypeInFile(term); return null; } public final Object CaseMInnerTypeInFile(katja.spec.model.MInnerTypeInFile term) throws E { visitMInnerTypeInFile(term); return null; } };
        private final katja.spec.model.SortDescriptorInFile.Switch<Object, E> variantVisit$SortDescriptorInFile = new katja.spec.model.SortDescriptorInFile.Switch<Object, E>() { public final Object CasePosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E { visitPosSortDescriptorInFile(term); return null; } public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyTypeInFile(katja.spec.model.MAnyTypeInFile term) throws E {
            term.Switch(variantVisit$MParamtypeDeclInFile);
        }

        public final void visitMModifierInFile(katja.spec.model.MModifierInFile term) throws E {
            term.Switch(variantVisit$MModifierInFile);
        }

        public final void visitMNonGenericTypeInFile(katja.spec.model.MNonGenericTypeInFile term) throws E {
            term.Switch(variantVisit$MAnyTypeInFile);
        }

        public final void visitMParamtypeDeclInFile(katja.spec.model.MParamtypeDeclInFile term) throws E {
            term.Switch(variantVisit$MParamtypeDeclInFile);
        }

        public final void visitMParamtypeInFile(katja.spec.model.MParamtypeInFile term) throws E {
            term.Switch(variantVisit$MParamtypeDeclInFile);
        }

        public final void visitMReturnTypeInFile(katja.spec.model.MReturnTypeInFile term) throws E {
            term.Switch(variantVisit$MReturnTypeInFile);
        }

        public final void visitMTypeInFile(katja.spec.model.MTypeInFile term) throws E {
            term.Switch(variantVisit$MAnyTypeInFile);
        }

        public final void visitMTypeOrWildcardInFile(katja.spec.model.MTypeOrWildcardInFile term) throws E {
            term.Switch(variantVisit$MTypeOrWildcardInFile);
        }

        public final void visitSortDescriptorInFile(katja.spec.model.SortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$SortDescriptorInFile);
        }
    }

    static class Impl extends KatjaListPosImpl<katja.spec.model.MFileInFile, katja.spec.model.MMethods, katja.spec.model.MMethodInFile, katja.spec.model.MMethod> implements katja.spec.model.MMethodsInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MMethods term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.MMethodInFile getElementInstance(int pos) {
            return katja.spec.model.Model.MMethodInFile(this, _term.get(pos), pos);
        }

        protected katja.spec.model.MMethodInFile[] createArray(int size) {
            return new katja.spec.model.MMethodInFile[size];
        }

        public katja.spec.model.MMethodsInFile add(katja.spec.model.MMethod element) {
            return replace(_term.add(element));
        }

        public katja.spec.model.MMethodsInFile addAll(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.model.MMethodsInFile remove(katja.spec.model.MMethod element) {
            return replace(_term.remove(element));
        }

        public katja.spec.model.MMethodsInFile removeAll(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.model.MMethodsInFile appBack(katja.spec.model.MMethod element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.model.MMethodsInFile appFront(katja.spec.model.MMethod element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.model.MMethodsInFile conc(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.model.MMethodsInFile reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.model.MMethodsInFile toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.model.MMethodsInFile setAdd(katja.spec.model.MMethod element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.model.MMethodsInFile setRemove(katja.spec.model.MMethod element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.model.MMethodsInFile setUnion(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.model.MMethodsInFile setWithout(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.model.MMethodsInFile setIntersection(KatjaList<? extends katja.spec.model.MMethod> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.model.MMethodInFile> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new MMethodsInFile.ListImpl(values);
        }

        public katja.spec.model.MMethodsInFile replace(katja.spec.model.MMethods term) {
            return (katja.spec.model.MMethodsInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MClassInFile parent() {
            return (katja.spec.model.MClassInFile) super.parent();
        }

        public katja.spec.model.MAttributesInFile lsib() {
            return (katja.spec.model.MAttributesInFile) super.lsib();
        }

        public katja.spec.model.MClassesInFile rsib() {
            return (katja.spec.model.MClassesInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MMethodsInFile";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.model.MMethodInFile> implements KatjaList<katja.spec.model.MMethodInFile> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.model.MMethodInFile... elements) {
                super(elements);

                for(katja.spec.model.MMethodInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MMethodInFile invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.model.MMethodInFile> createInstance(katja.spec.model.MMethodInFile[] elements, boolean isSet) {
                for(katja.spec.model.MMethodInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort MMethodInFile invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Model.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.model.MMethodInFile[] createArray(int size) {
                return new katja.spec.model.MMethodInFile[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.model.MMethodInFile element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

