package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MParameters extends KatjaList<katja.spec.model.MParameter> {

    //----- methods of MParameters -----

    public katja.spec.model.MParameters add(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters addAll(KatjaList<? extends katja.spec.model.MParameter> list);
    public katja.spec.model.MParameters remove(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters removeAll(KatjaList<? extends katja.spec.model.MParameter> list);
    public katja.spec.model.MParameters appBack(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters appFront(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters conc(KatjaList<? extends katja.spec.model.MParameter> list);
    public katja.spec.model.MParameters front();
    public katja.spec.model.MParameters back();
    public katja.spec.model.MParameters reverse();
    public katja.spec.model.MParameters sublist(int from, int to);
    public katja.spec.model.MParameters replace(int ith, Object element);
    public katja.spec.model.MParameters toSet();
    public katja.spec.model.MParameters setAdd(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters setRemove(katja.spec.model.MParameter element);
    public katja.spec.model.MParameters setUnion(KatjaList<? extends katja.spec.model.MParameter> list);
    public katja.spec.model.MParameters setIntersection(KatjaList<? extends katja.spec.model.MParameter> list);
    public katja.spec.model.MParameters setWithout(KatjaList<? extends katja.spec.model.MParameter> list);

    //----- nested classes of MParameters -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMParameter(katja.spec.model.MParameter term) throws E;
        public void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitMParamtype(katja.spec.model.MParamtype term) throws E;
        public void visitMFinal(katja.spec.model.MFinal term) throws E;
        public void visitMVararg(katja.spec.model.MVararg term) throws E;
        public void visitMAnyType(katja.spec.model.MAnyType term) throws E;
        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMArrayType(katja.spec.model.MArrayType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
        public void visitMParameters(katja.spec.model.MParameters term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MParameters.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MAnyType.Switch<Object, E> variantVisit$MAnyType = new katja.spec.model.MAnyType.Switch<Object, E>() { public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtype.Switch<Object, E> variantVisit$MParamtype = new katja.spec.model.MParamtype.Switch<Object, E>() { public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MParamtypeDecl.Switch<Object, E> variantVisit$MParamtypeDecl = new katja.spec.model.MParamtypeDecl.Switch<Object, E>() { public final Object CaseMFinal(katja.spec.model.MFinal term) throws E { visitMFinal(term); return null; } public final Object CaseMVararg(katja.spec.model.MVararg term) throws E { visitMVararg(term); return null; } public final Object CaseMArrayType(katja.spec.model.MArrayType term) throws E { visitMArrayType(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMAnyType(katja.spec.model.MAnyType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMParamtype(katja.spec.model.MParamtype term) throws E {
            term.Switch(variantVisit$MParamtype);
        }

        public final void visitMParamtypeDecl(katja.spec.model.MParamtypeDecl term) throws E {
            term.Switch(variantVisit$MParamtypeDecl);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MAnyType);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaListImpl<katja.spec.model.MParameter> implements katja.spec.model.MParameters {

        //----- methods of Impl -----

        Impl(katja.spec.model.MParameter... elements) {
            super(elements);

            for(katja.spec.model.MParameter element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MParameters invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.MParameters createInstance(katja.spec.model.MParameter[] elements, boolean isSet) {
            for(katja.spec.model.MParameter element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort MParameters invoked with null element");

            MParameters.Impl temp = new katja.spec.model.MParameters.Impl();
            temp.values = elements;
            temp = (MParameters.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.MParameter[] createArray(int size) {
            return new katja.spec.model.MParameter[size];
        }

        public katja.spec.model.MParameters add(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.add(element);
        }

        public katja.spec.model.MParameters addAll(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.addAll(list);
        }

        public katja.spec.model.MParameters remove(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.remove(element);
        }

        public katja.spec.model.MParameters removeAll(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.removeAll(list);
        }

        public katja.spec.model.MParameters appBack(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.appBack(element);
        }

        public katja.spec.model.MParameters appFront(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.appFront(element);
        }

        public katja.spec.model.MParameters conc(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.conc(list);
        }

        public katja.spec.model.MParameters front() {
            return (katja.spec.model.MParameters) super.front();
        }

        public katja.spec.model.MParameters back() {
            return (katja.spec.model.MParameters) super.back();
        }

        public katja.spec.model.MParameters reverse() {
            return (katja.spec.model.MParameters) super.reverse();
        }

        public katja.spec.model.MParameters sublist(int from, int to) {
            return (katja.spec.model.MParameters) super.sublist(from, to);
        }

        public katja.spec.model.MParameters replace(int ith, Object element) {
            return (katja.spec.model.MParameters) super.replace(ith, element);
        }

        public katja.spec.model.MParameters toSet() {
            return (katja.spec.model.MParameters) super.toSet();
        }

        public katja.spec.model.MParameters setAdd(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.setAdd(element);
        }

        public katja.spec.model.MParameters setRemove(katja.spec.model.MParameter element) {
            return (katja.spec.model.MParameters) super.setRemove(element);
        }

        public katja.spec.model.MParameters setUnion(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.setUnion(list);
        }

        public katja.spec.model.MParameters setIntersection(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.setIntersection(list);
        }

        public katja.spec.model.MParameters setWithout(KatjaList<? extends katja.spec.model.MParameter> list) {
            return (katja.spec.model.MParameters) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.MParameters");
            builder.append("( ");
            for(katja.spec.model.MParameter element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toJavaCode(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("MParameters");
            builder.append("( ");
            for(katja.spec.model.MParameter element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MParameters";
        }
    }
}

