package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface MWildcardInFile extends katja.spec.model.MTypeOrWildcardInFile, katja.spec.model.Model.TupleInFile<katja.spec.model.MWildcard> {

    //----- methods of MWildcardInFile -----

    public katja.spec.model.MWildcard termMTypeOrWildcard();
    public katja.spec.model.MWildcard term();
    public KatjaSortPos<katja.spec.model.MFileInFile> get(int i);
    public int size();
    public katja.spec.model.MWildcardInFile replace(katja.spec.model.MWildcard term);
    public katja.spec.model.MTypeOrWildcardsInFile parent();
    public katja.spec.model.MTypeOrWildcardInFile lsib();
    public katja.spec.model.MTypeOrWildcardInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MWildcardInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMWildcardInFile(katja.spec.model.MWildcardInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MWildcardInFile.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.model.MWildcard> implements katja.spec.model.MWildcardInFile {

        //----- methods of Impl -----

        public katja.spec.model.MWildcard termMTypeOrWildcard() {
            return term();
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.MWildcard term, int pos) {
            super(parent, term, pos);
        }

        public KatjaSortPos<katja.spec.model.MFileInFile> get(int i) {
            int ith = i;

            if(ith < 0) ith += 0;

            switch(ith) {
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MWildcardInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MWildcardInFile invoked with too large parameter "+i+", sort has only 0 components");
                    }
            }
        }

        public int size() {
            return 0;
        }

        public katja.spec.model.MWildcardInFile replace(katja.spec.model.MWildcard term) {
            return (katja.spec.model.MWildcardInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MTypeOrWildcardsInFile parent() {
            return (katja.spec.model.MTypeOrWildcardsInFile) super.parent();
        }

        public katja.spec.model.MTypeOrWildcardInFile lsib() {
            return (katja.spec.model.MTypeOrWildcardInFile) super.lsib();
        }

        public katja.spec.model.MTypeOrWildcardInFile rsib() {
            return (katja.spec.model.MTypeOrWildcardInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcardInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMWildcardInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "MWildcardInFile";
        }
    }
}

