package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface MWildcardLB extends katja.spec.model.MTypeOrWildcard, KatjaTuple {

    //----- methods of MWildcardLB -----

    public katja.spec.model.MType bound();
    public katja.spec.model.MWildcardLB replaceBound(katja.spec.model.MType bound);
    public katja.spec.model.MType get(int i);
    public int size();
    public katja.spec.model.MWildcardLB replace(int pos, Object term);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E;

    //----- nested classes of MWildcardLB -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitMType(katja.spec.model.MType term) throws E;
        public void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E;
        public void visitMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E;
        public void visitMJavaType(katja.spec.model.MJavaType term) throws E;
        public void visitMKatjaType(katja.spec.model.MKatjaType term) throws E;
        public void visitMInnerType(katja.spec.model.MInnerType term) throws E;
        public void visitMTypeOrWildcards(katja.spec.model.MTypeOrWildcards term) throws E;
        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
        public void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E;
        public void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E;
        public void visitPosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E;
        public void visitTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E;
        public void visitListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E;
        public void visitVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E;
        public void visitExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E;
        public void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E;
        public void visitInteger(java.lang.Integer term) throws E;
        public void visitBoolean(java.lang.Boolean term) throws E;
        public void visitPosStructDescriptor(katja.spec.descriptors.PosStructDescriptor term) throws E;
        public void visitMWildcard(katja.spec.model.MWildcard term) throws E;
        public void visitMWildcardLB(katja.spec.model.MWildcardLB term) throws E;
        public void visitMWildcardUB(katja.spec.model.MWildcardUB term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.MWildcardLB.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.MTypeOrWildcard.Switch<Object, E> variantVisit$MTypeOrWildcard = new katja.spec.model.MTypeOrWildcard.Switch<Object, E>() { public final Object CaseMWildcard(katja.spec.model.MWildcard term) throws E { visitMWildcard(term); return null; } public final Object CaseMWildcardLB(katja.spec.model.MWildcardLB term) throws E { visitMWildcardLB(term); return null; } public final Object CaseMWildcardUB(katja.spec.model.MWildcardUB term) throws E { visitMWildcardUB(term); return null; } public final Object CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) throws E { visitMGenericTypeApp(term); return null; } public final Object CaseMJavaType(katja.spec.model.MJavaType term) throws E { visitMJavaType(term); return null; } public final Object CaseMKatjaType(katja.spec.model.MKatjaType term) throws E { visitMKatjaType(term); return null; } public final Object CaseMInnerType(katja.spec.model.MInnerType term) throws E { visitMInnerType(term); return null; } };
        private final katja.spec.descriptors.SortDescriptor.Switch<Object, E> variantVisit$SortDescriptor = new katja.spec.descriptors.SortDescriptor.Switch<Object, E>() { public final Object CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) throws E { visitPosSortDescriptor(term); return null; } public final Object CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) throws E { visitTupleTermSortDescriptor(term); return null; } public final Object CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) throws E { visitListTermSortDescriptor(term); return null; } public final Object CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) throws E { visitVariantTermSortDescriptor(term); return null; } public final Object CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) throws E { visitExternTermSortDescriptor(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitMNonGenericType(katja.spec.model.MNonGenericType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMType(katja.spec.model.MType term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitMTypeOrWildcard(katja.spec.model.MTypeOrWildcard term) throws E {
            term.Switch(variantVisit$MTypeOrWildcard);
        }

        public final void visitSortDescriptor(katja.spec.descriptors.SortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }

        public final void visitTermSortDescriptor(katja.spec.descriptors.TermSortDescriptor term) throws E {
            term.Switch(variantVisit$SortDescriptor);
        }
    }

    static class Impl extends KatjaTupleImpl implements katja.spec.model.MWildcardLB {

        //----- attributes of Impl -----

        private katja.spec.model.MType _bound = null;

        //----- methods of Impl -----

        public katja.spec.model.MType bound() {
            return _bound;
        }

        public katja.spec.model.MWildcardLB replaceBound(katja.spec.model.MType bound) {
            return replace(0, bound);
        }

        Impl(katja.spec.model.MType bound) {
            if(bound == null)
                throw new IllegalArgumentException("constructor of sort MWildcardLB invoked with null parameter bound");

            this._bound = bound;
        }

        public katja.spec.model.MType get(int i) {
            int ith = i;

            if(ith < 0) ith += 1;

            switch(ith) {
                case 0: return _bound;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort MWildcardLB invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort MWildcardLB invoked with too large parameter "+i+", sort has only 1 components");
                    }
            }
        }

        public int size() {
            return 1;
        }

        public katja.spec.model.MWildcardLB replace(int pos, Object term) {
            if(pos < 0)
                throw new IllegalArgumentException("replace on sort MWildcardLB invoked with negative parameter "+pos);
            if(pos >= 1)
                throw new IllegalArgumentException("replace on sort MWildcardLB invoked with too large parameter "+pos+", sort has only 1 components");

            if(pos == 0 && !(term instanceof katja.spec.model.MType))
                throw new IllegalArgumentException("replace on sort MWildcardLB invoked with term of incorrect sort, MType expected");

            return (katja.spec.model.MWildcardLB) Model.unique(new katja.spec.model.MWildcardLB.Impl(
                pos == 0 ? (katja.spec.model.MType) term : _bound
            ));
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.MTypeOrWildcard.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseMWildcardLB(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MWildcardLB");
            builder.append("( ");
            _bound.toJavaCode(builder);
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("MWildcardLB");
            builder.append("( ");
            _bound.toString(builder);
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "MWildcardLB";
        }
    }
}

