package katja.spec.model;

import katja.common.*;
import java.util.*;
import java.io.Reader;
import java.io.IOException;
import java.util.List;
import java.util.TreeMap;

public class Model extends KatjaSpecification {

    //----- attributes of Model -----

    private static final Map<katja.spec.model.MFile, katja.spec.model.MFileInFile> _InFilecache = new TreeMap<katja.spec.model.MFile, katja.spec.model.MFileInFile>();
    private static final Model$Creator _Model$Creator = new Model$Creator();

    //----- methods of Model -----

    static final KatjaTerm unique(KatjaTerm term) {
        if(_termcache.containsKey(term)) return _termcache.get(term);
        _termcache.put(term, term);

        return term;
    }

    public static final katja.spec.model.ABSTRACT ABSTRACT() {
        katja.spec.model.ABSTRACT _temp = new katja.spec.model.ABSTRACT.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.ABSTRACT) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.ABSTRACTInFile ABSTRACTInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.ABSTRACT term, final int pos) {
        return new katja.spec.model.ABSTRACTInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.BooleanInFile BooleanInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final java.lang.Boolean term, final int pos) {
        return new katja.spec.model.BooleanInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.CLASS CLASS() {
        katja.spec.model.CLASS _temp = new katja.spec.model.CLASS.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.CLASS) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.CLASSInFile CLASSInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.CLASS term, final int pos) {
        return new katja.spec.model.CLASSInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.ExternTermSortDescriptorInFile ExternTermSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.ExternTermSortDescriptor term, final int pos) {
        return new katja.spec.model.ExternTermSortDescriptorInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.FINAL FINAL() {
        katja.spec.model.FINAL _temp = new katja.spec.model.FINAL.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.FINAL) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.FINALInFile FINALInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.FINAL term, final int pos) {
        return new katja.spec.model.FINALInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.INTERFACE INTERFACE() {
        katja.spec.model.INTERFACE _temp = new katja.spec.model.INTERFACE.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.INTERFACE) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.INTERFACEInFile INTERFACEInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.INTERFACE term, final int pos) {
        return new katja.spec.model.INTERFACEInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.IntegerInFile IntegerInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final java.lang.Integer term, final int pos) {
        return new katja.spec.model.IntegerInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.ListTermSortDescriptorInFile ListTermSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.ListTermSortDescriptor term, final int pos) {
        return new katja.spec.model.ListTermSortDescriptorInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MAnyTypeInFile MAnyTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MAnyType term, final int pos) {
        return term.Switch(new katja.spec.model.MAnyType.Switch<katja.spec.model.MAnyTypeInFile, RuntimeException>() { public final katja.spec.model.MAnyTypeInFile CaseMArrayType(katja.spec.model.MArrayType term) { return new katja.spec.model.MArrayTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MAnyTypeInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MAnyTypeInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MAnyTypeInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MAnyTypeInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    public static final katja.spec.model.MAnyTypes MAnyTypes(katja.spec.model.MAnyType... elements) {
        katja.spec.model.MAnyTypes _temp = new katja.spec.model.MAnyTypes.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MAnyTypes) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MArrayType MArrayType(katja.spec.model.MAnyType type) {
        katja.spec.model.MArrayType _temp = new katja.spec.model.MArrayType.Impl(type);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MArrayType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MArrayTypeInFile MArrayTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MArrayType term, final int pos) {
        return new katja.spec.model.MArrayTypeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MAttribute MAttribute(katja.spec.model.MModifiers modifiers, katja.spec.model.MAnyType type, java.lang.String name, katja.spec.model.MCodeFragment initial) {
        katja.spec.model.MAttribute _temp = new katja.spec.model.MAttribute.Impl(modifiers, type, name, initial);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MAttribute) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MAttributeInFile MAttributeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MAttribute term, final int pos) {
        return new katja.spec.model.MAttributeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MAttributes MAttributes(katja.spec.model.MAttribute... elements) {
        katja.spec.model.MAttributes _temp = new katja.spec.model.MAttributes.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MAttributes) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MAttributesInFile MAttributesInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MAttributes term, final int pos) {
        return new katja.spec.model.MAttributesInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MClass MClass(katja.spec.model.MModifiers modifiers, katja.spec.model.MClassType type, katja.spec.model.MTypeDef name, katja.spec.model.MTypes extend, katja.spec.model.MTypes implement, katja.spec.model.MAttributes attributes, katja.spec.model.MMethods methods, katja.spec.model.MClasses nested) {
        katja.spec.model.MClass _temp = new katja.spec.model.MClass.Impl(modifiers, type, name, extend, implement, attributes, methods, nested);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MClass) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MClass MClass(katja.spec.model.MModifiers modifiers, katja.spec.model.MClassType type, katja.spec.model.MTypeDef name, katja.spec.model.MTypes extend, katja.spec.model.MTypes implement, katja.spec.model.MAttributes attributes, katja.spec.model.MMethods methods, katja.spec.model.MClass... nested) {
        katja.spec.model.MClasses _list = katja.spec.model.Model.MClasses(nested);
        katja.spec.model.MClass _temp = new katja.spec.model.MClass.Impl(modifiers, type, name, extend, implement, attributes, methods, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MClass) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MClassInFile MClassInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MClass term, final int pos) {
        return new katja.spec.model.MClassInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MClassTypeInFile MClassTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MClassType term, final int pos) {
        return term.Switch(new katja.spec.model.MClassType.Switch<katja.spec.model.MClassTypeInFile, RuntimeException>() { public final katja.spec.model.MClassTypeInFile CaseINTERFACE(katja.spec.model.INTERFACE term) { return new katja.spec.model.INTERFACEInFile.Impl(parent, term, pos); } public final katja.spec.model.MClassTypeInFile CaseCLASS(katja.spec.model.CLASS term) { return new katja.spec.model.CLASSInFile.Impl(parent, term, pos); } });
    }

    public static final katja.spec.model.MClasses MClasses(katja.spec.model.MClass... elements) {
        katja.spec.model.MClasses _temp = new katja.spec.model.MClasses.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MClasses) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MClassesInFile MClassesInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MClasses term, final int pos) {
        return new katja.spec.model.MClassesInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MCode MCode(katja.spec.model.Strings lines, katja.spec.model.MTypes needed) {
        katja.spec.model.MCode _temp = new katja.spec.model.MCode.Impl(lines, needed);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MCode) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MCode MCode(katja.spec.model.Strings lines, katja.spec.model.MType... needed) {
        katja.spec.model.MTypes _list = katja.spec.model.Model.MTypes(needed);
        katja.spec.model.MCode _temp = new katja.spec.model.MCode.Impl(lines, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MCode) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MCodeFragment MCodeFragment(java.lang.String part, katja.spec.model.MTypes needed) {
        katja.spec.model.MCodeFragment _temp = new katja.spec.model.MCodeFragment.Impl(part, needed);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MCodeFragment) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MCodeFragment MCodeFragment(java.lang.String part, katja.spec.model.MType... needed) {
        katja.spec.model.MTypes _list = katja.spec.model.Model.MTypes(needed);
        katja.spec.model.MCodeFragment _temp = new katja.spec.model.MCodeFragment.Impl(part, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MCodeFragment) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MCodeFragmentInFile MCodeFragmentInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MCodeFragment term, final int pos) {
        return new katja.spec.model.MCodeFragmentInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MCodeInFile MCodeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MCode term, final int pos) {
        return new katja.spec.model.MCodeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MFile MFile(java.lang.String name, java.lang.String packageName, katja.spec.model.MClasses classes) {
        katja.spec.model.MFile _temp = new katja.spec.model.MFile.Impl(name, packageName, classes);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MFile) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MFile MFile(java.lang.String name, java.lang.String packageName, katja.spec.model.MClass... classes) {
        katja.spec.model.MClasses _list = katja.spec.model.Model.MClasses(classes);
        katja.spec.model.MFile _temp = new katja.spec.model.MFile.Impl(name, packageName, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MFile) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MFileInFile MFileInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MFile term, final int pos) {
        return new katja.spec.model.MFileInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MFileInFile MFileInFile(katja.spec.model.MFile term) {
        if(!_InFilecache.containsKey(term))
            _InFilecache.put(term, new katja.spec.model.MFileInFile.Impl(term));

        return _InFilecache.get(term);
    }

    public static final katja.spec.model.MFiles MFiles(katja.spec.model.MFile... elements) {
        katja.spec.model.MFiles _temp = new katja.spec.model.MFiles.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MFiles) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MFinal MFinal(katja.spec.model.MParamtype type) {
        katja.spec.model.MFinal _temp = new katja.spec.model.MFinal.Impl(type);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MFinal) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MFinalInFile MFinalInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MFinal term, final int pos) {
        return new katja.spec.model.MFinalInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MGenericTypeApp MGenericTypeApp(katja.spec.model.MNonGenericType type, katja.spec.model.MTypeOrWildcards types) {
        katja.spec.model.MGenericTypeApp _temp = new katja.spec.model.MGenericTypeApp.Impl(type, types);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MGenericTypeApp) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MGenericTypeApp MGenericTypeApp(katja.spec.model.MNonGenericType type, katja.spec.model.MTypeOrWildcard... types) {
        katja.spec.model.MTypeOrWildcards _list = katja.spec.model.Model.MTypeOrWildcards(types);
        katja.spec.model.MGenericTypeApp _temp = new katja.spec.model.MGenericTypeApp.Impl(type, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MGenericTypeApp) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MGenericTypeAppInFile MGenericTypeAppInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MGenericTypeApp term, final int pos) {
        return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MGenericTypeDef MGenericTypeDef(katja.spec.model.MJavaType type, katja.spec.model.MTypeVariables typeVars) {
        katja.spec.model.MGenericTypeDef _temp = new katja.spec.model.MGenericTypeDef.Impl(type, typeVars);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MGenericTypeDef) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MGenericTypeDef MGenericTypeDef(katja.spec.model.MJavaType type, katja.spec.model.MTypeVariable... typeVars) {
        katja.spec.model.MTypeVariables _list = katja.spec.model.Model.MTypeVariables(typeVars);
        katja.spec.model.MGenericTypeDef _temp = new katja.spec.model.MGenericTypeDef.Impl(type, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MGenericTypeDef) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MGenericTypeDefInFile MGenericTypeDefInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MGenericTypeDef term, final int pos) {
        return new katja.spec.model.MGenericTypeDefInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MInnerType MInnerType(katja.spec.model.MNonGenericType outerClass, java.lang.String innerClass) {
        katja.spec.model.MInnerType _temp = new katja.spec.model.MInnerType.Impl(outerClass, innerClass);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MInnerType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MInnerTypeInFile MInnerTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MInnerType term, final int pos) {
        return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MJavaType MJavaType(java.lang.String name, katja.spec.model.Strings importNames) {
        katja.spec.model.MJavaType _temp = new katja.spec.model.MJavaType.Impl(name, importNames);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MJavaType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MJavaType MJavaType(java.lang.String name, java.lang.String... importNames) {
        katja.spec.model.Strings _list = katja.spec.model.Model.Strings(importNames);
        katja.spec.model.MJavaType _temp = new katja.spec.model.MJavaType.Impl(name, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MJavaType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MJavaTypeInFile MJavaTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MJavaType term, final int pos) {
        return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MKatjaType MKatjaType(katja.spec.descriptors.SortDescriptor sortDesc) {
        katja.spec.model.MKatjaType _temp = new katja.spec.model.MKatjaType.Impl(sortDesc);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MKatjaType) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MKatjaTypeInFile MKatjaTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MKatjaType term, final int pos) {
        return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MMethod MMethod(katja.spec.model.MModifiers modifiers, katja.spec.model.MTypeVariables generics, katja.spec.model.MReturnType returnType, java.lang.String name, katja.spec.model.MParameters parameter, katja.spec.model.MTypes exceptions, katja.spec.model.MCode body) {
        katja.spec.model.MMethod _temp = new katja.spec.model.MMethod.Impl(modifiers, generics, returnType, name, parameter, exceptions, body);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MMethod) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MMethodInFile MMethodInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MMethod term, final int pos) {
        return new katja.spec.model.MMethodInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MMethods MMethods(katja.spec.model.MMethod... elements) {
        katja.spec.model.MMethods _temp = new katja.spec.model.MMethods.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MMethods) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MMethodsInFile MMethodsInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MMethods term, final int pos) {
        return new katja.spec.model.MMethodsInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MModifierInFile MModifierInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MModifier term, final int pos) {
        return term.Switch(new katja.spec.model.MModifier.Switch<katja.spec.model.MModifierInFile, RuntimeException>() { public final katja.spec.model.MModifierInFile CasePROTECTED(katja.spec.model.PROTECTED term) { return new katja.spec.model.PROTECTEDInFile.Impl(parent, term, pos); } public final katja.spec.model.MModifierInFile CasePRIVATE(katja.spec.model.PRIVATE term) { return new katja.spec.model.PRIVATEInFile.Impl(parent, term, pos); } public final katja.spec.model.MModifierInFile CasePUBLIC(katja.spec.model.PUBLIC term) { return new katja.spec.model.PUBLICInFile.Impl(parent, term, pos); } public final katja.spec.model.MModifierInFile CaseSTATIC(katja.spec.model.STATIC term) { return new katja.spec.model.STATICInFile.Impl(parent, term, pos); } public final katja.spec.model.MModifierInFile CaseABSTRACT(katja.spec.model.ABSTRACT term) { return new katja.spec.model.ABSTRACTInFile.Impl(parent, term, pos); } public final katja.spec.model.MModifierInFile CaseFINAL(katja.spec.model.FINAL term) { return new katja.spec.model.FINALInFile.Impl(parent, term, pos); } });
    }

    public static final katja.spec.model.MModifiers MModifiers(katja.spec.model.MModifier... elements) {
        katja.spec.model.MModifiers _temp = new katja.spec.model.MModifiers.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MModifiers) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MModifiersInFile MModifiersInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MModifiers term, final int pos) {
        return new katja.spec.model.MModifiersInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MNonGenericTypeInFile MNonGenericTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MNonGenericType term, final int pos) {
        return term.Switch(new katja.spec.model.MNonGenericType.Switch<katja.spec.model.MNonGenericTypeInFile, RuntimeException>() { public final katja.spec.model.MNonGenericTypeInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MNonGenericTypeInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MNonGenericTypeInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    public static final katja.spec.model.MNone MNone() {
        katja.spec.model.MNone _temp = new katja.spec.model.MNone.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MNone) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MNoneInFile MNoneInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MNone term, final int pos) {
        return new katja.spec.model.MNoneInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MParameter MParameter(katja.spec.model.MParamtypeDecl decl, java.lang.String name) {
        katja.spec.model.MParameter _temp = new katja.spec.model.MParameter.Impl(decl, name);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MParameter) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MParameterInFile MParameterInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MParameter term, final int pos) {
        return new katja.spec.model.MParameterInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MParameters MParameters(katja.spec.model.MParameter... elements) {
        katja.spec.model.MParameters _temp = new katja.spec.model.MParameters.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MParameters) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MParametersInFile MParametersInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MParameters term, final int pos) {
        return new katja.spec.model.MParametersInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.MParamtypeDeclInFile MParamtypeDeclInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MParamtypeDecl term, final int pos) {
        return term.Switch(new katja.spec.model.MParamtypeDecl.Switch<katja.spec.model.MParamtypeDeclInFile, RuntimeException>() { public final katja.spec.model.MParamtypeDeclInFile CaseMFinal(katja.spec.model.MFinal term) { return new katja.spec.model.MFinalInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMVararg(katja.spec.model.MVararg term) { return new katja.spec.model.MVarargInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMArrayType(katja.spec.model.MArrayType term) { return new katja.spec.model.MArrayTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeDeclInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.MParamtypeInFile MParamtypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MParamtype term, final int pos) {
        return term.Switch(new katja.spec.model.MParamtype.Switch<katja.spec.model.MParamtypeInFile, RuntimeException>() { public final katja.spec.model.MParamtypeInFile CaseMVararg(katja.spec.model.MVararg term) { return new katja.spec.model.MVarargInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeInFile CaseMArrayType(katja.spec.model.MArrayType term) { return new katja.spec.model.MArrayTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MParamtypeInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.MReturnTypeInFile MReturnTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MReturnType term, final int pos) {
        return term.Switch(new katja.spec.model.MReturnType.Switch<katja.spec.model.MReturnTypeInFile, RuntimeException>() { public final katja.spec.model.MReturnTypeInFile CaseMNone(katja.spec.model.MNone term) { return new katja.spec.model.MNoneInFile.Impl(parent, term, pos); } public final katja.spec.model.MReturnTypeInFile CaseMArrayType(katja.spec.model.MArrayType term) { return new katja.spec.model.MArrayTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MReturnTypeInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MReturnTypeInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MReturnTypeInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MReturnTypeInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.MTypeDefInFile MTypeDefInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypeDef term, final int pos) {
        return term.Switch(new katja.spec.model.MTypeDef.Switch<katja.spec.model.MTypeDefInFile, RuntimeException>() { public final katja.spec.model.MTypeDefInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeDefInFile CaseMGenericTypeDef(katja.spec.model.MGenericTypeDef term) { return new katja.spec.model.MGenericTypeDefInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.MTypeInFile MTypeInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MType term, final int pos) {
        return term.Switch(new katja.spec.model.MType.Switch<katja.spec.model.MTypeInFile, RuntimeException>() { public final katja.spec.model.MTypeInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.MTypeOrWildcardInFile MTypeOrWildcardInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypeOrWildcard term, final int pos) {
        return term.Switch(new katja.spec.model.MTypeOrWildcard.Switch<katja.spec.model.MTypeOrWildcardInFile, RuntimeException>() { public final katja.spec.model.MTypeOrWildcardInFile CaseMWildcard(katja.spec.model.MWildcard term) { return new katja.spec.model.MWildcardInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMWildcardLB(katja.spec.model.MWildcardLB term) { return new katja.spec.model.MWildcardLBInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMWildcardUB(katja.spec.model.MWildcardUB term) { return new katja.spec.model.MWildcardUBInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMGenericTypeApp(katja.spec.model.MGenericTypeApp term) { return new katja.spec.model.MGenericTypeAppInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMJavaType(katja.spec.model.MJavaType term) { return new katja.spec.model.MJavaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMKatjaType(katja.spec.model.MKatjaType term) { return new katja.spec.model.MKatjaTypeInFile.Impl(parent, term, pos); } public final katja.spec.model.MTypeOrWildcardInFile CaseMInnerType(katja.spec.model.MInnerType term) { return new katja.spec.model.MInnerTypeInFile.Impl(parent, term, pos); } });
    }

    public static final katja.spec.model.MTypeOrWildcards MTypeOrWildcards(katja.spec.model.MTypeOrWildcard... elements) {
        katja.spec.model.MTypeOrWildcards _temp = new katja.spec.model.MTypeOrWildcards.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MTypeOrWildcards) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MTypeOrWildcardsInFile MTypeOrWildcardsInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypeOrWildcards term, final int pos) {
        return new katja.spec.model.MTypeOrWildcardsInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MTypeVariable MTypeVariable(java.lang.String name, katja.spec.model.MTypes bounds) {
        katja.spec.model.MTypeVariable _temp = new katja.spec.model.MTypeVariable.Impl(name, bounds);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MTypeVariable) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    public static final katja.spec.model.MTypeVariable MTypeVariable(java.lang.String name, katja.spec.model.MType... bounds) {
        katja.spec.model.MTypes _list = katja.spec.model.Model.MTypes(bounds);
        katja.spec.model.MTypeVariable _temp = new katja.spec.model.MTypeVariable.Impl(name, _list);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MTypeVariable) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MTypeVariableInFile MTypeVariableInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypeVariable term, final int pos) {
        return new katja.spec.model.MTypeVariableInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MTypeVariables MTypeVariables(katja.spec.model.MTypeVariable... elements) {
        katja.spec.model.MTypeVariables _temp = new katja.spec.model.MTypeVariables.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MTypeVariables) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MTypeVariablesInFile MTypeVariablesInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypeVariables term, final int pos) {
        return new katja.spec.model.MTypeVariablesInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MTypes MTypes(katja.spec.model.MType... elements) {
        katja.spec.model.MTypes _temp = new katja.spec.model.MTypes.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MTypes) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MTypesInFile MTypesInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MTypes term, final int pos) {
        return new katja.spec.model.MTypesInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MVararg MVararg(katja.spec.model.MAnyType type) {
        katja.spec.model.MVararg _temp = new katja.spec.model.MVararg.Impl(type);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MVararg) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MVarargInFile MVarargInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MVararg term, final int pos) {
        return new katja.spec.model.MVarargInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MWildcard MWildcard() {
        katja.spec.model.MWildcard _temp = new katja.spec.model.MWildcard.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MWildcard) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MWildcardInFile MWildcardInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MWildcard term, final int pos) {
        return new katja.spec.model.MWildcardInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MWildcardLB MWildcardLB(katja.spec.model.MType bound) {
        katja.spec.model.MWildcardLB _temp = new katja.spec.model.MWildcardLB.Impl(bound);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MWildcardLB) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MWildcardLBInFile MWildcardLBInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MWildcardLB term, final int pos) {
        return new katja.spec.model.MWildcardLBInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.MWildcardUB MWildcardUB(katja.spec.model.MType bound) {
        katja.spec.model.MWildcardUB _temp = new katja.spec.model.MWildcardUB.Impl(bound);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.MWildcardUB) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.MWildcardUBInFile MWildcardUBInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.MWildcardUB term, final int pos) {
        return new katja.spec.model.MWildcardUBInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.PRIVATE PRIVATE() {
        katja.spec.model.PRIVATE _temp = new katja.spec.model.PRIVATE.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.PRIVATE) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.PRIVATEInFile PRIVATEInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.PRIVATE term, final int pos) {
        return new katja.spec.model.PRIVATEInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.PROTECTED PROTECTED() {
        katja.spec.model.PROTECTED _temp = new katja.spec.model.PROTECTED.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.PROTECTED) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.PROTECTEDInFile PROTECTEDInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.PROTECTED term, final int pos) {
        return new katja.spec.model.PROTECTEDInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.PUBLIC PUBLIC() {
        katja.spec.model.PUBLIC _temp = new katja.spec.model.PUBLIC.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.PUBLIC) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.PUBLICInFile PUBLICInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.PUBLIC term, final int pos) {
        return new katja.spec.model.PUBLICInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.PosSortDescriptorInFile PosSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.PosSortDescriptor term, final int pos) {
        return new katja.spec.model.PosSortDescriptorInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.PosStructDescriptorInFile PosStructDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.PosStructDescriptor term, final int pos) {
        return new katja.spec.model.PosStructDescriptorInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.STATIC STATIC() {
        katja.spec.model.STATIC _temp = new katja.spec.model.STATIC.Impl();
        if(_termcache.containsKey(_temp)) return (katja.spec.model.STATIC) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.STATICInFile STATICInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.STATIC term, final int pos) {
        return new katja.spec.model.STATICInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.SortDescriptorInFile SortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.SortDescriptor term, final int pos) {
        return term.Switch(new katja.spec.descriptors.SortDescriptor.Switch<katja.spec.model.SortDescriptorInFile, RuntimeException>() { public final katja.spec.model.SortDescriptorInFile CasePosSortDescriptor(katja.spec.descriptors.PosSortDescriptor term) { return new katja.spec.model.PosSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.SortDescriptorInFile CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) { return new katja.spec.model.TupleTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.SortDescriptorInFile CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) { return new katja.spec.model.ListTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.SortDescriptorInFile CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) { return new katja.spec.model.VariantTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.SortDescriptorInFile CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) { return new katja.spec.model.ExternTermSortDescriptorInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.StringInFile StringInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final java.lang.String term, final int pos) {
        return new katja.spec.model.StringInFile.Impl(parent, term, pos);
    }

    public static final katja.spec.model.Strings Strings(java.lang.String... elements) {
        katja.spec.model.Strings _temp = new katja.spec.model.Strings.Impl(elements);
        if(_termcache.containsKey(_temp)) return (katja.spec.model.Strings) _termcache.get(_temp);
        _termcache.put(_temp, _temp);

        return _temp;
    }

    static final katja.spec.model.StringsInFile StringsInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.model.Strings term, final int pos) {
        return new katja.spec.model.StringsInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.TermSortDescriptorInFile TermSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.TermSortDescriptor term, final int pos) {
        return term.Switch(new katja.spec.descriptors.TermSortDescriptor.Switch<katja.spec.model.TermSortDescriptorInFile, RuntimeException>() { public final katja.spec.model.TermSortDescriptorInFile CaseTupleTermSortDescriptor(katja.spec.descriptors.TupleTermSortDescriptor term) { return new katja.spec.model.TupleTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.TermSortDescriptorInFile CaseListTermSortDescriptor(katja.spec.descriptors.ListTermSortDescriptor term) { return new katja.spec.model.ListTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.TermSortDescriptorInFile CaseVariantTermSortDescriptor(katja.spec.descriptors.VariantTermSortDescriptor term) { return new katja.spec.model.VariantTermSortDescriptorInFile.Impl(parent, term, pos); } public final katja.spec.model.TermSortDescriptorInFile CaseExternTermSortDescriptor(katja.spec.descriptors.ExternTermSortDescriptor term) { return new katja.spec.model.ExternTermSortDescriptorInFile.Impl(parent, term, pos); } });
    }

    static final katja.spec.model.TupleTermSortDescriptorInFile TupleTermSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.TupleTermSortDescriptor term, final int pos) {
        return new katja.spec.model.TupleTermSortDescriptorInFile.Impl(parent, term, pos);
    }

    static final katja.spec.model.VariantTermSortDescriptorInFile VariantTermSortDescriptorInFile(final KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, final katja.spec.descriptors.VariantTermSortDescriptor term, final int pos) {
        return new katja.spec.model.VariantTermSortDescriptorInFile.Impl(parent, term, pos);
    }

    public static final KatjaElement fromAssembler(Reader reader) throws IOException {
        return parseInternal(reader, _Model$Creator);
    }

    //----- nested classes of Model -----

    public static interface SortInFile extends KatjaSortPos<katja.spec.model.MFileInFile> {

        //----- methods of SortInFile -----

        public Model.SortInFile parent();
        public Model.SortInFile lsib();
        public Model.SortInFile rsib();
        public Model.SortInFile preOrder();
        public Model.SortInFile postOrder();
        public Model.SortInFile postOrderStart();
        public Model.SortInFile follow(List<Integer> path);
    }

    public static interface TermInFile<T> extends Model.SortInFile, KatjaTermPos<katja.spec.model.MFileInFile, T> {
    }

    public static interface NodeInFile<T extends KatjaTerm> extends Model.TermInFile<T>, KatjaNodePos<katja.spec.model.MFileInFile, T> {
    }

    public static interface LeafInFile<T> extends Model.TermInFile<T>, KatjaLeafPos<katja.spec.model.MFileInFile, T> {
    }

    public static interface TupleInFile<T extends KatjaTuple> extends Model.NodeInFile<T>, KatjaTuplePos<katja.spec.model.MFileInFile, T> {
    }

    public static interface ListInFile<T extends KatjaList<E>, L extends KatjaSortPos<katja.spec.model.MFileInFile>, E> extends Model.NodeInFile<T>, KatjaListPos<katja.spec.model.MFileInFile, T, L, E> {
    }

    private static final class Model$Creator implements KatjaSpecification.ElementCreator {

        //----- attributes of Model$Creator -----

        private TreeMap<String, Integer> _sortnumber = new TreeMap<String, Integer>();

        //----- methods of Model$Creator -----

        Model$Creator() {
            _sortnumber.put("ABSTRACT", 0);
            _sortnumber.put("BackendBlock", 1);
            _sortnumber.put("CLASS", 2);
            _sortnumber.put("Empty", 3);
            _sortnumber.put("ExternTermSortDescriptor", 4);
            _sortnumber.put("External", 5);
            _sortnumber.put("FINAL", 6);
            _sortnumber.put("INTERFACE", 7);
            _sortnumber.put("Import", 8);
            _sortnumber.put("Include", 9);
            _sortnumber.put("KatjaSpecError", 10);
            _sortnumber.put("KatjaUsageError", 11);
            _sortnumber.put("KatjaWarning", 12);
            _sortnumber.put("ListProd", 13);
            _sortnumber.put("ListTermSortDescriptor", 14);
            _sortnumber.put("MArrayType", 15);
            _sortnumber.put("MAttribute", 16);
            _sortnumber.put("MClass", 17);
            _sortnumber.put("MCode", 18);
            _sortnumber.put("MCodeFragment", 19);
            _sortnumber.put("MFile", 20);
            _sortnumber.put("MFinal", 21);
            _sortnumber.put("MGenericTypeApp", 22);
            _sortnumber.put("MGenericTypeDef", 23);
            _sortnumber.put("MInnerType", 24);
            _sortnumber.put("MJavaType", 25);
            _sortnumber.put("MKatjaType", 26);
            _sortnumber.put("MMethod", 27);
            _sortnumber.put("MNone", 28);
            _sortnumber.put("MParameter", 29);
            _sortnumber.put("MTypeVariable", 30);
            _sortnumber.put("MVararg", 31);
            _sortnumber.put("MWildcard", 32);
            _sortnumber.put("MWildcardLB", 33);
            _sortnumber.put("MWildcardUB", 34);
            _sortnumber.put("PRIVATE", 35);
            _sortnumber.put("PROTECTED", 36);
            _sortnumber.put("PUBLIC", 37);
            _sortnumber.put("PackageName", 38);
            _sortnumber.put("PosSortDescriptor", 39);
            _sortnumber.put("PosStructDescriptor", 40);
            _sortnumber.put("Root", 41);
            _sortnumber.put("STATIC", 42);
            _sortnumber.put("Selector", 43);
            _sortnumber.put("SelectorDescriptor", 44);
            _sortnumber.put("SortId", 45);
            _sortnumber.put("Specification", 46);
            _sortnumber.put("TupleParam", 47);
            _sortnumber.put("TupleProd", 48);
            _sortnumber.put("TupleTermSortDescriptor", 49);
            _sortnumber.put("VariantProd", 50);
            _sortnumber.put("VariantTermSortDescriptor", 51);
            _sortnumber.put("BackendBlockList", 52);
            _sortnumber.put("ExternTermSortDescriptors", 53);
            _sortnumber.put("ExternalList", 54);
            _sortnumber.put("FileNameList", 55);
            _sortnumber.put("ImportList", 56);
            _sortnumber.put("IncludeList", 57);
            _sortnumber.put("KatjaErrorList", 58);
            _sortnumber.put("KatjaWarningList", 59);
            _sortnumber.put("ListTermSortDescriptors", 60);
            _sortnumber.put("MAnyTypes", 61);
            _sortnumber.put("MAttributes", 62);
            _sortnumber.put("MClasses", 63);
            _sortnumber.put("MFiles", 64);
            _sortnumber.put("MMethods", 65);
            _sortnumber.put("MModifiers", 66);
            _sortnumber.put("MParameters", 67);
            _sortnumber.put("MTypeOrWildcards", 68);
            _sortnumber.put("MTypeVariables", 69);
            _sortnumber.put("MTypes", 70);
            _sortnumber.put("PosSortDescriptors", 71);
            _sortnumber.put("PosStructDescriptors", 72);
            _sortnumber.put("ProductionList", 73);
            _sortnumber.put("ProductionPosList", 74);
            _sortnumber.put("RootList", 75);
            _sortnumber.put("SelectorDescriptors", 76);
            _sortnumber.put("SelectorList", 77);
            _sortnumber.put("SortDescriptors", 78);
            _sortnumber.put("SortIdList", 79);
            _sortnumber.put("SortSpecPosList", 80);
            _sortnumber.put("SpecificationPosList", 81);
            _sortnumber.put("Strings", 82);
            _sortnumber.put("TermSortDescriptors", 83);
            _sortnumber.put("TupleParamList", 84);
            _sortnumber.put("TupleTermSortDescriptors", 85);
            _sortnumber.put("VariantParamList", 86);
            _sortnumber.put("VariantParamPosList", 87);
            _sortnumber.put("VariantPosList", 88);
            _sortnumber.put("VariantTermSortDescriptors", 89);
            _sortnumber.put("MFileInFile", 90);
            _sortnumber.put("SpecificationPos", 91);
        }

        public final KatjaElement create(String name, Object[] parameters, int line) {
            if(!_sortnumber.containsKey(name))
                throw new IllegalArgumentException("unknown sort name "+name+", in line "+line);

            switch(_sortnumber.get(name)) {
                case 0:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ABSTRACT, in line "+line);

                    return katja.spec.model.Model.ABSTRACT();
                case 1:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort BackendBlock, in line "+line);

                    if(!(parameters[0] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of BackendBlock constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of BackendBlock constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of BackendBlock constructor, in line "+line);
                    return katja.spec.Katja.BackendBlock((java.lang.Integer) parameters[0], (java.lang.String) parameters[1], (java.lang.String) parameters[2]);
                case 2:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort CLASS, in line "+line);

                    return katja.spec.model.Model.CLASS();
                case 3:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Empty, in line "+line);

                    return katja.spec.Katja.Empty();
                case 4:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ExternTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of ExternTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of ExternTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.ExternTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 5:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort External, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of External constructor, in line "+line);
                    return katja.spec.Katja.External((katja.spec.SortId) parameters[0]);
                case 6:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort FINAL, in line "+line);

                    return katja.spec.model.Model.FINAL();
                case 7:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort INTERFACE, in line "+line);

                    return katja.spec.model.Model.INTERFACE();
                case 8:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Import, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Import constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Import constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Import constructor, in line "+line);
                    return katja.spec.Katja.Import((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 9:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Include, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Include constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Include constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Include constructor, in line "+line);
                    return katja.spec.Katja.Include((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 10:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaSpecError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaSpecError constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaSpecError constructor, in line "+line);
                    return katja.spec.Katja.KatjaSpecError((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 11:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaUsageError, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaUsageError constructor, in line "+line);
                    return katja.spec.Katja.KatjaUsageError((java.lang.String) parameters[0]);
                case 12:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort KatjaWarning, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of KatjaWarning constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of KatjaWarning constructor, in line "+line);
                    return katja.spec.Katja.KatjaWarning((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2]);
                case 13:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListProd constructor, in line "+line);
                    return katja.spec.Katja.ListProd((katja.spec.SortId) parameters[0], (katja.spec.SortId) parameters[1]);
                case 14:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort ListTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of ListTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of ListTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.ListTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 15:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MArrayType, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MAnyType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MArrayType constructor, in line "+line);
                    return katja.spec.model.Model.MArrayType((katja.spec.model.MAnyType) parameters[0]);
                case 16:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MAttribute, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MModifiers))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MAttribute constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MAnyType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MAttribute constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of MAttribute constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.model.MCodeFragment))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of MAttribute constructor, in line "+line);
                    return katja.spec.model.Model.MAttribute((katja.spec.model.MModifiers) parameters[0], (katja.spec.model.MAnyType) parameters[1], (java.lang.String) parameters[2], (katja.spec.model.MCodeFragment) parameters[3]);
                case 17:
                    if(parameters.length != 8)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MClass, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MModifiers))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MClass constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MClassType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MClass constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.model.MTypeDef))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of MClass constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of MClass constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of MClass constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.model.MAttributes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of MClass constructor, in line "+line);
                    if(!(parameters[6] instanceof katja.spec.model.MMethods))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 7 of MClass constructor, in line "+line);
                    if(!(parameters[7] instanceof katja.spec.model.MClasses))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 8 of MClass constructor, in line "+line);
                    return katja.spec.model.Model.MClass((katja.spec.model.MModifiers) parameters[0], (katja.spec.model.MClassType) parameters[1], (katja.spec.model.MTypeDef) parameters[2], (katja.spec.model.MTypes) parameters[3], (katja.spec.model.MTypes) parameters[4], (katja.spec.model.MAttributes) parameters[5], (katja.spec.model.MMethods) parameters[6], (katja.spec.model.MClasses) parameters[7]);
                case 18:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MCode, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.Strings))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MCode constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MCode constructor, in line "+line);
                    return katja.spec.model.Model.MCode((katja.spec.model.Strings) parameters[0], (katja.spec.model.MTypes) parameters[1]);
                case 19:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MCodeFragment, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MCodeFragment constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MCodeFragment constructor, in line "+line);
                    return katja.spec.model.Model.MCodeFragment((java.lang.String) parameters[0], (katja.spec.model.MTypes) parameters[1]);
                case 20:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MFile, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MFile constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MFile constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.model.MClasses))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of MFile constructor, in line "+line);
                    return katja.spec.model.Model.MFile((java.lang.String) parameters[0], (java.lang.String) parameters[1], (katja.spec.model.MClasses) parameters[2]);
                case 21:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MFinal, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MParamtype))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MFinal constructor, in line "+line);
                    return katja.spec.model.Model.MFinal((katja.spec.model.MParamtype) parameters[0]);
                case 22:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MGenericTypeApp, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MNonGenericType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MGenericTypeApp constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypeOrWildcards))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MGenericTypeApp constructor, in line "+line);
                    return katja.spec.model.Model.MGenericTypeApp((katja.spec.model.MNonGenericType) parameters[0], (katja.spec.model.MTypeOrWildcards) parameters[1]);
                case 23:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MGenericTypeDef, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MJavaType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MGenericTypeDef constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypeVariables))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MGenericTypeDef constructor, in line "+line);
                    return katja.spec.model.Model.MGenericTypeDef((katja.spec.model.MJavaType) parameters[0], (katja.spec.model.MTypeVariables) parameters[1]);
                case 24:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MInnerType, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MNonGenericType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MInnerType constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MInnerType constructor, in line "+line);
                    return katja.spec.model.Model.MInnerType((katja.spec.model.MNonGenericType) parameters[0], (java.lang.String) parameters[1]);
                case 25:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MJavaType, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MJavaType constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.Strings))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MJavaType constructor, in line "+line);
                    return katja.spec.model.Model.MJavaType((java.lang.String) parameters[0], (katja.spec.model.Strings) parameters[1]);
                case 26:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MKatjaType, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MKatjaType constructor, in line "+line);
                    return katja.spec.model.Model.MKatjaType((katja.spec.descriptors.SortDescriptor) parameters[0]);
                case 27:
                    if(parameters.length != 7)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MMethod, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MModifiers))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MMethod constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypeVariables))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MMethod constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.model.MReturnType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of MMethod constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of MMethod constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.model.MParameters))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of MMethod constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of MMethod constructor, in line "+line);
                    if(!(parameters[6] instanceof katja.spec.model.MCode))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 7 of MMethod constructor, in line "+line);
                    return katja.spec.model.Model.MMethod((katja.spec.model.MModifiers) parameters[0], (katja.spec.model.MTypeVariables) parameters[1], (katja.spec.model.MReturnType) parameters[2], (java.lang.String) parameters[3], (katja.spec.model.MParameters) parameters[4], (katja.spec.model.MTypes) parameters[5], (katja.spec.model.MCode) parameters[6]);
                case 28:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MNone, in line "+line);

                    return katja.spec.model.Model.MNone();
                case 29:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MParameter, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MParamtypeDecl))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MParameter constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MParameter constructor, in line "+line);
                    return katja.spec.model.Model.MParameter((katja.spec.model.MParamtypeDecl) parameters[0], (java.lang.String) parameters[1]);
                case 30:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MTypeVariable, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MTypeVariable constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.model.MTypes))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of MTypeVariable constructor, in line "+line);
                    return katja.spec.model.Model.MTypeVariable((java.lang.String) parameters[0], (katja.spec.model.MTypes) parameters[1]);
                case 31:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MVararg, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MAnyType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MVararg constructor, in line "+line);
                    return katja.spec.model.Model.MVararg((katja.spec.model.MAnyType) parameters[0]);
                case 32:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MWildcard, in line "+line);

                    return katja.spec.model.Model.MWildcard();
                case 33:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MWildcardLB, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MWildcardLB constructor, in line "+line);
                    return katja.spec.model.Model.MWildcardLB((katja.spec.model.MType) parameters[0]);
                case 34:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort MWildcardUB, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MType))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of MWildcardUB constructor, in line "+line);
                    return katja.spec.model.Model.MWildcardUB((katja.spec.model.MType) parameters[0]);
                case 35:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PRIVATE, in line "+line);

                    return katja.spec.model.Model.PRIVATE();
                case 36:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PROTECTED, in line "+line);

                    return katja.spec.model.Model.PROTECTED();
                case 37:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PUBLIC, in line "+line);

                    return katja.spec.model.Model.PUBLIC();
                case 38:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PackageName, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PackageName constructor, in line "+line);
                    return katja.spec.Katja.PackageName((java.lang.String) parameters[0]);
                case 39:
                    if(parameters.length != 6)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PosSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.descriptors.TermSortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of PosSortDescriptor constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.descriptors.PosStructDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of PosSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.PosSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3], (katja.spec.descriptors.TermSortDescriptor) parameters[4], (katja.spec.descriptors.PosStructDescriptor) parameters[5]);
                case 40:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort PosStructDescriptor, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.TermSortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of PosStructDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of PosStructDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.PosStructDescriptor((katja.spec.descriptors.TermSortDescriptor) parameters[0], (java.lang.String) parameters[1]);
                case 41:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Root, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Root constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Root constructor, in line "+line);
                    return katja.spec.Katja.Root((katja.spec.SortId) parameters[0], (java.lang.String) parameters[1]);
                case 42:
                    if(parameters.length != 0)
                        throw new IllegalArgumentException("wrong number of arguments given for sort STATIC, in line "+line);

                    return katja.spec.model.Model.STATIC();
                case 43:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Selector, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Selector constructor, in line "+line);
                    return katja.spec.Katja.Selector((java.lang.String) parameters[0]);
                case 44:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort SelectorDescriptor, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of SelectorDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.descriptors.SortDescriptor))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of SelectorDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.SelectorDescriptor((katja.spec.descriptors.SortDescriptor) parameters[0], (java.lang.Integer) parameters[1], (java.lang.String) parameters[2], (katja.spec.descriptors.SortDescriptor) parameters[3]);
                case 45:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort SortId, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of SortId constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of SortId constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of SortId constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of SortId constructor, in line "+line);
                    return katja.spec.Katja.SortId((java.lang.String) parameters[0], (java.lang.Boolean) parameters[1], (java.lang.String) parameters[2], (java.lang.Integer) parameters[3]);
                case 46:
                    if(parameters.length != 8)
                        throw new IllegalArgumentException("wrong number of arguments given for sort Specification, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of Specification constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.BackendBlockList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of Specification constructor, in line "+line);
                    if(!(parameters[2] instanceof katja.spec.RootList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of Specification constructor, in line "+line);
                    if(!(parameters[3] instanceof katja.spec.ExternalList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of Specification constructor, in line "+line);
                    if(!(parameters[4] instanceof katja.spec.ImportList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 5 of Specification constructor, in line "+line);
                    if(!(parameters[5] instanceof katja.spec.IncludeList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 6 of Specification constructor, in line "+line);
                    if(!(parameters[6] instanceof katja.spec.ProductionList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 7 of Specification constructor, in line "+line);
                    if(!(parameters[7] instanceof katja.spec.FileNameList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 8 of Specification constructor, in line "+line);
                    return katja.spec.Katja.Specification((java.lang.String) parameters[0], (katja.spec.BackendBlockList) parameters[1], (katja.spec.RootList) parameters[2], (katja.spec.ExternalList) parameters[3], (katja.spec.ImportList) parameters[4], (katja.spec.IncludeList) parameters[5], (katja.spec.ProductionList) parameters[6], (katja.spec.FileNameList) parameters[7]);
                case 47:
                    if(parameters.length != 3)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleParam, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleParam constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.SelectorOpt))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleParam constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of TupleParam constructor, in line "+line);
                    return katja.spec.Katja.TupleParam((katja.spec.SortId) parameters[0], (katja.spec.SelectorOpt) parameters[1], (java.lang.Boolean) parameters[2]);
                case 48:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.TupleParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleProd constructor, in line "+line);
                    return katja.spec.Katja.TupleProd((katja.spec.SortId) parameters[0], (katja.spec.TupleParamList) parameters[1]);
                case 49:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort TupleTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of TupleTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of TupleTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.TupleTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 50:
                    if(parameters.length != 2)
                        throw new IllegalArgumentException("wrong number of arguments given for sort VariantProd, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.SortId))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of VariantProd constructor, in line "+line);
                    if(!(parameters[1] instanceof katja.spec.VariantParamList))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of VariantProd constructor, in line "+line);
                    return katja.spec.Katja.VariantProd((katja.spec.SortId) parameters[0], (katja.spec.VariantParamList) parameters[1]);
                case 51:
                    if(parameters.length != 4)
                        throw new IllegalArgumentException("wrong number of arguments given for sort VariantTermSortDescriptor, in line "+line);

                    if(!(parameters[0] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 1 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[1] instanceof java.lang.String))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 2 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[2] instanceof java.lang.Integer))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 3 of VariantTermSortDescriptor constructor, in line "+line);
                    if(!(parameters[3] instanceof java.lang.Boolean))
                        throw new IllegalArgumentException("wrong sort on stack as parameter 4 of VariantTermSortDescriptor constructor, in line "+line);
                    return katja.spec.descriptors.Descriptors.VariantTermSortDescriptor((java.lang.String) parameters[0], (java.lang.String) parameters[1], (java.lang.Integer) parameters[2], (java.lang.Boolean) parameters[3]);
                case 52:
                    katja.spec.BackendBlock[] _BackendBlockList$array = new katja.spec.BackendBlock[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.BackendBlock))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for BackendBlockList constructor, in line "+line);
                        _BackendBlockList$array[i] = (katja.spec.BackendBlock) parameters[i];
                    }

                    return katja.spec.Katja.BackendBlockList(_BackendBlockList$array);
                case 53:
                    katja.spec.descriptors.ExternTermSortDescriptor[] _ExternTermSortDescriptors$array = new katja.spec.descriptors.ExternTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.ExternTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternTermSortDescriptors constructor, in line "+line);
                        _ExternTermSortDescriptors$array[i] = (katja.spec.descriptors.ExternTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.ExternTermSortDescriptors(_ExternTermSortDescriptors$array);
                case 54:
                    katja.spec.External[] _ExternalList$array = new katja.spec.External[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.External))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ExternalList constructor, in line "+line);
                        _ExternalList$array[i] = (katja.spec.External) parameters[i];
                    }

                    return katja.spec.Katja.ExternalList(_ExternalList$array);
                case 55:
                    java.lang.String[] _FileNameList$array = new java.lang.String[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof java.lang.String))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for FileNameList constructor, in line "+line);
                        _FileNameList$array[i] = (java.lang.String) parameters[i];
                    }

                    return katja.spec.Katja.FileNameList(_FileNameList$array);
                case 56:
                    katja.spec.Import[] _ImportList$array = new katja.spec.Import[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Import))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ImportList constructor, in line "+line);
                        _ImportList$array[i] = (katja.spec.Import) parameters[i];
                    }

                    return katja.spec.Katja.ImportList(_ImportList$array);
                case 57:
                    katja.spec.Include[] _IncludeList$array = new katja.spec.Include[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Include))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for IncludeList constructor, in line "+line);
                        _IncludeList$array[i] = (katja.spec.Include) parameters[i];
                    }

                    return katja.spec.Katja.IncludeList(_IncludeList$array);
                case 58:
                    katja.spec.KatjaError[] _KatjaErrorList$array = new katja.spec.KatjaError[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaError))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaErrorList constructor, in line "+line);
                        _KatjaErrorList$array[i] = (katja.spec.KatjaError) parameters[i];
                    }

                    return katja.spec.Katja.KatjaErrorList(_KatjaErrorList$array);
                case 59:
                    katja.spec.KatjaWarning[] _KatjaWarningList$array = new katja.spec.KatjaWarning[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.KatjaWarning))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for KatjaWarningList constructor, in line "+line);
                        _KatjaWarningList$array[i] = (katja.spec.KatjaWarning) parameters[i];
                    }

                    return katja.spec.Katja.KatjaWarningList(_KatjaWarningList$array);
                case 60:
                    katja.spec.descriptors.ListTermSortDescriptor[] _ListTermSortDescriptors$array = new katja.spec.descriptors.ListTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.ListTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ListTermSortDescriptors constructor, in line "+line);
                        _ListTermSortDescriptors$array[i] = (katja.spec.descriptors.ListTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.ListTermSortDescriptors(_ListTermSortDescriptors$array);
                case 61:
                    katja.spec.model.MAnyType[] _MAnyTypes$array = new katja.spec.model.MAnyType[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MAnyType))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MAnyTypes constructor, in line "+line);
                        _MAnyTypes$array[i] = (katja.spec.model.MAnyType) parameters[i];
                    }

                    return katja.spec.model.Model.MAnyTypes(_MAnyTypes$array);
                case 62:
                    katja.spec.model.MAttribute[] _MAttributes$array = new katja.spec.model.MAttribute[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MAttribute))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MAttributes constructor, in line "+line);
                        _MAttributes$array[i] = (katja.spec.model.MAttribute) parameters[i];
                    }

                    return katja.spec.model.Model.MAttributes(_MAttributes$array);
                case 63:
                    katja.spec.model.MClass[] _MClasses$array = new katja.spec.model.MClass[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MClass))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MClasses constructor, in line "+line);
                        _MClasses$array[i] = (katja.spec.model.MClass) parameters[i];
                    }

                    return katja.spec.model.Model.MClasses(_MClasses$array);
                case 64:
                    katja.spec.model.MFile[] _MFiles$array = new katja.spec.model.MFile[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MFile))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MFiles constructor, in line "+line);
                        _MFiles$array[i] = (katja.spec.model.MFile) parameters[i];
                    }

                    return katja.spec.model.Model.MFiles(_MFiles$array);
                case 65:
                    katja.spec.model.MMethod[] _MMethods$array = new katja.spec.model.MMethod[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MMethod))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MMethods constructor, in line "+line);
                        _MMethods$array[i] = (katja.spec.model.MMethod) parameters[i];
                    }

                    return katja.spec.model.Model.MMethods(_MMethods$array);
                case 66:
                    katja.spec.model.MModifier[] _MModifiers$array = new katja.spec.model.MModifier[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MModifier))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MModifiers constructor, in line "+line);
                        _MModifiers$array[i] = (katja.spec.model.MModifier) parameters[i];
                    }

                    return katja.spec.model.Model.MModifiers(_MModifiers$array);
                case 67:
                    katja.spec.model.MParameter[] _MParameters$array = new katja.spec.model.MParameter[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MParameter))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MParameters constructor, in line "+line);
                        _MParameters$array[i] = (katja.spec.model.MParameter) parameters[i];
                    }

                    return katja.spec.model.Model.MParameters(_MParameters$array);
                case 68:
                    katja.spec.model.MTypeOrWildcard[] _MTypeOrWildcards$array = new katja.spec.model.MTypeOrWildcard[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MTypeOrWildcard))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MTypeOrWildcards constructor, in line "+line);
                        _MTypeOrWildcards$array[i] = (katja.spec.model.MTypeOrWildcard) parameters[i];
                    }

                    return katja.spec.model.Model.MTypeOrWildcards(_MTypeOrWildcards$array);
                case 69:
                    katja.spec.model.MTypeVariable[] _MTypeVariables$array = new katja.spec.model.MTypeVariable[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MTypeVariable))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MTypeVariables constructor, in line "+line);
                        _MTypeVariables$array[i] = (katja.spec.model.MTypeVariable) parameters[i];
                    }

                    return katja.spec.model.Model.MTypeVariables(_MTypeVariables$array);
                case 70:
                    katja.spec.model.MType[] _MTypes$array = new katja.spec.model.MType[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.model.MType))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for MTypes constructor, in line "+line);
                        _MTypes$array[i] = (katja.spec.model.MType) parameters[i];
                    }

                    return katja.spec.model.Model.MTypes(_MTypes$array);
                case 71:
                    katja.spec.descriptors.PosSortDescriptor[] _PosSortDescriptors$array = new katja.spec.descriptors.PosSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.PosSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for PosSortDescriptors constructor, in line "+line);
                        _PosSortDescriptors$array[i] = (katja.spec.descriptors.PosSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.PosSortDescriptors(_PosSortDescriptors$array);
                case 72:
                    katja.spec.descriptors.PosStructDescriptor[] _PosStructDescriptors$array = new katja.spec.descriptors.PosStructDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.PosStructDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for PosStructDescriptors constructor, in line "+line);
                        _PosStructDescriptors$array[i] = (katja.spec.descriptors.PosStructDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.PosStructDescriptors(_PosStructDescriptors$array);
                case 73:
                    katja.spec.Production[] _ProductionList$array = new katja.spec.Production[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Production))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionList constructor, in line "+line);
                        _ProductionList$array[i] = (katja.spec.Production) parameters[i];
                    }

                    return katja.spec.Katja.ProductionList(_ProductionList$array);
                case 74:
                    katja.spec.ProductionPos[] _ProductionPosList$array = new katja.spec.ProductionPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.ProductionPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for ProductionPosList constructor, in line "+line);
                        _ProductionPosList$array[i] = (katja.spec.ProductionPos) parameters[i];
                    }

                    return katja.spec.Katja.ProductionPosList(_ProductionPosList$array);
                case 75:
                    katja.spec.Root[] _RootList$array = new katja.spec.Root[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Root))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for RootList constructor, in line "+line);
                        _RootList$array[i] = (katja.spec.Root) parameters[i];
                    }

                    return katja.spec.Katja.RootList(_RootList$array);
                case 76:
                    katja.spec.descriptors.SelectorDescriptor[] _SelectorDescriptors$array = new katja.spec.descriptors.SelectorDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.SelectorDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SelectorDescriptors constructor, in line "+line);
                        _SelectorDescriptors$array[i] = (katja.spec.descriptors.SelectorDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.SelectorDescriptors(_SelectorDescriptors$array);
                case 77:
                    katja.spec.Selector[] _SelectorList$array = new katja.spec.Selector[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.Selector))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SelectorList constructor, in line "+line);
                        _SelectorList$array[i] = (katja.spec.Selector) parameters[i];
                    }

                    return katja.spec.Katja.SelectorList(_SelectorList$array);
                case 78:
                    katja.spec.descriptors.SortDescriptor[] _SortDescriptors$array = new katja.spec.descriptors.SortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.SortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortDescriptors constructor, in line "+line);
                        _SortDescriptors$array[i] = (katja.spec.descriptors.SortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.SortDescriptors(_SortDescriptors$array);
                case 79:
                    katja.spec.SortId[] _SortIdList$array = new katja.spec.SortId[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortId))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortIdList constructor, in line "+line);
                        _SortIdList$array[i] = (katja.spec.SortId) parameters[i];
                    }

                    return katja.spec.Katja.SortIdList(_SortIdList$array);
                case 80:
                    katja.spec.SortSpecPos[] _SortSpecPosList$array = new katja.spec.SortSpecPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SortSpecPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SortSpecPosList constructor, in line "+line);
                        _SortSpecPosList$array[i] = (katja.spec.SortSpecPos) parameters[i];
                    }

                    return katja.spec.Katja.SortSpecPosList(_SortSpecPosList$array);
                case 81:
                    katja.spec.SpecificationPos[] _SpecificationPosList$array = new katja.spec.SpecificationPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.SpecificationPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for SpecificationPosList constructor, in line "+line);
                        _SpecificationPosList$array[i] = (katja.spec.SpecificationPos) parameters[i];
                    }

                    return katja.spec.Katja.SpecificationPosList(_SpecificationPosList$array);
                case 82:
                    java.lang.String[] _Strings$array = new java.lang.String[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof java.lang.String))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for Strings constructor, in line "+line);
                        _Strings$array[i] = (java.lang.String) parameters[i];
                    }

                    return katja.spec.model.Model.Strings(_Strings$array);
                case 83:
                    katja.spec.descriptors.TermSortDescriptor[] _TermSortDescriptors$array = new katja.spec.descriptors.TermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.TermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TermSortDescriptors constructor, in line "+line);
                        _TermSortDescriptors$array[i] = (katja.spec.descriptors.TermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.TermSortDescriptors(_TermSortDescriptors$array);
                case 84:
                    katja.spec.TupleParam[] _TupleParamList$array = new katja.spec.TupleParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.TupleParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleParamList constructor, in line "+line);
                        _TupleParamList$array[i] = (katja.spec.TupleParam) parameters[i];
                    }

                    return katja.spec.Katja.TupleParamList(_TupleParamList$array);
                case 85:
                    katja.spec.descriptors.TupleTermSortDescriptor[] _TupleTermSortDescriptors$array = new katja.spec.descriptors.TupleTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.TupleTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for TupleTermSortDescriptors constructor, in line "+line);
                        _TupleTermSortDescriptors$array[i] = (katja.spec.descriptors.TupleTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.TupleTermSortDescriptors(_TupleTermSortDescriptors$array);
                case 86:
                    katja.spec.VariantParam[] _VariantParamList$array = new katja.spec.VariantParam[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParam))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamList constructor, in line "+line);
                        _VariantParamList$array[i] = (katja.spec.VariantParam) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamList(_VariantParamList$array);
                case 87:
                    katja.spec.VariantParamPos[] _VariantParamPosList$array = new katja.spec.VariantParamPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantParamPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantParamPosList constructor, in line "+line);
                        _VariantParamPosList$array[i] = (katja.spec.VariantParamPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantParamPosList(_VariantParamPosList$array);
                case 88:
                    katja.spec.VariantProdPos[] _VariantPosList$array = new katja.spec.VariantProdPos[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.VariantProdPos))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantPosList constructor, in line "+line);
                        _VariantPosList$array[i] = (katja.spec.VariantProdPos) parameters[i];
                    }

                    return katja.spec.Katja.VariantPosList(_VariantPosList$array);
                case 89:
                    katja.spec.descriptors.VariantTermSortDescriptor[] _VariantTermSortDescriptors$array = new katja.spec.descriptors.VariantTermSortDescriptor[parameters.length];

                    for(int i = 0; i < parameters.length; i++) {
                        if(!(parameters[i] instanceof katja.spec.descriptors.VariantTermSortDescriptor))
                            throw new IllegalArgumentException("wrong sort on stack as parameter "+i+" for VariantTermSortDescriptors constructor, in line "+line);
                        _VariantTermSortDescriptors$array[i] = (katja.spec.descriptors.VariantTermSortDescriptor) parameters[i];
                    }

                    return katja.spec.descriptors.Descriptors.VariantTermSortDescriptors(_VariantTermSortDescriptors$array);
                case 90:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given root position MFileInFile, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.model.MFile))
                        throw new IllegalArgumentException("wrong sort on stack as parameter for MFileInFile constructor, in line "+line);

                    return katja.spec.model.Model.MFileInFile((katja.spec.model.MFile) parameters[0]);
                case 91:
                    if(parameters.length != 1)
                        throw new IllegalArgumentException("wrong number of arguments given root position SpecificationPos, in line "+line);

                    if(!(parameters[0] instanceof katja.spec.Specification))
                        throw new IllegalArgumentException("wrong sort on stack as parameter for SpecificationPos constructor, in line "+line);

                    return katja.spec.Katja.SpecificationPos((katja.spec.Specification) parameters[0]);
                default:
                    throw new IllegalStateException("impossible state");
            }
        }
    }
}

