package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface PosSortDescriptorInFile extends katja.spec.model.SortDescriptorInFile, katja.spec.model.Model.TupleInFile<katja.spec.descriptors.PosSortDescriptor> {

    //----- methods of PosSortDescriptorInFile -----

    public katja.spec.descriptors.PosSortDescriptor termSortDescriptor();
    public katja.spec.descriptors.PosSortDescriptor term();
    public katja.spec.model.StringInFile name();
    public katja.spec.model.PosSortDescriptorInFile replaceName(java.lang.String name);
    public katja.spec.model.StringInFile filename();
    public katja.spec.model.PosSortDescriptorInFile replaceFilename(java.lang.String filename);
    public katja.spec.model.IntegerInFile line();
    public katja.spec.model.PosSortDescriptorInFile replaceLine(java.lang.Integer line);
    public katja.spec.model.BooleanInFile imported();
    public katja.spec.model.PosSortDescriptorInFile replaceImported(java.lang.Boolean imported);
    public katja.spec.model.TermSortDescriptorInFile baseSort();
    public katja.spec.model.PosSortDescriptorInFile replaceBaseSort(katja.spec.descriptors.TermSortDescriptor baseSort);
    public katja.spec.model.PosStructDescriptorInFile struct();
    public katja.spec.model.PosSortDescriptorInFile replaceStruct(katja.spec.descriptors.PosStructDescriptor struct);
    public katja.spec.model.Model.SortInFile get(int i);
    public int size();
    public katja.spec.model.PosSortDescriptorInFile replace(katja.spec.descriptors.PosSortDescriptor term);
    public katja.spec.model.MKatjaTypeInFile parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.SortDescriptorInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of PosSortDescriptorInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitPosSortDescriptorInFile(katja.spec.model.PosSortDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.PosSortDescriptorInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.TermSortDescriptorInFile.Switch<Object, E> variantVisit$TermSortDescriptorInFile = new katja.spec.model.TermSortDescriptorInFile.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$TermSortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.descriptors.PosSortDescriptor> implements katja.spec.model.PosSortDescriptorInFile {

        //----- attributes of Impl -----

        private katja.spec.model.StringInFile _name = null;
        private katja.spec.model.StringInFile _filename = null;
        private katja.spec.model.IntegerInFile _line = null;
        private katja.spec.model.BooleanInFile _imported = null;
        private katja.spec.model.TermSortDescriptorInFile _baseSort = null;
        private katja.spec.model.PosStructDescriptorInFile _struct = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.PosSortDescriptor termSortDescriptor() {
            return term();
        }

        public katja.spec.model.StringInFile name() {
            if(_name == null)
                _name = katja.spec.model.Model.StringInFile(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.model.StringInFile filename() {
            if(_filename == null)
                _filename = katja.spec.model.Model.StringInFile(this, _term.filename(), 1);

            return _filename;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceFilename(java.lang.String filename) {
            return replace(_term.replaceFilename(filename));
        }

        public katja.spec.model.IntegerInFile line() {
            if(_line == null)
                _line = katja.spec.model.Model.IntegerInFile(this, _term.line(), 2);

            return _line;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceLine(java.lang.Integer line) {
            return replace(_term.replaceLine(line));
        }

        public katja.spec.model.BooleanInFile imported() {
            if(_imported == null)
                _imported = katja.spec.model.Model.BooleanInFile(this, _term.imported(), 3);

            return _imported;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceImported(java.lang.Boolean imported) {
            return replace(_term.replaceImported(imported));
        }

        public katja.spec.model.TermSortDescriptorInFile baseSort() {
            if(_baseSort == null)
                _baseSort = katja.spec.model.Model.TermSortDescriptorInFile(this, _term.baseSort(), 4);

            return _baseSort;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceBaseSort(katja.spec.descriptors.TermSortDescriptor baseSort) {
            return replace(_term.replaceBaseSort(baseSort));
        }

        public katja.spec.model.PosStructDescriptorInFile struct() {
            if(_struct == null)
                _struct = katja.spec.model.Model.PosStructDescriptorInFile(this, _term.struct(), 5);

            return _struct;
        }

        public katja.spec.model.PosSortDescriptorInFile replaceStruct(katja.spec.descriptors.PosStructDescriptor struct) {
            return replace(_term.replaceStruct(struct));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.descriptors.PosSortDescriptor term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.SortInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 6;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Model.StringInFile(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_filename == null)
                        _filename = Model.StringInFile(this, _term.filename(), 1);
                    
                    return _filename;
                case 2:
                    if(_line == null)
                        _line = Model.IntegerInFile(this, _term.line(), 2);
                    
                    return _line;
                case 3:
                    if(_imported == null)
                        _imported = Model.BooleanInFile(this, _term.imported(), 3);
                    
                    return _imported;
                case 4:
                    if(_baseSort == null)
                        _baseSort = Model.TermSortDescriptorInFile(this, _term.baseSort(), 4);
                    
                    return _baseSort;
                case 5:
                    if(_struct == null)
                        _struct = Model.PosStructDescriptorInFile(this, _term.struct(), 5);
                    
                    return _struct;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PosSortDescriptorInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PosSortDescriptorInFile invoked with too large parameter "+i+", sort has only 6 components");
                    }
            }
        }

        public int size() {
            return 6;
        }

        public katja.spec.model.PosSortDescriptorInFile replace(katja.spec.descriptors.PosSortDescriptor term) {
            return (katja.spec.model.PosSortDescriptorInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.MKatjaTypeInFile parent() {
            return (katja.spec.model.MKatjaTypeInFile) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.SortDescriptorInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CasePosSortDescriptorInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "PosSortDescriptorInFile";
        }
    }
}

