package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface PosStructDescriptorInFile extends katja.spec.model.Model.TupleInFile<katja.spec.descriptors.PosStructDescriptor> {

    //----- methods of PosStructDescriptorInFile -----

    public katja.spec.descriptors.PosStructDescriptor term();
    public katja.spec.model.TermSortDescriptorInFile rootSort();
    public katja.spec.model.PosStructDescriptorInFile replaceRootSort(katja.spec.descriptors.TermSortDescriptor rootSort);
    public katja.spec.model.StringInFile suffix();
    public katja.spec.model.PosStructDescriptorInFile replaceSuffix(java.lang.String suffix);
    public katja.spec.model.Model.SortInFile get(int i);
    public int size();
    public katja.spec.model.PosStructDescriptorInFile replace(katja.spec.descriptors.PosStructDescriptor term);
    public katja.spec.model.PosSortDescriptorInFile parent();
    public katja.spec.model.TermSortDescriptorInFile lsib();
    public katja.spec.model.Model.SortInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of PosStructDescriptorInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E;
        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E;
        public void visitListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
        public void visitExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitPosStructDescriptorInFile(katja.spec.model.PosStructDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.PosStructDescriptorInFile.VisitorType<E> {

        //----- attributes of Visitor<E extends Throwable> -----

        private final katja.spec.model.TermSortDescriptorInFile.Switch<Object, E> variantVisit$TermSortDescriptorInFile = new katja.spec.model.TermSortDescriptorInFile.Switch<Object, E>() { public final Object CaseTupleTermSortDescriptorInFile(katja.spec.model.TupleTermSortDescriptorInFile term) throws E { visitTupleTermSortDescriptorInFile(term); return null; } public final Object CaseListTermSortDescriptorInFile(katja.spec.model.ListTermSortDescriptorInFile term) throws E { visitListTermSortDescriptorInFile(term); return null; } public final Object CaseVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E { visitVariantTermSortDescriptorInFile(term); return null; } public final Object CaseExternTermSortDescriptorInFile(katja.spec.model.ExternTermSortDescriptorInFile term) throws E { visitExternTermSortDescriptorInFile(term); return null; } };

        //----- methods of Visitor<E extends Throwable> -----

        public final void visitTermSortDescriptorInFile(katja.spec.model.TermSortDescriptorInFile term) throws E {
            term.Switch(variantVisit$TermSortDescriptorInFile);
        }
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.descriptors.PosStructDescriptor> implements katja.spec.model.PosStructDescriptorInFile {

        //----- attributes of Impl -----

        private katja.spec.model.TermSortDescriptorInFile _rootSort = null;
        private katja.spec.model.StringInFile _suffix = null;

        //----- methods of Impl -----

        public katja.spec.model.TermSortDescriptorInFile rootSort() {
            if(_rootSort == null)
                _rootSort = katja.spec.model.Model.TermSortDescriptorInFile(this, _term.rootSort(), 0);

            return _rootSort;
        }

        public katja.spec.model.PosStructDescriptorInFile replaceRootSort(katja.spec.descriptors.TermSortDescriptor rootSort) {
            return replace(_term.replaceRootSort(rootSort));
        }

        public katja.spec.model.StringInFile suffix() {
            if(_suffix == null)
                _suffix = katja.spec.model.Model.StringInFile(this, _term.suffix(), 1);

            return _suffix;
        }

        public katja.spec.model.PosStructDescriptorInFile replaceSuffix(java.lang.String suffix) {
            return replace(_term.replaceSuffix(suffix));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.descriptors.PosStructDescriptor term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.SortInFile get(int i) {
            int ith = i;

            if(ith < 0) ith += 2;

            switch(ith) {
                case 0:
                    if(_rootSort == null)
                        _rootSort = Model.TermSortDescriptorInFile(this, _term.rootSort(), 0);
                    
                    return _rootSort;
                case 1:
                    if(_suffix == null)
                        _suffix = Model.StringInFile(this, _term.suffix(), 1);
                    
                    return _suffix;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort PosStructDescriptorInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort PosStructDescriptorInFile invoked with too large parameter "+i+", sort has only 2 components");
                    }
            }
        }

        public int size() {
            return 2;
        }

        public katja.spec.model.PosStructDescriptorInFile replace(katja.spec.descriptors.PosStructDescriptor term) {
            return (katja.spec.model.PosStructDescriptorInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.PosSortDescriptorInFile parent() {
            return (katja.spec.model.PosSortDescriptorInFile) super.parent();
        }

        public katja.spec.model.TermSortDescriptorInFile lsib() {
            return (katja.spec.model.TermSortDescriptorInFile) super.lsib();
        }

        public katja.spec.model.Model.SortInFile rsib() {
            return (katja.spec.model.Model.SortInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "PosStructDescriptorInFile";
        }
    }
}

