package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface StringInFile extends katja.spec.model.Model.LeafInFile<java.lang.String> {

    //----- methods of StringInFile -----

    public java.lang.String term();
    public katja.spec.model.Model.NodeInFile<?> parent();
    public katja.spec.model.Model.SortInFile lsib();
    public katja.spec.model.Model.TermInFile<?> rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of StringInFile -----

    static class Impl extends KatjaLeafPosImpl<katja.spec.model.MFileInFile, java.lang.String> implements katja.spec.model.StringInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, java.lang.String term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.NodeInFile<?> parent() {
            return (katja.spec.model.Model.NodeInFile<?>) super.parent();
        }

        public katja.spec.model.Model.SortInFile lsib() {
            return (katja.spec.model.Model.SortInFile) super.lsib();
        }

        public katja.spec.model.Model.TermInFile<?> rsib() {
            return (katja.spec.model.Model.TermInFile<?>) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            builder.append("\"").append(term().toString()).append("\"");
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StringInFile";
        }
    }
}

