package katja.spec.model;

import katja.common.*;
import java.io.IOException;

public interface Strings extends KatjaList<java.lang.String> {

    //----- methods of Strings -----

    public katja.spec.model.Strings add(java.lang.String element);
    public katja.spec.model.Strings addAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.Strings remove(java.lang.String element);
    public katja.spec.model.Strings removeAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.Strings appBack(java.lang.String element);
    public katja.spec.model.Strings appFront(java.lang.String element);
    public katja.spec.model.Strings conc(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.Strings front();
    public katja.spec.model.Strings back();
    public katja.spec.model.Strings reverse();
    public katja.spec.model.Strings sublist(int from, int to);
    public katja.spec.model.Strings replace(int ith, Object element);
    public katja.spec.model.Strings toSet();
    public katja.spec.model.Strings setAdd(java.lang.String element);
    public katja.spec.model.Strings setRemove(java.lang.String element);
    public katja.spec.model.Strings setUnion(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.Strings setIntersection(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.Strings setWithout(KatjaList<? extends java.lang.String> list);

    //----- nested classes of Strings -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitString(java.lang.String term) throws E;
        public void visitStrings(katja.spec.model.Strings term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.Strings.VisitorType<E> {
    }

    static class Impl extends KatjaListImpl<java.lang.String> implements katja.spec.model.Strings {

        //----- methods of Impl -----

        Impl(java.lang.String... elements) {
            super(elements);

            for(java.lang.String element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort Strings invoked with null element");
        }

        private Impl() {
        }

        protected katja.spec.model.Strings createInstance(java.lang.String[] elements, boolean isSet) {
            for(java.lang.String element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of sort Strings invoked with null element");

            Strings.Impl temp = new katja.spec.model.Strings.Impl();
            temp.values = elements;
            temp = (Strings.Impl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected java.lang.String[] createArray(int size) {
            return new java.lang.String[size];
        }

        public katja.spec.model.Strings add(java.lang.String element) {
            return (katja.spec.model.Strings) super.add(element);
        }

        public katja.spec.model.Strings addAll(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.addAll(list);
        }

        public katja.spec.model.Strings remove(java.lang.String element) {
            return (katja.spec.model.Strings) super.remove(element);
        }

        public katja.spec.model.Strings removeAll(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.removeAll(list);
        }

        public katja.spec.model.Strings appBack(java.lang.String element) {
            return (katja.spec.model.Strings) super.appBack(element);
        }

        public katja.spec.model.Strings appFront(java.lang.String element) {
            return (katja.spec.model.Strings) super.appFront(element);
        }

        public katja.spec.model.Strings conc(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.conc(list);
        }

        public katja.spec.model.Strings front() {
            return (katja.spec.model.Strings) super.front();
        }

        public katja.spec.model.Strings back() {
            return (katja.spec.model.Strings) super.back();
        }

        public katja.spec.model.Strings reverse() {
            return (katja.spec.model.Strings) super.reverse();
        }

        public katja.spec.model.Strings sublist(int from, int to) {
            return (katja.spec.model.Strings) super.sublist(from, to);
        }

        public katja.spec.model.Strings replace(int ith, Object element) {
            return (katja.spec.model.Strings) super.replace(ith, element);
        }

        public katja.spec.model.Strings toSet() {
            return (katja.spec.model.Strings) super.toSet();
        }

        public katja.spec.model.Strings setAdd(java.lang.String element) {
            return (katja.spec.model.Strings) super.setAdd(element);
        }

        public katja.spec.model.Strings setRemove(java.lang.String element) {
            return (katja.spec.model.Strings) super.setRemove(element);
        }

        public katja.spec.model.Strings setUnion(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.setUnion(list);
        }

        public katja.spec.model.Strings setIntersection(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.setIntersection(list);
        }

        public katja.spec.model.Strings setWithout(KatjaList<? extends java.lang.String> list) {
            return (katja.spec.model.Strings) super.setWithout(list);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Model.Strings");
            builder.append("( ");
            for(java.lang.String element : values) {
                if(first) first = false;
                else builder.append(", ");
                builder.append("\"").append(element.toString()).append("\"");
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("Strings");
            builder.append("( ");
            for(java.lang.String element : values) {
                if(first) first = false;
                else builder.append(", ");
                builder.append("\"").append(element.toString()).append("\"");
            }
            builder.append(" )");

            return builder;
        }

        public final String sortName() {
            return "Strings";
        }
    }
}

