package katja.spec.model;

import katja.common.*;
import java.util.List;
import java.io.IOException;

public interface StringsInFile extends katja.spec.model.Model.ListInFile<katja.spec.model.Strings, katja.spec.model.StringInFile, java.lang.String> {

    //----- methods of StringsInFile -----

    public katja.spec.model.Strings term();
    public katja.spec.model.StringsInFile add(java.lang.String element);
    public katja.spec.model.StringsInFile addAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.StringsInFile remove(java.lang.String element);
    public katja.spec.model.StringsInFile removeAll(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.StringsInFile appBack(java.lang.String element);
    public katja.spec.model.StringsInFile appFront(java.lang.String element);
    public katja.spec.model.StringsInFile conc(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.StringsInFile reverse();
    public katja.spec.model.StringsInFile toSet();
    public katja.spec.model.StringsInFile setAdd(java.lang.String element);
    public katja.spec.model.StringsInFile setRemove(java.lang.String element);
    public katja.spec.model.StringsInFile setUnion(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.StringsInFile setWithout(KatjaList<? extends java.lang.String> list);
    public katja.spec.model.StringsInFile setIntersection(KatjaList<? extends java.lang.String> list);
    public KatjaList<katja.spec.model.StringInFile> toList();
    public katja.spec.model.StringsInFile replace(katja.spec.model.Strings term);
    public katja.spec.model.Model.TupleInFile<?> parent();
    public katja.spec.model.StringInFile lsib();
    public katja.spec.model.MTypesInFile rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);

    //----- nested classes of StringsInFile -----

    static class ListImpl extends KatjaListImpl<katja.spec.model.StringInFile> implements KatjaList<katja.spec.model.StringInFile> {

        //----- methods of ListImpl -----

        ListImpl(katja.spec.model.StringInFile... elements) {
            super(elements);

            for(katja.spec.model.StringInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StringInFile invoked with null element");
        }

        private ListImpl() {
        }

        protected KatjaList<katja.spec.model.StringInFile> createInstance(katja.spec.model.StringInFile[] elements, boolean isSet) {
            for(katja.spec.model.StringInFile element : elements)
                if(element == null)
                    throw new IllegalArgumentException("constructor of katja list for position sort StringInFile invoked with null element");

            ListImpl temp = new ListImpl();
            temp.values = elements;
            temp = (ListImpl) Model.unique(temp);
            if(isSet) temp.set = temp;

            return temp;
        }

        protected katja.spec.model.StringInFile[] createArray(int size) {
            return new katja.spec.model.StringInFile[size];
        }

        public Appendable toString(Appendable builder) throws IOException {
            boolean first = true;

            builder.append("KatjaList( ");
            for(katja.spec.model.StringInFile element : values) {
                if(first) first = false;
                else builder.append(", ");
                element.toString(builder);
            }
            builder.append(" )");

            return builder;
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
        }

        public final String sortName() {
            return "<anonymous>";
        }
    }

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitStringsInFile(katja.spec.model.StringsInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.StringsInFile.VisitorType<E> {
    }

    static class Impl extends KatjaListPosImpl<katja.spec.model.MFileInFile, katja.spec.model.Strings, katja.spec.model.StringInFile, java.lang.String> implements katja.spec.model.StringsInFile {

        //----- methods of Impl -----

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.model.Strings term, int pos) {
            super(parent, term, pos);
        }

        protected katja.spec.model.StringInFile getElementInstance(int pos) {
            return katja.spec.model.Model.StringInFile(this, _term.get(pos), pos);
        }

        protected katja.spec.model.StringInFile[] createArray(int size) {
            return new katja.spec.model.StringInFile[size];
        }

        public katja.spec.model.StringsInFile add(java.lang.String element) {
            return replace(_term.add(element));
        }

        public katja.spec.model.StringsInFile addAll(KatjaList<? extends java.lang.String> list) {
            return replace(_term.addAll(list));
        }

        public katja.spec.model.StringsInFile remove(java.lang.String element) {
            return replace(_term.remove(element));
        }

        public katja.spec.model.StringsInFile removeAll(KatjaList<? extends java.lang.String> list) {
            return replace(_term.removeAll(list));
        }

        public katja.spec.model.StringsInFile appBack(java.lang.String element) {
            return replace(_term.appBack(element));
        }

        public katja.spec.model.StringsInFile appFront(java.lang.String element) {
            return replace(_term.appFront(element));
        }

        public katja.spec.model.StringsInFile conc(KatjaList<? extends java.lang.String> list) {
            return replace(_term.conc(list));
        }

        public katja.spec.model.StringsInFile reverse() {
            return replace(_term.reverse());
        }

        public katja.spec.model.StringsInFile toSet() {
            return replace(_term.toSet());
        }

        public katja.spec.model.StringsInFile setAdd(java.lang.String element) {
            return replace(_term.setAdd(element));
        }

        public katja.spec.model.StringsInFile setRemove(java.lang.String element) {
            return replace(_term.setRemove(element));
        }

        public katja.spec.model.StringsInFile setUnion(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setUnion(list));
        }

        public katja.spec.model.StringsInFile setWithout(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setWithout(list));
        }

        public katja.spec.model.StringsInFile setIntersection(KatjaList<? extends java.lang.String> list) {
            return replace(_term.setIntersection(list));
        }

        public KatjaList<katja.spec.model.StringInFile> toList() {
            for(int i = 0; i < size(); i++) if(values[i] == null) values[i] = getElementInstance(i);
            return new StringsInFile.ListImpl(values);
        }

        public katja.spec.model.StringsInFile replace(katja.spec.model.Strings term) {
            return (katja.spec.model.StringsInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.TupleInFile<?> parent() {
            return (katja.spec.model.Model.TupleInFile<?>) super.parent();
        }

        public katja.spec.model.StringInFile lsib() {
            return (katja.spec.model.StringInFile) super.lsib();
        }

        public katja.spec.model.MTypesInFile rsib() {
            return (katja.spec.model.MTypesInFile) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "StringsInFile";
        }

        //----- nested classes of Impl -----

        static class ListImpl extends KatjaListImpl<katja.spec.model.StringInFile> implements KatjaList<katja.spec.model.StringInFile> {

            //----- methods of ListImpl -----

            ListImpl(katja.spec.model.StringInFile... elements) {
                super(elements);

                for(katja.spec.model.StringInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StringInFile invoked with null element");
            }

            private ListImpl() {
            }

            protected KatjaList<katja.spec.model.StringInFile> createInstance(katja.spec.model.StringInFile[] elements, boolean isSet) {
                for(katja.spec.model.StringInFile element : elements)
                    if(element == null)
                        throw new IllegalArgumentException("constructor of katja list for position sort StringInFile invoked with null element");

                ListImpl temp = new ListImpl();
                temp.values = elements;
                temp = (ListImpl) Model.unique(temp);
                if(isSet) temp.set = temp;

                return temp;
            }

            protected katja.spec.model.StringInFile[] createArray(int size) {
                return new katja.spec.model.StringInFile[size];
            }

            public Appendable toString(Appendable builder) throws IOException {
                boolean first = true;

                builder.append("KatjaList( ");
                for(katja.spec.model.StringInFile element : values) {
                    if(first) first = false;
                    else builder.append(", ");
                    element.toString(builder);
                }
                builder.append(" )");

                return builder;
            }

            public Appendable toJavaCode(Appendable builder) throws IOException {
                throw new UnsupportedOperationException("toJavaCode invoked on an anonymous list of positions, you do not want to do that");
            }

            public final String sortName() {
                return "<anonymous>";
            }
        }
    }
}

