package katja.spec.model;

import java.util.List;
import katja.common.*;
import java.io.IOException;

public interface VariantTermSortDescriptorInFile extends katja.spec.model.TermSortDescriptorInFile, katja.spec.model.Model.TupleInFile<katja.spec.descriptors.VariantTermSortDescriptor> {

    //----- methods of VariantTermSortDescriptorInFile -----

    public katja.spec.descriptors.VariantTermSortDescriptor termTermSortDescriptor();
    public katja.spec.descriptors.VariantTermSortDescriptor termSortDescriptor();
    public katja.spec.descriptors.VariantTermSortDescriptor term();
    public katja.spec.model.StringInFile name();
    public katja.spec.model.VariantTermSortDescriptorInFile replaceName(java.lang.String name);
    public katja.spec.model.StringInFile filename();
    public katja.spec.model.VariantTermSortDescriptorInFile replaceFilename(java.lang.String filename);
    public katja.spec.model.IntegerInFile line();
    public katja.spec.model.VariantTermSortDescriptorInFile replaceLine(java.lang.Integer line);
    public katja.spec.model.BooleanInFile imported();
    public katja.spec.model.VariantTermSortDescriptorInFile replaceImported(java.lang.Boolean imported);
    public katja.spec.model.Model.LeafInFile<?> get(int i);
    public int size();
    public katja.spec.model.VariantTermSortDescriptorInFile replace(katja.spec.descriptors.VariantTermSortDescriptor term);
    public katja.spec.model.Model.TupleInFile<?> parent();
    public katja.spec.model.BooleanInFile lsib();
    public katja.spec.model.Model.TermInFile<?> rsib();
    public katja.spec.model.Model.SortInFile preOrder();
    public katja.spec.model.Model.SortInFile postOrder();
    public katja.spec.model.Model.SortInFile postOrderStart();
    public katja.spec.model.Model.SortInFile follow(List<Integer> path);
    public <CT, E extends Throwable> CT Switch(katja.spec.model.TermSortDescriptorInFile.Switch<CT, E> switchClass) throws E;
    public <CT, E extends Throwable> CT Switch(katja.spec.model.SortDescriptorInFile.Switch<CT, E> switchClass) throws E;

    //----- nested classes of VariantTermSortDescriptorInFile -----

    static interface VisitorType<E extends Throwable> {

        //----- methods of VisitorType<E extends Throwable> -----

        public void visitStringInFile(katja.spec.model.StringInFile term) throws E;
        public void visitIntegerInFile(katja.spec.model.IntegerInFile term) throws E;
        public void visitBooleanInFile(katja.spec.model.BooleanInFile term) throws E;
        public void visitVariantTermSortDescriptorInFile(katja.spec.model.VariantTermSortDescriptorInFile term) throws E;
    }

    public static abstract class Visitor<E extends Throwable> implements katja.spec.model.VariantTermSortDescriptorInFile.VisitorType<E> {
    }

    static class Impl extends KatjaTuplePosImpl<katja.spec.model.MFileInFile, katja.spec.descriptors.VariantTermSortDescriptor> implements katja.spec.model.VariantTermSortDescriptorInFile {

        //----- attributes of Impl -----

        private katja.spec.model.StringInFile _name = null;
        private katja.spec.model.StringInFile _filename = null;
        private katja.spec.model.IntegerInFile _line = null;
        private katja.spec.model.BooleanInFile _imported = null;

        //----- methods of Impl -----

        public katja.spec.descriptors.VariantTermSortDescriptor termTermSortDescriptor() {
            return term();
        }

        public katja.spec.descriptors.VariantTermSortDescriptor termSortDescriptor() {
            return term();
        }

        public katja.spec.model.StringInFile name() {
            if(_name == null)
                _name = katja.spec.model.Model.StringInFile(this, _term.name(), 0);

            return _name;
        }

        public katja.spec.model.VariantTermSortDescriptorInFile replaceName(java.lang.String name) {
            return replace(_term.replaceName(name));
        }

        public katja.spec.model.StringInFile filename() {
            if(_filename == null)
                _filename = katja.spec.model.Model.StringInFile(this, _term.filename(), 1);

            return _filename;
        }

        public katja.spec.model.VariantTermSortDescriptorInFile replaceFilename(java.lang.String filename) {
            return replace(_term.replaceFilename(filename));
        }

        public katja.spec.model.IntegerInFile line() {
            if(_line == null)
                _line = katja.spec.model.Model.IntegerInFile(this, _term.line(), 2);

            return _line;
        }

        public katja.spec.model.VariantTermSortDescriptorInFile replaceLine(java.lang.Integer line) {
            return replace(_term.replaceLine(line));
        }

        public katja.spec.model.BooleanInFile imported() {
            if(_imported == null)
                _imported = katja.spec.model.Model.BooleanInFile(this, _term.imported(), 3);

            return _imported;
        }

        public katja.spec.model.VariantTermSortDescriptorInFile replaceImported(java.lang.Boolean imported) {
            return replace(_term.replaceImported(imported));
        }

        Impl(KatjaNodePos<katja.spec.model.MFileInFile, ?> parent, katja.spec.descriptors.VariantTermSortDescriptor term, int pos) {
            super(parent, term, pos);
        }

        public katja.spec.model.Model.LeafInFile<?> get(int i) {
            int ith = i;

            if(ith < 0) ith += 4;

            switch(ith) {
                case 0:
                    if(_name == null)
                        _name = Model.StringInFile(this, _term.name(), 0);
                    
                    return _name;
                case 1:
                    if(_filename == null)
                        _filename = Model.StringInFile(this, _term.filename(), 1);
                    
                    return _filename;
                case 2:
                    if(_line == null)
                        _line = Model.IntegerInFile(this, _term.line(), 2);
                    
                    return _line;
                case 3:
                    if(_imported == null)
                        _imported = Model.BooleanInFile(this, _term.imported(), 3);
                    
                    return _imported;
                default:
                    if(ith < 0) {
                        throw new IllegalArgumentException("get on sort VariantTermSortDescriptorInFile invoked with negative parameter "+i);
                    } else {
                        throw new IllegalArgumentException("get on sort VariantTermSortDescriptorInFile invoked with too large parameter "+i+", sort has only 4 components");
                    }
            }
        }

        public int size() {
            return 4;
        }

        public katja.spec.model.VariantTermSortDescriptorInFile replace(katja.spec.descriptors.VariantTermSortDescriptor term) {
            return (katja.spec.model.VariantTermSortDescriptorInFile) super.replace(term);
        }

        protected katja.spec.model.MFileInFile freshRootPosition(KatjaSort term) {
            if(!(term instanceof katja.spec.model.MFile))
                throw new IllegalArgumentException("given term to replace root position has not the correct sort MFile");

            return Model.MFileInFile((MFile) term);
        }

        public katja.spec.model.Model.TupleInFile<?> parent() {
            return (katja.spec.model.Model.TupleInFile<?>) super.parent();
        }

        public katja.spec.model.BooleanInFile lsib() {
            return (katja.spec.model.BooleanInFile) super.lsib();
        }

        public katja.spec.model.Model.TermInFile<?> rsib() {
            return (katja.spec.model.Model.TermInFile<?>) super.rsib();
        }

        public katja.spec.model.Model.SortInFile preOrder() {
            return (katja.spec.model.Model.SortInFile) super.preOrder();
        }

        public katja.spec.model.Model.SortInFile postOrder() {
            return (katja.spec.model.Model.SortInFile) super.postOrder();
        }

        public katja.spec.model.Model.SortInFile postOrderStart() {
            return (katja.spec.model.Model.SortInFile) super.postOrderStart();
        }

        public katja.spec.model.Model.SortInFile follow(List<Integer> path) {
            return (katja.spec.model.Model.SortInFile) super.follow(path);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.TermSortDescriptorInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantTermSortDescriptorInFile(this);
        }

        public <CT, E extends Throwable> CT Switch(katja.spec.model.SortDescriptorInFile.Switch<CT, E> switchClass) throws E {
            return switchClass.CaseVariantTermSortDescriptorInFile(this);
        }

        public Appendable toJavaCode(Appendable builder) throws IOException {
            builder.append("Model.MFileInFile");
            builder.append("( ");
            root().term().toJavaCode(builder);
            builder.append(" )");
            for(int pos : path()) builder.append(".get("+pos+")");

            return builder;
        }

        public Appendable toString(Appendable builder) throws IOException {
            term().toString(builder);
            builder.append("@MFile");
            for(int pos : path()) builder.append("."+pos);

            return builder;
        }

        public final String sortName() {
            return "VariantTermSortDescriptorInFile";
        }
    }
}

